function varargout = View4D(varargin)
% VIEW3D MATLAB code for View4D.fig
%      VIEW3D, by itself, creates a new VIEW3D or raises the existing
%      singleton*.
%
%      H = VIEW3D returns the handle to a new VIEW3D or the handle to
%      the existing singleton*.
%
%      VIEW3D('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in VIEW3D.M with the given input arguments.
%
%      VIEW3D('Property','Value',...) creates a new VIEW3D or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before View4D_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to View4D_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help View4D

% Last Modified by GUIDE v2.5 07-Oct-2016 10:24:56

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @View4D_OpeningFcn, ...
                   'gui_OutputFcn',  @View4D_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before View4D is made visible.
function View4D_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to View4D (see VARARGIN)

% Choose default command line output for View4D
handles.output = hObject;

handles3D = getappdata(XIT,'hand');

ColorNames = [{'Black'} {'Density'} handles3D.names];

set(handles.popupmenu1,'string', handles3D.names);
set(handles.popupmenu2,'string', handles3D.names);
set(handles.popupmenu3,'string', handles3D.names);

set(handles.popupmenu1,'value', 1);
set(handles.popupmenu2,'value', length(handles3D.names)-3);
set(handles.popupmenu3,'value', length(handles3D.names)-4);

set(handles.popupmenu4,'string', ColorNames);
set(handles.popupmenu4,'value', 2);
set(handles.popupmenu5,'value', 2);

set(handles.linearBtn,'enable','off');

handles.BiExID = 0;
handles.inda = 1;
handles.indb = length(handles3D.names)-3;
handles.indc = length(handles3D.names)-4;
handles.popupXstr = handles3D.names;
handles.popupYstr = handles3D.names;
handles.popupZstr = handles3D.names;
handles.names = handles3D.names;
handles.stats = handles3D.stats;
handles.ColorNames = ColorNames;
handles.sizeSc = 10;
set(handles.lin_x,'enable','off')
set(handles.lin_y,'enable','off')
set(handles.lin_z,'enable','off')

set(handles.slider1,'Value',30);
set(handles.slider2,'Value',-37.5);

% Update handles structure
guidata(hObject, handles);

stats = handles.stats;
ind_a = get(handles.popupmenu1,'value');
ind_b = get(handles.popupmenu2,'value');
ind_c = get(handles.popupmenu3,'value');
names = handles.names;

abin = str2double(get(handles.densitybin,'String'));
edgesX = linspace(min(stats(:,ind_a)), max(stats(:,ind_a)), abin);
edgesY = linspace(min(stats(:,ind_b)), max(stats(:,ind_b)), abin);
edgesZ = linspace(min(stats(:,ind_c)), max(stats(:,ind_c)), abin);   
    
[One,~] = size(stats(:,ind_a));
        
[~,CountsX] = histc(stats(:,ind_a),edgesX);
[~,CountsY] = histc(stats(:,ind_b),edgesY);
[~,CountsZ] = histc(stats(:,ind_c),edgesZ);        
        
CountsA = [CountsX,CountsY];
CountsB = [CountsX,CountsZ];
CountsC = [CountsZ,CountsY];
    
DarrayA = accumarray(CountsA,1)./One;
DarrayNormA = DarrayA./max(DarrayA(:));
DarrayNormA = imgaussfilt(DarrayNormA,2);

DarrayB = accumarray(CountsB,1)./One;
DarrayNormB = DarrayB./max(DarrayB(:));
DarrayNormB = imgaussfilt(DarrayNormB,2);

DarrayC = accumarray(CountsC,1)./One;
DarrayNormC = DarrayC./max(DarrayC(:));
DarrayNormC = imgaussfilt(DarrayNormC,2);
        
indA = sub2ind(size(DarrayNormA),CountsX,CountsY);
indB = sub2ind(size(DarrayNormB),CountsX,CountsZ);
indC = sub2ind(size(DarrayNormC),CountsZ,CountsY);
    
col2A = DarrayNormA(indA);
col2B = DarrayNormB(indB);
col2C = DarrayNormC(indC);
    
col2 = zeros(length(col2A),1);
for i = 1:length(col2A)
	col2(i,1) = (col2A(i,1) + col2B(i,1) + col2C(i,1))/3 ;
end
    
U = sortrows([handles.stats(:,handles.inda),handles.stats(:,handles.indb),...
handles.stats(:,handles.indc),col2],4);
col1 = U(:,4);
        
%plot
axes(handles.axes3d)
scatter3(U(:,1),U(:,2),U(:,3),10,col1,'filled')    
view(30,-37.5)
grid on
h = xlabel(names(ind_a));
h1= ylabel(names(ind_b));
h2= zlabel(names(ind_c));
set(h,'interpreter','none')
set(h1,'interpreter','none')
set(h2,'interpreter','none')
rotate3d on



% UIWAIT makes View4D wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = View4D_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1
set(handles.output, 'pointer', 'watch')
drawnow;
names = handles.names;
stats = handles.stats;
ind_b = get(handles.popupmenu2,'Value');
ind_c = get(handles.popupmenu3,'Value');
sizeSc = handles.sizeSc;

a1 = get(hObject,'Value');
a = names(1,a1);

for i = 1:length(names)
    if strcmp(a,names(1,i)) == 1
        ind_a = i;
    end
end

s = get(handles.popupmenu4,'Value');
horiz = get(handles.slider1,'Value');
vert = get(handles.slider2,'Value');

if s == 1
	axes(handles.axes3d)
	scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,[0 0 0],'filled');
    view(horiz,vert)
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
elseif s == 2;
	abin = str2double(get(handles.densitybin,'String'));
	edgesX = linspace(min(stats(:,ind_a)), max(stats(:,ind_a)), abin);
	edgesY = linspace(min(stats(:,ind_b)), max(stats(:,ind_b)), abin);
    edgesZ = linspace(min(stats(:,ind_c)), max(stats(:,ind_c)), abin);   
    
	[One,~] = size(stats(:,ind_a));
        
	[~,CountsX] = histc(stats(:,ind_a),edgesX);
	[~,CountsY] = histc(stats(:,ind_b),edgesY);
	[~,CountsZ] = histc(stats(:,ind_c),edgesZ);        
        
	CountsA = [CountsX,CountsY];
    CountsB = [CountsX,CountsZ];
    CountsC = [CountsZ,CountsY];
    
	DarrayA = accumarray(CountsA,1)./One;
	DarrayNormA = DarrayA./max(DarrayA(:));
    DarrayNormA = imgaussfilt(DarrayNormA,2);
    
    DarrayB = accumarray(CountsB,1)./One;
	DarrayNormB = DarrayB./max(DarrayB(:));
    DarrayNormB = imgaussfilt(DarrayNormB,2);
    
    DarrayC = accumarray(CountsC,1)./One;
	DarrayNormC = DarrayC./max(DarrayC(:));
    DarrayNormC = imgaussfilt(DarrayNormC,2);
        
	indA = sub2ind(size(DarrayNormA),CountsX,CountsY);
    indB = sub2ind(size(DarrayNormB),CountsX,CountsZ);
    indC = sub2ind(size(DarrayNormC),CountsZ,CountsY);
    
	col2A = DarrayNormA(indA);
    col2B = DarrayNormB(indB);
    col2C = DarrayNormC(indC);
    
    col2 = zeros(length(col2A),1);
    for i = 1:length(col2A)
        col2(i,1) = (col2A(i,1) + col2B(i,1) + col2C(i,1))/3 ;
    end
    
	U = sortrows([stats(:,ind_a), stats(:,ind_b), stats(:,ind_c),col2],4);
	col1 = U(:,4);
        
	%plot
    axes(handles.axes3d)
    scatter3(U(:,1),U(:,2),U(:,3),sizeSc,col1,'filled')
    grid on
    view(horiz,vert)
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
elseif s > 2
    es = s-2;
    axes(handles.axes3d)
    scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats(:,es),'filled');
    view(horiz,vert)
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
    %ch = colorbar('northoutside');
    %set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
end
handles.inda = ind_a;

reziseaxes3D(stats,ind_a,str2num(get(handles.edit_xmin,'String')),...
    str2num(get(handles.edit_xmax,'String')),...
    str2num(get(handles.edit_ymin,'String')),...
    str2num(get(handles.edit_ymax,'String')),...
    str2num(get(handles.edit_zmin,'String')),...
    str2num(get(handles.edit_zmax,'String')),...
    handles.axes3d)

guidata(hObject, handles);
set(handles.output, 'pointer', 'arrow')


% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu2.
function popupmenu2_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu2
set(handles.output, 'pointer', 'watch')
drawnow;
names = handles.names;
stats = handles.stats;
ind_a = get(handles.popupmenu1,'Value');
ind_c = get(handles.popupmenu3,'Value');
sizeSc = handles.sizeSc;

a1 = get(hObject,'Value');
a = names(1,a1);

for i = 1:length(names)
    if strcmp(a,names(1,i)) == 1
        ind_b = i;
    end
end

s = get(handles.popupmenu4,'Value');
horiz = get(handles.slider1,'Value');
vert = get(handles.slider2,'Value');

if s == 1
	axes(handles.axes3d)
	scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,[0 0 0],'filled');
    view(horiz,vert)
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
elseif s == 2;
	abin = str2double(get(handles.densitybin,'String'));
	edgesX = linspace(min(stats(:,ind_a)), max(stats(:,ind_a)), abin);
	edgesY = linspace(min(stats(:,ind_b)), max(stats(:,ind_b)), abin);
    edgesZ = linspace(min(stats(:,ind_c)), max(stats(:,ind_c)), abin);   
    
	[One,~] = size(stats(:,ind_a));
        
	[~,CountsX] = histc(stats(:,ind_a),edgesX);
	[~,CountsY] = histc(stats(:,ind_b),edgesY);
	[~,CountsZ] = histc(stats(:,ind_c),edgesZ);        
        
	CountsA = [CountsX,CountsY];
    CountsB = [CountsX,CountsZ];
    CountsC = [CountsZ,CountsY];
    
	DarrayA = accumarray(CountsA,1)./One;
	DarrayNormA = DarrayA./max(DarrayA(:));
    DarrayNormA = imgaussfilt(DarrayNormA,2);
    
    DarrayB = accumarray(CountsB,1)./One;
	DarrayNormB = DarrayB./max(DarrayB(:));
    DarrayNormB = imgaussfilt(DarrayNormB,2);
    
    DarrayC = accumarray(CountsC,1)./One;
	DarrayNormC = DarrayC./max(DarrayC(:));
    DarrayNormC = imgaussfilt(DarrayNormC,2);
        
	indA = sub2ind(size(DarrayNormA),CountsX,CountsY);
    indB = sub2ind(size(DarrayNormB),CountsX,CountsZ);
    indC = sub2ind(size(DarrayNormC),CountsZ,CountsY);
    
	col2A = DarrayNormA(indA);
    col2B = DarrayNormB(indB);
    col2C = DarrayNormC(indC);
    
    col2 = zeros(length(col2A),1);
    for i = 1:length(col2A)
        col2(i,1) = (col2A(i,1) + col2B(i,1) + col2C(i,1))/3 ;
    end
    
	U = sortrows([stats(:,ind_a), stats(:,ind_b), stats(:,ind_c),col2],4);
	col1 = U(:,4);
        
    axes(handles.axes3d)
    scatter3(U(:,1),U(:,2),U(:,3),sizeSc,col1,'filled')
    view(horiz,vert)
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
elseif s > 2
    es = s-2;
    axes(handles.axes3d)
    scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats(:,es),'filled');
    view(horiz,vert)
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
    %ch = colorbar('northoutside');
    %set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
end
handles.indb = ind_b;

reziseaxes3D(stats,ind_a,str2num(get(handles.edit_xmin,'String')),...
    str2num(get(handles.edit_xmax,'String')),...
    str2num(get(handles.edit_ymin,'String')),...
    str2num(get(handles.edit_ymax,'String')),...
    str2num(get(handles.edit_zmin,'String')),...
    str2num(get(handles.edit_zmax,'String')),...
    handles.axes3d)

guidata(hObject, handles);
set(handles.output, 'pointer', 'arrow')

% --- Executes during object creation, after setting all properties.
function popupmenu2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu3.
function popupmenu3_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu3 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu3
set(handles.output, 'pointer', 'watch')
drawnow;
names = handles.names;
stats = handles.stats;
ind_a = get(handles.popupmenu1,'Value');
ind_b = get(handles.popupmenu2,'Value');
sizeSc = handles.sizeSc;

a1 = get(hObject,'Value');
a = names(1,a1);

for i = 1:length(names)
    if strcmp(a,names(1,i)) == 1
        ind_c = i;
    end
end

s = get(handles.popupmenu4,'Value');
horiz = get(handles.slider1,'Value');
vert = get(handles.slider2,'Value');

if s == 1
	axes(handles.axes3d)
	scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,[0 0 0],'filled');
    view(horiz,vert)
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
elseif s == 2;
	abin = str2double(get(handles.densitybin,'String'));
	edgesX = linspace(min(stats(:,ind_a)), max(stats(:,ind_a)), abin);
	edgesY = linspace(min(stats(:,ind_b)), max(stats(:,ind_b)), abin);
    edgesZ = linspace(min(stats(:,ind_c)), max(stats(:,ind_c)), abin);   
    
	[One,~] = size(stats(:,ind_a));
        
	[~,CountsX] = histc(stats(:,ind_a),edgesX);
	[~,CountsY] = histc(stats(:,ind_b),edgesY);
	[~,CountsZ] = histc(stats(:,ind_c),edgesZ);        
        
	CountsA = [CountsX,CountsY];
    CountsB = [CountsX,CountsZ];
    CountsC = [CountsZ,CountsY];
    
	DarrayA = accumarray(CountsA,1)./One;
	DarrayNormA = DarrayA./max(DarrayA(:));
    DarrayNormA = imgaussfilt(DarrayNormA,2);
    
    DarrayB = accumarray(CountsB,1)./One;
	DarrayNormB = DarrayB./max(DarrayB(:));
    DarrayNormB = imgaussfilt(DarrayNormB,2);
    
    DarrayC = accumarray(CountsC,1)./One;
	DarrayNormC = DarrayC./max(DarrayC(:));
    DarrayNormC = imgaussfilt(DarrayNormC,2);
        
	indA = sub2ind(size(DarrayNormA),CountsX,CountsY);
    indB = sub2ind(size(DarrayNormB),CountsX,CountsZ);
    indC = sub2ind(size(DarrayNormC),CountsZ,CountsY);
    
	col2A = DarrayNormA(indA);
    col2B = DarrayNormB(indB);
    col2C = DarrayNormC(indC);
    
    col2 = zeros(length(col2A),1);
    for i = 1:length(col2A)
        col2(i,1) = (col2A(i,1) + col2B(i,1) + col2C(i,1))/3 ;
    end
    
	U = sortrows([stats(:,ind_a), stats(:,ind_b), stats(:,ind_c),col2],4);
	col1 = U(:,4);
        
    axes(handles.axes3d)
    scatter3(U(:,1),U(:,2),U(:,3),sizeSc,col1,'filled')
    view(horiz,vert)
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
elseif s > 2
    es = s-2;
    axes(handles.axes3d)
    scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats(:,es),'filled');
    view(horiz,vert)  
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
end

handles.indc = ind_c;

reziseaxes3D(stats,ind_a,str2num(get(handles.edit_xmin,'String')),...
    str2num(get(handles.edit_xmax,'String')),...
    str2num(get(handles.edit_ymin,'String')),...
    str2num(get(handles.edit_ymax,'String')),...
    str2num(get(handles.edit_zmin,'String')),...
    str2num(get(handles.edit_zmax,'String')),...
    handles.axes3d)

guidata(hObject, handles);
set(handles.output, 'pointer', 'arrow')

% --- Executes during object creation, after setting all properties.
function popupmenu3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu4.
function popupmenu4_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu4 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu4
set(handles.output, 'pointer', 'watch')
drawnow;
s = get(handles.popupmenu4,'Value');
stats = handles.stats;
names = handles.names;
ind_a = get(handles.popupmenu1,'Value');
ind_b = get(handles.popupmenu2,'Value');
ind_c = get(handles.popupmenu3,'Value');
sizeSc = handles.sizeSc;

horiz = get(handles.slider1,'Value');
vert = get(handles.slider2,'Value');
cofact3D = str2double(get(handles.cofactor3D,'string'));
cofact_col3D = str2double(get(handles.cofact_col3D,'string'));
stats_col = stats;
    
if s == 1
	axes(handles.axes3d)
	scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,[0 0 0],'filled');
    view(horiz,vert)
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
elseif s == 2;
	abin = str2double(get(handles.densitybin,'String'));
	edgesX = linspace(min(stats(:,ind_a)), max(stats(:,ind_a)), abin);
	edgesY = linspace(min(stats(:,ind_b)), max(stats(:,ind_b)), abin);
    edgesZ = linspace(min(stats(:,ind_c)), max(stats(:,ind_c)), abin);   
    
	[One,~] = size(stats(:,ind_a));
        
	[~,CountsX] = histc(stats(:,ind_a),edgesX);
	[~,CountsY] = histc(stats(:,ind_b),edgesY);
	[~,CountsZ] = histc(stats(:,ind_c),edgesZ);        
        
	CountsA = [CountsX,CountsY];
    CountsB = [CountsX,CountsZ];
    CountsC = [CountsZ,CountsY];
    
	DarrayA = accumarray(CountsA,1)./One;
	DarrayNormA = DarrayA./max(DarrayA(:));
    DarrayNormA = imgaussfilt(DarrayNormA,2);
    
    DarrayB = accumarray(CountsB,1)./One;
	DarrayNormB = DarrayB./max(DarrayB(:));
    DarrayNormB = imgaussfilt(DarrayNormB,2);
    
    DarrayC = accumarray(CountsC,1)./One;
	DarrayNormC = DarrayC./max(DarrayC(:));
    DarrayNormC = imgaussfilt(DarrayNormC,2);
        
	indA = sub2ind(size(DarrayNormA),CountsX,CountsY);
    indB = sub2ind(size(DarrayNormB),CountsX,CountsZ);
    indC = sub2ind(size(DarrayNormC),CountsZ,CountsY);
    
	col2A = DarrayNormA(indA);
    col2B = DarrayNormB(indB);
    col2C = DarrayNormC(indC);
    
    
    for i = 1:length(col2A)
        col2(i,1) = (col2A(i,1) + col2B(i,1) + col2C(i,1))/3 ;
    end
    
	U = sortrows([stats(:,ind_a), stats(:,ind_b), stats(:,ind_c),col2],4);
	col1 = U(:,4);
        
    axes(handles.axes3d)
    scatter3(U(:,1),U(:,2),U(:,3),sizeSc,col1,'filled')
    view(horiz,vert)
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
elseif s > 2
    if get(handles.colasinh3D,'Value') == 1 & handles.BiExID == 0 %color should be transformed, not data
        stats_col = log((stats_col/(str2double(get(handles.cofact_col3D,'String'))))...
            +sqrt((((stats_col/(str2double(get(handles.cofact_col3D,'String')))).^2)+1)));
        es = s-2;
        axes(handles.axes3d)
        scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
    elseif get(handles.colasinh3D,'Value') == 0 & handles.BiExID == 1 %color should not be transformed, but data
        
        if get(handles.ash_z,'Value') == 0
            stats_col(:,ind_c) = cofact3D*(1/2)*(exp(stats_col(:,ind_c)) - exp(-1.*(stats_col(:,ind_c))));
            if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            end
            es = s-2;
            axes(handles.axes3d)
            scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
        else
            if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            end
            es = s-2;
            axes(handles.axes3d)
            scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
        end
            
    elseif get(handles.colasinh3D,'Value') == 0 & handles.BiExID == 0 %color should not be transformed, neither data
        es = s-2;
        axes(handles.axes3d)
        scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
    elseif get(handles.colasinh3D,'Value') == 1 & handles.BiExID == 1 %color and data should be transformed
        
        if get(handles.ash_z,'Value') == 0
            stats_col(:,ind_c) = cofact3D*(1/2)*(exp(stats_col(:,ind_c)) - exp(-1.*(stats_col(:,ind_c))));
            if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            end
        else
            if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            end
        end
        
        stats_col = log((stats_col/str2double(get(handles.cofact_col3D,'string')))+sqrt((((stats_col/str2double(get(handles.cofact_col3D,'string'))).^2)+1)));
        es = s-2;
        axes(handles.axes3d)
        scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
    end
    %es = s-2;
    %axes(handles.axes3d)
    %scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats(:,es),'filled');
    view(horiz,vert)  
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
end
handles.sizeSc = sizeSc;

reziseaxes3D(stats,ind_a,str2num(get(handles.edit_xmin,'String')),...
    str2num(get(handles.edit_xmax,'String')),...
    str2num(get(handles.edit_ymin,'String')),...
    str2num(get(handles.edit_ymax,'String')),...
    str2num(get(handles.edit_zmin,'String')),...
    str2num(get(handles.edit_zmax,'String')),...
    handles.axes3d)

guidata(hObject, handles);
set(handles.output, 'pointer', 'arrow')

% --- Executes during object creation, after setting all properties.
function popupmenu4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu5.
function popupmenu5_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu5 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu5
set(handles.output, 'pointer', 'watch')
drawnow;
sizeVal = get(handles.popupmenu5,'Value');
sizeSc1 = get(handles.popupmenu5,'String');
sizeSc = str2num(sizeSc1{sizeVal,1});
    
stats = handles.stats;
names = handles.names;
ind_a = get(handles.popupmenu1,'Value');
ind_b = get(handles.popupmenu2,'Value');
ind_c = get(handles.popupmenu3,'Value');
    
s = get(handles.popupmenu4,'Value');
horiz = get(handles.slider1,'Value');
vert = get(handles.slider2,'Value');

if s == 1
	axes(handles.axes3d)
	scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,[0 0 0],'filled');
    view(horiz,vert)
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
elseif s == 2;
	abin = str2double(get(handles.densitybin,'String'));
	edgesX = linspace(min(stats(:,ind_a)), max(stats(:,ind_a)), abin);
	edgesY = linspace(min(stats(:,ind_b)), max(stats(:,ind_b)), abin);
    edgesZ = linspace(min(stats(:,ind_c)), max(stats(:,ind_c)), abin);   
    
	[One,~] = size(stats(:,ind_a));
        
	[~,CountsX] = histc(stats(:,ind_a),edgesX);
	[~,CountsY] = histc(stats(:,ind_b),edgesY);
	[~,CountsZ] = histc(stats(:,ind_c),edgesZ);        
        
	CountsA = [CountsX,CountsY];
    CountsB = [CountsX,CountsZ];
    CountsC = [CountsZ,CountsY];
    
	DarrayA = accumarray(CountsA,1)./One;
	DarrayNormA = DarrayA./max(DarrayA(:));
    DarrayNormA = imgaussfilt(DarrayNormA,2);
    
    DarrayB = accumarray(CountsB,1)./One;
	DarrayNormB = DarrayB./max(DarrayB(:));
    DarrayNormB = imgaussfilt(DarrayNormB,2);
    
    DarrayC = accumarray(CountsC,1)./One;
	DarrayNormC = DarrayC./max(DarrayC(:));
    DarrayNormC = imgaussfilt(DarrayNormC,2);
        
	indA = sub2ind(size(DarrayNormA),CountsX,CountsY);
    indB = sub2ind(size(DarrayNormB),CountsX,CountsZ);
    indC = sub2ind(size(DarrayNormC),CountsZ,CountsY);
    
	col2A = DarrayNormA(indA);
    col2B = DarrayNormB(indB);
    col2C = DarrayNormC(indC);
    
    col2 = zeros(length(col2A),1);
    for i = 1:length(col2A)
        col2(i,1) = (col2A(i,1) + col2B(i,1) + col2C(i,1))/3 ;
    end
    
	U = sortrows([stats(:,ind_a), stats(:,ind_b), stats(:,ind_c),col2],4);
	col1 = U(:,4);
        
    axes(handles.axes3d)
    scatter3(U(:,1),U(:,2),U(:,3),sizeSc,col1,'filled')
    view(horiz,vert)
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
elseif s > 2
    es = s-2;
    axes(handles.axes3d)
    scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats(:,es),'filled');
    view(horiz,vert)  
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
end
handles.sizeSc = sizeSc;

reziseaxes3D(stats,ind_a,str2num(get(handles.edit_xmin,'String')),...
    str2num(get(handles.edit_xmax,'String')),...
    str2num(get(handles.edit_ymin,'String')),...
    str2num(get(handles.edit_ymax,'String')),...
    str2num(get(handles.edit_zmin,'String')),...
    str2num(get(handles.edit_zmax,'String')),...
    handles.axes3d)

guidata(hObject, handles)
set(handles.output, 'pointer', 'arrow')

% --- Executes during object creation, after setting all properties.
function popupmenu5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
set(handles.output, 'pointer', 'watch')
drawnow;
horiz = get(handles.slider1,'Value');
vert = get(handles.slider2,'Value');

set(handles.edit_horiz,'String',num2str(horiz-180));
drawnow

axes(handles.axes3d)
view(horiz,vert)
set(handles.output, 'pointer', 'arrow')


% --- Executes during object creation, after setting all properties.
function slider1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
set(handles.output, 'pointer', 'watch')
drawnow;
horiz = get(handles.slider1,'Value');
vert = get(handles.slider2,'Value');

set(handles.edit_vert,'String',num2str(vert));
drawnow

axes(handles.axes3d)
view(horiz,vert)
set(handles.output, 'pointer', 'arrow')

% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.output, 'pointer', 'watch')
drawnow;
horiz = 30;
set(handles.slider1,'Value',30);
set(handles.edit_horiz,'String',num2str(horiz-180));
vert = get(handles.slider2,'Value');

axes(handles.axes3d)
view(horiz,vert)
vert = get(handles.slider2,'Value');

axes(handles.axes3d)
view(horiz,vert)
reziseaxes3D(handles.stats,handles.inda,str2num(get(handles.edit_xmin,'String')),...
    str2num(get(handles.edit_xmax,'String')),...
    str2num(get(handles.edit_ymin,'String')),...
    str2num(get(handles.edit_ymax,'String')),...
    str2num(get(handles.edit_zmin,'String')),...
    str2num(get(handles.edit_zmax,'String')),...
    handles.axes3d)
set(handles.output, 'pointer', 'arrow')

% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.output, 'pointer', 'watch')
drawnow;
horiz = get(handles.slider1,'Value');
vert = -37.5;
set(handles.slider2,'Value',-37.5);
set(handles.edit_vert,'String',num2str(vert));

axes(handles.axes3d)
view(horiz,vert)
reziseaxes3D(handles.stats,handles.inda,str2num(get(handles.edit_xmin,'String')),...
    str2num(get(handles.edit_xmax,'String')),...
    str2num(get(handles.edit_ymin,'String')),...
    str2num(get(handles.edit_ymax,'String')),...
    str2num(get(handles.edit_zmin,'String')),...
    str2num(get(handles.edit_zmax,'String')),...
    handles.axes3d)
set(handles.output, 'pointer', 'arrow')



function densitybin_Callback(hObject, eventdata, handles)
% hObject    handle to densitybin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of densitybin as text
%        str2double(get(hObject,'String')) returns contents of densitybin as a double


% --- Executes during object creation, after setting all properties.
function densitybin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to densitybin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on key press with focus on densitybin and none of its controls.
function densitybin_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to densitybin (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
current_key = eventdata.Key;
drawnow
s = get(handles.popupmenu4,'Value');

if strcmp(current_key,'return') & s == 2
    set(handles.output, 'pointer', 'watch')
    drawnow;
    sizeVal = get(handles.popupmenu5,'Value');
    sizeSc1 = get(handles.popupmenu5,'String');
    sizeSc = str2num(sizeSc1{sizeVal,1});
    
    stats = handles.stats;
    names = handles.names;
    ind_a = get(handles.popupmenu1,'Value');
    ind_b = get(handles.popupmenu2,'Value');
    ind_c = get(handles.popupmenu3,'Value');
    

    horiz = get(handles.slider1,'Value');
    vert = get(handles.slider2,'Value');
	abin = str2double(get(handles.densitybin,'String'));
	edgesX = linspace(min(stats(:,ind_a)), max(stats(:,ind_a)), abin);
	edgesY = linspace(min(stats(:,ind_b)), max(stats(:,ind_b)), abin);
    edgesZ = linspace(min(stats(:,ind_c)), max(stats(:,ind_c)), abin);   
    
	[One,~] = size(stats(:,ind_a));
        
	[~,CountsX] = histc(stats(:,ind_a),edgesX);
	[~,CountsY] = histc(stats(:,ind_b),edgesY);
	[~,CountsZ] = histc(stats(:,ind_c),edgesZ);        
        
	CountsA = [CountsX,CountsY];
    CountsB = [CountsX,CountsZ];
    CountsC = [CountsZ,CountsY];
    
	DarrayA = accumarray(CountsA,1)./One;
	DarrayNormA = DarrayA./max(DarrayA(:));
    DarrayNormA = imgaussfilt(DarrayNormA,2);
    
    DarrayB = accumarray(CountsB,1)./One;
	DarrayNormB = DarrayB./max(DarrayB(:));
    DarrayNormB = imgaussfilt(DarrayNormB,2);
    
    DarrayC = accumarray(CountsC,1)./One;
	DarrayNormC = DarrayC./max(DarrayC(:));
    DarrayNormC = imgaussfilt(DarrayNormC,2);
        
	indA = sub2ind(size(DarrayNormA),CountsX,CountsY);
    indB = sub2ind(size(DarrayNormB),CountsX,CountsZ);
    indC = sub2ind(size(DarrayNormC),CountsZ,CountsY);
    
	col2A = DarrayNormA(indA);
    col2B = DarrayNormB(indB);
    col2C = DarrayNormC(indC);
    
    
    for i = 1:length(col2A)
        col2(i,1) = (col2A(i,1) + col2B(i,1) + col2C(i,1))/3 ;
    end
    
	U = sortrows([stats(:,ind_a), stats(:,ind_b), stats(:,ind_c),col2],4);
	col1 = U(:,4);
        
    axes(handles.axes3d)
    %colli = col1*20;
    scatter3(U(:,1),U(:,2),U(:,3),sizeSc,col1,'filled')
    view(horiz,vert)
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
end
reziseaxes3D(handles.stats,handles.inda,str2num(get(handles.edit_xmin,'String')),...
    str2num(get(handles.edit_xmax,'String')),...
    str2num(get(handles.edit_ymin,'String')),...
    str2num(get(handles.edit_ymax,'String')),...
    str2num(get(handles.edit_zmin,'String')),...
    str2num(get(handles.edit_zmax,'String')),...
    handles.axes3d)
set(handles.output, 'pointer', 'arrow')


% --- Executes on button press in saveBtn.
function saveBtn_Callback(hObject, eventdata, handles)
% hObject    handle to saveBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.output, 'pointer', 'watch')
drawnow;
figs =  findobj('type','figure');

handi = findobj(figs(1,1),'type','axes');
figgi = figure('Name','3D view','numbertitle','off');

copyobj(handi,figgi); %copies the object
d = daspect;
daspect(d);

colormap(jet)

hand = findobj(figgi,'type','axes');

%set(hand,'XTickMode','auto')
%set(hand,'YTickMode','auto')
%set(hand,'ZTickMode','auto')
%set(hand,'ActivePositionProperty','position')
%set(figgi, 'Units','normalized', 'OuterPosition',[0 0 1 1])
set(hand,'position',[0.15 0.15 0.7 0.7],'units','normalized')
set(figgi, 'Units','normalized', 'OuterPosition',[0.3 0.2 0.3 0.5])
set(hand,'outerposition',[0 0 1 1],'units','normalized')
set(hand, 'LooseInset', [0,0,0,0]);
%axis square

po = questdlg('Do you want a colorbar to be plotted with your figure?','Colorbar','Yes','No','Yes');
switch po
    case 'Yes'
        axes(hand)
        ch = colorbar('eastoutside');
    case 'No'
end

[FileName,PathName] = uiputfile('*.tif','Save graph');
if FileName == 0 & PathName == 0
    
end
FileName2 = fullfile(PathName, FileName);
set(figgi,'PaperPositionMode','auto')
print(figgi,FileName2,'-dtiff','-r300')
waitfor(msgbox('Export successful!'))
drawnow;

close(figgi)
set(handles.output, 'pointer', 'arrow')


% --- Executes on button press in save360Btn.
function save360Btn_Callback(hObject, eventdata, handles)
% hObject    handle to save360Btn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.output, 'pointer', 'watch')
drawnow;
[FileName, PathName] = uiputfile('*.mp4', 'Save 3D animation');
FileName2 = fullfile(PathName, FileName);
addpath(PathName)

figs =  findobj('type','figure');
handi = findobj(figs(1,1),'type','axes');
figgi = figure('Name','3D view','numbertitle','off');
copyobj(handi,figgi); %copies the object
d = daspect;
daspect(d);
colormap(jet)
hand = findobj(figgi,'type','axes');
set(hand,'position',[0.15 0.15 0.7 0.7],'units','normalized')
set(figgi, 'Units','normalized', 'OuterPosition',[0.3 0.2 0.3 0.5])
set(hand,'outerposition',[0 0 1 1],'units','normalized')
%set(hand, 'LooseInset', [0,0,0,0]);

%set(hand,'xlabel',[]);
%set(hand,'ylabel',[]);
%set(hand,'zlabel',[]);
set(hand,'color','w')
set(figgi,'color','w')

parameters1 = inputdlg({'Enter vertical view angle (horiz. rotation'},...
    'Save3D',1,{'-37.5'});
  
v = VideoWriter(FileName2,'MPEG-4');

open(v);
 
reziseaxes3D(handles.stats,handles.inda,str2num(get(handles.edit_xmin,'String')),...
    str2num(get(handles.edit_xmax,'String')),...
    str2num(get(handles.edit_ymin,'String')),...
    str2num(get(handles.edit_ymax,'String')),...
    str2num(get(handles.edit_zmin,'String')),...
    str2num(get(handles.edit_zmax,'String')),...
    hand)
axes(hand)
axis manual square 

set(hand,'nextplot','replacechildren'); 

for k = 0:360 
   view(k,str2num(parameters1{1,1}))
   frame = getframe(figgi);
   writeVideo(v,frame);
end

close(v);
close(figgi)
set(handles.output, 'pointer', 'arrow')


function edit_zmin_Callback(hObject, eventdata, handles)
% hObject    handle to edit_zmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_zmin as text
%        str2double(get(hObject,'String')) returns contents of edit_zmin as a double


% --- Executes during object creation, after setting all properties.
function edit_zmin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_zmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_zmax_Callback(hObject, eventdata, handles)
% hObject    handle to edit_zmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_zmax as text
%        str2double(get(hObject,'String')) returns contents of edit_zmax as a double


% --- Executes during object creation, after setting all properties.
function edit_zmax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_zmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton7.
function pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.output, 'pointer', 'watch')
drawnow;
ax = gca;
ax.ZTickMode  = 'auto';
axis 'auto z'
set(handles.edit_zmax,'String',' ');
set(handles.edit_zmin,'String',' ');
reziseaxes3D(handles.stats,handles.inda,str2num(get(handles.edit_xmin,'String')),...
    str2num(get(handles.edit_xmax,'String')),...
    str2num(get(handles.edit_ymin,'String')),...
    str2num(get(handles.edit_ymax,'String')),...
    str2num(get(handles.edit_zmin,'String')),...
    str2num(get(handles.edit_zmax,'String')),...
    handles.axes3d)
set(handles.output, 'pointer', 'arrow')


function edit_ymin_Callback(hObject, eventdata, handles)
% hObject    handle to edit_ymin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_ymin as text
%        str2double(get(hObject,'String')) returns contents of edit_ymin as a double


% --- Executes during object creation, after setting all properties.
function edit_ymin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_ymin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_ymax_Callback(hObject, eventdata, handles)
% hObject    handle to edit_ymax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_ymax as text
%        str2double(get(hObject,'String')) returns contents of edit_ymax as a double


% --- Executes during object creation, after setting all properties.
function edit_ymax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_ymax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.output, 'pointer', 'watch')
drawnow;
ax = gca;
ax.YTickMode  = 'auto';
axis 'auto y'
set(handles.edit_ymax,'String',' ');
set(handles.edit_ymin,'String',' ');
reziseaxes3D(handles.stats,handles.inda,str2num(get(handles.edit_xmin,'String')),...
    str2num(get(handles.edit_xmax,'String')),...
    str2num(get(handles.edit_ymin,'String')),...
    str2num(get(handles.edit_ymax,'String')),...
    str2num(get(handles.edit_zmin,'String')),...
    str2num(get(handles.edit_zmax,'String')),...
    handles.axes3d)
set(handles.output, 'pointer', 'arrow')


function edit_xmin_Callback(hObject, eventdata, handles)
% hObject    handle to edit_xmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_xmin as text
%        str2double(get(hObject,'String')) returns contents of edit_xmin as a double


% --- Executes during object creation, after setting all properties.
function edit_xmin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_xmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_xmax_Callback(hObject, eventdata, handles)
% hObject    handle to edit_xmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_xmax as text
%        str2double(get(hObject,'String')) returns contents of edit_xmax as a double


% --- Executes during object creation, after setting all properties.
function edit_xmax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_xmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.output, 'pointer', 'watch')
drawnow;
ax = gca;
ax.XTickMode  = 'auto';
axis 'auto x'
set(handles.edit_xmax,'String',' ');
set(handles.edit_xmin,'String',' ');
reziseaxes3D(handles.stats,handles.inda,str2num(get(handles.edit_xmin,'String')),...
    str2num(get(handles.edit_xmax,'String')),...
    str2num(get(handles.edit_ymin,'String')),...
    str2num(get(handles.edit_ymax,'String')),...
    str2num(get(handles.edit_zmin,'String')),...
    str2num(get(handles.edit_zmax,'String')),...
    handles.axes3d)
set(handles.output, 'pointer', 'arrow')


% --- Executes on key press with focus on edit_xmin and none of its controls.
function edit_xmin_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_xmin (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.output, 'pointer', 'watch')
    drawnow;
    xmin = str2double(get(handles.edit_xmin,'String'));
    xmax = str2double(get(handles.edit_xmax,'String'));

    o = handles.stats;
    p = get(handles.popupmenu1,'Value');
    q = o(:,p);
    h = max(q);

    if isnan(xmin)
        xmin = [];
    end
    if isnan(xmax)
        xmax = [];
    end

    if isempty(xmin) == 1 & isempty(xmax) == 1
    	ax =gca;
    	ax.XTickMode  = 'auto';
    elseif isempty(xmin) == 1 & strcmp(xmax,' ') == 0
        gca;
        xlim([0 xmax])
    elseif strcmp(xmin,' ') == 0 & isempty(xmax) == 1
        gca;
        xlim([xmin h])
    elseif strcmp(xmin,' ') == 0 & strcmp(xmax,' ') == 0
        gca;
        xlim([xmin xmax])
    end
end
reziseaxes3D(handles.stats,handles.inda,str2num(get(handles.edit_xmin,'String')),...
    str2num(get(handles.edit_xmax,'String')),...
    str2num(get(handles.edit_ymin,'String')),...
    str2num(get(handles.edit_ymax,'String')),...
    str2num(get(handles.edit_zmin,'String')),...
    str2num(get(handles.edit_zmax,'String')),...
    handles.axes3d)
set(handles.output, 'pointer', 'arrow')


% --- Executes on key press with focus on edit_xmax and none of its controls.
function edit_xmax_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_xmax (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    xmin = str2double(get(handles.edit_xmin,'String'));
    xmax = str2double(get(handles.edit_xmax,'String'));

    o = handles.stats;
    p = get(handles.popupmenu1,'Value');
    q = o(:,p);
    h = max(q);

    if isnan(xmin)
        xmin = [];
    end
    if isnan(xmax)
        xmax = [];
    end

    if isempty(xmin) == 1 & isempty(xmax) == 1
    	ax =gca;
    	ax.XTickMode  = 'auto';
    elseif isempty(xmin) == 1 & strcmp(xmax,' ') == 0
        gca;
        xlim([0 xmax])
    elseif strcmp(xmin,' ') == 0 & isempty(xmax) == 1
        gca;
        xlim([xmin h])
    elseif strcmp(xmin,' ') == 0 & strcmp(xmax,' ') == 0
        gca;
        xlim([xmin xmax])
    end
end
reziseaxes3D(handles.stats,handles.inda,str2num(get(handles.edit_xmin,'String')),...
    str2num(get(handles.edit_xmax,'String')),...
    str2num(get(handles.edit_ymin,'String')),...
    str2num(get(handles.edit_ymax,'String')),...
    str2num(get(handles.edit_zmin,'String')),...
    str2num(get(handles.edit_zmax,'String')),...
    handles.axes3d)
set(handles.figure1, 'pointer', 'arrow')


% --- Executes on key press with focus on edit_ymin and none of its controls.
function edit_ymin_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_ymin (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    ymin = str2double(get(handles.edit_ymin,'String'));
    ymax = str2double(get(handles.edit_ymax,'String'));

    o = handles.stats;
    p = get(handles.popupmenu2,'Value');
    q = o(:,p);
    h = max(q);

    if isnan(ymin)
        ymin = [];
    end
    if isnan(ymax)
        ymax = [];
    end

    if isempty(ymin) == 1 & isempty(ymax) == 1
        ax = gca;
    	ax.YTickMode  = 'auto';
    elseif isempty(ymin) == 1 & strcmp(ymax,' ') == 0
        gca;
        ylim([0 ymax])
    elseif strcmp(ymin,' ') == 0 & isempty(ymax) == 1
        gca;
        ylim([ymin h])
    elseif strcmp(ymin,' ') == 0 & strcmp(ymax,' ') == 0
        gca;
        ylim([ymin ymax])
    end
end
reziseaxes3D(handles.stats,handles.inda,str2num(get(handles.edit_xmin,'String')),...
    str2num(get(handles.edit_xmax,'String')),...
    str2num(get(handles.edit_ymin,'String')),...
    str2num(get(handles.edit_ymax,'String')),...
    str2num(get(handles.edit_zmin,'String')),...
    str2num(get(handles.edit_zmax,'String')),...
    handles.axes3d)
set(handles.figure1, 'pointer', 'arrow')

% --- Executes on key press with focus on edit_ymax and none of its controls.
function edit_ymax_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_ymax (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    ymin = str2double(get(handles.edit_ymin,'String'));
    ymax = str2double(get(handles.edit_ymax,'String'));

    o = handles.stats;
    p = get(handles.popupmenu2,'Value');
    q = o(:,p);
    h = max(q);

    if isnan(ymin)
        ymin = [];
    end
    if isnan(ymax)
        ymax = [];
    end

    if isempty(ymin) == 1 & isempty(ymax) == 1
        ax = gca;
    	ax.YTickMode  = 'auto';
    elseif isempty(ymin) == 1 & strcmp(ymax,' ') == 0
        gca;
        ylim([0 ymax])
    elseif strcmp(ymin,' ') == 0 & isempty(ymax) == 1
        gca;
        ylim([ymin h])
    elseif strcmp(ymin,' ') == 0 & strcmp(ymax,' ') == 0
        gca;
        ylim([ymin ymax])
    end
end
reziseaxes3D(handles.stats,handles.inda,str2num(get(handles.edit_xmin,'String')),...
    str2num(get(handles.edit_xmax,'String')),...
    str2num(get(handles.edit_ymin,'String')),...
    str2num(get(handles.edit_ymax,'String')),...
    str2num(get(handles.edit_zmin,'String')),...
    str2num(get(handles.edit_zmax,'String')),...
    handles.axes3d)
set(handles.figure1, 'pointer', 'arrow')

% --- Executes on key press with focus on edit_zmin and none of its controls.
function edit_zmin_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_zmin (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    zmin = str2double(get(handles.edit_zmin,'String'));
    zmax = str2double(get(handles.edit_zmax,'String'));

    o = handles.stats;
    p = get(handles.popupmenu3,'Value');
    q = o(:,p);
    h = max(q);

    if isnan(zmin)
        zmin = [];
    end
    if isnan(zmax)
        zmax = [];
    end

    if isempty(zmin) == 1 & isempty(zmax) == 1
        ax = gca;
    	ax.ZTickMode  = 'auto';
    elseif isempty(zmin) == 1 & strcmp(zmax,' ') == 0
        gca;
        zlim([0 zmax])
    elseif strcmp(zmin,' ') == 0 & isempty(zmax) == 1
        gca;
        zlim([zmin h])
    elseif strcmp(zmin,' ') == 0 & strcmp(zmax,' ') == 0
        gca;
        zlim([zmin zmax])
    end
end
reziseaxes3D(handles.stats,handles.inda,str2num(get(handles.edit_xmin,'String')),...
    str2num(get(handles.edit_xmax,'String')),...
    str2num(get(handles.edit_ymin,'String')),...
    str2num(get(handles.edit_ymax,'String')),...
    str2num(get(handles.edit_zmin,'String')),...
    str2num(get(handles.edit_zmax,'String')),...
    handles.axes3d)
set(handles.figure1, 'pointer', 'arrow')

% --- Executes on key press with focus on edit_zmax and none of its controls.
function edit_zmax_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_zmax (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    zmin = str2double(get(handles.edit_zmin,'String'));
    zmax = str2double(get(handles.edit_zmax,'String'));

    o = handles.stats;
    p = get(handles.popupmenu3,'Value');
    q = o(:,p);
    h = max(q);

    if isnan(zmin)
        zmin = [];
    end
    if isnan(zmax)
        zmax = [];
    end

    if isempty(zmin) == 1 & isempty(zmax) == 1
        ax = gca;
    	ax.ZTickMode  = 'auto';
    elseif isempty(zmin) == 1 & strcmp(zmax,' ') == 0
        gca;
        zlim([0 zmax])
    elseif strcmp(zmin,' ') == 0 & isempty(zmax) == 1
        gca;
        zlim([zmin h])
    elseif strcmp(zmin,' ') == 0 & strcmp(zmax,' ') == 0
        gca;
        zlim([zmin zmax])
    end
end
reziseaxes3D(handles.stats,handles.inda,str2num(get(handles.edit_xmin,'String')),...
    str2num(get(handles.edit_xmax,'String')),...
    str2num(get(handles.edit_ymin,'String')),...
    str2num(get(handles.edit_ymax,'String')),...
    str2num(get(handles.edit_zmin,'String')),...
    str2num(get(handles.edit_zmax,'String')),...
    handles.axes3d)
set(handles.figure1, 'pointer', 'arrow')


% --- Executes on button press in linearBtn.
function linearBtn_Callback(hObject, eventdata, handles)
% hObject    handle to linearBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.figure1, 'pointer', 'watch')
drawnow;
stats1 = handles.stats;
ind_a = get(handles.popupmenu1,'Value');
ind_b = get(handles.popupmenu2,'Value');
ind_c = get(handles.popupmenu3,'Value');
set(handles.cofactor3D,'enable','on')

if get(handles.ash_z,'Value') == 1
    lin_StatsZ = (str2double(get(handles.cofactor3D,'String')))...
        *(1/2)*(exp(stats1(:,ind_c)) - exp(-1.*(stats1(:,ind_c))));
        stats1(:,ind_c) = lin_StatsZ;
    set(handles.ash_z,'Value',1);
    
    % gets values of the tick boxes below the asinh/Linear button and thus
    % determines if one or both axes should be transformed
    if get(handles.lin_x,'Value') == 1 & get(handles.lin_y,'Value') == 0
        lin_StatsX = (str2double(get(handles.cofactor3D,'String')))...
        *(1/2)*(exp(stats1(:,ind_a)) - exp(-1.*(stats1(:,ind_a))));
        stats1(:,ind_a) = lin_StatsX;
        set(handles.ash_x,'Value',1);
        set(handles.ash_y,'Value',0);
    elseif get(handles.lin_x,'Value') == 0 & get(handles.lin_y,'Value') == 1
        lin_StatsY = (str2double(get(handles.cofactor3D,'String')))...
        *(1/2)*(exp(stats1(:,ind_b)) - exp(-1.*(stats1(:,ind_b))));
        stats1(:,ind_b) = lin_StatsY;
        set(handles.ash_x,'Value',0);
        set(handles.ash_y,'Value',1);
    elseif get(handles.lin_x,'Value') == 1 & get(handles.lin_y,'Value') == 1
        lin_StatsX = (str2double(get(handles.cofactor3D,'String')))...
        *(1/2)*(exp(stats1(:,ind_a)) - exp(-1.*(stats1(:,ind_a))));
        stats1(:,ind_a) = lin_StatsX;
        lin_StatsY = (str2double(get(handles.cofactor3D,'String')))...
        *(1/2)*(exp(stats1(:,ind_b)) - exp(-1.*(stats1(:,ind_b))));
        stats1(:,ind_b) = lin_StatsY;
        set(handles.ash_x,'Value',1);
        set(handles.ash_y,'Value',1);
     elseif get(handles.lin_x,'Value') == 0 & get(handles.lin_y,'Value') == 0
        set(handles.ash_x,'Value',0);
        set(handles.ash_y,'Value',0);
    end
else
    set(handles.ash_z,'Value',0);
    if get(handles.lin_x,'Value') == 1 & get(handles.lin_y,'Value') == 0
        lin_StatsX = (str2double(get(handles.cofactor3D,'String')))...
        *(1/2)*(exp(stats1(:,ind_a)) - exp(-1.*(stats1(:,ind_a))));
        stats1(:,ind_a) = lin_StatsX;
        set(handles.ash_x,'Value',1);
        set(handles.ash_y,'Value',0);
    elseif get(handles.lin_x,'Value') == 0 & get(handles.lin_y,'Value') == 1
        lin_StatsY = (str2double(get(handles.cofactor3D,'String')))...
        *(1/2)*(exp(stats1(:,ind_b)) - exp(-1.*(stats1(:,ind_b))));
        stats1(:,ind_b) = lin_StatsY;
        set(handles.ash_x,'Value',0);
        set(handles.ash_y,'Value',1);
    elseif get(handles.lin_x,'Value') == 1 & get(handles.lin_y,'Value') == 1
        lin_StatsX = (str2double(get(handles.cofactor3D,'String')))...
        *(1/2)*(exp(stats1(:,ind_a)) - exp(-1.*(stats1(:,ind_a))));
        stats1(:,ind_a) = lin_StatsX;
        lin_StatsY = (str2double(get(handles.cofactor3D,'String')))...
        *(1/2)*(exp(stats1(:,ind_b)) - exp(-1.*(stats1(:,ind_b))));
        stats1(:,ind_b) = lin_StatsY;
        set(handles.ash_x,'Value',1);
        set(handles.ash_y,'Value',1);
    end
end

set(handles.lin_x,'Value',0);
set(handles.lin_y,'Value',0);
set(handles.lin_z,'Value',0);
set(handles.lin_x,'Enable','off');
set(handles.lin_y,'Enable','off');
set(handles.lin_z,'Enable','off');
set(handles.linearBtn,'Enable','off');
set(handles.ash_x,'Enable','on');
set(handles.ash_y,'Enable','on');
set(handles.ash_z,'Enable','on');
set(handles.arcsinhBtn,'Enable','on');
handles.stats = stats1;
handles.BiExID = 0;
guidata(hObject, handles);

names = handles.names;
stats = handles.stats;
ind_a = get(handles.popupmenu1,'Value');
ind_b = get(handles.popupmenu2,'Value');
ind_c = get(handles.popupmenu3,'Value');
sizeSc = handles.sizeSc;


s = get(handles.popupmenu4,'Value');
horiz = get(handles.slider1,'Value');
vert = get(handles.slider2,'Value');

if s == 1
	axes(handles.axes3d)
	scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,[0 0 0],'filled');
    view(horiz,vert)
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
elseif s == 2;
	abin = str2double(get(handles.densitybin,'String'));
	edgesX = linspace(min(stats(:,ind_a)), max(stats(:,ind_a)), abin);
	edgesY = linspace(min(stats(:,ind_b)), max(stats(:,ind_b)), abin);
    edgesZ = linspace(min(stats(:,ind_c)), max(stats(:,ind_c)), abin);   
    
	[One,~] = size(stats(:,ind_a));
        
	[~,CountsX] = histc(stats(:,ind_a),edgesX);
	[~,CountsY] = histc(stats(:,ind_b),edgesY);
	[~,CountsZ] = histc(stats(:,ind_c),edgesZ);        
        
	CountsA = [CountsX,CountsY];
    CountsB = [CountsX,CountsZ];
    CountsC = [CountsZ,CountsY];
    
	DarrayA = accumarray(CountsA,1)./One;
	DarrayNormA = DarrayA./max(DarrayA(:));
    DarrayNormA = imgaussfilt(DarrayNormA,2);
    
    DarrayB = accumarray(CountsB,1)./One;
	DarrayNormB = DarrayB./max(DarrayB(:));
    DarrayNormB = imgaussfilt(DarrayNormB,2);
    
    DarrayC = accumarray(CountsC,1)./One;
	DarrayNormC = DarrayC./max(DarrayC(:));
    DarrayNormC = imgaussfilt(DarrayNormC,2);
        
	indA = sub2ind(size(DarrayNormA),CountsX,CountsY);
    indB = sub2ind(size(DarrayNormB),CountsX,CountsZ);
    indC = sub2ind(size(DarrayNormC),CountsZ,CountsY);
    
	col2A = DarrayNormA(indA);
    col2B = DarrayNormB(indB);
    col2C = DarrayNormC(indC);
    
    col2 = zeros(length(col2A),1);
    for i = 1:length(col2A)
        col2(i,1) = (col2A(i,1) + col2B(i,1) + col2C(i,1))/3 ;
    end
    
	U = sortrows([stats(:,ind_a), stats(:,ind_b), stats(:,ind_c),col2],4);
	col1 = U(:,4);
        
    axes(handles.axes3d)
    scatter3(U(:,1),U(:,2),U(:,3),sizeSc,col1,'filled')
    view(horiz,vert)
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
elseif s > 2
    stats_col = stats;
    cofact3D = str2double(get(handles.cofactor3D,'string'));
    if get(handles.colasinh3D,'Value') == 1 & handles.BiExID == 0 %color should be transformed, not data
        stats_col = log((stats_col/(str2double(get(handles.cofact_col3D,'String'))))...
            +sqrt((((stats_col/(str2double(get(handles.cofact_col3D,'String')))).^2)+1)));
        es = s-2;
        axes(handles.axes3d)
        scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
    elseif get(handles.colasinh3D,'Value') == 0 & handles.BiExID == 1 %color should not be transformed, but data
        
        if get(handles.ash_z,'Value') == 0
            stats_col(:,ind_c) = cofact3D*(1/2)*(exp(stats_col(:,ind_c)) - exp(-1.*(stats_col(:,ind_c))));
            if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            end
            es = s-2;
            axes(handles.axes3d)
            scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
        else
            if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            end
            es = s-2;
            axes(handles.axes3d)
            scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
        end
            
    elseif get(handles.colasinh3D,'Value') == 0 & handles.BiExID == 0 %color should not be transformed, neither data
        es = s-2;
        axes(handles.axes3d)
        scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
    elseif get(handles.colasinh3D,'Value') == 1 & handles.BiExID == 1 %color and data should be transformed
        
        if get(handles.ash_z,'Value') == 0
            stats_col(:,ind_c) = cofact3D*(1/2)*(exp(stats_col(:,ind_c)) - exp(-1.*(stats_col(:,ind_c))));
            if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            end
        else
            if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            end
        end
        
        stats_col = log((stats_col/str2double(get(handles.cofact_col3D,'string')))+sqrt((((stats_col/str2double(get(handles.cofact_col3D,'string'))).^2)+1)));
        es = s-2;
        axes(handles.axes3d)
        scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
    end
    %es = s-2;
    %axes(handles.axes3d)
    %scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats(:,es),'filled');
    view(horiz,vert)  
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
end
set(handles.edit_xmin,'String','');
set(handles.edit_xmax,'String','');
set(handles.edit_ymin,'String','');
set(handles.edit_ymax,'String','');
set(handles.edit_zmin,'String','');
set(handles.edit_zmax,'String','');
set(handles.figure1, 'pointer', 'arrow')
drawnow;
guidata(hObject, handles);

% --- Executes on button press in arcsinhBtn.
function arcsinhBtn_Callback(hObject, eventdata, handles)
% hObject    handle to arcsinhBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.figure1, 'pointer', 'watch')
drawnow;
ash_x = get(handles.ash_x,'Value');
ash_y = get(handles.ash_y,'Value');
asinhZ = get(handles.ash_z,'Value');
stats1 = handles.stats;
ind_a = get(handles.popupmenu1,'Value');
ind_b = get(handles.popupmenu2,'Value');
ind_c = get(handles.popupmenu3,'Value');
names = handles.names;
set(handles.cofactor3D,'enable','off')

% gets values of the tick boxes below the asinh/Linear button and thus
% determines if one or both axes should be transformed
if asinhZ == 1
    BiEx_StatsZ = log((stats1(:,ind_c)/(str2double(get(handles.cofactor3D,'String'))))...
    +sqrt((((stats1(:,ind_c)/(str2double(get(handles.cofactor3D,'String')))).^2)+1)));
    stats1(:,ind_c) = BiEx_StatsZ;
    set(handles.lin_z,'Value',1);
    
    if ash_x == 1 & ash_y == 0
        BiEx_StatsX = log((stats1(:,ind_a)/(str2double(get(handles.cofactor3D,'String'))))...
        +sqrt((((stats1(:,ind_a)/(str2double(get(handles.cofactor3D,'String')))).^2)+1)));
        stats1(:,ind_a) = BiEx_StatsX;
        set(handles.lin_x,'Value',1);
        set(handles.lin_y,'Value',0);
    elseif ash_x == 0 & ash_y == 1
        BiEx_StatsY = log((stats1(:,ind_b)/(str2double(get(handles.cofactor3D,'String'))))...
        +sqrt((((stats1(:,ind_b)/(str2double(get(handles.cofactor3D,'String')))).^2)+1)));
        stats1(:,ind_b) = BiEx_StatsY;
        set(handles.lin_x,'Value',0);
        set(handles.lin_y,'Value',1);
    elseif ash_x == 1 & ash_y == 1
        BiEx_StatsX = log((stats1(:,ind_a)/(str2double(get(handles.cofactor3D,'String'))))...
        +sqrt((((stats1(:,ind_a)/(str2double(get(handles.cofactor3D,'String')))).^2)+1)));
        stats1(:,ind_a) = BiEx_StatsX;
        BiEx_StatsY = log((stats1(:,ind_b)/(str2double(get(handles.cofactor3D,'String'))))...
        +sqrt((((stats1(:,ind_b)/(str2double(get(handles.cofactor3D,'String')))).^2)+1)));
        stats1(:,ind_b) = BiEx_StatsY;
        set(handles.lin_x,'Value',1);
        set(handles.lin_y,'Value',1);
	elseif ash_x == 0 & ash_y == 0
        set(handles.lin_x,'Value',0);
        set(handles.lin_y,'Value',0);
    end
else
    set(handles.lin_z,'Value',0);
    
    if ash_x == 1 & ash_y == 0
        BiEx_StatsX = log((stats1(:,ind_a)/(str2double(get(handles.cofactor3D,'String'))))...
        +sqrt((((stats1(:,ind_a)/(str2double(get(handles.cofactor3D,'String')))).^2)+1)));
        stats1(:,ind_a) = BiEx_StatsX;
        set(handles.lin_x,'Value',1);
        set(handles.lin_y,'Value',0);
    elseif ash_x == 0 & ash_y == 1
        BiEx_StatsY = log((stats1(:,ind_b)/(str2double(get(handles.cofactor3D,'String'))))...
        +sqrt((((stats1(:,ind_b)/(str2double(get(handles.cofactor3D,'String')))).^2)+1)));
        stats1(:,ind_b) = BiEx_StatsY;
        set(handles.lin_x,'Value',0);
        set(handles.lin_y,'Value',1);
    elseif ash_x == 1 & ash_y == 1
        BiEx_StatsX = log((stats1(:,ind_a)/(str2double(get(handles.cofactor3D,'String'))))...
        +sqrt((((stats1(:,ind_a)/(str2double(get(handles.cofactor3D,'String')))).^2)+1)));
        stats1(:,ind_a) = BiEx_StatsX;
        BiEx_StatsY = log((stats1(:,ind_b)/(str2double(get(handles.cofactor3D,'String'))))...
        +sqrt((((stats1(:,ind_b)/(str2double(get(handles.cofactor3D,'String')))).^2)+1)));
        stats1(:,ind_b) = BiEx_StatsY;
        set(handles.lin_x,'Value',1);
        set(handles.lin_y,'Value',1);
    end
end

set(handles.lin_x,'Enable','off');
set(handles.lin_y,'Enable','off');
set(handles.lin_z,'Enable','off');
set(handles.linearBtn,'Enable','on');
set(handles.ash_x,'Enable','off');
set(handles.ash_y,'Enable','off');
set(handles.ash_z,'Enable','off');
set(handles.arcsinhBtn,'Enable','off'); 
handles.stats = stats1;
handles.BiExID = 1;
guidata(hObject, handles);

names = handles.names;
stats = handles.stats;
ind_a = get(handles.popupmenu1,'Value');
ind_b = get(handles.popupmenu2,'Value');
ind_c = get(handles.popupmenu3,'Value');
sizeSc = handles.sizeSc;

s = get(handles.popupmenu4,'Value');
horiz = get(handles.slider1,'Value');
vert = get(handles.slider2,'Value');

if s == 1
	axes(handles.axes3d)
	scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,[0 0 0],'filled');
    view(horiz,vert)
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
elseif s == 2;
	abin = str2double(get(handles.densitybin,'String'));
	edgesX = linspace(min(stats(:,ind_a)), max(stats(:,ind_a)), abin);
	edgesY = linspace(min(stats(:,ind_b)), max(stats(:,ind_b)), abin);
    edgesZ = linspace(min(stats(:,ind_c)), max(stats(:,ind_c)), abin);   
    
	[One,~] = size(stats(:,ind_a));
        
	[~,CountsX] = histc(stats(:,ind_a),edgesX);
	[~,CountsY] = histc(stats(:,ind_b),edgesY);
	[~,CountsZ] = histc(stats(:,ind_c),edgesZ);        
        
	CountsA = [CountsX,CountsY];
    CountsB = [CountsX,CountsZ];
    CountsC = [CountsZ,CountsY];
    
	DarrayA = accumarray(CountsA,1)./One;
	DarrayNormA = DarrayA./max(DarrayA(:));
    DarrayNormA = imgaussfilt(DarrayNormA,2);
    
    DarrayB = accumarray(CountsB,1)./One;
	DarrayNormB = DarrayB./max(DarrayB(:));
    DarrayNormB = imgaussfilt(DarrayNormB,2);
    
    DarrayC = accumarray(CountsC,1)./One;
	DarrayNormC = DarrayC./max(DarrayC(:));
    DarrayNormC = imgaussfilt(DarrayNormC,2);
        
	indA = sub2ind(size(DarrayNormA),CountsX,CountsY);
    indB = sub2ind(size(DarrayNormB),CountsX,CountsZ);
    indC = sub2ind(size(DarrayNormC),CountsZ,CountsY);
    
	col2A = DarrayNormA(indA);
    col2B = DarrayNormB(indB);
    col2C = DarrayNormC(indC);
    
    col2 = zeros(length(col2A),1);
    for i = 1:length(col2A)
        col2(i,1) = (col2A(i,1) + col2B(i,1) + col2C(i,1))/3 ;
    end
    
	U = sortrows([stats(:,ind_a), stats(:,ind_b), stats(:,ind_c),col2],4);
	col1 = U(:,4);
        
    axes(handles.axes3d)
    scatter3(U(:,1),U(:,2),U(:,3),sizeSc,col1,'filled')
    view(horiz,vert)
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
elseif s > 2
    stats_col = stats;
    cofact3D = str2double(get(handles.cofactor3D,'string'));
    if get(handles.colasinh3D,'Value') == 1 & handles.BiExID == 0 %color should be transformed, not data
        stats_col = log((stats_col/(str2double(get(handles.cofact_col3D,'String'))))...
            +sqrt((((stats_col/(str2double(get(handles.cofact_col3D,'String')))).^2)+1)));
        es = s-2;
        axes(handles.axes3d)
        scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
    elseif get(handles.colasinh3D,'Value') == 0 & handles.BiExID == 1 %color should not be transformed, but data
        
        if get(handles.ash_z,'Value') == 0
            stats_col(:,ind_c) = cofact3D*(1/2)*(exp(stats_col(:,ind_c)) - exp(-1.*(stats_col(:,ind_c))));
            if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            end
            es = s-2;
            axes(handles.axes3d)
            scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
        else
            if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            end
            es = s-2;
            axes(handles.axes3d)
            scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
        end
            
    elseif get(handles.colasinh3D,'Value') == 0 & handles.BiExID == 0 %color should not be transformed, neither data
        es = s-2;
        axes(handles.axes3d)
        scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
    elseif get(handles.colasinh3D,'Value') == 1 & handles.BiExID == 1 %color and data should be transformed
        
        if get(handles.ash_z,'Value') == 0
            stats_col(:,ind_c) = cofact3D*(1/2)*(exp(stats_col(:,ind_c)) - exp(-1.*(stats_col(:,ind_c))));
            if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            end
        else
            if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
            end
        end
        
        stats_col = log((stats_col/str2double(get(handles.cofact_col3D,'string')))+sqrt((((stats_col/str2double(get(handles.cofact_col3D,'string'))).^2)+1)));
        es = s-2;
        axes(handles.axes3d)
        scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
    end
    %es = s-2;
    %axes(handles.axes3d)
    %scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats(:,es),'filled');
    view(horiz,vert)  
    grid on
    h = xlabel(names(ind_a));
    h1= ylabel(names(ind_b));
    h2= zlabel(names(ind_c));
    set(h,'interpreter','none')
    set(h1,'interpreter','none')
    set(h2,'interpreter','none')
    axes(handles.axes3d)
end

set(handles.edit_xmin,'String','');
set(handles.edit_xmax,'String','');
set(handles.edit_ymin,'String','');
set(handles.edit_ymax,'String','');
set(handles.edit_zmin,'String','');
set(handles.edit_zmax,'String','');

set(handles.figure1, 'pointer', 'arrow')
guidata(hObject, handles);



% --- Executes on button press in lin_x.
function lin_x_Callback(hObject, eventdata, handles)
% hObject    handle to lin_x (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of lin_x


% --- Executes on button press in lin_y.
function lin_y_Callback(hObject, eventdata, handles)
% hObject    handle to lin_y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of lin_y


% --- Executes on button press in ash_x.
function ash_x_Callback(hObject, eventdata, handles)
% hObject    handle to ash_x (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ash_x


% --- Executes on button press in ash_y.
function ash_y_Callback(hObject, eventdata, handles)
% hObject    handle to ash_y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ash_y


% --- Executes on button press in lin_z.
function lin_z_Callback(hObject, eventdata, handles)
% hObject    handle to lin_z (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of lin_z


% --- Executes on button press in ash_z.
function ash_z_Callback(hObject, eventdata, handles)
% hObject    handle to ash_z (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ash_z



function edit_horiz_Callback(hObject, eventdata, handles)
% hObject    handle to edit_horiz (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_horiz as text
%        str2double(get(hObject,'String')) returns contents of edit_horiz as a double


% --- Executes during object creation, after setting all properties.
function edit_horiz_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_horiz (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_vert_Callback(hObject, eventdata, handles)
% hObject    handle to edit_vert (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_vert as text
%        str2double(get(hObject,'String')) returns contents of edit_vert as a double


% --- Executes during object creation, after setting all properties.
function edit_vert_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_vert (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on key press with focus on edit_horiz and none of its controls.
function edit_horiz_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_horiz (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    horiz = str2num(get(handles.edit_horiz,'String'));
    vert = get(handles.slider2,'Value');
    set(handles.slider1,'Value',(horiz+180));
    set(handles.edit_horiz,'String',num2str(horiz));
    set(handles.slider2,'Value',vert);
    set(handles.edit_vert,'String',num2str(vert));
    
    axes(handles.axes3d)
    view(horiz+180,vert)
    reziseaxes3D(handles.stats,handles.inda,str2num(get(handles.edit_xmin,'String')),...
        str2num(get(handles.edit_xmax,'String')),...
        str2num(get(handles.edit_ymin,'String')),...
        str2num(get(handles.edit_ymax,'String')),...
        str2num(get(handles.edit_zmin,'String')),...
        str2num(get(handles.edit_zmax,'String')),...
        handles.axes3d)
    set(handles.figure1, 'pointer', 'arrow')
end

% --- Executes on key press with focus on edit_vert and none of its controls.
function edit_vert_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_vert (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    horiz = str2num(get(handles.edit_horiz,'String'));
    vert = str2num(get(handles.edit_vert,'String'));
    set(handles.slider1,'Value',(horiz+180));
    set(handles.edit_horiz,'String',num2str(horiz));
    set(handles.slider2,'Value',vert);
    set(handles.edit_vert,'String',num2str(vert));
    
    axes(handles.axes3d)
    view(horiz+180,vert)
    reziseaxes3D(handles.stats,handles.inda,str2num(get(handles.edit_xmin,'String')),...
        str2num(get(handles.edit_xmax,'String')),...
        str2num(get(handles.edit_ymin,'String')),...
        str2num(get(handles.edit_ymax,'String')),...
        str2num(get(handles.edit_zmin,'String')),...
        str2num(get(handles.edit_zmax,'String')),...
        handles.axes3d)
    set(handles.figure1, 'pointer', 'arrow')
end


% --- Executes on button press in pushbutton11.
function pushbutton11_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.figure1, 'pointer', 'watch')
drawnow;
figs =  findobj('type','figure');

handi = findobj(figs(1,1),'type','axes');
figgi = figure();

copyobj(handi,figgi); %copies the object
colormap(jet)

hand = findobj(figgi,'type','axes');
set(hand,'position',[0.15 0.15 0.7 0.7],'units','normalized')
set(figgi, 'Units','normalized', 'OuterPosition',[0.3 0.2 0.3 0.5])
set(hand,'outerposition',[0 0 1 1],'units','normalized')
set(hand, 'LooseInset', [0,0,0,0]);
daspect([1,1,1]);
set(handles.figure1, 'pointer', 'arrow')


function cofact_col3D_Callback(hObject, eventdata, handles)
% hObject    handle to cofact_col3D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cofact_col3D as text
%        str2double(get(hObject,'String')) returns contents of cofact_col3D as a double


% --- Executes during object creation, after setting all properties.
function cofact_col3D_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cofact_col3D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in colasinh3D.
function colasinh3D_Callback(hObject, eventdata, handles)
% hObject    handle to colasinh3D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of colasinh3D
%if get(handles.popupmenu4,'value') > 2 & get(handles.colasinh3D,'value') == 1
if get(handles.popupmenu4,'value') > 2 
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    s = get(handles.popupmenu4,'Value');
    stats = handles.stats;
    names = handles.names;
    ind_a = get(handles.popupmenu1,'Value');
    ind_b = get(handles.popupmenu2,'Value');
    ind_c = get(handles.popupmenu3,'Value');
    sizeSc = handles.sizeSc;

    horiz = get(handles.slider1,'Value');
    vert = get(handles.slider2,'Value');
    cofact3D = str2double(get(handles.cofactor3D,'string'));
    cofact_col3D = str2double(get(handles.cofact_col3D,'string'));
    stats_col = stats;
    
    if get(handles.colasinh3D,'Value') == 1 & handles.BiExID == 0 %color should be transformed, not data
            stats_col = log((stats_col/(str2double(get(handles.cofact_col3D,'String'))))...
                +sqrt((((stats_col/(str2double(get(handles.cofact_col3D,'String')))).^2)+1)));
            es = s-2;
            axes(handles.axes3d)
            scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
        elseif get(handles.colasinh3D,'Value') == 0 & handles.BiExID == 1 %color should not be transformed, but data

            if get(handles.ash_z,'Value') == 0
                stats_col(:,ind_c) = cofact3D*(1/2)*(exp(stats_col(:,ind_c)) - exp(-1.*(stats_col(:,ind_c))));
                if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                    stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                    stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                    stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                    stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                end
                es = s-2;
                axes(handles.axes3d)
                scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
            else
                if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                    stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                    stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                    stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                    stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                end
                es = s-2;
                axes(handles.axes3d)
                scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
            end

        elseif get(handles.colasinh3D,'Value') == 0 & handles.BiExID == 0 %color should not be transformed, neither data
            es = s-2;
            axes(handles.axes3d)
            scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
        elseif get(handles.colasinh3D,'Value') == 1 & handles.BiExID == 1 %color and data should be transformed

            if get(handles.ash_z,'Value') == 0
                stats_col(:,ind_c) = cofact3D*(1/2)*(exp(stats_col(:,ind_c)) - exp(-1.*(stats_col(:,ind_c))));
                if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                    stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                    stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                    stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                    stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                end
            else
                if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                    stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                    stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                    stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                    stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                end
            end

            stats_col = log((stats_col/str2double(get(handles.cofact_col3D,'string')))+sqrt((((stats_col/str2double(get(handles.cofact_col3D,'string'))).^2)+1)));
            es = s-2;
            axes(handles.axes3d)
            scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
        end
        %es = s-2;
        %axes(handles.axes3d)
        %scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats(:,es),'filled');
        view(horiz,vert)  
        grid on
        h = xlabel(names(ind_a));
        h1= ylabel(names(ind_b));
        h2= zlabel(names(ind_c));
        set(h,'interpreter','none')
        set(h1,'interpreter','none')
        set(h2,'interpreter','none')
        axes(handles.axes3d)

    handles.sizeSc = sizeSc;

    reziseaxes3D(stats,ind_a,str2num(get(handles.edit_xmin,'String')),...
        str2num(get(handles.edit_xmax,'String')),...
        str2num(get(handles.edit_ymin,'String')),...
        str2num(get(handles.edit_ymax,'String')),...
        str2num(get(handles.edit_zmin,'String')),...
        str2num(get(handles.edit_zmax,'String')),...
        handles.axes3d)
    set(handles.figure1, 'pointer', 'arrow')
    guidata(hObject, handles);
end

% --- Executes on key press with focus on colasinh3D and none of its controls.
function colasinh3D_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to colasinh3D (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on key press with focus on cofact_col3D and none of its controls.
function cofact_col3D_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to cofact_col3D (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return') & get(handles.popupmenu4,'value') > 2 & get(handles.colasinh3D,'value') == 1
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    s = get(handles.popupmenu4,'Value');
    stats = handles.stats;
    names = handles.names;
    ind_a = get(handles.popupmenu1,'Value');
    ind_b = get(handles.popupmenu2,'Value');
    ind_c = get(handles.popupmenu3,'Value');
    sizeSc = handles.sizeSc;

    horiz = get(handles.slider1,'Value');
    vert = get(handles.slider2,'Value');
    cofact3D = str2double(get(handles.cofactor3D,'string'));
    cofact_col3D = str2double(get(handles.cofact_col3D,'string'));
    stats_col = stats;
    
    if get(handles.colasinh3D,'Value') == 1 & handles.BiExID == 0 %color should be transformed, not data
            stats_col = log((stats_col/(str2double(get(handles.cofact_col3D,'String'))))...
                +sqrt((((stats_col/(str2double(get(handles.cofact_col3D,'String')))).^2)+1)));
            es = s-2;
            axes(handles.axes3d)
            scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
        elseif get(handles.colasinh3D,'Value') == 0 & handles.BiExID == 1 %color should not be transformed, but data

            if get(handles.ash_z,'Value') == 0
                stats_col(:,ind_c) = cofact3D*(1/2)*(exp(stats_col(:,ind_c)) - exp(-1.*(stats_col(:,ind_c))));
                if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                    stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                    stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                    stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                    stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                end
                es = s-2;
                axes(handles.axes3d)
                scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
            else
                if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                    stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                    stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                    stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                    stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                end
                es = s-2;
                axes(handles.axes3d)
                scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
            end

        elseif get(handles.colasinh3D,'Value') == 0 & handles.BiExID == 0 %color should not be transformed, neither data
            es = s-2;
            axes(handles.axes3d)
            scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
        elseif get(handles.colasinh3D,'Value') == 1 & handles.BiExID == 1 %color and data should be transformed

            if get(handles.ash_z,'Value') == 0
                stats_col(:,ind_c) = cofact3D*(1/2)*(exp(stats_col(:,ind_c)) - exp(-1.*(stats_col(:,ind_c))));
                if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                    stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                    stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                    stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                    stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                end
            else
                if get(handles.ash_x,'Value') == 0 & get(handles.ash_y,'Value') == 1
                    stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 0    
                    stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                elseif get(handles.ash_x,'Value') == 1 & get(handles.ash_y,'Value') == 1
                    stats_col(:,ind_a) = cofact3D*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                    stats_col(:,ind_b) = cofact3D*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                end
            end

            stats_col = log((stats_col/str2double(get(handles.cofact_col3D,'string')))+sqrt((((stats_col/str2double(get(handles.cofact_col3D,'string'))).^2)+1)));
            es = s-2;
            axes(handles.axes3d)
            scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats_col(:,es),'filled');
        end
        %es = s-2;
        %axes(handles.axes3d)
        %scatter3(stats(:,ind_a),stats(:,ind_b),stats(:,ind_c),sizeSc,stats(:,es),'filled');
        view(horiz,vert)  
        grid on
        h = xlabel(names(ind_a));
        h1= ylabel(names(ind_b));
        h2= zlabel(names(ind_c));
        set(h,'interpreter','none')
        set(h1,'interpreter','none')
        set(h2,'interpreter','none')
        axes(handles.axes3d)

    handles.sizeSc = sizeSc;

    reziseaxes3D(stats,ind_a,str2num(get(handles.edit_xmin,'String')),...
        str2num(get(handles.edit_xmax,'String')),...
        str2num(get(handles.edit_ymin,'String')),...
        str2num(get(handles.edit_ymax,'String')),...
        str2num(get(handles.edit_zmin,'String')),...
        str2num(get(handles.edit_zmax,'String')),...
        handles.axes3d)
    set(handles.figure1, 'pointer', 'arrow')
    guidata(hObject, handles);
end



function cofactor3D_Callback(hObject, eventdata, handles)
% hObject    handle to cofactor3D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cofactor3D as text
%        str2double(get(hObject,'String')) returns contents of cofactor3D as a double


% --- Executes during object creation, after setting all properties.
function cofactor3D_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cofactor3D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function mincol_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cofactor3D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on key press with focus on cofact_col3D and none of its controls.
function mincol_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to cofact_col3D (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    if get(handles.popupmenu4,'value') > 2
        cmax = str2double(get(handles.maxcol,'String'));    
        cmin = str2double(get(handles.mincol,'String'));  
        if isnan(cmin)
            cmin = 0;
        end
        if isnan(cmax)
            cmax = 255;
        end
        axes(handles.axes3d)
        caxis([cmin cmax])  
    end
    set(handles.figure1, 'pointer', 'arrow')
end

function mincol_Callback(hObject, eventdata, handles)
% hObject    handle to cofactor3D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cofactor3D as text
%        str2double(get(hObject,'String')) returns contents of cofactor3D as a double

% --- Executes during object creation, after setting all properties.
function maxcol_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cofactor3D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on key press with focus on cofact_col3D and none of its controls.
function maxcol_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to cofact_col3D (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    if get(handles.popupmenu4,'value') > 2
        cmax = str2double(get(handles.maxcol,'String'));    
        cmin = str2double(get(handles.mincol,'String'));  
        if isnan(cmin)
            cmin = 0;
        end
        if isnan(cmax)
            cmax = 255;
        end
        axes(handles.axes3d)
        caxis([cmin cmax])  
    end
    set(handles.figure1, 'pointer', 'arrow')
end

function maxcol_Callback(hObject, eventdata, handles)
% hObject    handle to cofactor3D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cofactor3D as text
%        str2double(get(hObject,'String')) returns contents of cofactor3D as a double