% function that allows plotting within XIT
% for scatter, line, fill, histogram plots
% with or without gates
% gate data has to be retrieved in XIT main function
function XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,ax,abin,num_forperc,asinhX,asinhY...
    ,cofact,cofact_col,colasinh,BiExID)

stats_col = stats;

if isnan(xmin)
    xmin = [];
end
if isnan(xmax)
    xmax = [];
end
if isnan(ymin)
    ymin = [];
end
if isnan(ymax)
    ymax = [];
end
if isnan(xgate)
    xgate = [];
end
if isnan(ygate)
    ygate = [];
end

switch Sel
    case 'Scatter'
        if isempty(xgate) & isempty(ygate)
            if s == 1 & kCol == 0;
                 handl.statid = 0;
                 axes(ax)
                 scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,[0 0 0],'filled');
            elseif s == 2 & kCol == 0;
                handl.statid = 0;
              	edgesX = linspace(min(stats(:,ind_a)), max(stats(:,ind_a)), abin);
              	edgesY = linspace(min(stats(:,ind_b)), max(stats(:,ind_b)), abin);
        
             	[One,~] = size(stats(:,ind_a));
        
               	[~,CountsX] = histc(stats(:,ind_a),edgesX);
             	[~,CountsY] = histc(stats(:,ind_b),edgesY);
        
        
                Counts = [CountsX,CountsY];
              	Darray = accumarray(Counts,1)./One;
              	DarrayNorm = Darray./max(Darray(:));
                DarrayNorm = imgaussfilt(DarrayNorm,2);
        
              	ind = sub2ind(size(DarrayNorm),CountsX,CountsY);
        
              	col2 = DarrayNorm(ind);
              	U = sortrows([stats(:,ind_a), stats(:,ind_b), col2],3);
             	col1 = U(:,3); colormap(jet(4096));
        
             	axes(ax)
              	scatter(U(:,1),U(:,2),sizeSc,col1,'filled')
            elseif s > 2 & kCol == 0;
                handl.statid = 1;
                if colasinh == 1 & BiExID == 0 %color should be transformed, not data
                    stats_col = log((stats_col/cofact_col)+sqrt((((stats_col/cofact_col).^2)+1)));
                    es = s-2;
                    axes(ax)
                    scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,stats_col(:,es),'filled');
                    ch = colorbar('northoutside');
                    set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
                    %set(handles.text39,'String',['asinh_Cofactor ' get(handles.cofact_col,'String') ' ' stringi(s)]);
                elseif colasinh == 0 & BiExID == 1 %color should not be transformed, but data
                    if asinhX == 0 & asinhY == 1
                        stats_col(:,ind_a) = cofact*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                    elseif asinhX == 1 & asinhY == 0    
                        stats_col(:,ind_b) = cofact*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                    elseif asinhX == 1 & asinhY == 1
                        stats_col(:,ind_a) = cofact*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                        stats_col(:,ind_b) = cofact*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                    end
                    es = s-2;
                    axes(ax)
                    scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,stats_col(:,es),'filled');
                    ch = colorbar('northoutside');
                    set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
                    %set(handles.text39,'String',['linear ' stringi(s)]);
                elseif colasinh == 0 & BiExID == 0 %color should not be transformed, neither data
                    es = s-2;
                    axes(ax)
                    scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,stats_col(:,es),'filled');
                    ch = colorbar('northoutside');
                    set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
                    %set(handles.text39,'String',['linear ' stringi(s)]);
                elseif colasinh == 1 & BiExID == 1 %color and data should be transformed
                    if asinhX == 0 & asinhY == 1
                        stats_col(:,ind_a) = cofact*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                    elseif asinhX == 1 & asinhY == 0    
                        stats_col(:,ind_b) = cofact*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                    elseif asinhX == 1 & asinhY == 1
                        stats_col(:,ind_a) = cofact*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                        stats_col(:,ind_b) = cofact*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                    end
                    stats_col = log((stats_col/cofact_col)+sqrt((((stats_col/cofact_col).^2)+1)));
                    es = s-2;
                    axes(ax)
                    scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,stats_col(:,es),'filled');
                    ch = colorbar('northoutside');
                    set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
                    %set(handles.text39,'String',['asinh_Cofactor ' get(handles.cofact_col,'String') ' ' stringi(s)]);
                end
            elseif length(kCol) > 1;
                handl.statid = 0;
                axes(ax)
                scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,kCol,'filled');   
            end
            if isempty(xmin) &  isempty(xmax)
            	ax.XTickMode  = 'auto';
            elseif isempty(xmin) & strcmp(xmax,' ') == 0
                ax.XLim = ([0 xmax]);
            elseif strcmp(xmin,' ') == 0 & isempty(xmax)
	            ax.XLim = ([xmin max(stats(:,ind_a))]);
            elseif strcmp(xmin,' ') == 0 & strcmp(xmax,' ') == 0
	            ax.XLim = ([xmin xmax]);
            end

            if isempty(ymin) & isempty(ymax)
                ax.YTickMode  = 'auto';
            elseif isempty(ymin) & strcmp(ymax,' ') == 0
                ax.YLim = ([0 ymax]);
            elseif strcmp(ymin,' ') == 0 & isempty(ymax)
            	ax.YLim = ([ymin max(stats(:,ind_a))]);
            elseif strcmp(ymin,' ') == 0 & strcmp(ymax,' ') == 0
            	ax.YLim = ([ymin ymax]);
            end
            
            handl.ID = 0;
            setappdata(XIT,'handl',handl)
            
        elseif ~isempty(xgate) & isempty(ygate)
            if s == 1 & kCol == 0;
                handl.statid = 0;
                axes(ax)
                scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,[0 0 0],'filled');
            elseif s == 2 & kCol == 0;
                handl.statid = 0;
              	edgesX = linspace(min(stats(:,ind_a)), max(stats(:,ind_a)), abin);
              	edgesY = linspace(min(stats(:,ind_b)), max(stats(:,ind_b)), abin);
        
             	[One,~] = size(stats(:,ind_a));
        
               	[~,CountsX] = histc(stats(:,ind_a),edgesX);
             	[~,CountsY] = histc(stats(:,ind_b),edgesY);
        
        
                Counts = [CountsX,CountsY];
              	Darray = accumarray(Counts,1)./One;
              	DarrayNorm = Darray./max(Darray(:));
                DarrayNorm = imgaussfilt(DarrayNorm,2);
        
              	ind = sub2ind(size(DarrayNorm),CountsX,CountsY);
        
              	col2 = DarrayNorm(ind);
              	U = sortrows([stats(:,ind_a), stats(:,ind_b), col2],3);
             	col1 = U(:,3); colormap(jet(4096));
        
             	axes(ax)
              	scatter(U(:,1),U(:,2),sizeSc,col1,'filled')
            elseif s > 2 & kCol == 0;
               handl.statid = 1;
                if colasinh == 1 & BiExID == 0 %color should be transformed, not data
                    stats_col = log((stats_col/cofact_col)+sqrt((((stats_col/cofact_col).^2)+1)));
                    es = s-2;
                    axes(ax)
                    scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,stats_col(:,es),'filled');
                    ch = colorbar('northoutside');
                    set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
                    %set(handles.text39,'String',['asinh_Cofactor ' get(handles.cofact_col,'String') ' ' stringi(s)]);
                elseif colasinh == 0 & BiExID == 1 %color should not be transformed, but data
                    if asinhX == 0 & asinhY == 1
                        stats_col(:,ind_a) = cofact*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                    elseif asinhX == 1 & asinhY == 0    
                        stats_col(:,ind_b) = cofact*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                    elseif asinhX == 1 & asinhY == 1
                        stats_col(:,ind_a) = cofact*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                        stats_col(:,ind_b) = cofact*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                    end
                    es = s-2;
                    axes(ax)
                    scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,stats_col(:,es),'filled');
                    ch = colorbar('northoutside');
                    set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
                    %set(handles.text39,'String',['linear ' stringi(s)]);
                elseif colasinh == 0 & BiExID == 0 %color should not be transformed, neither data
                    es = s-2;
                    axes(ax)
                    scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,stats_col(:,es),'filled');
                    ch = colorbar('northoutside');
                    set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
                    %set(handles.text39,'String',['linear ' stringi(s)]);
                elseif colasinh == 1 & BiExID == 1 %color and data should be transformed
                    if asinhX == 0 & asinhY == 1
                        stats_col(:,ind_a) = cofact*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                    elseif asinhX == 1 & asinhY == 0    
                        stats_col(:,ind_b) = cofact*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                    elseif asinhX == 1 & asinhY == 1
                        stats_col(:,ind_a) = cofact*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                        stats_col(:,ind_b) = cofact*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                    end
                    stats_col = log((stats_col/cofact_col)+sqrt((((stats_col/cofact_col).^2)+1)));
                    es = s-2;
                    axes(ax)
                    scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,stats_col(:,es),'filled');
                    ch = colorbar('northoutside');
                    set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
                    %set(handles.text39,'String',['asinh_Cofactor ' get(handles.cofact_col,'String') ' ' stringi(s)]);
                end
            elseif length(kCol) > 1;
                handl.statid = 0;
                axes(ax)
                scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,kCol,'filled');   
            end
            
            hold on
            plot([xgate xgate],[min(stats(:,ind_b)),max(stats(:,ind_b))], 'r-')
            hold on
            belowX = find(stats(:,ind_a) <= xgate);
            StatsMatrix2 = stats(belowX,:);
            percbelow = size(StatsMatrix2,1)/size(stats,1)*100;
            text(0.05, 0.95,['\color{red}' '\fontsize{13}' num2str(percbelow, '%.2f') '%'],'Units','normalized')
        
            aboveX = find(stats(:,ind_a) > xgate);
            StatsMatrix3 = stats(aboveX,:);
            percabove = size(StatsMatrix3,1)/size(stats,1)*100;
            text(0.85, 0.95,['\color{red}' '\fontsize{13}' num2str(percabove, '%.2f') '%'],'Units','normalized')
            hold off
            
            if isempty(xmin) &  isempty(xmax)
            	ax.XTickMode  = 'auto';
            elseif isempty(xmin) & strcmp(xmax,' ') == 0
                ax.XLim = ([0 xmax]);
            elseif strcmp(xmin,' ') == 0 & isempty(xmax)
	            ax.XLim = ([xmin max(stats(:,ind_a))]);
            elseif strcmp(xmin,' ') == 0 & strcmp(xmax,' ') == 0
	            ax.XLim = ([xmin xmax]);
            end

            if isempty(ymin) & isempty(ymax)
                ax.YTickMode  = 'auto';
            elseif isempty(ymin) & strcmp(ymax,' ') == 0
                ax.YLim = ([0 ymax]);
            elseif strcmp(ymin,' ') == 0 & isempty(ymax)
            	ax.YLim = ([ymin max(stats(:,ind_a))]);
            elseif strcmp(ymin,' ') == 0 & strcmp(ymax,' ') == 0
            	ax.YLim = ([ymin ymax]);
            end
            
            handl.percofallaX = size(StatsMatrix3,1)/num_forperc*100;
            handl.percofallbX = size(StatsMatrix2,1)/num_forperc*100;
            handl.StatsMatrix2 = StatsMatrix2;
            handl.StatsMatrix3 = StatsMatrix3;
            handl.percbelowX = percbelow;
            handl.percaboveX = percabove;
            handl.numbelowX = size(StatsMatrix2,1);
            handl.numaboveX = size(StatsMatrix3,1);
            handl.ID = 1;
            setappdata(XIT,'handl',handl)
            
        elseif isempty(xgate) & ~isempty(ygate)
            if s == 1 & kCol == 0;
                handl.statid = 0;
                axes(ax)
                scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,[0 0 0],'filled');
            elseif s == 2 & kCol == 0;
                handl.statid = 0;
              	edgesX = linspace(min(stats(:,ind_a)), max(stats(:,ind_a)), abin);
              	edgesY = linspace(min(stats(:,ind_b)), max(stats(:,ind_b)), abin);
        
             	[One,~] = size(stats(:,ind_a));
        
               	[~,CountsX] = histc(stats(:,ind_a),edgesX);
             	[~,CountsY] = histc(stats(:,ind_b),edgesY);
        
        
                Counts = [CountsX,CountsY];
              	Darray = accumarray(Counts,1)./One;
              	DarrayNorm = Darray./max(Darray(:)); DarrayNorm = imgaussfilt(DarrayNorm,2);
        
              	ind = sub2ind(size(DarrayNorm),CountsX,CountsY);
        
              	col2 = DarrayNorm(ind);
              	U = sortrows([stats(:,ind_a), stats(:,ind_b), col2],3);
             	col1 = U(:,3); colormap(jet(4096));
        
             	axes(ax)
              	scatter(U(:,1),U(:,2),sizeSc,col1,'filled')
            elseif s > 2 & kCol == 0;
                handl.statid = 1;
                if colasinh == 1 & BiExID == 0 %color should be transformed, not data
                    stats_col = log((stats_col/cofact_col)+sqrt((((stats_col/cofact_col).^2)+1)));
                    es = s-2;
                    axes(ax)
                    scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,stats_col(:,es),'filled');
                    ch = colorbar('northoutside');
                    set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
                    %set(handles.text39,'String',['asinh_Cofactor ' get(handles.cofact_col,'String') ' ' stringi(s)]);
                elseif colasinh == 0 & BiExID == 1 %color should not be transformed, but data
                    if asinhX == 0 & asinhY == 1
                        stats_col(:,ind_a) = cofact*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                    elseif asinhX == 1 & asinhY == 0    
                        stats_col(:,ind_b) = cofact*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                    elseif asinhX == 1 & asinhY == 1
                        stats_col(:,ind_a) = cofact*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                        stats_col(:,ind_b) = cofact*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                    end
                    es = s-2;
                    axes(ax)
                    scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,stats_col(:,es),'filled');
                    ch = colorbar('northoutside');
                    set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
                    %set(handles.text39,'String',['linear ' stringi(s)]);
                elseif colasinh == 0 & BiExID == 0 %color should not be transformed, neither data
                    es = s-2;
                    axes(ax)
                    scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,stats_col(:,es),'filled');
                    ch = colorbar('northoutside');
                    set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
                    %set(handles.text39,'String',['linear ' stringi(s)]);
                elseif colasinh == 1 & BiExID == 1 %color and data should be transformed
                    if asinhX == 0 & asinhY == 1
                        stats_col(:,ind_a) = cofact*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                    elseif asinhX == 1 & asinhY == 0    
                        stats_col(:,ind_b) = cofact*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                    elseif asinhX == 1 & asinhY == 1
                        stats_col(:,ind_a) = cofact*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                        stats_col(:,ind_b) = cofact*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                    end
                    stats_col = log((stats_col/cofact_col)+sqrt((((stats_col/cofact_col).^2)+1)));
                    es = s-2;
                    axes(ax)
                    scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,stats_col(:,es),'filled');
                    ch = colorbar('northoutside');
                    set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
                    %set(handles.text39,'String',['asinh_Cofactor ' get(handles.cofact_col,'String') ' ' stringi(s)]);
                end
            elseif length(kCol) > 1;
                handl.statid = 0;
                axes(ax)
                scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,kCol,'filled');   
            end
            
            hold on
            plot([min(stats(:,ind_a)),max(stats(:,ind_a))],[ygate ygate], 'r-')
            hold on
            belowY = find(stats(:,ind_b) <= ygate);
            StatsMatrix2 = stats(belowY,:);
            percbelow = size(StatsMatrix2,1)/size(stats,1)*100;
            text(0.85, 0.05,['\color{red}' '\fontsize{13}' num2str(percbelow, '%.2f') '%'],'Units','normalized')
        
            aboveY = find(stats(:,ind_b) > ygate);
            StatsMatrix3 = stats(aboveY,:);
            percabove = size(StatsMatrix3,1)/size(stats,1)*100;
            text(0.85, 0.95,['\color{red}' '\fontsize{13}' num2str(percabove, '%.2f') '%'],'Units','normalized')
            hold off

            if isempty(xmin) &  isempty(xmax)
            	ax.XTickMode  = 'auto';
            elseif isempty(xmin) & strcmp(xmax,' ') == 0
                ax.XLim = ([0 xmax]);
            elseif strcmp(xmin,' ') == 0 & isempty(xmax)
	            ax.XLim = ([xmin max(stats(:,ind_a))]);
            elseif strcmp(xmin,' ') == 0 & strcmp(xmax,' ') == 0
	            ax.XLim = ([xmin xmax]);
            end

            if isempty(ymin) & isempty(ymax)
                ax.YTickMode  = 'auto';
            elseif isempty(ymin) & strcmp(ymax,' ') == 0
                ax.YLim = ([0 ymax]);
            elseif strcmp(ymin,' ') == 0 & isempty(ymax)
            	ax.YLim = ([ymin max(stats(:,ind_a))]);
            elseif strcmp(ymin,' ') == 0 & strcmp(ymax,' ') == 0
            	ax.YLim = ([ymin ymax]);
            end
            
            handl.percofallaY = size(StatsMatrix3,1)/num_forperc*100;
            handl.percofallbY = size(StatsMatrix2,1)/num_forperc*100;
            handl.StatsMatrix2 = StatsMatrix2;
            handl.StatsMatrix3 = StatsMatrix3;
            handl.percbelowY = percbelow;
            handl.percaboveY = percabove;
            handl.numbelowY = size(StatsMatrix2,1);
            handl.numaboveY = size(StatsMatrix3,1);
            handl.ID = 3;
            setappdata(XIT,'handl',handl)
            
        elseif ~isempty(xgate) & ~isempty(ygate)
            if s == 1 & kCol == 0;
                handl.statid = 0;
                axes(ax)
                scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,[0 0 0],'filled');
            elseif s == 2 & kCol == 0;
                handl.statid = 0;
              	edgesX = linspace(min(stats(:,ind_a)), max(stats(:,ind_a)), abin);
              	edgesY = linspace(min(stats(:,ind_b)), max(stats(:,ind_b)), abin);
        
             	[One,~] = size(stats(:,ind_a));
        
               	[~,CountsX] = histc(stats(:,ind_a),edgesX);
             	[~,CountsY] = histc(stats(:,ind_b),edgesY);
        
        
                Counts = [CountsX,CountsY];
              	Darray = accumarray(Counts,1)./One;
              	DarrayNorm = Darray./max(Darray(:)); DarrayNorm = imgaussfilt(DarrayNorm,2);
        
              	ind = sub2ind(size(DarrayNorm),CountsX,CountsY);
        
              	col2 = DarrayNorm(ind);
              	U = sortrows([stats(:,ind_a), stats(:,ind_b), col2],3);
             	col1 = U(:,3); colormap(jet(4096));
        
             	axes(ax)
              	scatter(U(:,1),U(:,2),sizeSc,col1,'filled')
            elseif s > 2 & kCol == 0;
                handl.statid = 1;
                if colasinh == 1 & BiExID == 0 %color should be transformed, not data
                    stats_col = log((stats_col/cofact_col)+sqrt((((stats_col/cofact_col).^2)+1)));
                    es = s-2;
                    axes(ax)
                    scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,stats_col(:,es),'filled');
                    ch = colorbar('northoutside');
                    set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
                    %set(handles.text39,'String',['asinh_Cofactor ' get(handles.cofact_col,'String') ' ' stringi(s)]);
                elseif colasinh == 0 & BiExID == 1 %color should not be transformed, but data
                    if asinhX == 0 & asinhY == 1
                        stats_col(:,ind_a) = cofact*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                    elseif asinhX == 1 & asinhY == 0    
                        stats_col(:,ind_b) = cofact*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                    elseif asinhX == 1 & asinhY == 1
                        stats_col(:,ind_a) = cofact*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                        stats_col(:,ind_b) = cofact*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                    end
                    es = s-2;
                    axes(ax)
                    scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,stats_col(:,es),'filled');
                    ch = colorbar('northoutside');
                    set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
                    %set(handles.text39,'String',['linear ' stringi(s)]);
                elseif colasinh == 0 & BiExID == 0 %color should not be transformed, neither data
                    es = s-2;
                    axes(ax)
                    scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,stats_col(:,es),'filled');
                    ch = colorbar('northoutside');
                    set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
                    %set(handles.text39,'String',['linear ' stringi(s)]);
                elseif colasinh == 1 & BiExID == 1 %color and data should be transformed
                    if asinhX == 0 & asinhY == 1
                        stats_col(:,ind_a) = cofact*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                    elseif asinhX == 1 & asinhY == 0    
                        stats_col(:,ind_b) = cofact*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                    elseif asinhX == 1 & asinhY == 1
                        stats_col(:,ind_a) = cofact*(1/2)*(exp(stats_col(:,ind_a)) - exp(-1.*(stats_col(:,ind_a))));
                        stats_col(:,ind_b) = cofact*(1/2)*(exp(stats_col(:,ind_b)) - exp(-1.*(stats_col(:,ind_b))));
                    end
                    stats_col = log((stats_col/cofact_col)+sqrt((((stats_col/cofact_col).^2)+1)));
                    es = s-2;
                    axes(ax)
                    scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,stats_col(:,es),'filled');
                    ch = colorbar('northoutside');
                    set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
                    %set(handles.text39,'String',['asinh_Cofactor ' get(handles.cofact_col,'String') ' ' stringi(s)]);
                end
            elseif length(kCol) > 1;
                handl.statid = 0;
                axes(ax)
                scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,kCol,'filled');   
            end

            hold on
            plot([xgate xgate],[min(stats(:,ind_b)),max(stats(:,ind_b))], 'r-')
            hold on
            plot([min(stats(:,ind_a)),max(stats(:,ind_a))],[ygate ygate], 'r-')
        
            Q1 = find(stats(:,ind_a) <= xgate & stats(:,ind_b) <= ygate);
            StatsMatrixQ1 = stats(Q1,:);
            percQ1 = size(StatsMatrixQ1,1)/size(stats,1)*100;
            percofallQ1 = size(StatsMatrixQ1,1)/num_forperc*100;
            text(0.05, 0.05,['\color{red}' '\fontsize{13}' 'Q1 ' num2str(percQ1, '%.2f') '%'],'Units','normalized')
        
            Q2 = find(stats(:,ind_a) <= xgate & stats(:,ind_b) > ygate);
            StatsMatrixQ2 = stats(Q2,:);
            percQ2 = size(StatsMatrixQ2,1)/size(stats,1)*100;
            percofallQ2 = size(StatsMatrixQ2,1)/num_forperc*100;
            text(0.05, 0.95,['\color{red}' '\fontsize{13}' 'Q2 ' num2str(percQ2, '%.2f') '%'],'Units','normalized')
        
            Q3 = find(stats(:,ind_a) > xgate & stats(:,ind_b) > ygate);
            StatsMatrixQ3 = stats(Q3,:);
            percQ3 = size(StatsMatrixQ3,1)/size(stats,1)*100;
            percofallQ3 = size(StatsMatrixQ3,1)/num_forperc*100;
            text(0.8, 0.95,['\color{red}' '\fontsize{13}' 'Q3 ' num2str(percQ3, '%.2f') '%'],'Units','normalized')
        
            Q4 = find(stats(:,ind_a) > xgate & stats(:,ind_b) <= ygate);
            StatsMatrixQ4 = stats(Q4,:);
            percQ4 = size(StatsMatrixQ4,1)/size(stats,1)*100;
            percofallQ4 = size(StatsMatrixQ4,1)/num_forperc*100;
            text(0.8, 0.05,['\color{red}' '\fontsize{13}' 'Q4 ' num2str(percQ4, '%.2f') '%'],'Units','normalized')
            hold off
            
            if isempty(xmin) &  isempty(xmax)
            	ax.XTickMode  = 'auto';
            elseif isempty(xmin) & strcmp(xmax,' ') == 0
                ax.XLim = ([0 xmax]);
            elseif strcmp(xmin,' ') == 0 & isempty(xmax)
	            ax.XLim = ([xmin max(stats(:,ind_a))]);
            elseif strcmp(xmin,' ') == 0 & strcmp(xmax,' ') == 0
	            ax.XLim = ([xmin xmax]);
            end

            if isempty(ymin) & isempty(ymax)
                ax.YTickMode  = 'auto';
            elseif isempty(ymin) & strcmp(ymax,' ') == 0
                ax.YLim = ([0 ymax]);
            elseif strcmp(ymin,' ') == 0 & isempty(ymax)
            	ax.YLim = ([ymin max(stats(:,ind_a))]);
            elseif strcmp(ymin,' ') == 0 & strcmp(ymax,' ') == 0
            	ax.YLim = ([ymin ymax]);
            end
            
            handl.StatsMatrixQ1 = StatsMatrixQ1;
            handl.StatsMatrixQ2 = StatsMatrixQ2;
            handl.StatsMatrixQ3 = StatsMatrixQ3;
            handl.StatsMatrixQ4 = StatsMatrixQ4;
            handl.percQ1 = percQ1;
            handl.percQ2 = percQ2;
            handl.percQ3 = percQ3;
            handl.percQ4 = percQ4;
            handl.percofallQ1 = percofallQ1;
            handl.percofallQ2 = percofallQ2;
            handl.percofallQ3 = percofallQ3;
            handl.percofallQ4 = percofallQ4;
            handl.numQ1 = size(StatsMatrixQ1,1);
            handl.numQ2 = size(StatsMatrixQ2,1);
            handl.numQ3 = size(StatsMatrixQ3,1);
            handl.numQ4 = size(StatsMatrixQ4,1);
            handl.ID = 2;
            setappdata(XIT,'handl',handl)
        end

    case 'Histogram'
        handl.statid = 0; 
        if isempty(xgate)
            axes(ax)
            hist(stats(:,ind_a),bins);
            
            if isempty(xmin) &  isempty(xmax)
            	ax.XTickMode  = 'auto';
            elseif isempty(xmin) & strcmp(xmax,' ') == 0
                ax.XLim = ([0 xmax]);
            elseif strcmp(xmin,' ') == 0 & isempty(xmax)
	            ax.XLim = ([xmin max(stats(:,ind_a))]);
            elseif strcmp(xmin,' ') == 0 & strcmp(xmax,' ') == 0
	            ax.XLim = ([xmin xmax]);
            end

            if isempty(ymin) & isempty(ymax)
                ax.YTickMode  = 'auto';
            elseif isempty(ymin) & strcmp(ymax,' ') == 0
                ax.YLim = ([0 ymax]);
            elseif strcmp(ymin,' ') == 0 & isempty(ymax)
            	ax.YLim = ([ymin max(stats(:,ind_a))]);
            elseif strcmp(ymin,' ') == 0 & strcmp(ymax,' ') == 0
            	ax.YLim = ([ymin ymax]);
            end
            
            handl.ID = 0;
            setappdata(XIT,'handl',handl)
        else
            axes(ax)
            hist(stats(:,ind_a),bins);
            counts = hist(stats(:,ind_a),bins);
            hold on
            plot([xgate xgate],[0,max(counts)], 'r-')
            hold on
            belowX = find(stats(:,ind_a) <= xgate);
            StatsMatrix2 = stats(belowX,:);
            percbelow = size(StatsMatrix2,1)/size(stats,1)*100;
            text(0.05, 0.9,['\color{red}' '\fontsize{13}' num2str(percbelow, '%.2f') '%'],'Units','normalized')
        
            aboveX = find(stats(:,ind_a) > xgate);
            StatsMatrix3 = stats(aboveX,:);
            percabove = size(StatsMatrix3,1)/size(stats,1)*100;
            text(0.85, 0.9,['\color{red}' '\fontsize{13}' num2str(percabove, '%.2f') '%'],'Units','normalized')
            hold off
            
            if isempty(xmin) &  isempty(xmax)
            	ax.XTickMode  = 'auto';
            elseif isempty(xmin) & strcmp(xmax,' ') == 0
                ax.XLim = ([0 xmax]);
            elseif strcmp(xmin,' ') == 0 & isempty(xmax)
	            ax.XLim = ([xmin max(stats(:,ind_a))]);
            elseif strcmp(xmin,' ') == 0 & strcmp(xmax,' ') == 0
	            ax.XLim = ([xmin xmax]);
            end

            if isempty(ymin) & isempty(ymax)
                ax.YTickMode  = 'auto';
            elseif isempty(ymin) & strcmp(ymax,' ') == 0
                ax.YLim = ([0 ymax]);
            elseif strcmp(ymin,' ') == 0 & isempty(ymax)
            	ax.YLim = ([ymin max(stats(:,ind_a))]);
            elseif strcmp(ymin,' ') == 0 & strcmp(ymax,' ') == 0
            	ax.YLim = ([ymin ymax]);
            end
    
            handl.percofallaX = size(StatsMatrix3,1)/num_forperc*100;
            handl.percofallbX = size(StatsMatrix2,1)/num_forperc*100;
            handl.StatsMatrix2 = StatsMatrix2;
            handl.StatsMatrix3 = StatsMatrix3;
            handl.percbelowX = percbelow;
            handl.percaboveX = percabove;
            handl.numbelowX = size(StatsMatrix2,1);
            handl.numaboveX = size(StatsMatrix3,1);
            handl.ID = 1;
            setappdata(XIT,'handl',handl)
        end
    
    case 'Line' 
        handl.statid = 0; 
        if isempty(xgate) 
            axes(ax)
            [h,he] = hist(stats(:,ind_a),bins);
            area1 = sum(h) * (he(2)-he(1));
            xx = linspace((min(stats(:,ind_a))),max(stats(:,ind_a)));
            f = ksdensity(stats(:,ind_a),xx,'bandwidth',(max(stats(:,ind_a))-min(stats(:,ind_a)))/200);
            line = plot(xx,area1*f,'k-');
            
            if isempty(xmin) &  isempty(xmax)
            	ax.XTickMode  = 'auto';
            elseif isempty(xmin) & strcmp(xmax,' ') == 0
                ax.XLim = ([0 xmax]);
            elseif strcmp(xmin,' ') == 0 & isempty(xmax)
	            ax.XLim = ([xmin max(stats(:,ind_a))]);
            elseif strcmp(xmin,' ') == 0 & strcmp(xmax,' ') == 0
	            ax.XLim = ([xmin xmax]);
            end

            if isempty(ymin) & isempty(ymax)
                ax.YTickMode  = 'auto';
            elseif isempty(ymin) & strcmp(ymax,' ') == 0
                ax.YLim = ([0 ymax]);
            elseif strcmp(ymin,' ') == 0 & isempty(ymax)
            	ax.YLim = ([ymin max(stats(:,ind_a))]);
            elseif strcmp(ymin,' ') == 0 & strcmp(ymax,' ') == 0
            	ax.YLim = ([ymin ymax]);
            end
            handl.ID = 0;
            setappdata(XIT,'handl',handl)
        else
            axes(ax)
            [h,he] = hist(stats(:,ind_a),bins);
            area1 = sum(h) * (he(2)-he(1));
            xx = linspace((min(stats(:,ind_a))),max(stats(:,ind_a)));
            f = ksdensity(stats(:,ind_a),xx,'bandwidth',(max(stats(:,ind_a))-min(stats(:,ind_a)))/200);
            line = plot(xx,area1*f,'k-');
            hold on
            plot([xgate xgate],[0,max(h)], 'r-')
            hold on
            belowX = find(stats(:,ind_a) <= xgate);
            StatsMatrix2 = stats(belowX,:);
            percbelow = size(StatsMatrix2,1)/size(stats,1)*100;
            text(0.05, 0.9,['\color{red}' '\fontsize{13}' num2str(percbelow, '%.2f') '%'],'Units','normalized')
        
            aboveX = find(stats(:,ind_a) > xgate);
            StatsMatrix3 = stats(aboveX,:);
            percabove = size(StatsMatrix3,1)/size(stats,1)*100;
            text(0.85, 0.9,['\color{red}' '\fontsize{13}' num2str(percabove, '%.2f') '%'],'Units','normalized')
            hold off
            
            if isempty(xmin) &  isempty(xmax)
            	ax.XTickMode  = 'auto';
            elseif isempty(xmin) & strcmp(xmax,' ') == 0
                ax.XLim = ([0 xmax]);
            elseif strcmp(xmin,' ') == 0 & isempty(xmax)
	            ax.XLim = ([xmin max(stats(:,ind_a))]);
            elseif strcmp(xmin,' ') == 0 & strcmp(xmax,' ') == 0
	            ax.XLim = ([xmin xmax]);
            end

            if isempty(ymin) & isempty(ymax)
                ax.YTickMode  = 'auto';
            elseif isempty(ymin) & strcmp(ymax,' ') == 0
                ax.YLim = ([0 ymax]);
            elseif strcmp(ymin,' ') == 0 & isempty(ymax)
            	ax.YLim = ([ymin max(stats(:,ind_a))]);
            elseif strcmp(ymin,' ') == 0 & strcmp(ymax,' ') == 0
            	ax.YLim = ([ymin ymax]);
            end
    
            handl.percofallaX = size(StatsMatrix3,1)/num_forperc*100;
            handl.percofallbX = size(StatsMatrix2,1)/num_forperc*100;
            handl.StatsMatrix2 = StatsMatrix2;
            handl.StatsMatrix3 = StatsMatrix3;
            handl.percbelowX = percbelow;
            handl.percaboveX = percabove;
            handl.numbelowX = size(StatsMatrix2,1);
            handl.numaboveX = size(StatsMatrix3,1);
            handl.ID = 1;
            setappdata(XIT,'handl',handl)
        end
    
    case 'Fill'
        handl.statid = 0;    
        if isempty(xgate)
            axes(ax)
            [h,he] = hist(stats(:,ind_a),bins);
            area1 = sum(h) * (he(2)-he(1));
            xx = linspace((min(stats(:,ind_a))),max(stats(:,ind_a)));
            f = ksdensity(stats(:,ind_a),xx,'bandwidth',(max(stats(:,ind_a))-min(stats(:,ind_a)))/200);
            area(xx,(area1*f));
            hold on
            plot(xx,(area1*f),'k-');
            hold off
                
            if isempty(xmin) &  isempty(xmax)
            	ax.XTickMode  = 'auto';
            elseif isempty(xmin) & strcmp(xmax,' ') == 0
                ax.XLim = ([0 xmax]);
            elseif strcmp(xmin,' ') == 0 & isempty(xmax)
	            ax.XLim = ([xmin max(stats(:,ind_a))]);
            elseif strcmp(xmin,' ') == 0 & strcmp(xmax,' ') == 0
	            ax.XLim = ([xmin xmax]);
            end

            if isempty(ymin) & isempty(ymax)
                ax.YTickMode  = 'auto';
            elseif isempty(ymin) & strcmp(ymax,' ') == 0
                ax.YLim = ([0 ymax]);
            elseif strcmp(ymin,' ') == 0 & isempty(ymax)
            	ax.YLim = ([ymin max(stats(:,ind_a))]);
            elseif strcmp(ymin,' ') == 0 & strcmp(ymax,' ') == 0
            	ax.YLim = ([ymin ymax]);
            end
            handl.ID = 0;
            setappdata(XIT,'handl',handl)
            
        else
            axes(ax)
            [h,he] = hist(stats(:,ind_a),bins);
            area1 = sum(h) * (he(2)-he(1));
            xx = linspace((min(stats(:,ind_a))),max(stats(:,ind_a)));
            f = ksdensity(stats(:,ind_a),xx,'bandwidth',(max(stats(:,ind_a))-min(stats(:,ind_a)))/200);
            area(xx,area1*f);
            hold on
            plot([xgate xgate],[0,max(h)], 'r-')
            hold on
            belowX = find(stats(:,ind_a) <= xgate);
            StatsMatrix2 = stats(belowX,:);
            percbelow = size(StatsMatrix2,1)/size(stats,1)*100;
            text(0.05, 0.9,['\color{red}' '\fontsize{13}' num2str(percbelow, '%.2f') '%'],'Units','normalized')
        
            aboveX = find(stats(:,ind_a) > xgate);
            StatsMatrix3 = stats(aboveX,:);
            percabove = size(StatsMatrix3,1)/size(stats,1)*100;
            text(0.85, 0.9,['\color{red}' '\fontsize{13}' num2str(percabove, '%.2f') '%'],'Units','normalized')
            hold off
            
            if isempty(xmin) &  isempty(xmax)
            	ax.XTickMode  = 'auto';
            elseif isempty(xmin) & strcmp(xmax,' ') == 0
                ax.XLim = ([0 xmax]);
            elseif strcmp(xmin,' ') == 0 & isempty(xmax)
	            ax.XLim = ([xmin max(stats(:,ind_a))]);
            elseif strcmp(xmin,' ') == 0 & strcmp(xmax,' ') == 0
	            ax.XLim = ([xmin xmax]);
            end

            if isempty(ymin) & isempty(ymax)
                ax.YTickMode  = 'auto';
            elseif isempty(ymin) & strcmp(ymax,' ') == 0
                ax.YLim = ([0 ymax]);
            elseif strcmp(ymin,' ') == 0 & isempty(ymax)
            	ax.YLim = ([ymin max(stats(:,ind_a))]);
            elseif strcmp(ymin,' ') == 0 & strcmp(ymax,' ') == 0
            	ax.YLim = ([ymin ymax]);
            end
            
            handl.percofallaX = size(StatsMatrix3,1)/num_forperc*100;
            handl.percofallbX = size(StatsMatrix2,1)/num_forperc*100;
            handl.StatsMatrix2 = StatsMatrix2;
            handl.StatsMatrix3 = StatsMatrix3;
            handl.percbelowX = percbelow;
            handl.percaboveX = percabove;
            handl.numbelowX = size(StatsMatrix2,1);
            handl.numaboveX = size(StatsMatrix3,1);
            handl.ID = 1;
            setappdata(XIT,'handl',handl)
        end
end
end