% Copyright (c) 2017, ETH Zurich (Switzerland)
% All rights reserved.
% Published under the BSD-3-Clause License.

% This scrit has been developed within ETH Zurich, Department of Biosystems Science and Engineering by Leo Kunz
% Last update: 29.05.2017 (LK) 

function varargout = XIT(varargin)
% XIT MATLAB code for XIT.fig
%      XIT, by itself, creates a new XIT or raises the existing
%      singleton*.
%
%      H = XIT returns the handle to a new XIT or the handle to
%      the existing singleton*.
%
%      XIT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in XIT.M with the given input arguments.
%
%      XIT('Property','Value',...) creates a new XIT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before XIT_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to XIT_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help XIT

% Last Modified by GUIDE v2.5 11-Oct-2016 17:52:09

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @XIT_OpeningFcn, ...
                   'gui_OutputFcn',  @XIT_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before XIT is made visible.
function XIT_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to XIT (see VARARGIN)

% Choose default command line output for XIT
handles.output = hObject;

% Update handles structure
warning('off')

% creates by default the variables saveID and loadIF as 0 so that the
% program thinks no path has been set, which is true
saveID = 0;
handles.saveID = saveID;
handles.savepath = ' ';
handles.loadpath = ' ';
loadID = 0;
handles.loadID = loadID;
guidata(hObject, handles);



% UIWAIT makes XIT wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = XIT_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in GetBtn.
function GetBtn_Callback(hObject, eventdata, handles)
% hObject    handle to GetBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% initializes the asinh and Lin buttons to default "linear"
set(handles.colasinh,'value',0);
set(handles.asinhX,'Enable','on');
set(handles.asinhY,'Enable','on');
set(handles.BiExBtn,'Enable','on');
set(handles.linX,'Enable','off');
set(handles.linY,'Enable','off');
set(handles.LinBtn,'Enable','off');
set(handles.applygateBtn,'Enable','off');
% the gate box is initialized
celli = {'Parent population'; '...'};
set(handles.gatebox,'String',celli);
    
% Question dialog asking which kind of dataset you want to load, assigns
% IDs that are used later
qst = questdlg('What kind of dataset do you want to load?','Dataset specification','Imaris','XIT format','Workspace','Imaris');
    switch qst
        case 'Imaris'
        Im = 1;
        XiT = 0;
        Ws = 0;
        set(handles.textWSs,'String',' ')
        set(handles.popupWS,'String','Workspaces')
        case 'XIT format'
        XiT = 1;
        Im = 0;
        Ws = 0;
        set(handles.textWSs,'String',' ')
        set(handles.popupWS,'String','Workspaces')
        case 'Workspace'
        XiT = 0;
        Im = 0;
        Ws = 1;
        set(handles.textWSs,'String',' ')
        set(handles.popupWS,'String','Workspaces')
    end

figs =  findobj('type','figure');
for i = 1:length(figs)
    if strcmp('XIT',get(figs(i),'Name'))
        index = i;
    end
end
figs(index) = [];
close(figs)
set(handles.popupFigure,'String','Figures')
set(handles.popupFigure,'Value',1)

% executes if either an Imaris or XiT dataset is chosen
if Im == 1 || XiT == 1
    % initializes buttons and textboxes in the GUI
    set(handles.cofactor,'String',1);
    set(handles.cofact_col,'String',1);
	set(handles.textXax,'string',' ');
	set(handles.textYax,'string',' ');
	set(handles.popupX,'string',' ');
	set(handles.popupY,'string',' ');
	set(handles.scatterplot,'value',1);
	set(handles.histplot,'value',0);
	set(handles.popupY,'Enable','on');
	set(handles.hist_bins,'String','1000');
	set(handles.Ymin,'String',' ');
 	set(handles.Ymax,'String',' ');
 	set(handles.Xmin,'String',' ');
 	set(handles.Xmax,'String',' ');
 	set(handles.Gate_Y,'String',' ');
 	set(handles.Gate_X,'String',' ');
  	set(handles.GateBtn,'Enable','on')
    set(handles.RectGateBtn,'Enable','on')
  	set(handles.Gate_Y,'Enable','on');
 	set(handles.GatingTable,'Data',[])
   	set(handles.radminus,'Value',0)
  	set(handles.radmultiply,'Value',0)
  	set(handles.raddivide,'Value',0)
  	set(handles.plusrad,'Value',0) 
end
  
% If the user chose the XIT format this code is executed
if XiT == 1;
    set(handles.figure1, 'pointer', 'watch')
    drawnow;

    loadID = handles.loadID;
    pathname = handles.loadpath;
    
    if loadID == 1 %loading path defined
        [filename, pathname] = ...
        uigetfile({'*.xlsx';'*.*'}, 'Select file', pathname, 'MultiSelect', 'off');
        filename = [pathname filename];
    else %no loading path defined
        [filename, pathname] = ...
        uigetfile({'*.xlsx';'*.*'}, 'Select file', 'MultiSelect', 'off');
        filename = [pathname filename];
    end
       
    % imports data
    newfilename = filename;
    filenamea1{1,1} = filename;
    Names1 = cell2struct(filenamea1, 'name', 1);
    h = waitbar(33/100,'Loading data...');
    dataD1 = cell(1,length(Names1));
    for k = 1:length(Names1)
        emptycell1 = Names1.name;
        dataD1{1,k} = importdata(emptycell1);
        waitbar(k/length(Names1))
    end
    close(h)
          
    % gets Names of parameters
    if isstruct(dataD1{1,1}.textdata) == 1
        StatNames = cell(length(dataD1{1,1}.textdata.Sheet1),1);
        for i = 1:length(dataD1{1,1}.textdata.Sheet1)
            StatNames{i,1} = (dataD1{1,1}.textdata.Sheet1{1,i});
        end
          
        for i = 1:length(dataD1{1,1}.textdata.Sheet1)
            StatNames{i,1}(strfind(StatNames{i,1}, '=')) = [];
            StatNames{i,1} = StatNames{i,1}(find(~isspace(StatNames{i,1})));
        end
    else
        StatNames = cell(length(dataD1{1,1}.textdata),1);
        for i = 1:length(dataD1{1,1}.textdata)
            StatNames{i,1} = (dataD1{1,1}.textdata{1,i});
        end
          
        for i = 1:length(dataD1{1,1}.textdata)
            StatNames{i,1}(strfind(StatNames{i,1}, '=')) = [];
            StatNames{i,1} = StatNames{i,1}(find(~isspace(StatNames{i,1})));
        end
    end

    StatNames = StatNames';
    
    % if there are position files, they are read in automatically 
    % if not dummy X/Y/Z data is generated (zeros)  
	if isstruct(dataD1{1,1}.textdata) == 1
        for i = 1:length(dataD1{1,1}.textdata.Sheet1)
            if strcmp(dataD1{1,1}.textdata.Sheet1{1,i},'PositionX') == 1
                Xsf = dataD1{1,1}.data.Sheet1(:,i);
                Xid = 1;
                Xnumb = i;
                break
            elseif strcmp(dataD1{1,1}.textdata.Sheet1{1,i},'PositionX') == 0
                Xid = 0;
            end
        end
        for i = 1:length(dataD1{1,1}.textdata.Sheet1)
            if strcmp(dataD1{1,1}.textdata.Sheet1{1,i},'PositionY') == 1
                Ysf = dataD1{1,1}.data.Sheet1(:,i);
                Yid = 1;
                Ynumb = i;
                break
            elseif strcmp(dataD1{1,1}.textdata.Sheet1{1,i},'PositionY') == 0
                Yid = 0;
            end
        end
        for i = 1:length(dataD1{1,1}.textdata.Sheet1)
            if strcmp(dataD1{1,1}.textdata.Sheet1{1,i},'PositionZ') == 1
                Zsf = dataD1{1,1}.data.Sheet1(:,i);
                Zid = 1;
                break
            elseif strcmp(dataD1{1,1}.textdata.Sheet1{1,i},'PositionZ') == 0
                Zid = 0;
            end            
        end
    else  
        for i = 1:length(dataD1{1,1}.textdata)
            if strcmp(dataD1{1,1}.textdata{1,i},'PositionX') == 1
                Xsf = dataD1{1,1}.data(:,i);
                Xid = 1;
                Xnumb = i;
                break
            elseif strcmp(dataD1{1,1}.textdata{1,i},'PositionX') == 0
                Xid = 0;
            end
        end
        for i = 1:length(dataD1{1,1}.textdata)
            if strcmp(dataD1{1,1}.textdata{1,i},'PositionY') == 1
                Ysf = dataD1{1,1}.data(:,i);
                Yid = 1;
                Ynumb = i;
                break
            elseif strcmp(dataD1{1,1}.textdata{1,i},'PositionY') == 0
                Yid = 0;
            end
        end
        for i = 1:length(dataD1{1,1}.textdata)
            if strcmp(dataD1{1,1}.textdata{1,i},'PositionZ') == 1
                Zsf = dataD1{1,1}.data(:,i);
                Zid = 1;
                break
            elseif strcmp(dataD1{1,1}.textdata{1,i},'PositionZ') == 0
                Zid = 0;
            end                    
        end
    end
                      
    % checks if the user has entered ID numbers, if yes those are used
    % (column header needs to be named "ID"), if not IDs starting from 0
    % are generated for each cell (=row)
    if isstruct(dataD1{1,1}.textdata) == 1
        qw = strcmp(dataD1{1,1}.textdata.Sheet1,'ID'); 
        if sum(qw) == 0
          	ch = (questdlg('Have you provided ID numbers specified by the column header "ID" in the last column?','ID','Yes','No (new IDs are generated)','No (new IDs are generated)'));
          	if strcmp(ch,'No (new IDs are generated)') == 1
            	IDs1 = [0:(size(dataD1{1,1}.data.Sheet1,1)-1)]';
              	IDid = 0;
            else
              	waitfor(msgbox('Data could not be read in properly. Please check your data format.'))
            end
        else
            for i = 1:length(dataD1{1,1}.textdata.Sheet1)
                if strcmp(dataD1{1,1}.textdata.Sheet1{1,i},'ID') == 1
                	IDs1 = dataD1{1,1}.data.Sheet1(:,i);
                 	IDid = 1;
                end
            end
        end
    else
        qw = strcmp(dataD1{1,1}.textdata,'ID'); 
        if sum(qw) == 0
        	ch = (questdlg('Have you provided ID numbers specified by the column header "ID" in the last column?','ID','Yes','No (new IDs are generated)','No (new IDs are generated)'));
         	if strcmp(ch,'No (new IDs are generated)') == 1
                IDs1 = [0:(size(dataD1{1,1}.data,1)-1)]';
              	IDid = 0;
            else
                waitfor(msgbox('Data could not be read in properly. Please check your data format.'))
         	end
        else
            for i = 1:length(dataD1{1,1}.textdata)
                if strcmp(dataD1{1,1}.textdata{1,i},'ID') == 1
                	IDs1 = dataD1{1,1}.data(:,i);
                 	IDid = 1;
                end
            end
        end
    end   
    
  
    if isstruct(dataD1{1,1}.textdata) == 1
        stats = dataD1{1,1}.data.Sheet1(:,1:end);
    else
        stats = dataD1{1,1}.data(:,1:end);
    end

    %if no x coordinate is there create ones
    if IDid == 1 & Xid == 0
       stats_wo_ID = stats(:,1:end-1); 
       Xsf = ones(size(stats,1),1);
       stats = [stats_wo_ID Xsf stats(:,end)];
       StatNames_wo_ID =  StatNames(1,1:end-1);
       X = 'PositionX';
       StatNames = [StatNames_wo_ID X 'ID'];
       Xid = 1;
    elseif IDid == 0 & Xid == 0
       Xsf = ones(size(stats,1),1);
       stats = [stats Xsf];
       X = 'PositionX';
       StatNames = [StatNames X];
       Xid = 1;
    end
    
    %if no y coordinate is there create ones
    if IDid == 1 & Yid == 0
       stats_wo_ID = stats(:,1:end-1); 
       Ysf = ones(size(stats,1),1);
       stats = [stats_wo_ID Ysf stats(:,end)];
       StatNames_wo_ID =  StatNames(1,1:end-1);
       Y = 'PositionY';
       StatNames = [StatNames_wo_ID Y 'ID'];
       Yid = 1;
    elseif IDid == 0 & Yid == 0
       Ysf = ones(size(stats,1),1);
       stats = [stats Ysf];
       Y = 'PositionY';
       StatNames = [StatNames Y];
       Yid = 1;
    end
    
    %if no z coordinate is there create ones
    if IDid == 1 & Zid == 0
       stats_wo_ID = stats(:,1:end-1); 
       Zsf = ones(size(stats,1),1);
       stats = [stats_wo_ID Zsf stats(:,end)];
       StatNames_wo_ID =  StatNames(1,1:end-1);
       Z = 'PositionZ';
       StatNames = [StatNames_wo_ID Z 'ID'];
       Zid = 1;
    elseif IDid == 0 & Zid == 0
       Zsf = ones(size(stats,1),1);
       stats = [stats Zsf];
       Z = 'PositionZ';
       StatNames = [StatNames Z];
       Zid = 1;
    end

% get all stats except coordinates and ID
    if Xid == 0 & Yid == 0 & Zid == 0 & IDid == 0       % no XYZ, no ID
        Stats_Matrix = [stats IDs1];
        Names_of_stats = StatNames;
        StatNames = [StatNames {'ID'}];
        ParentXYZs = [0,0,0; 0,0,0];
    elseif Xid == 0 & Yid == 0 & Zid == 0 & IDid == 1   % no XYZ, but ID
        for i = 1:size(stats,2)
            if strcmp(StatNames(1,i),'ID') == 1
                stats(:,i) = [];
                StatNames(:,i) = [];
                ParentXYZs = [0,0,0; 0,0,0];
                break
            end
        end
        Stats_Matrix = [stats IDs1];
        Names_of_stats = StatNames;
        StatNames = [StatNames {'ID'}];
    elseif Xid == 1 & Yid == 1 & Zid == 1 & IDid == 0   % XYZ, no ID
        XYZsf = [Xsf Ysf Zsf];   
        XYZname = [{'PositionX'} {'PositionY'} {'PositionZ'}];
        for i = 1:size(stats,2)
            if strcmp(StatNames(1,i),'PositionX') == 1
                stats(:,i) = [];
                StatNames(:,i) = [];
                ParentXYZs = [0,0,0; 0,0,0];
                break
            end
        end
        for i = 1:size(stats,2)
            if strcmp(StatNames(1,i),'PositionY') == 1
                stats(:,i) = [];
                StatNames(:,i) = [];
                break
            end
        end
        for i = 1:size(stats,2)
            if strcmp(StatNames(1,i),'PositionZ') == 1
                stats(:,i) = [];
                StatNames(:,i) = [];
                break
            end
        end
        Stats_Matrix = [stats XYZsf IDs1];
        Names_of_stats = StatNames;
        StatNames = [StatNames XYZname {'ID'}];
        ParentXYZs = [max(XYZsf(:,1)), max(XYZsf(:,2)), max(XYZsf(:,3));...
                min(XYZsf(:,1)), min(XYZsf(:,2)), min(XYZsf(:,3))];
            
    elseif Xid == 1 & Yid == 1 & Zid == 0 & IDid == 0   % XY, no Z, no ID
        XYZsf = [Xsf Ysf];   
        XYZname = [{'PositionX'} {'PositionY'}];
        for i = 1:size(stats,2)
            if strcmp(StatNames(1,i),'PositionX') == 1
                stats(:,i) = [];
                StatNames(:,i) = [];
                break
            end
        end
        for i = 1:size(stats,2)
            if strcmp(StatNames(1,i),'PositionY') == 1
                stats(:,i) = [];
                StatNames(:,i) = [];
                break
            end
        end
        Stats_Matrix = [stats XYZsf IDs1];
        Names_of_stats = StatNames;
        StatNames = [StatNames XYZname {'ID'}];
                    ParentXYZs = [max(XYZsf(:,1)), max(XYZsf(:,2)), 0;...
                min(XYZsf(:,1)), min(XYZsf(:,2)), 0];
            
    elseif Xid == 1 & Yid == 1 & Zid == 0 & IDid == 1   % XY, no Z, but ID
        XYZsf = [Xsf Ysf];   
        XYZname = [{'PositionX'} {'PositionY'}];
        for i = 1:size(stats,2)
            if strcmp(StatNames(1,i),'PositionX') == 1
                stats(:,i) = [];
                StatNames(:,i) = [];
                break
            end
        end
        for i = 1:size(stats,2)
            if strcmp(StatNames(1,i),'PositionY') == 1
                stats(:,i) = [];
                StatNames(:,i) = [];
                break
            end
        end
        for i = 1:size(stats,2)
            if strcmp(StatNames(1,i),'ID') == 1
                stats(:,i) = [];
                StatNames(:,i) = [];
                break
            end
        end
        Stats_Matrix = [stats XYZsf IDs1];
        Names_of_stats = StatNames;
        StatNames = [StatNames XYZname {'ID'}];
                    ParentXYZs = [max(XYZsf(:,1)), max(XYZsf(:,2)), 0;...
                min(XYZsf(:,1)), min(XYZsf(:,2)), 0];
            
    elseif Xid == 1 & Yid == 1 & Zid == 1 & IDid == 1   % XYZ & ID
        XYZsf = [Xsf Ysf Zsf];
        XYZname = [{'PositionX'} {'PositionY'} {'PositionZ'}];
        for i = 1:size(stats,2)
            if strcmp(StatNames(1,i),'PositionX') == 1
                stats(:,i) = [];
                StatNames(:,i) = [];
                break
            end
        end
        for i = 1:size(stats,2)
            if strcmp(StatNames(1,i),'PositionY') == 1
                stats(:,i) = [];
                StatNames(:,i) = [];
                break
            end
        end
        for i = 1:size(stats,2)
            if strcmp(StatNames(1,i),'PositionZ') == 1
                stats(:,i) = [];
                StatNames(:,i) = [];
                break
            end
        end
        for i = 1:size(stats,2)
            if strcmp(StatNames(1,i),'ID') == 1
                stats(:,i) = [];
                StatNames(:,i) = [];
                break
            end
        end
        Stats_Matrix = [stats XYZsf IDs1];
        Names_of_stats = StatNames;
        StatNames = [StatNames XYZname {'ID'}];
        ParentXYZs = [max(XYZsf(:,1)), max(XYZsf(:,2)),max(XYZsf(:,3));...
                min(XYZsf(:,1)), min(XYZsf(:,2)),min(XYZsf(:,3))];
    end
        
    if Xid == 1 & Yid == 1
        diffx = max(Xsf(:,1))-min(Xsf(:,1));
        diffy = max(Ysf(:,1))-min(Ysf(:,1));
        
        if diffx > diffy 
            Yi = Stats_Matrix(:,Xnumb);
            Xi = Stats_Matrix(:,Ynumb);
            Stats_Matrix(:,Xnumb) = Xi;
            Stats_Matrix(:,Ynumb) = Yi;
            Yi = ParentXYZs(:,1);
            Xi = ParentXYZs(:,2);
            ParentXYZs(:,1) = Xi;
            ParentXYZs(:,2) = Yi;
            dispID = 1;
        else
            dispID = 0;
        end
    end
     
elseif Im == 1; % user selected to load the imaris dataformat
	set(handles.figure1, 'pointer', 'watch')
    drawnow;
    
    % loads an Imaris statistic dataset (many csv files) either from a
    % predefined path or just by Get file
    pathname = handles.loadpath;
    loadID = handles.loadID;
    if loadID == 1
        waitfor(msgbox('Specify folder containing formated statistic data!'));
        Im_dname = uigetdir(pathname);
        pathname = Im_dname;
    else
        waitfor(msgbox('Specify folder containing formated statistic data!'));
        pathname = uigetdir;
    end
    
    f = dir([pathname '\*.csv']);
    h = waitbar(0,'Loading data...');
    nu = numel(f);
    dataIm = cell(1,nu);
    ListStr = cell(nu,1);
    for k=1:nu
        dataIm{1,k}=importdata([pathname '\' f(k).name]);
        ListStr{k,1} = f(k).name;
        waitbar(k/nu)
    end
    close(h)
    
    % if there is a position file, it gets read in automatically
    h = waitbar(0,'Please wait... (1/2)');
    for i = 1:length(ListStr)
        if strfind(ListStr{i,1},'Position') > 1
            aXYZIm = cell(((length(dataIm{1,i}.textdata))-4),3);
            for j = 1:3
                for k = 5:(length(dataIm{1,i}.textdata))
                    aXYZIm{k,j} = str2double(dataIm{1,i}.textdata{k,j});
                end
            end
            XYZIm = cell2mat(aXYZIm);
        else
        end
     waitbar(i/length(ListStr))
     end
     close(h)
     
     % Getting all stats except for XYZ position
     dataImStats = dataIm;
     for i = 1:length(ListStr)
         if strfind(ListStr{i,1},'Position') > 1
             dataImStats(:,i) = [];
         end
     end
     for i = 1:length(ListStr)
         if strfind(ListStr{i,1},'Overall') > 1
             dataImStats(:,i) = [];
         end
     end
         
     cImStat = zeros(size(XYZIm,1),length(dataImStats));
     
	try
    
 	h = waitbar(40/100,'Please wait... (2/2)');
	for i = 1:length(dataImStats)
    	aImStat = cell(1,(length(dataImStats{1,i}.textdata))-4);
      	for j = 5:(length(dataImStats{1,i}.textdata))
        	aImStat{1,j} = str2double(dataImStats{1,i}.textdata{j,1});
        end
     	bImStat = cell2mat(aImStat);
     	cImStat(:,i) = bImStat;
	end
        
    catch 
        % sometimes there is a bug in Imaris statistics deleting some cells
        % in some statistics. If that happens you cannot load the data
        % becuase of inconsitency issues.
        errordlg('Your dataset seems to be inconsistent (.xslx files dont contain same number of cells). Redo the isosurface in Imaris and try again.','File Error');
	end
	close(h)
     
    % gets Names of parameters
  	for i = 1:numel(ListStr)
        if strfind(ListStr{i,1},'Overall') > 1
            indexOv = i;
        end
    end
   	for i = 1:numel(ListStr)
      	if strfind(ListStr{i,1},'Position') > 1
         	indexPos = i;
        end
    end
         
	if indexOv > indexPos
        ListStr(indexOv,:) = [];
        ListStr(indexPos,:) = [];
    else
      	ListStr(indexPos,:) = [];
      	ListStr(indexOv,:) = [];
    end
      
             
  	for i = 1:numel(ListStr)
      	ListStr{i,1}(strfind(ListStr{i,1}, '=')) = [];
      	ListStr{i,1} = ListStr{i,1}(find(~isspace(ListStr{i,1})));
      	ListStr{i,1} = ListStr{i,1}(1:(end-4));
    end
         
    ListStr{(length(ListStr)+1),1} = 'PositionX';
    ListStr{(length(ListStr)+1),1} = 'PositionY';
    ListStr{(length(ListStr)+1),1} = 'PositionZ';
    ListStr{(length(ListStr)+1),1} = 'ID';
     
    StatNames = ListStr';
    for i = 1:length(StatNames)
        u = strfind('_',StatNames{1,i});
        if isempty(u) == 0
            StatNames{1,i} = StatNames{1,i}(u(1,1)+1:end);
        end
    end
     
    % if there is a position dataset (XYZ coordinates) they will be
    % concatenated with the other stats. This also happens without
    % coodinates being present in the datset
    if any(strcmp(who,'XYZIm')) == 1
       Stats_Matrix = [cImStat XYZIm dataIm{1,1}.data(1:end,size(dataIm{1,1}.data,2))]; %contains all stats except for coord. + xyz coordinates + ID
       ParentXYZs = [max(XYZIm(:,1)), max(XYZIm(:,2)),max(XYZIm(:,3));...
                    min(XYZIm(:,1)), min(XYZIm(:,2)),min(XYZIm(:,3))];
    else
       Stats_Matrix = [cImStat dataIm{1,1}.data(1:end,size(dataIm{1,1}.data,2))]; %contains all stats except for coord. + xyz coordinates + ID
       ParentXYZs = [0,0,0; 0,0,0];
    end
 	Names_of_stats = StatNames(1,1:(length(StatNames)-1));
    
    % A common bug in Imaris results in IDs starting from a number other than 0
    % in the exported csv files. this line corrects for that.
    if Stats_Matrix(1,end) ~= 0
        qqq = questdlg('IDs are not starting at 0. Do you want to renumber them to start at 0?','IDs','Yes','No','No');
        switch qqq
            case 'Yes'
                Stats_Matrix(1:end,end) = [0:((size(Stats_Matrix,1)-1))]';
            case 'No'
        end
    end
    dispID = 0;
end


if Im == 1 || XiT == 1   % if Imaris or XIT are chosen as data formats further buttons are initialized and the GUI is filled with the data 
    Names_of_stats = StatNames(1,1:(length(StatNames)-1));
    set(handles.popupX,'string',Names_of_stats);
    set(handles.popupY,'string',Names_of_stats);
    set(handles.popupA,'string',Names_of_stats);
    set(handles.popupB,'string',Names_of_stats);
    set(handles.popupX,'Value',1)
    set(handles.popupY,'Value',length(Names_of_stats))
    set(handles.popupCol,'Value',2);
    set(handles.popupSize,'Value',2);
    % color can be black, density color coding (default) or according to
    % different statistic (only in scatter opplot)
    ColorNames = [{'Black'} {'Density'} Names_of_stats];
    set(handles.popupCol,'String',ColorNames);
    % first and last statistic are chosen for the first scatterplot
    ind_a = 1;
    ind_b = length(Names_of_stats);
    
    % density plot is created as default
    abin = 250;
    set(handles.densitybin,'String','250');
	edgesX = linspace(min(Stats_Matrix(:,ind_a)), max(Stats_Matrix(:,ind_a)), abin);
	edgesY = linspace(min(Stats_Matrix(:,ind_b)), max(Stats_Matrix(:,ind_b)), abin);
    [One,~] = size(Stats_Matrix(:,ind_a));
    [~,CountsX] = histc(Stats_Matrix(:,ind_a),edgesX); %counts cells in grid established by edgesX
	[~,CountsY] = histc(Stats_Matrix(:,ind_b),edgesY); %counts cells in grid established by edgesY
    Counts = [CountsX,CountsY];
	Darray = accumarray(Counts,1)./One; %normalization of the counting matrix
	DarrayNorm = Darray./max(Darray(:));
    DarrayNorm = imgaussfilt(DarrayNorm,2); % Gaussian filter to blur the denisty matrix DarrayNorm
    ind = sub2ind(size(DarrayNorm),CountsX,CountsY);
    col2 = DarrayNorm(ind);
    U = sortrows([Stats_Matrix(:,ind_a), Stats_Matrix(:,ind_b), col2],3); %rows are sorted so that high density areas are plotted on top of low density areas
    col1 = U(:,3);
	axes(handles.axes1)
    scatter(U(:,1),U(:,2),10,col1,'filled')
    colormap(jet(4096)); %4096 colors for the density plot    
    set(handles.textXax,'string',Names_of_stats(1,1));
    set(handles.textYax,'string',Names_of_stats(1,ind_b));
    if XiT == 1
        set(handles.textFile,'String',filename)
    else
        set(handles.textFile,'string',pathname)
    end
    
    BiEx_StatsMatrix = log((Stats_Matrix/(str2double(get(handles.cofactor,'String'))))...
        +sqrt((((Stats_Matrix/(str2double(get(handles.cofactor,'String')))).^2)+1))); %arcsinh transformation of the dataset
    set(handles.hist_bins,'String','1000');

    handles = guidata(hObject);
    handles.ParentXYZs = ParentXYZs;
    handles.StatNames = StatNames;
    handles.kmCol = 0;
    handles.sizeSc = 10;
    handles.ColorNames = ColorNames;
    handles.BiExID = 0;
    handles.percQ1 = 0;
    handles.percQ2 = 0;
    handles.percQ3 = 0;
    handles.percQ4 = 0;
    handles.numQ1 = 0;
    handles.numQ2 = 0;
    handles.numQ3 = 0;
    handles.numQ4 = 0;
    handles.percbelowX = 0;
    handles.percaboveX = 0;
    handles.numbelowX = 0;
    handles.numaboveX = 0;
    handles.percbelowY = 0;
    handles.percaboveY = 0;
    handles.numbelowY = 0;
    handles.numaboveY = 0;
	handles.percofallQ1 = 0;
	handles.percofallQ2 = 0;
	handles.percofallQ3 = 0;
	handles.percofallQ4 = 0;
	handles.percofallaX = 0;
	handles.percofallbX = 0;
	handles.percofallaY = 0;
	handles.percofallbY = 0;
    handles.aritID = 0;
    handles.aritstats = Stats_Matrix;
    handles.nodes = [0 0; 0 0; 0 0; 0 0];
    
    % initialize the handles structure for the gating history
    gatinghist = cell(7,100);
    gatinghist{1,1} = Stats_Matrix;     % stats
    gatinghist{2,1} = ind_a;            % x statistic
    gatinghist{3,1} = ind_b;            % y statistic
    f = get(handles.uipanel1,'SelectedObject');
    Sel = get(f,'String');
    gatinghist{4,1} = Sel;              % type of plot
    gatinghist{5,1} = 0;                % state of data (lin/arcsinh/both or one axis)
    gatinghist{6,1} = 0;                % state of data (lin/arcsinh)
    gatinghist{7,1} = Names_of_stats;	% current list of names
    set(handles.gatebox,'value',1)
    handles.gatinghist = gatinghist;
    
    handles.names = Names_of_stats;
    handles.stats = Stats_Matrix;
    handles.BiEx_StatsMatrix = BiEx_StatsMatrix;
    handles.statsCl = Stats_Matrix;     %stats to go back on upon "clear gates" (changes by spatial gating)
    handles.statsClear = Stats_Matrix;  %stats to go back on upon "clear all"   (not changed anymore)
    handles.namesCl = Names_of_stats;   %original names of statistic (for clear all)
    handles.inda = ind_a;
    handles.indb = ind_b;
    handles.indexAa = 1;
    handles.indexAb = 1;
    handles.NamesforExp = StatNames;
    handles.histo = 0;
    handles.line = 0;
    handles.fillarea = 0;
    
    if dispID == 1
    	msgbox('For display purposes x and y axes have been changed.')
    end
end
set(handles.figure1, 'pointer', 'arrow')

if Ws == 1 %if the user selected the workspace data format
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    
    handles = guidata(hObject);
    % loading from path 
    pathname = handles.loadpath;
    loadID = handles.loadID;
    if loadID == 1 %loading path defined
        [filename, pathname] = ...
        uigetfile({'*.mat'}, 'Select file', pathname, 'MultiSelect', 'off');
        filenamews = [pathname filename];
    else %no loading path defined
        [filename, pathname] = ...
        uigetfile({'*.mat'}, 'Select file', 'MultiSelect', 'off');
        filenamews = [pathname filename];
    end
    
    % loading the dataset and state of the GUI
    load(filenamews)
    set(handles.popupSize,'Value',state.popupSizeVal);
    set(handles.popupSize,'String',state.popupSizeString);
    set(handles.popupCol,'Value',state.popupColVal);
    set(handles.popupCol,'String',state.popupColStr);
    set(handles.textFile,'string',filenamews);
    set(handles.textXax,'string', state.textXax);
    set(handles.textYax,'string', state.textYax);
    set(handles.popupX,'enable', 'on');
    set(handles.popupY,'enable', 'on');
    set(handles.popupX,'string', state.popupXst);
    set(handles.popupY,'string', state.popupYst);
    set(handles.popupY,'Value', state.popupYval);
    set(handles.popupX,'Value', state.popupXval);
    set(handles.hist_bins,'String', state.hist_bins);
    set(handles.Ymin,'String', state.Ymin);
    set(handles.Ymax,'String', state.Ymax);
    set(handles.Xmin,'String', state.Xmin);
    set(handles.Xmax,'String', state.Xmax);
    set(handles.Gate_Y,'String', state.Gate_Y);
    set(handles.Gate_X,'String', state.Gate_X);
    set(handles.Gate_Yperc,'String', state.Gate_Yperc);
    set(handles.Gate_Xperc,'String', state.Gate_Xperc);
    set(handles.GatingTable,'Data', state.GatingTable);
    set(handles.radminus,'Value', state.radminus);
    set(handles.radmultiply,'Value', state.radmultiply);
    set(handles.raddivide,'Value', state.raddivide);
    set(handles.plusrad,'Value', state.plusrad);
    set(handles.popupA,'string',state.popupAStr);
    set(handles.popupB,'string',state.popupBStr);
    set(handles.popupA,'value',state.popupAVal);
    set(handles.popupB,'value',state.popupBVal);
    set(handles.StaAfact,'string',state.StaAfact);
    set(handles.StaBfact,'string',state.StaAfact);
    if isfield(state, 'cofactor') == 0
        set(handles.cofactor,'String','1');
        set(handles.cofact_col,'String','1');
        set(handles.colasinh,'Value',0);
    else   
        set(handles.cofactor,'string',state.cofactor);
        set(handles.cofact_col,'String',state.cofact_col);
        set(handles.colasinh,'value', state.colasinh);
    end    

    handles.ParentXYZs = state.ParentXYZs;
    handles.kmCol = state.kmCol;
    val = state.popupSizeVal;
    str = state.popupSizeString;
    handles.sizeSc = str2double(str{val,1});
    handles.ColorNames = state.popupColStr;
    handles.StatNames = state.StatNames;
    handles.percQ1 = state.percQ1;
    handles.percQ2 = state.percQ2;
    handles.percQ3 = state.percQ3;
    handles.percQ4 = state.percQ4;
    handles.numQ1 = state.numQ1;
    handles.numQ2 = state.numQ2;
    handles.numQ3 = state.numQ3;
    handles.numQ4 = state.numQ4;
    handles.percbelowX = state.percbelowX;
    handles.percaboveX = state.percaboveX;
    handles.numbelowX = state.numbelowX;
    handles.numaboveX = state.numaboveX;
    handles.percbelowY = state.percbelowY;
    handles.percaboveY = state.percaboveY;
    handles.numbelowY = state.numbelowY;
    handles.numaboveY = state.numaboveY;
	handles.percofallQ1 = state.percofallQ1;
	handles.percofallQ2 = state.percofallQ2;
	handles.percofallQ3 = state.percofallQ3;
	handles.percofallQ4 = state.percofallQ4;
	handles.percofallaX = state.percofallaX;
	handles.percofallbX = state.percofallbX;
	handles.percofallaY = state.percofallaY;
	handles.percofallbY = state.percofallbY;
    handles.names = state.names;
    handles.stats = state.stats;
    handles.BiEx_StatsMatrix = state.BiEx_StatsMatrix;
    handles.BiExID = state.BiExID;
    handles.statsCl = state.statsCl;
    handles.statsClear = state.statsClear;
    handles.namesCl = state.namesCl;
    handles.inda = state.inda;
    handles.indb = state.indb;
    handles.indexAa = state.indexAa;
    handles.indexAb = state.indexAb;
    handles.NamesforExp = state.NamesforExp;
    handles.histo = state.histo;
    handles.line = state.line;
    handles.fillarea = state.fillarea;
    axes1 = findobj('type','axes');
    handles.axes1 = axes1;
    handles.aritID = state.aritID;
    handles.aritstats = state.aritstats;
    handles.gatinghist = state.gatinghist;
    handles.gateboxtext = state.gateboxtext;
    handles.gateboxvalue = state.gateboxvalue;
    handles.nodes = [0 0; 0 0; 0 0; 0 0];
    guidata(hObject,handles)
    
    % check for plot type and puts x/y axis text accordingly
    f = state.Sel;
    Sel = get(f,'String');
    if strcmp(Sel,'Scatter')
        set(handles.textYax,'string',state.textYax);
        set(handles.popupY,'value',state.indb);
    else
        ind_b = handles.indb;
        names = handles.names;
        set(handles.textYax,'string',names(1,ind_b));
        set(handles.popupY,'value', ind_b);
    end
    
    switch Sel
        case 'Scatter'
            set(handles.scatterplot,'value', 1);
            set(handles.GateBtn,'Enable','on')
            set(handles.RectGateBtn,'Enable','on')
            set(handles.popupY,'enable', 'on');
            set(handles.Gate_Y,'Enable', 'on');
            set(handles.Gate_Yperc,'Enable', 'on');
        case 'Histogram'
            set(handles.histplot,'value', 1);
            set(handles.GateBtn,'Enable','off')
            set(handles.RectGateBtn,'Enable','off')
            set(handles.popupY,'enable', 'off');
            set(handles.Gate_Y,'Enable', 'off');
            set(handles.Gate_Yperc,'Enable', 'off');
        case 'Line'
            set(handles.lineplot,'value', 1);
            set(handles.GateBtn,'Enable','off')
            set(handles.RectGateBtn,'Enable','off')
            set(handles.popupY,'enable', 'off');
            set(handles.Gate_Y,'Enable', 'off');
            set(handles.Gate_Yperc,'Enable', 'off');
        case 'Fill'
            set(handles.fillplot,'value', 1);
            set(handles.GateBtn,'Enable','off')
            set(handles.RectGateBtn,'Enable','off')
            set(handles.popupY,'enable', 'off');
            set(handles.Gate_Y,'Enable', 'off');
            set(handles.Gate_Yperc,'Enable', 'off');
    end

    % checks for plot type, if there is a x/y gate selected, stats,
    % parentpopulation stats, x and y axis (which statistic should be
    % plotted), size, colorcode, kmeans coloring, histogram bins, c and y
    % limits and starts the XITplot function that does the plotting
    f = get(handles.uipanel1,'SelectedObject');
    Sel = get(f,'String');
    xgate = str2double(get(handles.Gate_X,'String'));
    ygate = str2double(get(handles.Gate_Y,'String'));
    stats = handles.stats;
    StatsMatrixCl = handles.statsCl;
    num_forperc = size(StatsMatrixCl,1);
    ind_a = handles.inda;
    ind_b = handles.indb;
    sizeSc = handles.sizeSc;
    s = get(handles.popupCol,'Value');
    kCol = handles.kmCol;
    abin = str2double(get(handles.densitybin,'String'));
    bins = str2double(get(handles.hist_bins,'String'));
    xmin = str2double(get(handles.Xmin,'String'));
    xmax = str2double(get(handles.Xmax,'String'));
    ymin = str2double(get(handles.Ymin,'String'));
    ymax = str2double(get(handles.Ymax,'String'));
    
    % executes function for plotting
    XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,1,1,...
        str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)

    if get(handles.popupCol,'value') > 2
        cmax = str2double(get(handles.colorMax,'String'));    
        cmin = str2double(get(handles.colorMin,'String'));  
        if isnan(cmin)
            cmin = 0;
        end
        if isnan(cmax)
            cmax = 255;
        end
        axes(handles.axes1)
        caxis([cmin cmax])  
    end
    
    % gets data from the plotting (e.g. gates and gated statistics)
    a = getappdata(XIT,'handl');
    GateID = a.ID;
    if GateID == 0
    elseif GateID == 1
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowX = a.percbelowX;
        handles.percaboveX = a.percaboveX;
        handles.numbelowX = a.numbelowX;
        handles.numaboveX = a.numaboveX;
        handles.percofallaX = a.percofallaX;
        handles.percofallbX = a.percofallbX;
    elseif GateID == 3
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowY = a.percbelowY;
        handles.percaboveY = a.percaboveY;
        handles.numbelowY = a.numbelowY;
        handles.numaboveY = a.numaboveY;
        handles.percofallaY = a.percofallaY;
        handles.percofallbY = a.percofallbY;
    elseif GateID == 2
        handles.StatsMatrixQ1 = a.StatsMatrixQ1;
        handles.StatsMatrixQ2 = a.StatsMatrixQ2;
        handles.StatsMatrixQ3 = a.StatsMatrixQ3;
        handles.StatsMatrixQ4 = a.StatsMatrixQ4;
        handles.percQ1 = a.percQ1;
        handles.percQ2 = a.percQ2;
        handles.percQ3 = a.percQ3;
        handles.percQ4 = a.percQ4;
        handles.percofallQ1 = a.percofallQ1;
        handles.percofallQ2 = a.percofallQ2;
        handles.percofallQ3 = a.percofallQ3;
        handles.percofallQ4 = a.percofallQ4;
        handles.numQ1 = a.numQ1;
        handles.numQ2 = a.numQ2;
        handles.numQ3 = a.numQ3;
        handles.numQ4 = a.numQ4;
    end
    
    set(handles.gatebox,'String',handles.gateboxtext)
    set(handles.gatebox,'Value',handles.gateboxvalue)
    set(handles.asinhX,'Value',state.asinhX);
    set(handles.asinhY,'Value',state.asinhY);
    set(handles.linX,'Value',state.linX);
    set(handles.linY,'Value',state.linY);
    set(handles.linX,'Enable',state.enlinX);
    set(handles.linY,'Enable',state.enlinY);
    set(handles.LinBtn,'Enable',state.LinBtn);
    set(handles.asinhX,'Enable',state.enasinhX);
    set(handles.asinhY,'Enable',state.enasinhY);
    set(handles.BiExBtn,'Enable',state.BiExBtn);
    guidata(hObject,handles)
end
clearvars Im XiT Ws
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject, handles);

% --- Executes on selection change in popupX.
function popupX_Callback(hObject, eventdata, handles)
% hObject    handle to popupX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupX contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupX
% executes plotting when the x axis statistic is changed

% checks if data is arcsinh transformed, one/both axes and if so also
% transforms the gates
set(handles.figure1, 'pointer', 'watch')
drawnow;
if handles.BiExID == 1
    stats1 = handles.stats;
    ind_a = handles.inda;
    ind_b = handles.indb;

    if get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 0
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats1(:,ind_a)) - exp(-1.*(stats1(:,ind_a))));
        stats1(:,ind_a) = lin_StatsX;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',0);
    elseif get(handles.linX,'Value') == 0 & get(handles.linY,'Value') == 1
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats1(:,ind_b)) - exp(-1.*(stats1(:,ind_b))));
        stats1(:,ind_b) = lin_StatsY;
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',0);
        set(handles.asinhY,'Value',1);
    elseif get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 1
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats1(:,ind_a)) - exp(-1.*(stats1(:,ind_a))));
        stats1(:,ind_a) = lin_StatsX;
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats1(:,ind_b)) - exp(-1.*(stats1(:,ind_b))));
        stats1(:,ind_b) = lin_StatsY;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',1);
    end
   	set(handles.linX,'Enable','off');
    set(handles.linY,'Enable','off');
    set(handles.LinBtn,'Enable','off');
    set(handles.asinhX,'Enable','on');
    set(handles.asinhY,'Enable','on');
    set(handles.BiExBtn,'Enable','on');

    handles.stats = stats1;
    handles.BiExID = 0;
    guidata(hObject, handles);
    set(handles.cofactor,'enable','on')
end

Names = handles.names;
a1 = get(hObject,'Value');
a = Names(1,a1);

for i = 1:length(Names)
    if strcmp(a,Names(1,i)) == 1
        ind_a = i;
    end
end
stats = handles.stats;
ind_b = handles.indb;
sizeSc = handles.sizeSc;
f = get(handles.uipanel1,'SelectedObject');
Sel = get(f,'String');
xgate = [];
ygate = str2double(get(handles.Gate_Y,'String'));
StatsMatrixCl = handles.statsCl;
num_forperc = size(StatsMatrixCl,1);
s = get(handles.popupCol,'Value');
kCol = handles.kmCol;
abin = str2double(get(handles.densitybin,'String'));
bins = str2double(get(handles.hist_bins,'String'));
xmin = [];
xmax = [];
set(handles.Xmin,'String',' ');
set(handles.Xmax,'String',' ');
ymin = str2double(get(handles.Ymin,'String'));
ymax = str2double(get(handles.Ymax,'String'));

XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,1,1,...
    str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)

a = getappdata(XIT,'handl');

if get(handles.popupCol,'value') > 2
    cmax = str2double(get(handles.colorMax,'String'));    
    cmin = str2double(get(handles.colorMin,'String'));  
    if isnan(cmin)
        cmin = 0;
    end
    if isnan(cmax)
        cmax = 255;
    end
    axes(handles.axes1)
    caxis([cmin cmax])  
end

GateID = a.ID;
if GateID == 0
elseif GateID == 3
   	handles.StatsMatrix2 = a.StatsMatrix2;
 	handles.StatsMatrix3 = a.StatsMatrix3;
	handles.percbelowY = a.percbelowY;
   	handles.percaboveY = a.percaboveY;
   	handles.numbelowY = a.numbelowY;
  	handles.numaboveY = a.numaboveY;
	handles.percofallaY = a.percofallaY;
   	handles.percofallbY = a.percofallbY;
end

handles.inda = ind_a;
set(handles.textXax,'string',Names(1,ind_a));
set(handles.figure1, 'pointer', 'arrow')

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupX_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in popupY.
function popupY_Callback(hObject, eventdata, handles)
% hObject    handle to popupY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupY contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupY

% Allows the selection of a statistic on the y axis
set(handles.figure1, 'pointer', 'watch')
drawnow;

if handles.BiExID == 1
    stats1 = handles.stats;
    ind_a = handles.inda;
    ind_b = handles.indb;

    if get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 0
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats1(:,ind_a)) - exp(-1.*(stats1(:,ind_a))));
        stats1(:,ind_a) = lin_StatsX;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',0);
    elseif get(handles.linX,'Value') == 0 & get(handles.linY,'Value') == 1
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats1(:,ind_b)) - exp(-1.*(stats1(:,ind_b))));
        stats1(:,ind_b) = lin_StatsY;
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',0);
        set(handles.asinhY,'Value',1);
    elseif get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 1
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats1(:,ind_a)) - exp(-1.*(stats1(:,ind_a))));
        stats1(:,ind_a) = lin_StatsX;
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats1(:,ind_b)) - exp(-1.*(stats1(:,ind_b))));
        stats1(:,ind_b) = lin_StatsY;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',1);
    end
   	set(handles.linX,'Enable','off');
    set(handles.linY,'Enable','off');
    set(handles.LinBtn,'Enable','off');
    set(handles.asinhX,'Enable','on');
    set(handles.asinhY,'Enable','on');
    set(handles.BiExBtn,'Enable','on');

    handles.stats = stats1;
    handles.BiExID = 0;
    guidata(hObject, handles);
    set(handles.cofactor,'enable','on')
end

ind_a = handles.inda;
Names = handles.names;
stats = handles.stats;
b1 = get(hObject,'Value');
b = Names(1,b1);
sizeSc = handles.sizeSc;

for i = 1:length(Names)
    if strcmp(b,Names(1,i)) == 1
        ind_b = i;
    end
end
clearvars b1 b


f = get(handles.uipanel1,'SelectedObject');
Sel = get(f,'String');
xgate = str2double(get(handles.Gate_X,'String'));
ygate = [];
StatsMatrixCl = handles.statsCl;
num_forperc = size(StatsMatrixCl,1);
s = get(handles.popupCol,'Value');
kCol = handles.kmCol;
abin = str2double(get(handles.densitybin,'String'));
bins = str2double(get(handles.hist_bins,'String'));
xmin = str2double(get(handles.Xmin,'String'));
xmax = str2double(get(handles.Xmax,'String'));
ymin = [];
ymax = [];
set(handles.Ymin,'String',' ');
set(handles.Ymax,'String',' ');

XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,1,1,...
    str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)
a = getappdata(XIT,'handl');

if get(handles.popupCol,'value') > 2
    cmax = str2double(get(handles.colorMax,'String'));    
    cmin = str2double(get(handles.colorMin,'String'));  
    if isnan(cmin)
        cmin = 0;
    end
    if isnan(cmax)
        cmax = 255;
    end
    axes(handles.axes1)
    caxis([cmin cmax])  
end

GateID = a.ID;
if GateID == 0
elseif GateID == 1
   	handles.StatsMatrix2 = a.StatsMatrix2;
 	handles.StatsMatrix3 = a.StatsMatrix3;
	handles.percbelowX = a.percbelowX;
   	handles.percaboveX = a.percaboveX;
   	handles.numbelowX = a.numbelowX;
  	handles.numaboveX = a.numaboveX;
	handles.percofallaX = a.percofallaX;
   	handles.percofallbX = a.percofallbX;
end

handles.indb = ind_b;
set(handles.textYax,'string',Names(1,ind_b));
set(handles.figure1, 'pointer', 'arrow')

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupY_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in GateBtn.
function GateBtn_Callback(hObject, eventdata, handles)
% hObject    handle to GateBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Allows Polygon gating on scatter plots
stats = handles.stats;
fig = handles.axes1;
ind_a = handles.inda;
ind_b = handles.indb;
clearst = handles.statsCl;
set(handles.Gate_X,'String',' ');
set(handles.Gate_Y,'String',' ');
s = get(handles.popupCol,'Value');
sizeSc = handles.sizeSc;
kCol = handles.kmCol;
        
% the user can draw a polygon on the main axes
h = impoly(fig);
setColor(h,'r');
nodes = getPosition(h);
% everything outside the polygon (on the lines = within the polygon) will be deleted
selected_indices = find(inpolygon(stats(:,ind_a),stats(:,ind_b), nodes(:,1), nodes(:,2)));
StatsMatrix2 = stats(selected_indices(:,1),:);

%save this gate?
savegate = questdlg('Do you want to save this gate in order to apply it later?','Save gate','Yes','No','Yes');
switch savegate  
	case 'Yes'
        handles.nodes = nodes;
        set(handles.applygateBtn,'Enable','on')
    case 'No'
end

%dialog that allows adding gate view to figures
saveit = questdlg('Do you want to save this gate view in the plot editor?','Add figure','Yes','No','Yes');
set(handles.figure1, 'pointer', 'watch')
drawnow;

switch saveit  
	case 'Yes'
        hold on
        hey = fill(nodes(:,1),nodes(:,2),'k','FaceAlpha',0,'EdgeColor','r','Linewidth',1);
        hold off
        delete(findobj(h));
     	Names = get(handles.popupFigure,'string');
        % checks if there is already an entry in the menu
        if strcmp(Names,'Figures') | strcmp(Names,' ')
            figgi = figure('name',['Figure ' num2str(1)],'numbertitle','off'); set(figgi, 'Visible', 'off');
            name = {get(figgi,'Name')};
            set(handles.popupFigure,'String',name);
            Val = 0;
        else
            Str = get(handles.popupFigure,'String');
            Val = str2num(Str{end,1}(end-1:end));
            figgi = figure('name',['Figure ' num2str(Val+1)],'numbertitle','off'); set(figgi, 'Visible', 'off');
            name = get(figgi,'Name');
            namethere = {get(handles.popupFigure,'String')};
            namethere{1,1}{end+1,1} = name;
            set(handles.popupFigure,'String',namethere{1,1});
        end

        copyobj(fig,figgi); %copies the object
        d = daspect;
        daspect(d);

        hand = findobj(figgi,'type','axes');
        set(handles.popupFigure,'Value',Val+1);

        handles.tx = get(hand,'Xtick');
        handles.ty = get(hand,'Ytick');
        tx = get(hand,'Xtick');
        ty = get(hand,'Ytick');

        kCol = handles.kmCol;
        s = get(handles.popupCol,'Value');

        if strcmp(get(get(handles.axes1,'child'),'type'),'contour')
            cID = 1;
        else
            cID = 0;
        end

        % Matlab2015 specific set the default colormap to jet when needed
        if s == 2 & kCol == 0 & cID == 0
            colormap(figgi,jet);
        elseif s > 2 & kCol == 0
            colormap(figgi,jet);
        elseif s == 2 & kCol == 0 & cID == 1
            myColorMap = jet(4096); 
            myColorMap(1, :) = [1 1 1];
            colormap(figgi,myColorMap);
        end

        histo = handles.histo;
        line = handles.line;
        fillarea =handles.fillarea;

        if histo == 0 & line == 0 & fillarea == 0
            Xstring = cell2mat(get(handles.textXax,'String'));
            Ystring = cell2mat(get(handles.textYax,'String'));
        else
            Xstring = cell2mat(get(handles.textXax,'String'));
            Ystring = get(handles.textYax,'String');
        end

        idcsX = strfind(Xstring,'_');
        idcsY = strfind(Ystring,'_');
        Xstring(idcsX) = ' '; 
        Ystring(idcsY) = ' '; 
        xlabel(Xstring)
        ylabel(Ystring)

        set(figgi, 'Units','normalized', 'OuterPosition',[0.3 0.2 0.3 0.5])
        set(hand,'outerposition',[0 0 1 1],'units','normalized')
        set(hand, 'LooseInset', [0,0,0,0]);
        axis square

        % gets the tick labels to store for adding them later if needed
        var_prep = ['tx_' get(figgi,'Name')];
        var1 = matlab.lang.makeValidName(var_prep);
        eval([var1, '= tx;'])

        var_prep1 = ['ty_' get(figgi,'Name')];
        var2 = matlab.lang.makeValidName(var_prep1);
        eval([var2, '= ty;'])
        eval(['handles.', var1, '= tx;'])
        eval(['handles.', var2, '= ty;'])

        set(handles.popupColor,'Value',1)
        set(handles.popupLiT,'Value',1)
        set(handles.popupFontSize,'Value',10)

        hand = findobj(figgi,'type','axes');
        texthand = findobj(hand,'type','text');
        hline = findobj(figgi, 'type', 'line');

        % reads all properties to be edited later and returns them in the
        % appropriate buttons, check boxes etc.
        a0 = get(hand,'xtick');
        if ~isempty(a0)
            set(handles.Axesti,'Value',1);
        else
            set(handles.Axesti,'Value',0);
        end

        set(handles.ticklabels,'Value',1);

        b = get(hand,'Box');
        if strcmp(b,'on') == 1
            set(handles.tickbox,'Value',1)
        else
            set(handles.tickbox,'Value',0)
        end

        c = get(texthand,'Visible');
        if isempty(c)
            set(handles.ticktext,'Value',0);
        elseif strcmp(c,'on') == 1
            set(handles.ticktext,'Value',1);
        elseif strcmp(c,'off') == 1
            set(handles.ticktext,'Value',0);
        end

        d = get(hand,'Fontsize');
        set(handles.popupFontSize,'Value',d)

        e = 1;
        set(handles.popupLiT,'Value',2)

        f = get(hand,'LineWidth');
        if isempty(f) == 0
            if length(f) > 1
                set(handles.boxthipopup,'Value',f(1,1))
            elseif f == 0.5
                set(handles.boxthipopup,'Value',1)
            else
                set(handles.boxthipopup,'Value',f+1)
            end
        else
            set(handles.boxthipopup,'Value',1)
        end
        delete(hey)
    case 'No'
        delete(findobj(h));
end

% new dataset is plotted
if s == 1 & kCol == 0;
	axes(handles.axes1)
	scatter(StatsMatrix2(:,ind_a),StatsMatrix2(:,ind_b),sizeSc,[0 0 0],'filled');
elseif s == 2 & kCol == 0;
	abin = str2double(get(handles.densitybin,'String'));
	edgesX = linspace(min(StatsMatrix2(:,ind_a)), max(StatsMatrix2(:,ind_a)), abin);
 	edgesY = linspace(min(StatsMatrix2(:,ind_b)), max(StatsMatrix2(:,ind_b)), abin);   
  	[One,~] = size(StatsMatrix2(:,ind_a));  
 	[~,CountsX] = histc(StatsMatrix2(:,ind_a),edgesX);
	[~,CountsY] = histc(StatsMatrix2(:,ind_b),edgesY);         
  	Counts = [CountsX,CountsY];
   	Darray = accumarray(Counts,1)./One;
	DarrayNorm = Darray./max(Darray(:));
    DarrayNorm = imgaussfilt(DarrayNorm,2);   
  	ind = sub2ind(size(DarrayNorm),CountsX,CountsY);    
	col2 = DarrayNorm(ind);
  	U = sortrows([StatsMatrix2(:,ind_a), StatsMatrix2(:,ind_b), col2],3);
  	col1 = U(:,3);   
 	colormap(jet(4096));
  	axes(handles.axes1)
  	scatter(U(:,1),U(:,2),sizeSc,col1,'filled')
elseif s > 2 & kCol == 0;
	es = s-2;
	axes(handles.axes1)
	scatter(StatsMatrix2(:,ind_a),StatsMatrix2(:,ind_b),sizeSc,StatsMatrix2(:,es),'filled');
elseif length(kCol) > 1;
    kCol2 = kCol(selected_indices(:,1),:);
	axes(handles.axes1)
	scatter(StatsMatrix2(:,ind_a),StatsMatrix2(:,ind_b),sizeSc,kCol2,'filled');   
end
axis 'auto xy'
set(handles.Ymin,'String',' ');
set(handles.Ymax,'String',' ');
set(handles.Xmin,'String',' ');
set(handles.Xmax,'String',' ');
        
% percentage of the gate within the parent population is calculated and
% inserted into the gating history table
percofall = size(StatsMatrix2,1)/size(clearst,1)*100;
perc = size(StatsMatrix2,1)/size(stats,1)*100;
numb = size(StatsMatrix2,1);
a = [cell2mat(get(handles.textXax,'String')) ' vs. ' cell2mat(get(handles.textYax,'String')) ' polygon'];
a1 = get(handles.GatingTable,'Data');
a2 = (size(a1,1)+1);
                                
if isempty(a1) == 1 %if its the first entry in the table
    b = {a, numb, perc, percofall};
    set(handles.GatingTable,'Data',b)
else
end
if isempty(a1) == 0 %if there is already an entry in the table
    b1 = {' ', ' ', ' ',' '};
    a1 = [a1; b1];
    a1(a2,:) = {a, numb, perc, percofall};
    set(handles.GatingTable,'Data',a1)
else
end 
handles.stats = StatsMatrix2;
handles.aritstats = StatsMatrix2;
Names = get(handles.gatebox,'string');

for i = 1:length(Names)
	if strcmp(Names{i,1},'...')
        Val = i;
        break
	end
end
% Gating history is updated
gatehist = handles.gatinghist;
gatehist{1,Val} = StatsMatrix2;
gatehist{2,Val} = ind_a;
gatehist{3,Val} = ind_b;

if strcmp(Names{Val-1},'Parent population') == 1
    gatehist{2,Val-1} = ind_a;
    gatehist{3,Val-1} = ind_b;
end

f = get(handles.uipanel1,'SelectedObject');
Sel = get(f,'String');
gatehist{4,Val} = Sel;
asinhIDX = get(handles.asinhX,'Value');
asinhIDY = get(handles.asinhY,'Value');
asinhIDen = get(handles.BiExBtn,'Enable');
if strcmp(asinhIDen,'off')
    asinhIDen = 1;
else
    asinhIDen = 0;
end
if asinhIDen == 1 & (asinhIDX == 1 & asinhIDY == 0) 
    gatehist{5,Val} = 1;
elseif asinhIDen == 1 & (asinhIDX == 0 & asinhIDY == 1)
    gatehist{5,Val} = 2;
elseif asinhIDen == 1 & (asinhIDX == 1 & asinhIDY == 1) 
    gatehist{5,Val} = 3;
elseif asinhIDen == 0
    gatehist{5,Val} = 0;    
end
gatehist{6,Val} = handles.BiExID;
gatehist{7,Val} = handles.names;

handles.gatinghist = gatehist;
Names{Val,1} = a;
Names{Val+1,1} = '...';
set(handles.gatebox,'Value',(Val));
set(handles.gatebox,'String',Names);
set(handles.figure1, 'pointer', 'arrow')

guidata(hObject, handles);


% --- Executes on button press in ExcBtn.
function ExcBtn_Callback(hObject, eventdata, handles)
% hObject    handle to ExcBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Executes gating with values from the apply textboxes
set(handles.figure1, 'pointer', 'watch')
drawnow;

xgate = str2double(get(handles.Gate_X,'String'));
ygate = str2double(get(handles.Gate_Y,'String'));
xgatep = str2double(get(handles.Gate_Xperc,'String'));
ygatep = str2double(get(handles.Gate_Yperc,'String'));
if isnan(xgate)
    xgate = [];
end
if isnan(ygate)
    ygate = [];
end
if isnan(xgatep)
    xgatep = [];
end
if isnan(ygatep)
    ygatep = [];
end

% get the gate information, which gate should be executed
if isempty(xgate) & ~isempty(xgatep) % if there is a perc gat & no value gate take the perc gate
    xgate = xgatep;
end
if isempty(ygate) & ~isempty(ygatep) % if there is a perc gat & no value gate take the perc gate
    ygate = ygatep;
end
if ~isempty(ygate) & ~isempty(ygatep) % if there is a perc gat & a value gate take the val gate
    ygate = ygate;
end
if ~isempty(xgate) & ~isempty(xgatep) % if there is a perc gat & a value gate take the val gate
    xgate = xgate;
end
noX = isempty(xgate);
noY = isempty(ygate);
stats = handles.stats;
% sets gate to empty
set(handles.Gate_X,'String',' ');
set(handles.Gate_Y,'String',' ');
set(handles.Gate_Xperc,'String',' ');
set(handles.Gate_Yperc,'String',' ');
ind_a = handles.inda;
ind_b = handles.indb;
% gets all values needed fro any gating
percQ1 = handles.percQ1;
percQ2 = handles.percQ2;
percQ3 = handles.percQ3;
percQ4 = handles.percQ4;
percofallQ1 = handles.percofallQ1;
percofallQ2 = handles.percofallQ2;
percofallQ3 = handles.percofallQ3;
percofallQ4 = handles.percofallQ4;
numQ1 = handles.numQ1;
numQ2 = handles.numQ2;
numQ3 = handles.numQ3;
numQ4 = handles.numQ4;
percbelowX = handles.percbelowX;
percaboveX = handles.percaboveX;
percofallaX = handles.percofallaX;
percofallbX = handles.percofallbX;
numbelowX = handles.numbelowX;
numaboveX = handles.numaboveX;
percbelowY = handles.percbelowY;
percaboveY = handles.percaboveY;
percofallaY = handles.percofallaY;
percofallbY = handles.percofallbY;
numbelowY = handles.numbelowY;
numaboveY = handles.numaboveY;

sizeSc = handles.sizeSc;
bins = str2double(get(handles.hist_bins,'String'));
% info about which plot is present
histo = handles.histo;
line = handles.line;
fillarea = handles.fillarea;
                
if line == 1 %line plot
   	set(0,'DefaultImageVisible','off')
   	highlow = questdlg('Above or below?','Gate decision','Above','Below','Above');
  	set(0,'DefaultImageVisible','on')
  	switch highlow
        case 'Above' %for the case "above threshold"
       	StatsMatrix3 = handles.StatsMatrix3;    %new statistic
     	statis = handles.StatsMatrix3;
       	axes(handles.axes1)
     	[h,he] = hist(StatsMatrix3(:,ind_a),bins);
      	area1 = sum(h) * (he(2)-he(1));
     	xx = linspace((min(StatsMatrix3(:,ind_a))),max(StatsMatrix3(:,ind_a)));
      	f = ksdensity(StatsMatrix3(:,ind_a),xx,'bandwidth',(max(StatsMatrix3(:,ind_a))-min(StatsMatrix3(:,ind_a)))/200);
      	line = plot(xx,area1*f,'k-');
        axis 'auto xy'
       	set(handles.Ymin,'String',' ');
      	set(handles.Ymax,'String',' ');
     	set(handles.Xmin,'String',' ');
     	set(handles.Xmax,'String',' ');
       	handles.stats = StatsMatrix3;
        handles.aritstats = StatsMatrix3;
      	guidata(hObject, handles)
        a = [cell2mat(get(handles.textXax,'String')) ' above ' num2str(xgate)];
      	a1 = get(handles.GatingTable,'Data');
      	a2 = (size(a1,1)+1);
        % puts gate in gating history table                        
    	if isempty(a1) == 1
        	b = {a, numaboveX, percaboveX, percofallaX};
           	set(handles.GatingTable,'Data',b)
        else
     	end
        if isempty(a1) == 0 
            b1 = {' ', ' ', ' ',' '};
         	a1 = [a1; b1];
          	a1(a2,:) = {a, numaboveX, percaboveX, percofallaX};
           	set(handles.GatingTable,'Data',a1)
        else
        end
        
        case 'Below' %for the case "below threshold"
     	StatsMatrix2 = handles.StatsMatrix2;
        statis = handles.StatsMatrix2;
        axes(handles.axes1)
      	[h,he] = hist(StatsMatrix2(:,ind_a),bins);
       	area1 = sum(h) * (he(2)-he(1));
      	xx = linspace((min(StatsMatrix2(:,ind_a))),max(StatsMatrix2(:,ind_a)));
      	f = ksdensity(StatsMatrix2(:,ind_a),xx,'bandwidth',(max(StatsMatrix2(:,ind_a))-min(StatsMatrix2(:,ind_a)))/200);
      	line = plot(xx,area1*f,'k-');
       	axis 'auto xy'
       	set(handles.Ymin,'String',' ');
      	set(handles.Ymax,'String',' ');
      	set(handles.Xmin,'String',' ');
      	set(handles.Xmax,'String',' ');
       	handles.stats = StatsMatrix2;
        handles.aritstats = StatsMatrix2;
    	guidata(hObject, handles)
        a = [cell2mat(get(handles.textXax,'String')) ' below ' num2str(xgate)];
     	a1 = get(handles.GatingTable,'Data');
      	a2 = (size(a1,1)+1);
        % puts gate in gating history table                            
        if isempty(a1) == 1
        	b = {a, numbelowX, percbelowX, percofallbX};
         	set(handles.GatingTable,'Data',b)
        else
        end
      	if isempty(a1) == 0 
         	b1 = {' ', ' ', ' ',' '};
         	a1 = [a1; b1];
          	a1(a2,:) = {a, numbelowX, percbelowX, percofallbX};
        	set(handles.GatingTable,'Data',a1)
     	end
    end
        
        set(handles.lineplot,'Value',1)
        set(handles.fillplot,'Value',0)
        set(handles.scatterplot,'Value',0)
        set(handles.histplot,'Value',0)          
end

if fillarea == 1 %fill plot
 	set(0,'DefaultImageVisible','off')
   	highlow = questdlg('Above or below?','Gate decision','Above','Below','Above');
  	set(0,'DefaultImageVisible','on')
        switch highlow
            case 'Above'
                statis = handles.StatsMatrix3;
                StatsMatrix3 = handles.StatsMatrix3;
                axes(handles.axes1)
                [h,he] = hist(StatsMatrix3(:,ind_a),bins);
                area1 = sum(h) * (he(2)-he(1));
                xx = linspace((min(StatsMatrix3(:,ind_a))),max(StatsMatrix3(:,ind_a)));
                f = ksdensity(StatsMatrix3(:,ind_a),xx,'bandwidth',(max(StatsMatrix3(:,ind_a))-min(StatsMatrix3(:,ind_a)))/200);
                area(xx,area1*f);
                hold on
                plot(xx,(area1*f),'k-');
                hold off
                axis 'auto xy'
                set(handles.Ymin,'String',' ');
                set(handles.Ymax,'String',' ');
                set(handles.Xmin,'String',' ');
                set(handles.Xmax,'String',' ');
                handles.stats = StatsMatrix3;
                handles.aritstats = StatsMatrix3;
                guidata(hObject, handles)
                a = [cell2mat(get(handles.textXax,'String')) ' above ' num2str(xgate)];
                a1 = get(handles.GatingTable,'Data');
                a2 = (size(a1,1)+1);
                % puts gate in gating history table                    
                if isempty(a1) == 1
                    b = {a, numaboveX, percaboveX, percofallaX};
                    set(handles.GatingTable,'Data',b)
                else
                end
                if isempty(a1) == 0 
                    b1 = {' ', ' ', ' ',' '};
                    a1 = [a1; b1];
                    a1(a2,:) = {a, numaboveX, percaboveX, percofallaX};
                    set(handles.GatingTable,'Data',a1)
                else
                end
            case 'Below'
                StatsMatrix2 = handles.StatsMatrix2;
                statis = handles.StatsMatrix2;
                axes(handles.axes1)
                [h,he] = hist(StatsMatrix2(:,ind_a),bins);
                area1 = sum(h) * (he(2)-he(1));
                xx = linspace((min(StatsMatrix2(:,ind_a))),max(StatsMatrix2(:,ind_a)));
                f = ksdensity(StatsMatrix2(:,ind_a),xx,'bandwidth',(max(StatsMatrix2(:,ind_a))-min(StatsMatrix2(:,ind_a)))/200);
                area(xx,area1*f);
                hold on
                plot(xx,(area1*f),'k-');
                hold off
                axis 'auto xy'
                set(handles.Ymin,'String',' ');
                set(handles.Ymax,'String',' ');
                set(handles.Xmin,'String',' ');
                set(handles.Xmax,'String',' ');
                handles.stats = StatsMatrix2;
                handles.aritstats = StatsMatrix2;
                guidata(hObject, handles)
                % puts gate in gating history table    
                a = [cell2mat(get(handles.textXax,'String')) ' below ' num2str(xgate)];
                a1 = get(handles.GatingTable,'Data');
                a2 = (size(a1,1)+1);
                                
                if isempty(a1) == 1
                    b = {a, numbelowX, percbelowX, percofallbX};
                    set(handles.GatingTable,'Data',b)
                else
                end
                if isempty(a1) == 0 
                    b1 = {' ', ' ', ' ',' '};
                    a1 = [a1; b1];
                    a1(a2,:) = {a, numbelowX, percbelowX, percofallbX};
                    set(handles.GatingTable,'Data',a1)
                end
        end
        set(handles.lineplot,'Value',0)
        set(handles.fillplot,'Value',1)
        set(handles.scatterplot,'Value',0)
        set(handles.histplot,'Value',0)          
end        
        
if histo == 1 %histogram plot
    set(0,'DefaultImageVisible','off')
   	highlow = questdlg('Above or below?','Gate decision','Above','Below','Above');
  	set(0,'DefaultImageVisible','on')
 	switch highlow
        case 'Above'
            statis = handles.StatsMatrix3;
         	StatsMatrix3 = handles.StatsMatrix3;
          	axes(handles.axes1)
         	hist(StatsMatrix3(:,ind_a),bins);
         	axis 'auto xy'
        	set(handles.Ymin,'String',' ');
         	set(handles.Ymax,'String',' ');
         	set(handles.Xmin,'String',' ');
        	set(handles.Xmax,'String',' ');
         	handles.stats = StatsMatrix3;
            handles.aritstats = StatsMatrix3;
         	guidata(hObject, handles)   
         	a = [cell2mat(get(handles.textXax,'String')) ' above ' num2str(xgate)];
          	a1 = get(handles.GatingTable,'Data');
          	a2 = (size(a1,1)+1);                    
         	if isempty(a1) == 1
            	b = {a, numaboveX, percaboveX, percofallaX};
             	set(handles.GatingTable,'Data',b)
            else
            end
          	if isempty(a1) == 0 
                b1 = {' ', ' ', ' ',' '};
              	a1 = [a1; b1];
               	a1(a2,:) = {a, numaboveX, percaboveX, percofallaX};
              	set(handles.GatingTable,'Data',a1)
            else
            end
                
     	case 'Below'
          	StatsMatrix2 = handles.StatsMatrix2;
         	statis = handles.StatsMatrix2;
         	axes(handles.axes1)
           	hist(StatsMatrix2(:,ind_a),bins);
          	axis 'auto xy'
         	set(handles.Ymin,'String',' ');
            set(handles.Ymax,'String',' ');
           	set(handles.Xmin,'String',' ');
          	set(handles.Xmax,'String',' ');
          	handles.stats = StatsMatrix2;
            handles.aritstats = StatsMatrix2;
          	guidata(hObject, handles)   
          	a = [cell2mat(get(handles.textXax,'String')) ' below ' num2str(xgate)];
          	a1 = get(handles.GatingTable,'Data');
           	a2 = (size(a1,1)+1);
                                
         	if isempty(a1) == 1
            	b = {a, numbelowX, percbelowX, percofallbX};
            	set(handles.GatingTable,'Data',b)
            end
        	if isempty(a1) == 0 
            	b1 = {' ', ' ', ' ',' '};
                a1 = [a1; b1];
            	a1(a2,:) = {a, numbelowX, percbelowX, percofallbX};
               	set(handles.GatingTable,'Data',a1)
           	end
        end
        set(handles.lineplot,'Value',0)
        set(handles.fillplot,'Value',0)
        set(handles.scatterplot,'Value',0)
        set(handles.histplot,'Value',1)
end
        
if histo == 0 & line == 0 & fillarea == 0
    if noX == 1 & noY == 0
        set(0,'DefaultImageVisible','off')
        highlow = questdlg('Above or below?','Gate decision','Above','Below','Above');
        set(0,'DefaultImageVisible','on')
        switch highlow
            case 'Above'
                statis = handles.StatsMatrix3;
                StatsMatrix3 = handles.StatsMatrix3;
                [~,n,~] = intersect(stats,statis,'rows');
                s = get(handles.popupCol,'Value');
                kCol = handles.kmCol;
                if s == 1 & kCol == 0;
                    axes(handles.axes1)
                    scatter(StatsMatrix3(:,ind_a),StatsMatrix3(:,ind_b),sizeSc,[0 0 0],'filled');
                elseif s == 2 & kCol == 0;
                    abin = str2double(get(handles.densitybin,'String'));
                    edgesX = linspace(min(StatsMatrix3(:,ind_a)), max(StatsMatrix3(:,ind_a)), abin);
                    edgesY = linspace(min(StatsMatrix3(:,ind_b)), max(StatsMatrix3(:,ind_b)), abin);
                    [One,~] = size(StatsMatrix3(:,ind_a));
                    [~,CountsX] = histc(StatsMatrix3(:,ind_a),edgesX);
                    [~,CountsY] = histc(StatsMatrix3(:,ind_b),edgesY);
                    Counts = [CountsX,CountsY];
                    Darray = accumarray(Counts,1)./One;
                    DarrayNorm = Darray./max(Darray(:));
                    DarrayNorm = imgaussfilt(DarrayNorm,2);
                    ind = sub2ind(size(DarrayNorm),CountsX,CountsY);
                    col2 = DarrayNorm(ind);
                    U = sortrows([StatsMatrix3(:,ind_a), StatsMatrix3(:,ind_b), col2],3);
                    col1 = U(:,3);
                    colormap(jet(4096));
                    axes(handles.axes1)
                    scatter(U(:,1),U(:,2),sizeSc,col1,'filled')
                elseif s > 2 & kCol == 0;
                	es = s-2;
                	axes(handles.axes1)
                	scatter(StatsMatrix3(:,ind_a),StatsMatrix3(:,ind_b),sizeSc,StatsMatrix3(:,es),'filled');
                elseif length(kCol) > 1;
                    kCol2 = handles.kmCol(n);
                	axes(handles.axes1)
                	scatter(StatsMatrix3(:,ind_a),StatsMatrix3(:,ind_b),sizeSc,kCol2,'filled');  
                end
                
                axis 'auto xy'
                set(handles.Ymin,'String',' ');
                set(handles.Ymax,'String',' ');
                set(handles.Xmin,'String',' ');
                set(handles.Xmax,'String',' ');
                handles.stats = StatsMatrix3;
                handles.aritstats = StatsMatrix3;
                guidata(hObject, handles)
                a = [cell2mat(get(handles.textYax,'String')) ' above ' num2str(ygate)];
                a1 = get(handles.GatingTable,'Data');
                a2 = (size(a1,1)+1);
                % puts gate in gating history table                    
                if isempty(a1) == 1
                    b = {a, numaboveY, percaboveY, percofallaY};
                    set(handles.GatingTable,'Data',b)
                end
                if isempty(a1) == 0 
                    b1 = {' ', ' ', ' ',' '};
                    a1 = [a1; b1];
                    a1(a2,:) = {a, numaboveY, percaboveY, percofallaY};
                    set(handles.GatingTable,'Data',a1)
                end
             
            case 'Below'
                StatsMatrix2 = handles.StatsMatrix2;
                statis = handles.StatsMatrix2;
                [~,n,~] = intersect(stats,statis,'rows');
                s = get(handles.popupCol,'Value');
                kCol = handles.kmCol;
                if s == 1 & kCol == 0;
                    axes(handles.axes1)
                    scatter(StatsMatrix2(:,ind_a),StatsMatrix2(:,ind_b),sizeSc,[0 0 0],'filled');
                elseif s == 2 & kCol == 0;
                    abin = str2double(get(handles.densitybin,'String'));
                    edgesX = linspace(min(StatsMatrix2(:,ind_a)), max(StatsMatrix2(:,ind_a)), abin);
                    edgesY = linspace(min(StatsMatrix2(:,ind_b)), max(StatsMatrix2(:,ind_b)), abin);
                    [One,~] = size(StatsMatrix2(:,ind_a));
                    [~,CountsX] = histc(StatsMatrix2(:,ind_a),edgesX);
                    [~,CountsY] = histc(StatsMatrix2(:,ind_b),edgesY);
                    Counts = [CountsX,CountsY];
                    Darray = accumarray(Counts,1)./One;
                    DarrayNorm = Darray./max(Darray(:));
                    DarrayNorm = imgaussfilt(DarrayNorm,2);
                    ind = sub2ind(size(DarrayNorm),CountsX,CountsY);
                    col2 = DarrayNorm(ind);
                    U = sortrows([StatsMatrix2(:,ind_a), StatsMatrix2(:,ind_b), col2],3);
                    col1 = U(:,3);
                    colormap(jet(4096));
                    axes(handles.axes1)
                    scatter(U(:,1),U(:,2),sizeSc,col1,'filled')
                elseif s > 2 & kCol == 0;
                	es = s-2;
                	axes(handles.axes1)
                	scatter(StatsMatrix2(:,ind_a),StatsMatrix2(:,ind_b),sizeSc,StatsMatrix2(:,es),'filled');
                elseif length(kCol) > 1;
                    kCol2 = handles.kmCol(n);
                	axes(handles.axes1)
                	scatter(StatsMatrix2(:,ind_a),StatsMatrix2(:,ind_b),sizeSc,kCol2,'filled');  
                end
                axis 'auto xy'
                set(handles.Ymin,'String',' ');
                set(handles.Ymax,'String',' ');
                set(handles.Xmin,'String',' ');
                set(handles.Xmax,'String',' ');
                handles.stats = StatsMatrix2;
                handles.aritstats = StatsMatrix2;
                guidata(hObject, handles)
                % puts gate in gating history table    
                a = [cell2mat(get(handles.textYax,'String')) ' below ' num2str(ygate)];
                a1 = get(handles.GatingTable,'Data');
                a2 = (size(a1,1)+1);             
                if isempty(a1) == 1
                    b = {a, numbelowY, percbelowY, percofallbY};
                    set(handles.GatingTable,'Data',b)
                end
                if isempty(a1) == 0 
                    b1 = {' ', ' ', ' ',' '};
                    a1 = [a1; b1];
                    a1(a2,:) = {a, numbelowY, percbelowY, percofallbY};
                    set(handles.GatingTable,'Data',a1)
                end
        end
    elseif noY == 1 & noX == 0
        set(0,'DefaultImageVisible','off')
        highlow = questdlg('Above or below?','Gate decision','Above','Below','Above');
        set(0,'DefaultImageVisible','on')
        switch highlow
            case 'Above'
                statis = handles.StatsMatrix3;
                StatsMatrix3 = handles.StatsMatrix3;
                [~,n,~] = intersect(stats,statis,'rows');
                s = get(handles.popupCol,'Value');
                kCol = handles.kmCol;
                if s == 1 & kCol == 0;
                    axes(handles.axes1)
                    scatter(StatsMatrix3(:,ind_a),StatsMatrix3(:,ind_b),sizeSc,[0 0 0],'filled');
                elseif s == 2 & kCol == 0;
                    abin = str2double(get(handles.densitybin,'String'));
                    edgesX = linspace(min(StatsMatrix3(:,ind_a)), max(StatsMatrix3(:,ind_a)), abin);
                    edgesY = linspace(min(StatsMatrix3(:,ind_b)), max(StatsMatrix3(:,ind_b)), abin);
                    [One,~] = size(StatsMatrix3(:,ind_a));
                    [~,CountsX] = histc(StatsMatrix3(:,ind_a),edgesX);
                    [~,CountsY] = histc(StatsMatrix3(:,ind_b),edgesY);
                    Counts = [CountsX,CountsY];
                    Darray = accumarray(Counts,1)./One;
                    DarrayNorm = Darray./max(Darray(:));
                    DarrayNorm = imgaussfilt(DarrayNorm,2);
                    ind = sub2ind(size(DarrayNorm),CountsX,CountsY);
                    col2 = DarrayNorm(ind);
                    U = sortrows([StatsMatrix3(:,ind_a), StatsMatrix3(:,ind_b), col2],3);
                    col1 = U(:,3);
                    colormap(jet(4096));
                    axes(handles.axes1)
                    scatter(U(:,1),U(:,2),sizeSc,col1,'filled')
                elseif s > 2 & kCol == 0;
                	es = s-2;
                	axes(handles.axes1)
                	scatter(StatsMatrix3(:,ind_a),StatsMatrix3(:,ind_b),sizeSc,StatsMatrix3(:,es),'filled');
                elseif length(kCol) > 1;
                    kCol2 = handles.kmCol(n);
                	axes(handles.axes1)
                	scatter(StatsMatrix3(:,ind_a),StatsMatrix3(:,ind_b),sizeSc,kCol2,'filled');  
                end
                axis 'auto xy'
                set(handles.Ymin,'String',' ');
                set(handles.Ymax,'String',' ');
                set(handles.Xmin,'String',' ');
                set(handles.Xmax,'String',' ');
                handles.stats = StatsMatrix3;
                handles.aritstats = StatsMatrix3;
                guidata(hObject, handles)
                % puts gate in gating history table    
                a = [cell2mat(get(handles.textXax,'String')) ' above ' num2str(xgate)];
                a1 = get(handles.GatingTable,'Data');
                a2 = (size(a1,1)+1);                
                if isempty(a1) == 1
                    b = {a, numaboveX, percaboveX, percofallaX};
                    set(handles.GatingTable,'Data',b)
                end
                if isempty(a1) == 0 
                    b1 = {' ', ' ', ' ',' '};
                    a1 = [a1; b1];
                    a1(a2,:) = {a, numaboveX, percaboveX, percofallaX};
                    set(handles.GatingTable,'Data',a1)
                end
            case 'Below'
                StatsMatrix2 = handles.StatsMatrix2;
                statis = handles.StatsMatrix2;
                [~,n,~] = intersect(stats,statis,'rows');
                s = get(handles.popupCol,'Value');
                kCol = handles.kmCol;
                if s == 1 & kCol == 0;
                    axes(handles.axes1)
                    scatter(StatsMatrix2(:,ind_a),StatsMatrix2(:,ind_b),sizeSc,[0 0 0],'filled');
                elseif s == 2 & kCol == 0;
                    abin = str2double(get(handles.densitybin,'String'));
                    edgesX = linspace(min(StatsMatrix2(:,ind_a)), max(StatsMatrix2(:,ind_a)), abin);
                    edgesY = linspace(min(StatsMatrix2(:,ind_b)), max(StatsMatrix2(:,ind_b)), abin);
                    [One,~] = size(StatsMatrix2(:,ind_a));
                    [~,CountsX] = histc(StatsMatrix2(:,ind_a),edgesX);
                    [~,CountsY] = histc(StatsMatrix2(:,ind_b),edgesY);
                    Counts = [CountsX,CountsY];
                    Darray = accumarray(Counts,1)./One;
                    DarrayNorm = Darray./max(Darray(:));
                    DarrayNorm = imgaussfilt(DarrayNorm,2);
                    ind = sub2ind(size(DarrayNorm),CountsX,CountsY);
                    col2 = DarrayNorm(ind);
                    U = sortrows([StatsMatrix2(:,ind_a), StatsMatrix2(:,ind_b), col2],3);
                    col1 = U(:,3);
                    colormap(jet(4096));
                    axes(handles.axes1)
                    scatter(U(:,1),U(:,2),sizeSc,col1,'filled')
                elseif s > 2 & kCol == 0;
                	es = s-2;
                	axes(handles.axes1)
                	scatter(StatsMatrix2(:,ind_a),StatsMatrix2(:,ind_b),sizeSc,StatsMatrix2(:,es),'filled');
                elseif length(kCol) > 1;
                    kCol2 = handles.kmCol(n);
                	axes(handles.axes1)
                	scatter(StatsMatrix2(:,ind_a),StatsMatrix2(:,ind_b),sizeSc,kCol2,'filled');  
                end
                axis 'auto xy'
                set(handles.Ymin,'String',' ');
                set(handles.Ymax,'String',' ');
                set(handles.Xmin,'String',' ');
                set(handles.Xmax,'String',' ');
                handles.stats = StatsMatrix2;
                handles.aritstats = StatsMatrix2;
                guidata(hObject, handles)
                
                % puts gate in gating history table    
                a = [cell2mat(get(handles.textXax,'String')) ' below ' num2str(xgate)];
                a1 = get(handles.GatingTable,'Data');
                a2 = (size(a1,1)+1);                
                if isempty(a1) == 1
                    b = {a, numbelowX, percbelowX, percofallbX};
                    set(handles.GatingTable,'Data',b)
                end
                if isempty(a1) == 0 
                    b1 = {' ', ' ', ' ',' '};
                    a1 = [a1; b1];
                    a1(a2,:) = {a, numbelowX, percbelowX, percofallbX};
                    set(handles.GatingTable,'Data',a1)
                end
        end
    elseif noX == 0 & noY == 0
        highlow = menu('Gate decision','Q1','Q2','Q3','Q4');      
        StatsMatrixQ1 = handles.StatsMatrixQ1;
        StatsMatrixQ2 = handles.StatsMatrixQ2;
        StatsMatrixQ3 = handles.StatsMatrixQ3;
        StatsMatrixQ4 = handles.StatsMatrixQ4;
        kCol = handles.kmCol;
        if highlow == 1
            statis = handles.StatsMatrixQ1;
            [~,n,~] = intersect(stats,statis,'rows');
            figgi = figure(); set(figgi,'visible','off')
            s = get(handles.popupCol,'Value');
         	if s == 1 & kCol == 0;
             	axes(handles.axes1)
              	scatter(StatsMatrixQ1(:,ind_a),StatsMatrixQ1(:,ind_b),sizeSc,[0 0 0],'filled');
         	elseif s == 2 & kCol == 0;
               	abin = str2double(get(handles.densitybin,'String'));
              	edgesX = linspace(min(StatsMatrixQ1(:,ind_a)), max(StatsMatrixQ1(:,ind_a)), abin);
                edgesY = linspace(min(StatsMatrixQ1(:,ind_b)), max(StatsMatrixQ1(:,ind_b)), abin);
                [One,~] = size(StatsMatrixQ1(:,ind_a));
                [~,CountsX] = histc(StatsMatrixQ1(:,ind_a),edgesX);
                [~,CountsY] = histc(StatsMatrixQ1(:,ind_b),edgesY);
                Counts = [CountsX,CountsY];
               	Darray = accumarray(Counts,1)./One;
              	DarrayNorm = Darray./max(Darray(:));
                DarrayNorm = imgaussfilt(DarrayNorm,2);
                ind = sub2ind(size(DarrayNorm),CountsX,CountsY);
                col2 = DarrayNorm(ind);
              	U = sortrows([StatsMatrixQ1(:,ind_a), StatsMatrixQ1(:,ind_b), col2],3);
             	col1 = U(:,3);
                colormap(jet(4096));
             	axes(handles.axes1)
               	scatter(U(:,1),U(:,2),sizeSc,col1,'filled')
          	elseif s > 2 & kCol == 0;
               	es = s-2;
               	axes(handles.axes1)
             	scatter(StatsMatrixQ1(:,ind_a),StatsMatrixQ1(:,ind_b),sizeSc,StatsMatrixQ1(:,es),'filled');
            elseif length(kCol) > 1;
              	kCol2 = handles.kmCol(n);
              	axes(handles.axes1)
             	scatter(StatsMatrixQ1(:,ind_a),StatsMatrixQ1(:,ind_b),sizeSc,kCol2,'filled');  
            end
          	axis 'auto xy'
          	set(handles.Ymin,'String',' ');
           	set(handles.Ymax,'String',' ');
          	set(handles.Xmin,'String',' ');
          	set(handles.Xmax,'String',' ');
          	handles.stats = StatsMatrixQ1;
            handles.aritstats = StatsMatrixQ1;
          	guidata(hObject, handles)
            
            % puts gate in gate history table     
           	a = [cell2mat(get(handles.textXax,'String')) '(' num2str(xgate) ')'...
                    ' vs. ' cell2mat(get(handles.textYax,'String')) '(' num2str(ygate) ')' ' Q1'];
         	a1 = get(handles.GatingTable,'Data');
        	a2 = (size(a1,1)+1);
                                
           	if isempty(a1) == 1
                b = {a, numQ1, percQ1, percofallQ1};
             	set(handles.GatingTable,'Data',b)
            end
            if isempty(a1) == 0 
                b1 = {' ', ' ', ' ',' '};
               	a1 = [a1; b1];
              	a1(a2,:) = {a, numQ1, percQ1, percofallQ1};
               	set(handles.GatingTable,'Data',a1)
           	end
        elseif highlow == 2
            statis = handles.StatsMatrixQ2;
            [~,n,~] = intersect(stats,statis,'rows');
            s = get(handles.popupCol,'Value');
            kCol = handles.kmCol;
            if s == 1 & kCol == 0;
            	axes(handles.axes1)
             	scatter(StatsMatrixQ2(:,ind_a),StatsMatrixQ2(:,ind_b),sizeSc,[0 0 0],'filled');
           	elseif s == 2 & kCol == 0;
              	abin = str2double(get(handles.densitybin,'String'));
               	edgesX = linspace(min(StatsMatrixQ2(:,ind_a)), max(StatsMatrixQ2(:,ind_a)), abin);
              	edgesY = linspace(min(StatsMatrixQ2(:,ind_b)), max(StatsMatrixQ2(:,ind_b)), abin);
                [One,~] = size(StatsMatrixQ2(:,ind_a));
                [~,CountsX] = histc(StatsMatrixQ2(:,ind_a),edgesX);
               	[~,CountsY] = histc(StatsMatrixQ2(:,ind_b),edgesY);
                Counts = [CountsX,CountsY];
            	Darray = accumarray(Counts,1)./One;
              	DarrayNorm = Darray./max(Darray(:));
                DarrayNorm = imgaussfilt(DarrayNorm,2);
                ind = sub2ind(size(DarrayNorm),CountsX,CountsY);
                col2 = DarrayNorm(ind);
               	U = sortrows([StatsMatrixQ2(:,ind_a), StatsMatrixQ2(:,ind_b), col2],3);
              	col1 = U(:,3);
                colormap(jet(4096));
                axes(handles.axes1)
              	scatter(U(:,1),U(:,2),sizeSc,col1,'filled')
            elseif s > 2 & kCol == 0;
              	es = s-2;
               	axes(handles.axes1)
               	scatter(StatsMatrixQ2(:,ind_a),StatsMatrixQ2(:,ind_b),sizeSc,StatsMatrixQ2(:,es),'filled');
         	elseif length(kCol) > 1;
              	kCol2 = handles.kmCol(n);
               	axes(handles.axes1)
               	scatter(StatsMatrixQ2(:,ind_a),StatsMatrixQ2(:,ind_b),sizeSc,kCol2,'filled');  
            end
           	axis 'auto xy'
           	set(handles.Ymin,'String',' ');
          	set(handles.Ymax,'String',' ');
           	set(handles.Xmin,'String',' ');
         	set(handles.Xmax,'String',' ');
           	handles.stats = StatsMatrixQ2;
            handles.aritstats = StatsMatrixQ2;
          	guidata(hObject, handles)
            
            % puts gate in gate history table    
           	a = [cell2mat(get(handles.textXax,'String')) '(' num2str(xgate) ')'...
                    ' vs. ' cell2mat(get(handles.textYax,'String')) '(' num2str(ygate) ')' ' Q2'];
           	a1 = get(handles.GatingTable,'Data');
          	a2 = (size(a1,1)+1);
            if isempty(a1) == 1
             	b = {a, numQ2, percQ2, percofallQ2};
              	set(handles.GatingTable,'Data',b)
            end
           	if isempty(a1) == 0 
            	b1 = {' ', ' ', ' ',' '};
              	a1 = [a1; b1];
             	a1(a2,:) = {a, numQ2, percQ2, percofallQ2};
              	set(handles.GatingTable,'Data',a1)
            end
        elseif highlow == 3
            statis = handles.StatsMatrixQ3;
            [~,n,~] = intersect(stats,statis,'rows');
            s = get(handles.popupCol,'Value');
          	kCol = handles.kmCol;
         	if s == 1 & kCol == 0;
             	axes(handles.axes1)
              	scatter(StatsMatrixQ3(:,ind_a),StatsMatrixQ3(:,ind_b),sizeSc,[0 0 0],'filled');
          	elseif s == 2 & kCol == 0;
              	abin = str2double(get(handles.densitybin,'String'));
             	edgesX = linspace(min(StatsMatrixQ3(:,ind_a)), max(StatsMatrixQ3(:,ind_a)), abin);
              	edgesY = linspace(min(StatsMatrixQ3(:,ind_b)), max(StatsMatrixQ3(:,ind_b)), abin);
                [One,~] = size(StatsMatrixQ3(:,ind_a));
                [~,CountsX] = histc(StatsMatrixQ3(:,ind_a),edgesX);
             	[~,CountsY] = histc(StatsMatrixQ3(:,ind_b),edgesY);
                Counts = [CountsX,CountsY];
             	Darray = accumarray(Counts,1)./One;
              	DarrayNorm = Darray./max(Darray(:));
                DarrayNorm = imgaussfilt(DarrayNorm,2);
                ind = sub2ind(size(DarrayNorm),CountsX,CountsY);
                col2 = DarrayNorm(ind);
              	U = sortrows([StatsMatrixQ3(:,ind_a), StatsMatrixQ3(:,ind_b), col2],3);
               	col1 = U(:,3);
             	colormap(jet(4096));
              	axes(handles.axes1)
              	scatter(U(:,1),U(:,2),sizeSc,col1,'filled')
          	elseif s > 2 & kCol == 0;
              	es = s-2;
              	axes(handles.axes1)
               	scatter(StatsMatrixQ3(:,ind_a),StatsMatrixQ3(:,ind_b),sizeSc,StatsMatrixQ3(:,es),'filled');
          	elseif length(kCol) > 1;
               	kCol2 = handles.kmCol(n);
             	axes(handles.axes1)
              	scatter(StatsMatrixQ3(:,ind_a),StatsMatrixQ3(:,ind_b),sizeSc,kCol2,'filled');  
          	end
          	axis 'auto xy'
          	set(handles.Ymin,'String',' ');
          	set(handles.Ymax,'String',' ');
           	set(handles.Xmin,'String',' ');
           	set(handles.Xmax,'String',' ');
          	handles.stats = StatsMatrixQ3;
            handles.aritstats = StatsMatrixQ3;
          	guidata(hObject, handles)
            
            % puts gate in gate history table    
           	a = [cell2mat(get(handles.textXax,'String')) '(' num2str(xgate) ')'...
                    ' vs. ' cell2mat(get(handles.textYax,'String')) '(' num2str(ygate) ')' ' Q3'];
          	a1 = get(handles.GatingTable,'Data');
          	a2 = (size(a1,1)+1);
            if isempty(a1) == 1
             	b = {a, numQ3, percQ3, percofallQ3};
              	set(handles.GatingTable,'Data',b)
            end
           	if isempty(a1) == 0 
            	b1 = {' ', ' ', ' ',' '};
               	a1 = [a1; b1];
              	a1(a2,:) = {a, numQ3, percQ3, percofallQ3};
              	set(handles.GatingTable,'Data',a1)
           end
        elseif highlow == 4
            statis = handles.StatsMatrixQ4;
            [~,n,~] = intersect(stats,statis,'rows');
            s = get(handles.popupCol,'Value');
           	kCol = handles.kmCol;
        	if s == 1 & kCol == 0;
            	axes(handles.axes1)
            	scatter(StatsMatrixQ4(:,ind_a),StatsMatrixQ4(:,ind_b),sizeSc,[0 0 0],'filled');
          	elseif s == 2 & kCol == 0;
              	abin = str2double(get(handles.densitybin,'String'));
             	edgesX = linspace(min(StatsMatrixQ4(:,ind_a)), max(StatsMatrixQ4(:,ind_a)), abin);
             	edgesY = linspace(min(StatsMatrixQ4(:,ind_b)), max(StatsMatrixQ4(:,ind_b)), abin);
                [One,~] = size(StatsMatrixQ4(:,ind_a));
                [~,CountsX] = histc(StatsMatrixQ4(:,ind_a),edgesX);
              	[~,CountsY] = histc(StatsMatrixQ4(:,ind_b),edgesY);
                Counts = [CountsX,CountsY];
             	Darray = accumarray(Counts,1)./One;
             	DarrayNorm = Darray./max(Darray(:));
                DarrayNorm = imgaussfilt(DarrayNorm,2);
                ind = sub2ind(size(DarrayNorm),CountsX,CountsY);
                col2 = DarrayNorm(ind);
              	U = sortrows([StatsMatrixQ4(:,ind_a), StatsMatrixQ4(:,ind_b), col2],3);
            	col1 = U(:,3);
                colormap(jet(4096));
              	axes(handles.axes1)
              	scatter(U(:,1),U(:,2),sizeSc,col1,'filled')
        	elseif s > 2 & kCol == 0;
              	es = s-2;
             	axes(handles.axes1)
               	scatter(StatsMatrixQ4(:,ind_a),StatsMatrixQ4(:,ind_b),sizeSc,StatsMatrixQ4(:,es),'filled');
          	elseif length(kCol) > 1;
             	kCol2 = handles.kmCol(n);
              	axes(handles.axes1)
               	scatter(StatsMatrixQ4(:,ind_a),StatsMatrixQ4(:,ind_b),sizeSc,kCol2,'filled');  
         	end
          	axis 'auto xy'
           	set(handles.Ymin,'String',' ');
          	set(handles.Ymax,'String',' ');
           	set(handles.Xmin,'String',' ');
          	set(handles.Xmax,'String',' ');
         	handles.stats = StatsMatrixQ4;
            handles.aritstats = StatsMatrixQ4;
        	guidata(hObject, handles)
            
            % puts gate in gate history table    
           	a = [cell2mat(get(handles.textXax,'String')) '(' num2str(xgate) ')'...
                    ' vs. ' cell2mat(get(handles.textYax,'String')) '(' num2str(ygate) ')' ' Q4'];
           	a1 = get(handles.GatingTable,'Data');
          	a2 = (size(a1,1)+1);
            if isempty(a1) == 1
                b = {a, numQ4, percQ4, percofallQ4};
                set(handles.GatingTable,'Data',b)
            end
          	if isempty(a1) == 0 
                b1 = {' ', ' ', ' ', ' '};
              	a1 = [a1; b1];
            	a1(a2,:) = {a, numQ4, percQ4, percofallQ4};
                set(handles.GatingTable,'Data',a1)
          	end
        end
    end
    set(handles.lineplot,'Value',0)
    set(handles.fillplot,'Value',0)
    set(handles.histplot,'Value',0)
end

% update gatebox
Names = get(handles.gatebox,'string');
for i = 1:length(Names)
	if strcmp(Names{i,1},'...')
        Val = i;
        break
    end
end
gatehist = handles.gatinghist;
gatehist{1,Val} = statis;
gatehist{2,Val} = ind_a;
gatehist{3,Val} = ind_b;

if strcmp(Names{Val-1},'Parent population') == 1
    gatehist{2,Val-1} = ind_a;
    gatehist{3,Val-1} = ind_b;
end

f = get(handles.uipanel1,'SelectedObject');
Sel = get(f,'String');
gatehist{4,Val} = Sel;
asinhIDX = get(handles.asinhX,'Value');
asinhIDY = get(handles.asinhY,'Value');
asinhIDen = handles.BiExID;
if asinhIDen == 1 & (asinhIDX == 1 & asinhIDY == 0) 
    gatehist{5,Val} = 1;
elseif asinhIDen == 1 & (asinhIDX == 0 & asinhIDY == 1)
    gatehist{5,Val} = 2;
elseif asinhIDen == 1 & (asinhIDX == 1 & asinhIDY == 1) 
    gatehist{5,Val} = 3;
elseif asinhIDen == 0
    gatehist{5,Val} = 0;    
end
gatehist{6,Val} = asinhIDen;
gatehist{7,Val} = handles.names;
handles.gatinghist = gatehist;

Names{Val,1} = a;
Names{Val+1,1} = '...';
set(handles.gatebox,'Value',(Val));
set(handles.gatebox,'String',Names);
set(handles.figure1, 'pointer', 'arrow')

guidata(hObject, handles)

% --- Executes on button press in ClearBtn.
function ClearBtn_Callback(hObject, eventdata, handles)
% hObject    handle to ClearBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% deletes gates and spatial gating, also arithmetic and sets the GUI back
% to its original state
% get original values
set(handles.figure1, 'pointer', 'watch')
drawnow;

Cleared_stats = handles.statsClear;
Names_of_stats = handles.namesCl;
ExpNames = handles.StatNames;
ind_a = 1;
ind_b = length(Names_of_stats);
set(handles.popupX,'Value',1)
set(handles.popupY,'Value',length(Names_of_stats))
% plot the default density plot
abin = 250;
set(handles.densitybin,'String','250');
edgesX = linspace(min(Cleared_stats(:,ind_a)), max(Cleared_stats(:,ind_a)), abin);
edgesY = linspace(min(Cleared_stats(:,ind_b)), max(Cleared_stats(:,ind_b)), abin);      
[One,~] = size(Cleared_stats(:,ind_a));
[~,CountsX] = histc(Cleared_stats(:,ind_a),edgesX);
[~,CountsY] = histc(Cleared_stats(:,ind_b),edgesY);        
Counts = [CountsX,CountsY];
Darray = accumarray(Counts,1)./One;
DarrayNorm = Darray./max(Darray(:)); 
DarrayNorm = imgaussfilt(DarrayNorm,2);
ind = sub2ind(size(DarrayNorm),CountsX,CountsY);
col2 = DarrayNorm(ind);
U = sortrows([Cleared_stats(:,ind_a), Cleared_stats(:,ind_b), col2],3);
col1 = U(:,3);
colormap(jet(4096));
axes(handles.axes1)
scatter(U(:,1),U(:,2),10,col1,'filled')
% set GUI state to the initial state
set(handles.cofactor,'enable','on')
set(handles.LinBtn,'Enable','off')
set(handles.BiExBtn,'Enable','on')
set(handles.linX,'Enable','off')
set(handles.linY,'Enable','off')
set(handles.asinhX,'Enable','on')
set(handles.asinhY,'Enable','on')
set(handles.linX,'Value',1)
set(handles.linY,'Value',1)
set(handles.asinhX,'Value',1)
set(handles.asinhY,'Value',1)
set(handles.textXax,'string',Names_of_stats(1,1));
set(handles.textYax,'string',Names_of_stats(1,ind_b));
set(handles.StaAtext,'string',' ');
set(handles.StaBtext,'string',' ');
set(handles.popupX,'String',Names_of_stats)
set(handles.popupY,'String',Names_of_stats)
gatinghist = cell(7,100);
gatinghist{1,1} = Cleared_stats;
gatinghist{2,1} = ind_a;
gatinghist{3,1} = ind_b;
gatinghist{4,1} = 'Scatter';
gatinghist{5,1} = 0;
gatinghist{6,1} = 0;
gatinghist{7,1} = Names_of_stats;
celli = {'Parent population'; '...'};
set(handles.gatebox,'String',celli);
set(handles.gatebox,'Value',1);
set(handles.scatterplot,'value',1);
set(handles.histplot,'value',0);
set(handles.lineplot,'value',0);
set(handles.fillplot,'value',0);
set(handles.plusrad,'value',0);
set(handles.radminus,'value',0);
set(handles.radmultiply,'value',0);
set(handles.raddivide,'value',0);
set(handles.popupY,'Enable','on');
set(handles.hist_bins,'String','1000');
axis 'auto xy'
set(handles.Ymin,'String',' ');
set(handles.Ymax,'String',' ');
set(handles.Xmin,'String',' ');
set(handles.Xmax,'String',' ');
set(handles.Gate_Y,'String',' ');
set(handles.Gate_X,'String',' ');
set(handles.Gate_Y,'Enable','on');
set(handles.Gate_Yperc,'Enable','on');
set(handles.Gate_Yperc,'String',' ');
set(handles.Gate_Xperc,'String',' ');
set(handles.popupCol,'Value',2);
set(handles.popupSize,'Value',2);
set(handles.GateBtn,'Enable','on')
set(handles.RectGateBtn,'Enable','on')
set(handles.cofactor,'Enable','on')
set(handles.cofactor,'String','1')
set(handles.colasinh,'value',0)
set(handles.cofact_col,'String','1')
Name_of_col = ['Black' 'Density' Names_of_stats];
set(handles.popupCol,'string',Name_of_col);

handles.gatinghist = gatinghist;
handles.BiExID = 0;
handles.kmCol = 0;
handles.sizeSc = 10;
handles.percQ1 = 0;
handles.percQ2 = 0;
handles.percQ3 = 0;
handles.percQ4 = 0;
handles.percofallQ1 = 0;
handles.percofallQ2 = 0;
handles.percofallQ3 = 0;
handles.percofallQ4 = 0;
handles.numQ1 = 0;
handles.numQ2 = 0;
handles.numQ3 = 0;
handles.numQ4 = 0;
handles.percbelowX = 0;
handles.percaboveX = 0;
handles.percofallbX = 0;
handles.percofallaX = 0;
handles.numbelowX = 0;
handles.numaboveX = 0;
handles.percbelowY = 0;
handles.percaboveY = 0;
handles.percofallbY = 0;
handles.percofallaY = 0;
handles.numbelowY = 0;
handles.numaboveY = 0;
set(handles.GatingTable,'Data',[])
handles.line = 0;
handles.fillarea = 0;
handles.histo = 0;
handles.stats = Cleared_stats;
handles.statsCl = Cleared_stats;
handles.names = Names_of_stats;
handles.NamesforExp = ExpNames;
handles.inda = ind_a;
handles.indb = ind_b;
handles.indexAa = 1;
handles.indexAb = 1;
handles.aritID = 0;
set(handles.applygateBtn,'Enable','off')
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject, handles);

% --- Executes on button press in ExportBtn.
function ExportBtn_Callback(hObject, eventdata, handles)
% hObject    handle to ExportBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% allows the user to export the statistic of the current gate in the XIT format
set(handles.figure1, 'pointer', 'watch')
drawnow;

stats = handles.stats;
BiExID = handles.BiExID;
ind_a = handles.inda;
ind_b = handles.indb;

if BiExID == 1
    set(handles.asinhX,'Enable','on');
    set(handles.asinhY,'Enable','on');
    set(handles.BiExBtn,'Enable','on');
    set(handles.linX,'Enable','off');
    set(handles.linY,'Enable','off');
    set(handles.LinBtn,'Enable','off');
    if get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 0
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats(:,ind_a)) - exp(-1.*(stats(:,ind_a))));
        stats(:,ind_a) = lin_StatsX;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',0);
    elseif get(handles.linX,'Value') == 0 & get(handles.linY,'Value') == 1
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats(:,ind_b)) - exp(-1.*(stats(:,ind_b))));
        stats(:,ind_b) = lin_StatsY;
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',0);
        set(handles.asinhY,'Value',1);
    elseif get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 1
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats(:,ind_a)) - exp(-1.*(stats(:,ind_a))));
        stats(:,ind_a) = lin_StatsX;
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats(:,ind_b)) - exp(-1.*(stats(:,ind_b))));
        stats(:,ind_b) = lin_StatsY;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',1);
    end
end

StatNames  =  handles.NamesforExp;
Export = [StatNames; num2cell(stats)];
pathname = handles.savepath;
saveID = handles.saveID;

% if a savepath has been defined the browser starts there, otherwise it
% starts from c
if saveID == 1
    [FileName,pathname] = uiputfile('*.xlsx','Save stats as XiT format',pathname);
    FileName2 = fullfile(pathname, FileName);
    PathName = pathname;
else    
    [FileName,PathName] = uiputfile('*.xlsx','Save stats as XiT format');
    FileName2 = fullfile(PathName, FileName);
end
if ~ischar(PathName)

else
    xlswrite(FileName2,Export)
    waitfor(msgbox('Export successful!'))
    drawnow;
end
set(handles.figure1, 'pointer', 'arrow')



% --- Executes on button press in LTformat.
function LTformat_Callback(hObject, eventdata, handles)
% hObject    handle to LTformat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of LTformat

% --- Executes when selected object is changed in uipanel1.
function uipanel1_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanel1 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
% allows selection between scatter/histogram/line/fill plots
set(handles.figure1, 'pointer', 'watch')
drawnow;

f = get(handles.uipanel1,'SelectedObject');
Sel = get(f,'String');
stats = handles.stats;
Names = handles.names;
ind_a = handles.inda;
ind_b = handles.indb;

xgate = str2double(get(handles.Gate_X,'String'));
ygate = str2double(get(handles.Gate_Y,'String'));
if isempty(get(handles.Gate_Xperc,'String'))
    set(handles.Gate_Xperc,'String',' ')
end
if isempty(get(handles.Gate_Yperc,'String'))
    set(handles.Gate_Yperc,'String',' ')
end
if strcmp(' ',get(handles.Gate_Xperc,'String')) == 0 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 1
	xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
	xgate = prctile(stats(:,ind_a),xgate_perc);
  	ygate = str2double(get(handles.Gate_Y,'String'));
elseif strcmp(' ',get(handles.Gate_Xperc,'String')) == 1 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 0
   	ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
  	ygate = prctile(stats(:,ind_b),ygate_perc);
 	xgate = str2double(get(handles.Gate_X,'String'));
elseif strcmp(' ',get(handles.Gate_Xperc,'String')) == 0 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 0
  	xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
  	ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
  	set(handles.Gate_X,'String',' ');
  	set(handles.Gate_Y,'String',' ');
	xgate = prctile(stats(:,ind_a),xgate_perc);
	ygate = prctile(stats(:,ind_b),ygate_perc);
elseif strcmp(' ',get(handles.Gate_Xperc,'String')) == 1 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 1
 	xgate = str2double(get(handles.Gate_X,'String'));
   	ygate = str2double(get(handles.Gate_Y,'String'));
end
    
StatsMatrixCl = handles.statsCl;
num_forperc = size(StatsMatrixCl,1);
sizeSc = handles.sizeSc;
s = get(handles.popupCol,'Value');
kCol = handles.kmCol;
abin = str2double(get(handles.densitybin,'String'));
bins = str2double(get(handles.hist_bins,'String'));

xmin = str2double(get(handles.Xmin,'String'));
xmax = str2double(get(handles.Xmax,'String'));
ymin = str2double(get(handles.Ymin,'String'));
ymax = str2double(get(handles.Ymax,'String'));

XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,1,1,...
str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)

if get(handles.popupCol,'value') > 2
    cmax = str2double(get(handles.colorMax,'String'));    
    cmin = str2double(get(handles.colorMin,'String'));  
    if isnan(cmin)
        cmin = 0;
    end
    if isnan(cmax)
        cmax = 255;
    end
    axes(handles.axes1)
    caxis([cmin cmax])  
end
    
a = getappdata(XIT,'handl');

% put the settings of the GUI to fitthe plot selected
switch Sel
    case 'Scatter'
        set(handles.GateBtn,'Enable','on')
        set(handles.RectGateBtn,'Enable','on')
        set(handles.textXax,'string',Names(1,ind_a));
        set(handles.textYax,'string',Names(1,ind_b));
        set(handles.textXax,'value',ind_a);
        set(handles.textYax,'value',ind_b);
        set(handles.popupY,'Enable','on')
        set(handles.histplot,'value',0)
        set(handles.lineplot,'value',0)
        set(handles.fillplot,'value',0)
        set(handles.Gate_Y,'Enable','on');
        set(handles.Gate_Y,'String',' ');
        set(handles.Gate_Yperc,'Enable','on');
        set(handles.Gate_Yperc,'String',' ');
        handles.histo = 0;
        handles.line = 0;
        handles.fillarea = 0;
    case 'Histogram'
        set(handles.scatterplot,'value',0)
        set(handles.lineplot,'value',0)
        set(handles.fillplot,'value',0)
        set(handles.GateBtn,'Enable','off')
        set(handles.RectGateBtn,'Enable','off')
        set(handles.Gate_Y,'Enable','off');
        set(handles.Gate_Y,'String',' ');
        set(handles.Gate_Yperc,'Enable','off');
        set(handles.Gate_Yperc,'String',' ');
        set(handles.popupY,'Enable','off')
        set(handles.textYax,'string','Count');
        set(handles.textXax,'string',Names(1,ind_a));
        set(handles.textXax,'value',ind_a);  
        handles.histo = 1;
        handles.line = 0;
        handles.fillarea = 0;
    case 'Line'
        set(handles.scatterplot,'value',0)
        set(handles.histplot,'value',0)
        set(handles.fillplot,'value',0)
        set(handles.GateBtn,'Enable','off')
        set(handles.RectGateBtn,'Enable','off')
        set(handles.Gate_Y,'Enable','off');
        set(handles.Gate_Y,'String',' ');
        set(handles.Gate_Yperc,'Enable','off');
        set(handles.Gate_Yperc,'String',' ');
        set(handles.popupY,'Enable','off')
        set(handles.textYax,'string','Count');
        set(handles.textXax,'string',Names(1,ind_a));
        set(handles.textXax,'value',ind_a);    
        handles.linehandle = line;
        handles.histo = 0;
        handles.line = 1;
        handles.fillarea = 0;
    case 'Fill'
        set(handles.scatterplot,'value',0)
        set(handles.histplot,'value',0)
        set(handles.lineplot,'value',0)
        set(handles.GateBtn,'Enable','off')
        set(handles.RectGateBtn,'Enable','off')
        set(handles.Gate_Y,'Enable','off');
        set(handles.Gate_Y,'String',' ');
        set(handles.Gate_Yperc,'Enable','off');
        set(handles.Gate_Yperc,'String',' ');
        set(handles.popupY,'Enable','off')
        set(handles.textYax,'string','Count');
        set(handles.textXax,'string',Names(1,ind_a));
        set(handles.textXax,'value',ind_a);
        handles.histo = 0;
        handles.line = 0;
        handles.fillarea = 1;
end

a = getappdata(XIT,'handl');
GateID = a.ID;
if GateID == 0
elseif GateID == 1
	handles.StatsMatrix2 = a.StatsMatrix2;
	handles.StatsMatrix3 = a.StatsMatrix3;
  	handles.percbelowX = a.percbelowX;
   	handles.percaboveX = a.percaboveX;
   	handles.numbelowX = a.numbelowX;
   	handles.numaboveX = a.numaboveX;
 	handles.percofallaX = a.percofallaX;
  	handles.percofallbX = a.percofallbX;
elseif GateID == 3
  	handles.StatsMatrix2 = a.StatsMatrix2;
  	handles.StatsMatrix3 = a.StatsMatrix3;
   	handles.percbelowY = a.percbelowY;
  	handles.percaboveY = a.percaboveY;
 	handles.numbelowY = a.numbelowY;
  	handles.numaboveY = a.numaboveY;
   	handles.percofallaY = a.percofallaY;
  	handles.percofallbY = a.percofallbY;
elseif GateID == 2
   	handles.StatsMatrixQ1 = a.StatsMatrixQ1;
  	handles.StatsMatrixQ2 = a.StatsMatrixQ2;
  	handles.StatsMatrixQ3 = a.StatsMatrixQ3;
  	handles.StatsMatrixQ4 = a.StatsMatrixQ4;
  	handles.percQ1 = a.percQ1;
   	handles.percQ2 = a.percQ2;
   	handles.percQ3 = a.percQ3;
   	handles.percQ4 = a.percQ4;
   	handles.percofallQ1 = a.percofallQ1;
   	handles.percofallQ2 = a.percofallQ2;
   	handles.percofallQ3 = a.percofallQ3;
   	handles.percofallQ4 = a.percofallQ4;
  	handles.numQ1 = a.numQ1;
   	handles.numQ2 = a.numQ2;
  	handles.numQ3 = a.numQ3;
   	handles.numQ4 = a.numQ4;
end
set(handles.figure1, 'pointer', 'arrow')

guidata(hObject, handles);
   
function hist_bins_Callback(hObject, eventdata, handles)
% hObject    handle to hist_bins (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of hist_bins as text
%        str2double(get(hObject,'String')) returns contents of hist_bins as a double

% --- Executes during object creation, after setting all properties.
function hist_bins_CreateFcn(hObject, eventdata, handles)
% hObject    handle to hist_bins (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function Ymin_Callback(hObject, eventdata, handles)
% hObject    handle to Ymin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ymin as text
%        str2double(get(hObject,'String')) returns contents of Ymin as a double

% --- Executes during object creation, after setting all properties.
function Ymin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ymin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function Ymax_Callback(hObject, eventdata, handles)
% hObject    handle to Ymax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ymax as text
%        str2double(get(hObject,'String')) returns contents of Ymax as a double

% --- Executes during object creation, after setting all properties.
function Ymax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ymax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Xmin_Callback(hObject, eventdata, handles)
% hObject    handle to Xmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Xmin as text
%        str2double(get(hObject,'String')) returns contents of Xmin as a double

% --- Executes during object creation, after setting all properties.
function Xmin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Xmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function Xmax_Callback(hObject, eventdata, handles)
% hObject    handle to Xmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Xmax as text
%        str2double(get(hObject,'String')) returns contents of Xmax as a double

% --- Executes during object creation, after setting all properties.
function Xmax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Xmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in ClearY.
function ClearY_Callback(hObject, eventdata, handles)
% hObject    handle to ClearY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% resets the y axis so that Matlab chooses the limits
set(handles.figure1, 'pointer', 'watch')
drawnow;
ax = handles.axes1;
ax.YTickMode  = 'auto';
axis 'auto y'
set(handles.Ymax,'String',' ');
set(handles.Ymin,'String',' ');
set(handles.figure1, 'pointer', 'arrow')

% --- Executes on button press in ClearX.
function ClearX_Callback(hObject, eventdata, handles)
% hObject    handle to ClearX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% resets the x axis so that Matlab chooses the limits
set(handles.figure1, 'pointer', 'watch')
drawnow;
ax = handles.axes1;
ax.XTickMode  = 'auto';
axis 'auto x'
set(handles.Xmax,'String',' ');
set(handles.Xmin,'String',' ');
set(handles.figure1, 'pointer', 'arrow')

function Gate_X_Callback(hObject, eventdata, handles)
% hObject    handle to Gate_X (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Gate_X as text
%        str2double(get(hObject,'String')) returns contents of Gate_X as a double

% --- Executes during object creation, after setting all properties.
function Gate_X_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Gate_X (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function Gate_Y_Callback(hObject, eventdata, handles)
% hObject    handle to Gate_Y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Gate_Y as text
%        str2double(get(hObject,'String')) returns contents of Gate_Y as a double

% --- Executes during object creation, after setting all properties.
function Gate_Y_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Gate_Y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in RenameBtn.
function RenameBtn_Callback(hObject, eventdata, handles)
% hObject    handle to RenameBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% enables renaming of statistics
set(handles.figure1, 'pointer', 'watch')
drawnow;
listofnames = handles.names;
length = size(listofnames,2);
b = cell(length,1);
for i = 1:length
    b{i,1} = ' ';
end
listofnames2 = [listofnames', b];
f = figure;
%table with 2 columns: 1 with the old name and one empty column where one
%can enter the new name
t = uitable(f,'Data',listofnames2,'ColumnName', {'old','renamed'},'ColumnEditable', [false true],...
            'RowName',[],'Units','normalized','Position',[0 0 1 1], 'Columnwidth',{400 100});
% When Ok is clicked in the box the function continues and terminates
waitfor(msgbox('Press OK when finsihed renaming'));
drawnow
e = get(t,'Data');
close(f)

for i = 1:length
    if strcmp(' ',e{i,2}) == 0
        e{i,1} = e{i,2};
    end
end

set(handles.popupX,'string',e(:,1)');
set(handles.popupY,'string',e(:,1)');
set(handles.popupA,'string',e(:,1)');
set(handles.popupB,'string',e(:,1)');
ef = ['Black' 'Density' e(:,1)'];
set(handles.popupCol,'string',ef);
set(handles.textXax,'string',e(handles.inda,1)');
set(handles.textYax,'string',e(handles.indb,1)');
handles.names = (e(:,1))';
b = get(handles.gatebox,'Value');
gatinghist = handles.gatinghist;
gatinghist{7,b} = (e(:,1))';
handles.gatinghist = gatinghist;
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject, handles);
  

% --- Executes on button press in BiExBtn.
function BiExBtn_Callback(hObject, eventdata, handles)
% hObject    handle to BiExBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% transforms the data with an arcsinh transformation for better visibility
set(handles.figure1, 'pointer', 'watch')
drawnow;
asinhX = get(handles.asinhX,'Value');
asinhY = get(handles.asinhY,'Value');
stats1 = handles.stats;
ind_a = handles.inda;
ind_b = handles.indb;

if isempty(get(handles.Gate_Xperc,'String'))
    set(handles.Gate_Xperc,'String',' ')
end
if isempty(get(handles.Gate_Yperc,'String'))
    set(handles.Gate_Yperc,'String',' ')
end
if strcmp(' ',get(handles.Gate_Xperc,'String')) == 0 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 1
	xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
	xgate = prctile(stats1(:,ind_a),xgate_perc);
  	ygate = str2double(get(handles.Gate_Y,'String'));
elseif strcmp(' ',get(handles.Gate_Xperc,'String')) == 1 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 0
   	ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
  	ygate = prctile(stats1(:,ind_b),ygate_perc);
 	xgate = str2double(get(handles.Gate_X,'String'));
elseif strcmp(' ',get(handles.Gate_Xperc,'String')) == 0 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 0
  	xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
  	ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
  	set(handles.Gate_X,'String',' ');
  	set(handles.Gate_Y,'String',' ');
	xgate = prctile(stats1(:,ind_a),xgate_perc);
	ygate = prctile(stats1(:,ind_b),ygate_perc);
elseif strcmp(' ',get(handles.Gate_Xperc,'String')) == 1 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 1
 	xgate = str2double(get(handles.Gate_X,'String'));
   	ygate = str2double(get(handles.Gate_Y,'String'));
end
handles.xgate = xgate;
handles.ygate = ygate;
guidata(hObject,handles)

set(handles.cofactor,'enable','off')

% gets values of the tick boxes below the asinh/Linear button and thus
% determines if one or both axes should be transformed
if asinhX == 1 & asinhY == 0
    BiEx_StatsX = log((stats1(:,ind_a)/(str2double(get(handles.cofactor,'String'))))...
        +sqrt((((stats1(:,ind_a)/(str2double(get(handles.cofactor,'String')))).^2)+1)));
    stats1(:,ind_a) = BiEx_StatsX;
    handles.xgate = log((xgate/(str2double(get(handles.cofactor,'String'))))...
        +sqrt((((xgate/(str2double(get(handles.cofactor,'String')))).^2)+1)));
    set(handles.linX,'Value',1);
    set(handles.linY,'Value',0);
elseif asinhX == 0 & asinhY == 1
    BiEx_StatsY = log((stats1(:,ind_b)/(str2double(get(handles.cofactor,'String'))))...
        +sqrt((((stats1(:,ind_b)/(str2double(get(handles.cofactor,'String')))).^2)+1)));
    stats1(:,ind_b) = BiEx_StatsY;
    handles.ygate = log((ygate/(str2double(get(handles.cofactor,'String'))))...
        +sqrt((((ygate/(str2double(get(handles.cofactor,'String')))).^2)+1)));
    set(handles.linX,'Value',0);
    set(handles.linY,'Value',1);
elseif asinhX == 1 & asinhY == 1
    BiEx_StatsX = log((stats1(:,ind_a)/(str2double(get(handles.cofactor,'String'))))...
        +sqrt((((stats1(:,ind_a)/(str2double(get(handles.cofactor,'String')))).^2)+1)));
    stats1(:,ind_a) = BiEx_StatsX;
    BiEx_StatsY = log((stats1(:,ind_b)/(str2double(get(handles.cofactor,'String'))))...
        +sqrt((((stats1(:,ind_b)/(str2double(get(handles.cofactor,'String')))).^2)+1)));
    stats1(:,ind_b) = BiEx_StatsY;
    handles.xgate = log((xgate/(str2double(get(handles.cofactor,'String'))))...
        +sqrt((((xgate/(str2double(get(handles.cofactor,'String')))).^2)+1)));
    handles.ygate = log((ygate/(str2double(get(handles.cofactor,'String'))))...
        +sqrt((((ygate/(str2double(get(handles.cofactor,'String')))).^2)+1)));
    set(handles.linX,'Value',1);
    set(handles.linY,'Value',1);
end
set(handles.linX,'Enable','off');
set(handles.linY,'Enable','off');
set(handles.LinBtn,'Enable','on');
set(handles.asinhX,'Enable','off');
set(handles.asinhY,'Enable','off');
set(handles.BiExBtn,'Enable','off'); 
handles.stats = stats1;
handles.BiExID = 1;
r = handles.gatinghist;
r{6,get(handles.gatebox,'value')} = 1;
handles.gatinghist = r;
guidata(hObject, handles);

set(handles.Gate_X,'String',num2str(handles.xgate))
set(handles.Gate_Y,'String',num2str(handles.ygate))

%gather stats to run XITplot
f = get(handles.uipanel1,'SelectedObject');
Sel = get(f,'String');
xgate = handles.xgate;
ygate = handles.ygate;
stats = handles.stats;
StatsMatrixCl = handles.statsCl;
num_forperc = size(StatsMatrixCl,1);
sizeSc = handles.sizeSc;
s = get(handles.popupCol,'Value');
kCol = handles.kmCol;
abin = str2double(get(handles.densitybin,'String'));
bins = str2double(get(handles.hist_bins,'String'));

xmin = str2double(get(handles.Xmin,'String'));
xmax = str2double(get(handles.Xmax,'String'));
ymin = str2double(get(handles.Ymin,'String'));
ymax = str2double(get(handles.Ymax,'String'));


XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,asinhX,asinhY...
    ,str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)
a = getappdata(XIT,'handl');

if get(handles.popupCol,'value') > 2
        cmax = str2double(get(handles.colorMax,'String'));    
        cmin = str2double(get(handles.colorMin,'String'));  
        if isnan(cmin)
            cmin = 0;
        end
        if isnan(cmax)
            cmax = 255;
        end
        axes(handles.axes1)
        caxis([cmin cmax])  
end
    
% get gating info from XITplot
GateID = a.ID;
if GateID == 0
elseif GateID == 1
	handles.StatsMatrix2 = a.StatsMatrix2;
	handles.StatsMatrix3 = a.StatsMatrix3;
  	handles.percbelowX = a.percbelowX;
   	handles.percaboveX = a.percaboveX;
   	handles.numbelowX = a.numbelowX;
   	handles.numaboveX = a.numaboveX;
 	handles.percofallaX = a.percofallaX;
  	handles.percofallbX = a.percofallbX;
elseif GateID == 3
  	handles.StatsMatrix2 = a.StatsMatrix2;
  	handles.StatsMatrix3 = a.StatsMatrix3;
   	handles.percbelowY = a.percbelowY;
  	handles.percaboveY = a.percaboveY;
 	handles.numbelowY = a.numbelowY;
  	handles.numaboveY = a.numaboveY;
   	handles.percofallaY = a.percofallaY;
  	handles.percofallbY = a.percofallbY;
elseif GateID == 2
   	handles.StatsMatrixQ1 = a.StatsMatrixQ1;
  	handles.StatsMatrixQ2 = a.StatsMatrixQ2;
  	handles.StatsMatrixQ3 = a.StatsMatrixQ3;
  	handles.StatsMatrixQ4 = a.StatsMatrixQ4;
  	handles.percQ1 = a.percQ1;
   	handles.percQ2 = a.percQ2;
   	handles.percQ3 = a.percQ3;
   	handles.percQ4 = a.percQ4;
   	handles.percofallQ1 = a.percofallQ1;
   	handles.percofallQ2 = a.percofallQ2;
   	handles.percofallQ3 = a.percofallQ3;
   	handles.percofallQ4 = a.percofallQ4;
  	handles.numQ1 = a.numQ1;
   	handles.numQ2 = a.numQ2;
  	handles.numQ3 = a.numQ3;
   	handles.numQ4 = a.numQ4;
end
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject, handles);


% --- Executes on button press in LinBtn.
function LinBtn_Callback(hObject, eventdata, handles)
% hObject    handle to LinBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% transforms the data back (sinh transformation) to linear
set(handles.figure1, 'pointer', 'watch')
drawnow;
stats1 = handles.stats;
ind_a = handles.inda;
ind_b = handles.indb;

if isempty(get(handles.Gate_Xperc,'String'))
    set(handles.Gate_Xperc,'String',' ')
end
if isempty(get(handles.Gate_Yperc,'String'))
    set(handles.Gate_Yperc,'String',' ')
end
if strcmp(' ',get(handles.Gate_Xperc,'String')) == 0 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 1
	xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
	xgate = prctile(stats1(:,ind_a),xgate_perc);
  	ygate = str2double(get(handles.Gate_Y,'String'));
elseif strcmp(' ',get(handles.Gate_Xperc,'String')) == 1 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 0
   	ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
  	ygate = prctile(stats1(:,ind_b),ygate_perc);
 	xgate = str2double(get(handles.Gate_X,'String'));
elseif strcmp(' ',get(handles.Gate_Xperc,'String')) == 0 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 0
  	xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
  	ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
  	set(handles.Gate_X,'String',' ');
  	set(handles.Gate_Y,'String',' ');
	xgate = prctile(stats1(:,ind_a),xgate_perc);
	ygate = prctile(stats1(:,ind_b),ygate_perc);
elseif strcmp(' ',get(handles.Gate_Xperc,'String')) == 1 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 1
 	xgate = str2double(get(handles.Gate_X,'String'));
   	ygate = str2double(get(handles.Gate_Y,'String'));
end

handles.xgate = xgate;
handles.ygate = ygate;
guidata(hObject,handles)

% gets values of the tick boxes below the asinh/Linear button and thus
% determines if one or both axes should be transformed
if get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 0
    lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats1(:,ind_a)) - exp(-1.*(stats1(:,ind_a))));
    stats1(:,ind_a) = lin_StatsX;
    handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(xgate) - exp(-1.*(xgate)));
    set(handles.asinhX,'Value',1);
    set(handles.asinhY,'Value',0);
elseif get(handles.linX,'Value') == 0 & get(handles.linY,'Value') == 1
    lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats1(:,ind_b)) - exp(-1.*(stats1(:,ind_b))));
    stats1(:,ind_b) = lin_StatsY;
    handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(ygate) - exp(-1.*(ygate)));
    set(handles.asinhX,'Value',0);
    set(handles.asinhY,'Value',1);
elseif get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 1
    lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats1(:,ind_a)) - exp(-1.*(stats1(:,ind_a))));
    stats1(:,ind_a) = lin_StatsX;
    lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats1(:,ind_b)) - exp(-1.*(stats1(:,ind_b))));
    stats1(:,ind_b) = lin_StatsY;
    handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(xgate) - exp(-1.*(xgate)));
    handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(ygate) - exp(-1.*(ygate)));
    set(handles.asinhX,'Value',1);
    set(handles.asinhY,'Value',1);
end
set(handles.linX,'Enable','off');
set(handles.linY,'Enable','off');
set(handles.LinBtn,'Enable','off');
set(handles.asinhX,'Enable','on');
set(handles.asinhY,'Enable','on');
set(handles.BiExBtn,'Enable','on');
set(handles.cofactor,'enable','on')
handles.stats = stats1;
handles.BiExID = 0;
r = handles.gatinghist;
r{6,get(handles.gatebox,'value')} = 0;
handles.gatinghist = r;
guidata(hObject, handles);

set(handles.Gate_X,'String',num2str(handles.xgate))
set(handles.Gate_Y,'String',num2str(handles.ygate))
% gather statistics for executing XITplot
f = get(handles.uipanel1,'SelectedObject');
Sel = get(f,'String');
xgate = handles.xgate;
ygate = handles.ygate;
stats = handles.stats;
StatsMatrixCl = handles.statsCl;
num_forperc = size(StatsMatrixCl,1);
ind_a = handles.inda;
ind_b = handles.indb;
sizeSc = handles.sizeSc;
s = get(handles.popupCol,'Value');
kCol = handles.kmCol;
abin = str2double(get(handles.densitybin,'String'));
bins = str2double(get(handles.hist_bins,'String'));
xmin = str2double(get(handles.Xmin,'String'));
xmax = str2double(get(handles.Xmax,'String'));
ymin = str2double(get(handles.Ymin,'String'));
ymax = str2double(get(handles.Ymax,'String'));

XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,get(handles.linX,'Value'),get(handles.linY,'Value')...
    ,str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)

if get(handles.popupCol,'value') > 2
        cmax = str2double(get(handles.colorMax,'String'));    
        cmin = str2double(get(handles.colorMin,'String'));  
        if isnan(cmin)
            cmin = 0;
        end
        if isnan(cmax)
            cmax = 255;
        end
        axes(handles.axes1)
        caxis([cmin cmax])  
end
    
% gets gating data from the XITplot function
a = getappdata(XIT,'handl');
GateID = a.ID;
if GateID == 0
elseif GateID == 1
	handles.StatsMatrix2 = a.StatsMatrix2;
	handles.StatsMatrix3 = a.StatsMatrix3;
  	handles.percbelowX = a.percbelowX;
   	handles.percaboveX = a.percaboveX;
   	handles.numbelowX = a.numbelowX;
   	handles.numaboveX = a.numaboveX;
 	handles.percofallaX = a.percofallaX;
  	handles.percofallbX = a.percofallbX;
elseif GateID == 3
  	handles.StatsMatrix2 = a.StatsMatrix2;
  	handles.StatsMatrix3 = a.StatsMatrix3;
   	handles.percbelowY = a.percbelowY;
  	handles.percaboveY = a.percaboveY;
 	handles.numbelowY = a.numbelowY;
  	handles.numaboveY = a.numaboveY;
   	handles.percofallaY = a.percofallaY;
  	handles.percofallbY = a.percofallbY;
elseif GateID == 2
   	handles.StatsMatrixQ1 = a.StatsMatrixQ1;
  	handles.StatsMatrixQ2 = a.StatsMatrixQ2;
  	handles.StatsMatrixQ3 = a.StatsMatrixQ3;
  	handles.StatsMatrixQ4 = a.StatsMatrixQ4;
  	handles.percQ1 = a.percQ1;
   	handles.percQ2 = a.percQ2;
   	handles.percQ3 = a.percQ3;
   	handles.percQ4 = a.percQ4;
   	handles.percofallQ1 = a.percofallQ1;
   	handles.percofallQ2 = a.percofallQ2;
   	handles.percofallQ3 = a.percofallQ3;
   	handles.percofallQ4 = a.percofallQ4;
  	handles.numQ1 = a.numQ1;
   	handles.numQ2 = a.numQ2;
  	handles.numQ3 = a.numQ3;
   	handles.numQ4 = a.numQ4;
end
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject, handles);


% --- Executes on button press in ArtRemovBtn.
function ArtRemovBtn_Callback(hObject, eventdata, handles)
% hObject    handle to ArtRemovBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Spatial gating to remove artifacts or gate on a ROI
set(handles.figure1, 'pointer', 'watch')
drawnow;
AnalysisMatrix = handles.stats;
BiExID = handles.BiExID;
ind_a = handles.inda;
ind_b = handles.indb;
% checks if data is transformed and transforms it back to not have problems
% with spacial gating
if BiExID == 1
    set(handles.asinhX,'Enable','on');
    set(handles.asinhY,'Enable','on');
    set(handles.BiExBtn,'Enable','on');
    set(handles.linX,'Enable','off');
    set(handles.linY,'Enable','off');
    set(handles.LinBtn,'Enable','off');
    if get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 0
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_a)) - exp(-1.*(AnalysisMatrix(:,ind_a))));
        AnalysisMatrix(:,ind_a) = lin_StatsX;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',0);
    elseif get(handles.linX,'Value') == 0 & get(handles.linY,'Value') == 1
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_b)) - exp(-1.*(AnalysisMatrix(:,ind_b))));
        AnalysisMatrix(:,ind_b) = lin_StatsY;
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',0);
        set(handles.asinhY,'Value',1);
    elseif get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 1
        lin_StatsX =(str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_a)) - exp(-1.*(AnalysisMatrix(:,ind_a))));
        AnalysisMatrix(:,ind_a) = lin_StatsX;
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_b)) - exp(-1.*(AnalysisMatrix(:,ind_b))));;
        AnalysisMatrix(:,ind_b) = lin_StatsY;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',1);
    end
end
% gather data to execute ArtRemovalV3
Names_of_stats = handles.names;
Position_Matrix = AnalysisMatrix(:,(end-3):end);
data1{1,1} = AnalysisMatrix;
data2{1,1} = Position_Matrix;
xgate = str2double(get(handles.Gate_X,'String'));
ygate = str2double(get(handles.Gate_Y,'String'));
jj = 1;

ArtRemovalV3    %Spatial Gating function to remove unwanted datapoints or gate on a specific region (XY or XZ)
                    
stats = data3{1,1}.data{1,1}; %All stats plus XYZ coordinates plus ID
% gather data to execute XITplot
f = get(handles.uipanel1,'SelectedObject');
Sel = get(f,'String');
StatsMatrixCl = stats;
num_forperc = size(StatsMatrixCl,1);
ind_a = handles.inda;
ind_b = handles.indb;
sizeSc = 10;
s = get(handles.popupCol,'Value');
kCol = handles.kmCol;
abin = str2double(get(handles.densitybin,'String'));
bins = str2double(get(handles.hist_bins,'String'));
xmin = str2double(get(handles.Xmin,'String'));
xmax = str2double(get(handles.Xmax,'String'));
ymin = str2double(get(handles.Ymin,'String'));
ymax = str2double(get(handles.Ymax,'String'));

XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,1,1,...
str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)
a = getappdata(XIT,'handl');

if get(handles.popupCol,'value') > 2
    cmax = str2double(get(handles.colorMax,'String'));    
    cmin = str2double(get(handles.colorMin,'String'));  
    if isnan(cmin)
        cmin = 0;
    end
    if isnan(cmax)
        cmax = 255;
    end
    axes(handles.axes1)
    caxis([cmin cmax])  
end
    
GateID = a.ID;
if GateID == 0
elseif GateID == 1
	handles.StatsMatrix2 = a.StatsMatrix2;
	handles.StatsMatrix3 = a.StatsMatrix3;
  	handles.percbelowX = a.percbelowX;
   	handles.percaboveX = a.percaboveX;
   	handles.numbelowX = a.numbelowX;
   	handles.numaboveX = a.numaboveX;
 	handles.percofallaX = a.percofallaX;
  	handles.percofallbX = a.percofallbX;
elseif GateID == 3
  	handles.StatsMatrix2 = a.StatsMatrix2;
  	handles.StatsMatrix3 = a.StatsMatrix3;
   	handles.percbelowY = a.percbelowY;
  	handles.percaboveY = a.percaboveY;
 	handles.numbelowY = a.numbelowY;
  	handles.numaboveY = a.numaboveY;
   	handles.percofallaY = a.percofallaY;
  	handles.percofallbY = a.percofallbY;
elseif GateID == 2
   	handles.StatsMatrixQ1 = a.StatsMatrixQ1;
  	handles.StatsMatrixQ2 = a.StatsMatrixQ2;
  	handles.StatsMatrixQ3 = a.StatsMatrixQ3;
  	handles.StatsMatrixQ4 = a.StatsMatrixQ4;
  	handles.percQ1 = a.percQ1;
   	handles.percQ2 = a.percQ2;
   	handles.percQ3 = a.percQ3;
   	handles.percQ4 = a.percQ4;
   	handles.percofallQ1 = a.percofallQ1;
   	handles.percofallQ2 = a.percofallQ2;
   	handles.percofallQ3 = a.percofallQ3;
   	handles.percofallQ4 = a.percofallQ4;
  	handles.numQ1 = a.numQ1;
   	handles.numQ2 = a.numQ2;
  	handles.numQ3 = a.numQ3;
   	handles.numQ4 = a.numQ4;
end

set(handles.textXax,'string',Names_of_stats(1,ind_a));
set(handles.textYax,'string',Names_of_stats(1,ind_b));
set(handles.popupX,'value',ind_a);
set(handles.popupY,'value',ind_b);
set(handles.scatterplot,'Value',1)
set(handles.histplot,'Value',0)
set(handles.lineplot,'Value',0)
set(handles.fillplot,'Value',0)
set(handles.popupY,'Enable','on')
set(handles.popupSize,'Value',2)
handles.stats = stats;
handles.statsCl = stats;
handles.sizeSc = 10;

% Checks for the gating history in the gate box and puts a Spatial Gate
% there
Names = get(handles.gatebox,'string');
for i = 1:length(Names)
	if strcmp(Names{i,1},'...')
        Val = i;
        break
	end
end
gatehist = handles.gatinghist;
gatehist{1,Val} = stats;
gatehist{2,Val} = ind_a;
gatehist{3,Val} = ind_b;
f = get(handles.uipanel1,'SelectedObject');
Sel = get(f,'String');
gatehist{4,Val} = Sel;
asinhIDX = get(handles.asinhX,'Value');
asinhIDY = get(handles.asinhY,'Value');
asinhIDen = handles.BiExID;
if asinhIDen == 1 & (asinhIDX == 1 & asinhIDY == 0) 
    gatehist{5,Val} = 1;
elseif asinhIDen == 1 & (asinhIDX == 0 & asinhIDY == 1)
    gatehist{5,Val} = 2;
elseif asinhIDen == 1 & (asinhIDX == 1 & asinhIDY == 1) 
    gatehist{5,Val} = 3;
elseif asinhIDen == 0
    gatehist{5,Val} = 0;    
end
gatehist{6,Val} = asinhIDen;
gatehist{7,Val} = handles.names;
handles.gatinghist = gatehist;
Names{Val,1} = 'Spatial Gate';
Names{Val+1,1} = '...';
set(handles.gatebox,'Value',(Val));
set(handles.gatebox,'String',Names);
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject, handles);

% --- Executes on button press in CoordBtn.
function CoordBtn_Callback(hObject, eventdata, handles)
% hObject    handle to CoordBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Shows the current gate within the parent population as XY and XZ plots
set(handles.figure1, 'pointer', 'watch')
drawnow;

AnalysisMatrix = handles.stats;
BiExID = handles.BiExID;
ind_a = handles.inda;
ind_b = handles.indb;
xgate = str2double(get(handles.Gate_X,'String'));
ygate = str2double(get(handles.Gate_Y,'String'));
% checks if data is transformed and transforms it back to not have problems
% with spacial gating
if BiExID == 1
    set(handles.asinhX,'Enable','off');
    set(handles.asinhY,'Enable','off');
    set(handles.BiExBtn,'Enable','off');
    set(handles.linX,'Enable','off');
    set(handles.linY,'Enable','off');
    set(handles.LinBtn,'Enable','on');
    
    if get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 0
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_a)) - exp(-1.*(AnalysisMatrix(:,ind_a))));
        AnalysisMatrix(:,ind_a) = lin_StatsX;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(xgate) - exp(-1.*(xgate)));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',0);
    elseif get(handles.linX,'Value') == 0 & get(handles.linY,'Value') == 1
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_b)) - exp(-1.*(AnalysisMatrix(:,ind_b))));
        AnalysisMatrix(:,ind_b) = lin_StatsY;
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(ygate) - exp(-1.*(ygate)));
        set(handles.asinhX,'Value',0);
        set(handles.asinhY,'Value',1);
    elseif get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 1
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_a)) - exp(-1.*(AnalysisMatrix(:,ind_a))));
        AnalysisMatrix(:,ind_a) = lin_StatsX;
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_b)) - exp(-1.*(AnalysisMatrix(:,ind_b))));
        AnalysisMatrix(:,ind_b) = lin_StatsY;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(xgate) - exp(-1.*(xgate)));
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(ygate) - exp(-1.*(ygate)));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',1);
    end
end
Position_Matrix = AnalysisMatrix(:,(end-3):end);
Parentpop = handles.statsCl;
Parentpop_Pos = Parentpop(:,(end-3):end);
data2{1,1} = Position_Matrix;

% plot the projections in new figure/ can be closed by simply X-ing it
first = figure('position', [100, 100, 800, 400]);
fc = subplot(2,1,1);
daspect manual
scatter(handles.ParentXYZs(:,2),handles.ParentXYZs(:,1),3,'Markerfacecolor','none',...
    'MarkerEdgeColor','none')
hold on
scatter(Parentpop_Pos(:,2),Parentpop_Pos(:,1),3,'Markerfacecolor',[0.8 0.8 0.8],...
    'MarkerEdgeColor','none')
hold on
scatter(data2{1,1}(:,2),data2{1,1}(:,1),3,'Markerfacecolor','r','MarkerEdgeColor','k');
daspect([1 1 1]);
title('XY projection')
hold off

ec = subplot(2,1,2);
daspect manual
scatter(handles.ParentXYZs(:,2),handles.ParentXYZs(:,3),3,'Markerfacecolor','none',...
    'MarkerEdgeColor','none');
hold on
scatter(Parentpop_Pos(:,2),Parentpop_Pos(:,3),3,'Markerfacecolor',[0.8 0.8 0.8],...
    'MarkerEdgeColor','none')
hold on
scatter(data2{1,1}(:,2),data2{1,1}(:,3),3,'Markerfacecolor','r','MarkerEdgeColor','k');
daspect([1 1 1]);
title('XZ projection')
hold off

second = figure('position', [100, 600, 800, 400]);
grid off
daspect manual
scatter3(handles.ParentXYZs(:,1),handles.ParentXYZs(:,2),handles.ParentXYZs(:,3),5,'Markerfacecolor','none',...
    'MarkerEdgeColor','none')
hold on
scatter3(Parentpop_Pos(:,1),Parentpop_Pos(:,2),Parentpop_Pos(:,3),2,'Markerfacecolor',[0.8 0.8 0.8],...
    'MarkerEdgeColor','none')
hold on
scatter3(data2{1,1}(:,1),data2{1,1}(:,2),data2{1,1}(:,3),3,'Markerfacecolor','r','MarkerEdgeColor','k');
daspect([1 1 1]);
title('XYZ view')
grid off
hold off
set(handles.figure1, 'pointer', 'arrow')


% --- Executes on selection change in popupA.
function popupA_Callback(hObject, eventdata, handles)
% hObject    handle to popupA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupA contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupA
% Allows the user to select the first statistic in the arithmetic panel
Names = handles.names;
indexAa = handles.indexAa;

a1 = get(hObject,'Value');
a = Names(1,a1);

for i = 1:length(Names)
    if strcmp(a,Names(1,i)) == 1
        indexAa = i;
    end
end
handles.indexAa = indexAa;
set(handles.StaAtext,'String',Names(1,indexAa));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in popupB.
function popupB_Callback(hObject, eventdata, handles)
% hObject    handle to popupB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupB contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupB
% Allows the user to select the second statistic in the arithmetic panel
Names = handles.names;
indexAb = handles.indexAb;

a1 = get(hObject,'Value');
a = Names(1,a1);

for i = 1:length(Names)
    if strcmp(a,Names(1,i)) == 1
        indexAb = i;
    end
end
handles.indexAb = indexAb;
set(handles.StaBtext,'String',Names(1,indexAb));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupB_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in AritBtn.
function AritBtn_Callback(hObject, eventdata, handles)
% hObject    handle to AritBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Executes the arithmetic operation selected by the radiobuttons in between
% the two statistic selection menus/fields
set(handles.figure1, 'pointer', 'watch')
drawnow;

ef = get(handles.uipanel10,'SelectedObject');
Select = get(ef,'String');
ta = get(handles.StaAtext,'String');
tb = get(handles.StaBtext,'String');
factStatA = str2double(get(handles.StaAfact,'String'));
factStatB = str2double(get(handles.StaBfact,'String'));
factstrA = get(handles.StaAfact,'String');
factstrB = get(handles.StaBfact,'String');

BiExID = handles.BiExID;
ind_a = handles.inda;
ind_b = handles.indb;
stats = handles.stats;
if BiExID == 1 %if data is asinh transformed, transform it back for this purpose
    set(handles.asinhX,'Enable','on');
    set(handles.asinhY,'Enable','on');
    set(handles.BiExBtn,'Enable','on');
    set(handles.linX,'Enable','off');
    set(handles.linY,'Enable','off');
    set(handles.LinBtn,'Enable','off');
    if get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 0
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats(:,ind_a)) - exp(-1.*(stats(:,ind_a))));
        stats(:,ind_a) = lin_StatsX;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',0);
    elseif get(handles.linX,'Value') == 0 & get(handles.linY,'Value') == 1
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats(:,ind_b)) - exp(-1.*(stats(:,ind_b))));
        stats(:,ind_b) = lin_StatsY;
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',0);
        set(handles.asinhY,'Value',1);
    elseif get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 1
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats(:,ind_a)) - exp(-1.*(stats(:,ind_a))));
        stats(:,ind_a) = lin_StatsX;
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats(:,ind_b)) - exp(-1.*(stats(:,ind_b))));
        stats(:,ind_b) = lin_StatsY;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',1);
    end
end
handles.BiExID = 0;

Names_of_stats = handles.names;
u = 0;

for i = 1:length(Names_of_stats)
    if strcmp(ta,Names_of_stats(1,i)) == 1
        indexAa = i;
    end
end
for i = 1:length(Names_of_stats)
    if strcmp(tb,Names_of_stats(1,i)) == 1
        indexAb = i;
    end
end
% determines which arithmetic operation should be performed and performs it
switch Select
    case 'Plus (+)'
        set(handles.radminus,'Value',0)
        set(handles.radmultiply,'Value',0)
        set(handles.raddivide,'Value',0)
        New_Stats = (factStatA * stats(:,indexAa)) + (factStatB * stats(:,indexAb));
        New_Name = {[factstrA '_' Names_of_stats{:,indexAa} '_plus_' factstrB '_' Names_of_stats{:,indexAb}]};
        u = 1;
    case 'Minus (-)'
        set(handles.plusrad,'Value',0)
        set(handles.radmultiply,'Value',0)
        set(handles.raddivide,'Value',0)
        New_Stats = (factStatA * stats(:,indexAa)) - (factStatB * stats(:,indexAb));
        New_Name = {[factstrA '_' Names_of_stats{:,indexAa} '_minus_' factstrB '_' Names_of_stats{:,indexAb}]};
        u = 1;
    case 'Multiply (*)'
        set(handles.radminus,'Value',0)
        set(handles.plusrad,'Value',0)
        set(handles.raddivide,'Value',0)
        New_Stats = (factStatA * stats(:,indexAa)) .* (factStatB * stats(:,indexAb));
        New_Name = {[factstrA '_' Names_of_stats{:,indexAa} '_multiplied_by_' factstrB '_' Names_of_stats{:,indexAb}]};
        u = 1;
    case 'Divide (/)' %if there is a division by 0, one can either delete those cells or dont perform the action
        set(handles.radminus,'Value',0)
        set(handles.radmultiply,'Value',0)
        set(handles.plusrad,'Value',0)
        
        zeroID = cell(size(stats,1),1);
        for i = 1:size(stats,1)
            if stats(i,indexAb) == 0
                zeroID{i,1} = i;
            end
        end
        
        if isempty(cell2mat(zeroID))
            New_Stats = (factStatA * stats(:,indexAa)) ./ (factStatB *stats(:,indexAb));
            New_Name = {[factstrA '_' Names_of_stats{:,indexAa} '_divided_by_' factstrB '_' Names_of_stats{:,indexAb}]};
            u = 1;
        else
            ass = questdlg('0s detected, you cannot divide by 0. Do you want to delete those cells and proceed?',...
                    'Zero Warning','Yes','No','Yes');
            switch ass
                case 'Yes'
                    stats(cell2mat(zeroID),:) = [];
                    New_Stats = (factStatA * stats(:,indexAa)) ./ (factStatB *stats(:,indexAb));
                    New_Name = {[factstrA '_' Names_of_stats{:,indexAa} '_divided_by_' factstrB '_' Names_of_stats{:,indexAb}]};
                    u = 1;
                case 'No'
                    u = 0;
            end
        end
end

if u == 1 %if an arithmetic operation was executed updates the Names and Statistic variables
    NamesforExp = handles.NamesforExp;
    New_NamesfExp = [NamesforExp(:,1:(end-4)) New_Name NamesforExp(:,(end-3):end)];
    New_StatsMatrix = [stats(:,1:(end-4)) New_Stats stats(:,(end-3):end)];
    New_Names = [Names_of_stats(:,1:(end-3)) New_Name Names_of_stats(:,(end-2):end)];                
    handles.NamesforExp = New_NamesfExp;
    handles.stats = New_StatsMatrix;
    handles.names = New_Names;
    set(handles.popupX,'String',New_Names)
    set(handles.popupY,'String',New_Names)
    set(handles.popupA,'String',New_Names)
    set(handles.popupB,'String',New_Names) 
    ColorNames = [{'Black'} {'Density'} New_Names];
    set(handles.popupCol,'String',ColorNames);
    set(handles.scatterplot,'value',1);
    set(handles.histplot,'value',0);
    set(handles.lineplot,'value',0);
    set(handles.fillplot,'value',0);
    handles.histo = 0;
    handles.fillarea = 0;
    handles.line = 0;

    f = get(handles.uipanel1,'SelectedObject');
    Sel = get(f,'String');
    xgate = str2double(get(handles.Gate_X,'String'));
    ygate = str2double(get(handles.Gate_Y,'String'));
    stats = New_StatsMatrix;
    StatsMatrixCl = handles.statsCl;
    num_forperc = size(StatsMatrixCl,1);
    ind_a = handles.inda;
    ind_b = handles.indb;
    set(handles.popupX,'Value',ind_a)
    set(handles.popupY,'Value',ind_b)
    xx = get(handles.popupX,'String');
    yy = get(handles.popupY,'String');
    set(handles.textXax,'String',xx(ind_a))
    set(handles.textYax,'String',yy(ind_b))
    sizeSc = handles.sizeSc;
    s = get(handles.popupCol,'Value');
    kCol = handles.kmCol;
    abin = str2double(get(handles.densitybin,'String'));
    bins = str2double(get(handles.hist_bins,'String'));
    xmin = str2double(get(handles.Xmin,'String'));
    xmax = str2double(get(handles.Xmax,'String'));
    ymin = str2double(get(handles.Ymin,'String'));
    ymax = str2double(get(handles.Ymax,'String'));
    XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,1,1,...
        str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)
    a = getappdata(XIT,'handl');
    if get(handles.popupCol,'value') > 2
        cmax = str2double(get(handles.colorMax,'String'));    
        cmin = str2double(get(handles.colorMin,'String'));  
        if isnan(cmin)
            cmin = 0;
        end
        if isnan(cmax)
            cmax = 255;
        end
        axes(handles.axes1)
        caxis([cmin cmax])  
    end
    
    handles.aritID = 1;
    handles.aritstats = New_StatsMatrix;
    waitfor(msgbox('Done'))
end
% set radiobuttons to 0, to be able to start a new operation
set(handles.plusrad,'Value',0);
set(handles.radminus,'Value',0);
set(handles.radmultiply,'Value',0);
set(handles.raddivide,'Value',0);

Val = get(handles.gatebox,'Value');
gatehist = handles.gatinghist;
gatehist{1,Val} = New_StatsMatrix;
gatehist{2,Val} = ind_a;
gatehist{3,Val} = ind_b;
gatehist{4,Val} = Sel;
asinhIDX = get(handles.asinhX,'Value');
asinhIDY = get(handles.asinhY,'Value');
asinhIDen = handles.BiExID;
if asinhIDen == 1 & (asinhIDX == 1 & asinhIDY == 0) 
    gatehist{5,Val} = 1;
elseif asinhIDen == 1 & (asinhIDX == 0 & asinhIDY == 1)
    gatehist{5,Val} = 2;
elseif asinhIDen == 1 & (asinhIDX == 1 & asinhIDY == 1) 
    gatehist{5,Val} = 3;
elseif asinhIDen == 0
    gatehist{5,Val} = 0;    
end
gatehist{6,Val} = asinhIDen;
gatehist{7,Val} = New_Names;
handles.gatinghist = gatehist;
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject, handles);

function StaAfact_Callback(hObject, eventdata, handles)
% hObject    handle to StaAfact (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of StaAfact as text
%        str2double(get(hObject,'String')) returns contents of StaAfact as a double


% --- Executes during object creation, after setting all properties.
function StaAfact_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StaAfact (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function StaBfact_Callback(hObject, eventdata, handles)
% hObject    handle to StaBfact (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of StaBfact as text
%        str2double(get(hObject,'String')) returns contents of StaBfact as a double


% --- Executes during object creation, after setting all properties.
function StaBfact_CreateFcn(hObject, eventdata, handles)
% hObject    handle to StaBfact (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in SaveWSBtn.
function SaveWSBtn_Callback(hObject, eventdata, handles)
% hObject    handle to SaveWSBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% saves data and state of gui as .mat workspace, the current gate is set to
% be the parent population
set(handles.figure1, 'pointer', 'watch')
drawnow;
% if arithmetic or z norm was done, the stats and names are updated
% accordingly, so that those new stats will be saved as well
if handles.aritID == 1
    stats       = handles.aritstats;    %Stats with arithmetic stats included
    names       = handles.names;        %Names with arithmetic name included
    NamesforExp = handles.NamesforExp;  %Names with arithmetic name included + ID
else
    stats       = handles.stats;
    names       = handles.names;        
    NamesforExp = handles.NamesforExp;
end
state.names         = names;
state.stats         = stats;
state.statsCl       = stats; 
state.statsClear    = stats;
state.namesCl    	= names;
state.NamesforExp   = NamesforExp;
state.StatNames     = names;

% if the data is transformed dont do it again, otherwise do it and thus
% create a parentpop that is transformed
r = handles.gatinghist;
BiExID = r{6,get(handles.gatebox,'value')};
state.BiExID = BiExID;

if BiExID == 1
    state.BiEx_StatsMatrix  = stats;
else
    state.BiEx_StatsMatrix  = log((stats/(str2double(get(handles.cofactor,'String'))))...
        +sqrt((((stats/(str2double(get(handles.cofactor,'String')))).^2)+1)));
end

% get the position of the gating box (current gate) and set this as the
% parent gate
gateboxvalue = get(handles.gatebox,'Value');
gatinghist = handles.gatinghist; 
currentgate = gatinghist(:,gateboxvalue);
gatinghistNew = cell(7,100);
gatinghistNew(:,1) = currentgate;
state.gatinghist = gatinghistNew;                   %gating history data
state.gateboxtext = {'Parent population'; '...'};   %gating history text
state.gateboxvalue = 1;  %gating history position

state.cofact_col = get(handles.cofact_col,'String');
state.cofactor = get(handles.cofactor,'String');
state.colasinh = get(handles.colasinh,'Value');
state.ParentXYZs = handles.ParentXYZs;
state.asinhX = get(handles.asinhX,'Value'); %x transformed?
state.asinhY = get(handles.asinhY,'Value'); %y transformed?
state.linX = get(handles.linX,'Value');     %x transformed?
state.linY = get(handles.linY,'Value');     %y transformed?
state.enlinX = get(handles.linX,'Enable');
state.enlinY = get(handles.linY,'Enable');
state.enasinhX = get(handles.asinhX,'Enable');
state.enasinhY = get(handles.asinhY,'Enable');
state.BiExBtn = get(handles.BiExBtn,'Enable');
state.LinBtn = get(handles.LinBtn,'Enable');
state.Sel = get(handles.uipanel1,'SelectedObject'); %which plot
state.sizeSc = handles.sizeSc;
state.aritID = handles.aritID;                      % arithmetic/normz carried out?
state.aritstats = handles.aritstats;                % stats with arithmetic/normz carried out
state.kmCol = handles.kmCol;
state.popupSizeVal = get(handles.popupSize,'Value');
state.popupSizeString = get(handles.popupSize,'String');
state.popupColVal = get(handles.popupCol,'Value');
state.popupColStr = get(handles.popupCol,'String');
state.textXax = get(handles.textXax,'string');
state.textYax = get(handles.textYax,'string');
state.popupXst = get(handles.popupX,'string');
state.popupYst = get(handles.popupY,'string');
state.popupYval = get(handles.popupY,'Value');
state.popupXval = get(handles.popupX,'Value');
state.hist_bins = get(handles.hist_bins,'String');
state.Ymin = get(handles.Ymin,'String');
state.Ymax = get(handles.Ymax,'String');
state.Xmin = get(handles.Xmin,'String');
state.Xmax = get(handles.Xmax,'String');
state.Gate_Y = get(handles.Gate_Y,'String');
state.Gate_X = get(handles.Gate_X,'String');
state.Gate_Yperc = get(handles.Gate_Yperc,'String');
state.Gate_Xperc = get(handles.Gate_Xperc,'String');
state.GatingTable = [];
state.radminus = get(handles.radminus,'Value');
state.radmultiply = get(handles.radmultiply,'Value');
state.raddivide = get(handles.raddivide,'Value');
state.plusrad = get(handles.plusrad,'Value');
state.popupAStr = get(handles.popupA,'string');
state.popupBStr = get(handles.popupB,'string');
state.popupAVal = get(handles.popupA,'value');
state.popupBVal = get(handles.popupB,'value');
state.StaAfact = get(handles.StaAfact,'string');
state.StaBfact = get(handles.StaBfact,'string');
state.percQ1 = handles.percQ1;
state.percQ2 = handles.percQ2;
state.percQ3 = handles.percQ3;
state.percQ4 = handles.percQ4;
state.numQ1 = handles.numQ1;
state.numQ2 = handles.numQ2;
state.numQ3 = handles.numQ3;
state.numQ4 = handles.numQ4;
state.percbelowX = handles.percbelowX;
state.percaboveX = handles.percaboveX;
state.numbelowX = handles.numbelowX;
state.numaboveX = handles.numaboveX;
state.percbelowY = handles.percbelowY;
state.percaboveY = handles.percaboveY;
state.numbelowY = handles.numbelowY;
state.numaboveY = handles.numaboveY;
state.percofallQ1 = handles.percofallQ1;
state.percofallQ2 = handles.percofallQ2;
state.percofallQ3 = handles.percofallQ3;
state.percofallQ4 = handles.percofallQ4;
state.percofallaX = handles.percofallaX;
state.percofallbX = handles.percofallbX;
state.percofallaY = handles.percofallaX;
state.percofallbY = handles.percofallbX;
state.inda  = handles.inda;
state.indb  = handles.indb;
state.indexAa  = handles.indexAa;
state.indexAb  = handles.indexAb;
state.histo  = handles.histo;
state.line  = handles.line;
state.fillarea  = handles.fillarea;
state.axes1 = handles.axes1;
state.lineplot = handles.lineplot;
state.histplot = handles.histplot;
state.fillplot = handles.fillplot;
state.nodes = handles.nodes;

pathname = handles.savepath;
saveID = handles.saveID;

if saveID == 1
    [FileNameWS,PathNameWS] = uiputfile('*.mat','Save workspace',pathname);
    FileNameWS2 = fullfile(PathNameWS, FileNameWS);
    PathName = pathname;
else    
    [FileNameWS,PathNameWS] = uiputfile('*.mat','Save workspace');
    FileNameWS2 = fullfile(PathNameWS, FileNameWS);
    PathName = PathNameWS;
end
if ~ischar(PathName)

else
    save(FileNameWS2,'state');
    waitfor(msgbox('Export successful!'))
end
set(handles.figure1, 'pointer', 'arrow')


% --- Executes on button press in Workspace.
function Workspace_Callback(hObject, eventdata, handles)
% hObject    handle to Workspace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Workspace


% --- Executes on selection change in popupWS.
function popupWS_Callback(hObject, eventdata, handles)
% hObject    handle to popupWS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupWS contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupWS
% selecting workspaces in this popup menu allows you to switch between them
% The workspace you are currently working on is saved and the next one is
% opened
set(handles.figure1, 'pointer', 'watch')
drawnow;

cmpstr = get(handles.textWSs,'String'); %gets WS you've been working on
filenamewss = handles.filenamewss;

for i = 1: length(filenamewss)
    if strcmp(cmpstr,filenamewss{1,i}) == 1
        index = i;
    end
end

%saves your progress on WS temporarily, until new data is loaded
files                                   = handles.files;
files{1,index}.state.Sel                = get(handles.uipanel1,'SelectedObject');
files{1,index}.state.asinhX             = get(handles.asinhX,'Value');
files{1,index}.state.asinhY             = get(handles.asinhY,'Value');
files{1,index}.state.linX               = get(handles.linX,'Value');
files{1,index}.state.linY               = get(handles.linY,'Value');
files{1,index}.state.enlinX             = get(handles.linX,'Enable');
files{1,index}.state.enlinY             = get(handles.linY,'Enable');
files{1,index}.state.LinBtn             = get(handles.LinBtn,'Enable');
files{1,index}.state.enasinhX           = get(handles.asinhX,'Enable');
files{1,index}.state.enasinhY           = get(handles.asinhY,'Enable');
files{1,index}.state.BiExBtn            = get(handles.BiExBtn,'Enable');
files{1,index}.state.gatinghist         = handles.gatinghist;
files{1,index}.state.gateboxtext        = get(handles.gatebox,'String');
files{1,index}.state.gateboxvalue       = get(handles.gatebox,'Value');
files{1,index}.state.aritID             = handles.aritID;
files{1,index}.state.aritstats      	= handles.aritstats;
files{1,index}.state.kmCol              = handles.kmCol;
files{1,index}.state.StatNames          = handles.StatNames;
files{1,index}.state.popupSizeVal       = get(handles.popupSize,'Value');
files{1,index}.state.popupSizeString    = get(handles.popupSize,'String');
files{1,index}.state.popupColVal        = get(handles.popupCol,'Value');
files{1,index}.state.popupColStr        = get(handles.popupCol,'String');
files{1,index}.state.textXax            = get(handles.textXax,'string');
files{1,index}.state.textYax            = get(handles.textYax,'string');
files{1,index}.state.popupXst           = get(handles.popupX,'string');
files{1,index}.state.popupYst           = get(handles.popupY,'string');
files{1,index}.state.popupYval          = get(handles.popupY,'Value');
files{1,index}.state.popupXval          = get(handles.popupX,'Value');
files{1,index}.state.hist_bins          = get(handles.hist_bins,'String');
files{1,index}.state.Ymin               = get(handles.Ymin,'String');
files{1,index}.state.Ymax               = get(handles.Ymax,'String');
files{1,index}.state.Xmin               = get(handles.Xmin,'String');
files{1,index}.state.Xmax               = get(handles.Xmax,'String');
files{1,index}.state.Gate_Y             = get(handles.Gate_Y,'String');
files{1,index}.state.Gate_X             = get(handles.Gate_X,'String');
files{1,index}.state.Gate_Yperc         = get(handles.Gate_Yperc,'String');
files{1,index}.state.Gate_Xperc         = get(handles.Gate_Xperc,'String');
files{1,index}.state.GatingTable        = get(handles.GatingTable,'Data');
files{1,index}.state.radminus           = get(handles.radminus,'Value');
files{1,index}.state.radmultiply        = get(handles.radmultiply,'Value');
files{1,index}.state.raddivide          = get(handles.raddivide,'Value');
files{1,index}.state.plusrad            = get(handles.plusrad,'Value');
files{1,index}.state.popupAStr          = get(handles.popupA,'string');
files{1,index}.state.popupBStr          = get(handles.popupB,'string');
files{1,index}.state.popupAVal          = get(handles.popupA,'value');
files{1,index}.state.popupBVal          = get(handles.popupB,'value');
files{1,index}.state.StaAfact           = get(handles.StaAfact,'string');
files{1,index}.state.StaBfact           = get(handles.StaBfact,'string');
files{1,index}.state.BiExID             = handles.BiExID;
files{1,index}.state.percQ1             = handles.percQ1;
files{1,index}.state.percQ2             = handles.percQ2;
files{1,index}.state.percQ3             = handles.percQ3;
files{1,index}.state.percQ4             = handles.percQ4;
files{1,index}.state.numQ1              = handles.numQ1;
files{1,index}.state.numQ2              = handles.numQ2;
files{1,index}.state.numQ3              = handles.numQ3;
files{1,index}.state.numQ4              = handles.numQ4;
files{1,index}.state.percbelowX         = handles.percbelowX;
files{1,index}.state.percaboveX         = handles.percaboveX;
files{1,index}.state.numbelowX          = handles.numbelowX;
files{1,index}.state.numaboveX          = handles.numaboveX;
files{1,index}.state.percbelowY         = handles.percbelowY;
files{1,index}.state.percaboveY         = handles.percaboveY;
files{1,index}.state.numbelowY          = handles.numbelowY;
files{1,index}.state.numaboveY          = handles.numaboveY;
files{1,index}.state.percofallQ1        = handles.percofallQ1;
files{1,index}.state.percofallQ2        = handles.percofallQ2;
files{1,index}.state.percofallQ3        = handles.percofallQ3;
files{1,index}.state.percofallQ4        = handles.percofallQ4;
files{1,index}.state.percofallaX        = handles.percofallaX;
files{1,index}.state.percofallbX        = handles.percofallbX;
files{1,index}.state.percofallaY        = handles.percofallaX;
files{1,index}.state.percofallbY        = handles.percofallbX;
files{1,index}.state.names              = handles.names;
files{1,index}.state.stats              = handles.stats;
files{1,index}.state.BiEx_StatsMatrix   = handles.BiEx_StatsMatrix;
files{1,index}.state.statsCl            = handles.statsCl;
files{1,index}.state.statsClear         = handles.statsClear;
files{1,index}.state.namesCl            = handles.namesCl;
files{1,index}.state.inda               = handles.inda;
files{1,index}.state.indb               = handles.indb;
files{1,index}.state.indexAa            = handles.indexAa;
files{1,index}.state.indexAb            = handles.indexAb;
files{1,index}.state.NamesforExp        = handles.NamesforExp;
files{1,index}.state.histo              = handles.histo;
files{1,index}.state.line               = handles.line;
files{1,index}.state.fillarea           = handles.fillarea;
files{1,index}.state.axes1              = handles.axes1;
files{1,index}.state.nodes              = handles.nodes;
files{1,index}.state.ParentXYZs         = handles.ParentXYZs;
if isfield(files{1,index}.state, 'cofactor') == 0
    files{1,index}.state.cofactor       = get(handles.cofactor,'String');
    files{1,index}.state.cofact_col     = get(handles.cofact_col,'String'); 
    files{1,index}.state.colasinh       = get(handles.colasinh,'Value');
else   
    files{1,index}.state.cofactor           = get(handles.cofactor,'String');
    files{1,index}.state.cofact_col         = get(handles.cofact_col,'String'); 
    files{1,index}.state.colasinh           = get(handles.colasinh,'Value');
end

% loads selected WS data
g = get(hObject,'Value');
set(handles.textWSs,'String',filenamewss{1,g});
f = files{1,g}.state.Sel;
Sel = get(f,'String');
set(handles.popupSize,'Value', files{1,g}.state.popupSizeVal);
set(handles.popupSize,'String', files{1,g}.state.popupSizeString);
set(handles.popupCol,'Value', files{1,g}.state.popupColVal);
set(handles.popupCol,'String', files{1,g}.state.popupColStr);
set(handles.textXax,'string', files{1,g}.state.textXax);
set(handles.textYax,'string', files{1,g}.state.textYax);
set(handles.popupX,'enable', 'on');
set(handles.popupX,'string', files{1,g}.state.popupXst);
set(handles.popupY,'string', files{1,g}.state.popupYst);

switch Sel
    case 'Scatter'
        set(handles.scatterplot,'value', 1);
        set(handles.GateBtn,'Enable','on')
        set(handles.RectGateBtn,'Enable','on')
        set(handles.popupY,'enable', 'on');
        set(handles.Gate_Y,'Enable', 'on');
        set(handles.Gate_Yperc,'Enable', 'on');
    case 'Histogram'
        set(handles.histplot,'value', 1);
        set(handles.GateBtn,'Enable','off')
        set(handles.RectGateBtn,'Enable','off')
        set(handles.popupY,'enable', 'off');
        set(handles.Gate_Y,'Enable', 'off');
        set(handles.Gate_Yperc,'Enable', 'off');
        set(handles.applygateBtn,'Enable','off');
    case 'Line'
        set(handles.lineplot,'value', 1);
        set(handles.GateBtn,'Enable','off')
        set(handles.RectGateBtn,'Enable','off')
        set(handles.popupY,'enable', 'off');
        set(handles.Gate_Y,'Enable', 'off');
        set(handles.Gate_Yperc,'Enable', 'off');
        set(handles.applygateBtn,'Enable','off');
    case 'Fill'
        set(handles.fillplot,'value', 1);
        set(handles.GateBtn,'Enable','off')
        set(handles.RectGateBtn,'Enable','off')
        set(handles.popupY,'enable', 'off');
        set(handles.Gate_Y,'Enable', 'off');
        set(handles.Gate_Yperc,'Enable', 'off');
        set(handles.applygateBtn,'Enable','off');
end
set(handles.popupY,'Value', files{1,g}.state.popupYval);
set(handles.popupX,'Value', files{1,g}.state.popupXval);
set(handles.hist_bins,'String', files{1,g}.state.hist_bins);
set(handles.Ymin,'String', files{1,g}.state.Ymin);
set(handles.Ymax,'String', files{1,g}.state.Ymax);
set(handles.Xmin,'String', files{1,g}.state.Xmin);
set(handles.Xmax,'String', files{1,g}.state.Xmax);
set(handles.Gate_Y,'String', files{1,g}.state.Gate_Y);
set(handles.Gate_X,'String', files{1,g}.state.Gate_X);
set(handles.Gate_Yperc,'String', files{1,g}.state.Gate_Yperc);
set(handles.Gate_Xperc,'String', files{1,g}.state.Gate_Xperc);
set(handles.Gate_X,'Enable', 'on');
set(handles.GatingTable,'Data', files{1,g}.state.GatingTable);
set(handles.radminus,'Value', files{1,g}.state.radminus);
set(handles.radmultiply,'Value', files{1,g}.state.radmultiply);
set(handles.raddivide,'Value', files{1,g}.state.raddivide);
set(handles.plusrad,'Value', files{1,g}.state.plusrad);
set(handles.popupA,'string',files{1,g}.state.popupAStr);
set(handles.popupB,'string',files{1,g}.state.popupBStr);
set(handles.popupA,'value',files{1,g}.state.popupAVal);
set(handles.popupB,'value',files{1,g}.state.popupBVal);
set(handles.StaAfact,'string',files{1,g}.state.StaAfact);
set(handles.StaBfact,'string',files{1,g}.state.StaAfact);
set(handles.asinhX,'Value',files{1,g}.state.asinhX);
set(handles.asinhY,'Value',files{1,g}.state.asinhY);
set(handles.linX,'Value',files{1,g}.state.linX);
set(handles.linY,'Value',files{1,g}.state.linY);
set(handles.linX,'Enable',files{1,g}.state.enlinX);
set(handles.linY,'Enable',files{1,g}.state.enlinY);
set(handles.LinBtn,'Enable',files{1,g}.state.LinBtn);
set(handles.asinhX,'Enable',files{1,g}.state.enasinhX);
set(handles.asinhY,'Enable',files{1,g}.state.enasinhY);
set(handles.BiExBtn,'Enable',files{1,g}.state.BiExBtn);

if isfield(files{1,g}.state, 'cofactor') == 0
    set(handles.cofactor,'string','1');
    set(handles.cofact_col,'string','1');
    set(handles.colasinh,'value',0);
else   
    set(handles.cofactor,'string',files{1,g}.state.cofactor);
    set(handles.cofact_col,'string',files{1,g}.state.cofact_col);
    set(handles.colasinh,'value',files{1,g}.state.colasinh);
end

handles.ParentXYZs = files{1,g}.state.ParentXYZs;
handles.BiExID = files{1,g}.state.BiExID;
handles.StatNames = files{1,g}.state.StatNames;
handles.kmCol = files{1,g}.state.kmCol;
handles.ColorNames = files{1,g}.state.popupColStr;
handles.percQ1 = files{1,g}.state.percQ1;
handles.percQ2 = files{1,g}.state.percQ2;
handles.percQ3 = files{1,g}.state.percQ3;
handles.percQ4 = files{1,g}.state.percQ4;
handles.numQ1 = files{1,g}.state.numQ1;
handles.numQ2 = files{1,g}.state.numQ2;
handles.numQ3 = files{1,g}.state.numQ3;
handles.numQ4 = files{1,g}.state.numQ4;
handles.percbelowX = files{1,g}.state.percbelowX;
handles.percaboveX = files{1,g}.state.percaboveX;
handles.numbelowX = files{1,g}.state.numbelowX;
handles.numaboveX = files{1,g}.state.numaboveX;
handles.percbelowY = files{1,g}.state.percbelowY;
handles.percaboveY = files{1,g}.state.percaboveY;
handles.numbelowY = files{1,g}.state.numbelowY;
handles.numaboveY = files{1,g}.state.numaboveY;
handles.percofallQ1 = files{1,g}.state.percofallQ1;
handles.percofallQ2 = files{1,g}.state.percofallQ2;
handles.percofallQ3 = files{1,g}.state.percofallQ3;
handles.percofallQ4 = files{1,g}.state.percofallQ4;
handles.percofallaX = files{1,g}.state.percofallaX;
handles.percofallbX = files{1,g}.state.percofallbX;
handles.percofallaY = files{1,g}.state.percofallaY;
handles.percofallbY = files{1,g}.state.percofallbY;
handles.aritID = files{1,g}.state.aritID;
handles.aritstats = files{1,g}.state.aritstats;
handles.names = files{1,g}.state.names;
handles.stats = files{1,g}.state.stats;
handles.BiEx_StatsMatrix = files{1,g}.state.BiEx_StatsMatrix;
handles.statsCl = files{1,g}.state.statsCl;
handles.statsClear = files{1,g}.state.statsClear;
handles.namesCl = files{1,g}.state.namesCl;
handles.inda = files{1,g}.state.inda;
handles.indb = files{1,g}.state.indb;
handles.indexAa = files{1,g}.state.indexAa;
handles.indexAb = files{1,g}.state.indexAb;
handles.NamesforExp = files{1,g}.state.NamesforExp;
handles.histo = files{1,g}.state.histo;
handles.line = files{1,g}.state.line;
handles.fillarea = files{1,g}.state.fillarea;
axes1 = findobj('type','axes');
handles.axes1 = axes1;
handles.histo = files{1,g}.state.histo;
handles.line = files{1,g}.state.line;
handles.fillarea = files{1,g}.state.fillarea;
handles.gatinghist = files{1,g}.state.gatinghist;
handles.gateboxtext = files{1,g}.state.gateboxtext;
handles.gateboxvalue = files{1,g}.state.gateboxvalue;
handles.nodes = files{1,index}.state.nodes;
handles.files = files;
guidata(hObject, handles);
    
if handles.histo == 1 || handles.line == 1 || handles.fillarea == 1
    ind_b = handles.indb;
    names = handles.names;
    set(handles.textYax,'string',names(1,ind_b));
    set(handles.popupY,'value', ind_b);
end

if length(axes1)>1    
    yu = get(gcf,'Currentaxes');
    [a,~,~] = intersect(yu,axes1);
    handles.axes1 = a;
    guidata(hObject,handles)
end
sizeVal = get(handles.popupSize,'Value');
sizeSc1 = get(handles.popupSize,'String');
sizeSc = str2double(sizeSc1{sizeVal,1});
handles.sizeSc = sizeSc;
guidata(hObject,handles);

xgate = str2double(get(handles.Gate_X,'String'));
ygate = str2double(get(handles.Gate_Y,'String'));
stats = handles.stats;
StatsMatrixCl = handles.statsCl;
num_forperc = size(StatsMatrixCl,1);
ind_a = handles.inda;
ind_b = handles.indb;
sizeSc = handles.sizeSc;
s = get(handles.popupCol,'Value');
kCol = handles.kmCol;
abin = str2double(get(handles.densitybin,'String'));
bins = str2double(get(handles.hist_bins,'String'));
xmin = str2double(get(handles.Xmin,'String'));
xmax = str2double(get(handles.Xmax,'String'));
ymin = str2double(get(handles.Ymin,'String'));
ymax = str2double(get(handles.Ymax,'String'));

XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,1,1,...
    str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)
a = getappdata(XIT,'handl');

if get(handles.popupCol,'value') > 2
    cmax = str2double(get(handles.colorMax,'String'));    
    cmin = str2double(get(handles.colorMin,'String'));  
    if isnan(cmin)
        cmin = 0;
    end
    if isnan(cmax)
        cmax = 255;
    end
    axes(handles.axes1)
    caxis([cmin cmax])  
end
    
GateID = a.ID;
if GateID == 0
elseif GateID == 1
	handles.StatsMatrix2 = a.StatsMatrix2;
	handles.StatsMatrix3 = a.StatsMatrix3;
  	handles.percbelowX = a.percbelowX;
   	handles.percaboveX = a.percaboveX;
   	handles.numbelowX = a.numbelowX;
   	handles.numaboveX = a.numaboveX;
 	handles.percofallaX = a.percofallaX;
  	handles.percofallbX = a.percofallbX;
elseif GateID == 3
  	handles.StatsMatrix2 = a.StatsMatrix2;
  	handles.StatsMatrix3 = a.StatsMatrix3;
   	handles.percbelowY = a.percbelowY;
  	handles.percaboveY = a.percaboveY;
 	handles.numbelowY = a.numbelowY;
  	handles.numaboveY = a.numaboveY;
   	handles.percofallaY = a.percofallaY;
  	handles.percofallbY = a.percofallbY;
elseif GateID == 2
   	handles.StatsMatrixQ1 = a.StatsMatrixQ1;
  	handles.StatsMatrixQ2 = a.StatsMatrixQ2;
  	handles.StatsMatrixQ3 = a.StatsMatrixQ3;
  	handles.StatsMatrixQ4 = a.StatsMatrixQ4;
  	handles.percQ1 = a.percQ1;
   	handles.percQ2 = a.percQ2;
   	handles.percQ3 = a.percQ3;
   	handles.percQ4 = a.percQ4;
   	handles.percofallQ1 = a.percofallQ1;
   	handles.percofallQ2 = a.percofallQ2;
   	handles.percofallQ3 = a.percofallQ3;
   	handles.percofallQ4 = a.percofallQ4;
  	handles.numQ1 = a.numQ1;
   	handles.numQ2 = a.numQ2;
  	handles.numQ3 = a.numQ3;
   	handles.numQ4 = a.numQ4;
end
set(handles.gatebox,'String',handles.gateboxtext)
set(handles.gatebox,'Value',handles.gateboxvalue)
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject,handles)
   

% --- Executes during object creation, after setting all properties.
function popupWS_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupWS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in loadWSs.
function loadWSs_Callback(hObject, eventdata, handles)
% hObject    handle to loadWSs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% loads workspaces to use popupWS in order to switch between them
set(handles.figure1, 'pointer', 'watch')
drawnow;
figs =  findobj('type','figure');
for i = 1:length(figs)
    if strcmp('XIT',get(figs(i),'Name'))
        index = i;
    end
end

figs(index) = [];

close(figs)

set(handles.popupFigure,'String','Figures')
set(handles.popupFigure,'Value',1)

pathname = handles.loadpath;
loadID = handles.loadID;
if loadID == 1 %loading path defined
    [filename, pathname] = ...
    uigetfile({'*.mat'}, 'Select file', pathname,'MultiSelect', 'on');
    for i = 1:length(filename)
        filenamewss{1,i} = [pathname filename{1,i}];
    end
else %no loading path defined
    [filename, pathname] = ...
    uigetfile({'*.mat'}, 'Select file', 'MultiSelect', 'on');
    for i = 1:length(filename)
        filenamewss{1,i} = [pathname filename{1,i}];
    end
end

files = cell(1,length(filenamewss));
for i = 1:length(filenamewss)
    files{1,i} = load(filenamewss{1,i});
end

handles.files = files;
handles.filenamewss = filenamewss;
set(handles.textFile,'String',' ')
set(handles.popupWS,'String',filenamewss)
set(handles.popupWS,'Value',1)
set(handles.textWSs,'String',filenamewss{1,1});
guidata(hObject,handles)
set(handles.popupX,'String', files{1,1}.state.popupXst);
set(handles.popupY,'String', files{1,1}.state.popupYst);
set(handles.popupSize,'Value',files{1,1}.state.popupSizeVal);
set(handles.popupSize,'String',files{1,1}.state.popupSizeString);
  
f = files{1,1}.state.Sel;
Sel = get(f,'String');
if strcmp(Sel,'Scatter')
    set(handles.textYax,'string', files{1,1}.state.textYax);
    set(handles.popupY,'value', files{1,1}.state.indb);
else
    ind_b = files{1,1}.state.indb;
	names = files{1,1}.state.names;
	set(handles.textYax,'string',names(1,ind_b));
	set(handles.popupY,'value', ind_b);
end

handles.sizeSc = files{1,1}.state.sizeSc;
guidata(hObject,handles);

set(handles.popupCol,'Value', files{1,1}.state.popupColVal);
set(handles.popupCol,'String', files{1,1}.state.popupColStr);
set(handles.textXax,'string', files{1,1}.state.textXax);
set(handles.textYax,'string', files{1,1}.state.textYax);
set(handles.popupX,'string', files{1,1}.state.popupXst);
set(handles.popupY,'string', files{1,1}.state.popupYst);
       
set(handles.applygateBtn,'Enable','off');
switch Sel
    case 'Scatter'
        set(handles.scatterplot,'value', 1);
        set(handles.histplot,'value', 0);
        set(handles.lineplot,'value', 0);
        set(handles.fillplot,'value', 0);
        set(handles.GateBtn,'Enable','on')
        set(handles.RectGateBtn,'Enable','on')
        set(handles.popupX,'enable', 'on');
        set(handles.popupY,'enable', 'on');
        set(handles.Gate_Y,'Enable', 'on');
        set(handles.Gate_X,'Enable', 'on');
        set(handles.Gate_Yperc,'Enable', 'on');
        set(handles.Gate_Xperc,'Enable', 'on');
    case 'Histogram'
        set(handles.scatterplot,'value', 0);
        set(handles.histplot,'value', 1);
        set(handles.lineplot,'value', 0);
        set(handles.fillplot,'value', 0);
        set(handles.popupX,'enable', 'on');
        set(handles.popupY,'enable', 'off');
        set(handles.Gate_Y,'Enable', 'off');
        set(handles.Gate_X,'Enable', 'on');
        set(handles.Gate_Yperc,'Enable', 'off');
        set(handles.Gate_Xperc,'Enable', 'on');
        set(handles.GateBtn,'Enable','off')
        set(handles.RectGateBtn,'Enable','off')
    case 'Line'
        set(handles.scatterplot,'value', 0);
        set(handles.histplot,'value', 0);
        set(handles.lineplot,'value', 1);
        set(handles.fillplot,'value', 0);
        set(handles.popupX,'enable', 'on');
        set(handles.popupY,'enable', 'off');
        set(handles.Gate_Y,'Enable', 'off');
        set(handles.Gate_X,'Enable', 'on');
        set(handles.Gate_Yperc,'Enable', 'off');
        set(handles.Gate_Xperc,'Enable', 'on');
        set(handles.GateBtn,'Enable','off')
        set(handles.RectGateBtn,'Enable','off')
    case 'Fill'
        set(handles.scatterplot,'value', 0);
        set(handles.histplot,'value', 0);
        set(handles.lineplot,'value', 0);
        set(handles.fillplot,'value', 1);
        set(handles.popupX,'enable', 'on');
        set(handles.popupY,'enable', 'off');
        set(handles.Gate_Y,'Enable', 'off');
        set(handles.Gate_X,'Enable', 'on');
        set(handles.Gate_Yperc,'Enable', 'off');
        set(handles.Gate_Xperc,'Enable', 'on');
        set(handles.GateBtn,'Enable','off')
        set(handles.RectGateBtn,'Enable','off')
end

if isfield(files{1,1}.state, 'cofactor') == 0
    set(handles.cofactor,'String','1');
    set(handles.cofact_col,'String','1');
    set(handles.colasinh,'Value',0);
else   
    set(handles.cofactor,'String', files{1,1}.state.cofactor);
    set(handles.cofact_col,'String', files{1,1}.state.cofact_col);
    set(handles.colasinh,'Value', files{1,1}.state.colasinh);
end
set(handles.popupY,'Value', files{1,1}.state.popupYval);
set(handles.popupX,'Value', files{1,1}.state.popupXval);
set(handles.hist_bins,'String', files{1,1}.state.hist_bins);
set(handles.Ymin,'String', files{1,1}.state.Ymin);
set(handles.Ymax,'String', files{1,1}.state.Ymax);
set(handles.Xmin,'String', files{1,1}.state.Xmin);
set(handles.Xmax,'String', files{1,1}.state.Xmax);
set(handles.Gate_Y,'String', files{1,1}.state.Gate_Y);
set(handles.Gate_X,'String', files{1,1}.state.Gate_X);
set(handles.Gate_Yperc,'String', files{1,1}.state.Gate_Yperc);
set(handles.Gate_Xperc,'String', files{1,1}.state.Gate_Xperc);
set(handles.GatingTable,'Data', files{1,1}.state.GatingTable);
set(handles.radminus,'Value', files{1,1}.state.radminus);
set(handles.radmultiply,'Value', files{1,1}.state.radmultiply);
set(handles.raddivide,'Value', files{1,1}.state.raddivide);
set(handles.plusrad,'Value', files{1,1}.state.plusrad);
set(handles.popupA,'string',files{1,1}.state.popupAStr);
set(handles.popupB,'string',files{1,1}.state.popupBStr);
set(handles.popupA,'value',files{1,1}.state.popupAVal);
set(handles.popupB,'value',files{1,1}.state.popupBVal);
set(handles.StaAfact,'string',files{1,1}.state.StaAfact);
set(handles.StaBfact,'string',files{1,1}.state.StaAfact);
handles.ParentXYZs = files{1,1}.state.ParentXYZs;
handles.StatNames = files{1,1}.state.StatNames;
handles.BiExID = files{1,1}.state.BiExID;
handles.kmCol = files{1,1}.state.kmCol;
handles.ColorNames = files{1,1}.state.popupColStr;
handles.percQ1 = files{1,1}.state.percQ1;
handles.percQ2 = files{1,1}.state.percQ2;
handles.percQ3 = files{1,1}.state.percQ3;
handles.percQ4 = files{1,1}.state.percQ4;
handles.numQ1 = files{1,1}.state.numQ1;
handles.numQ2 = files{1,1}.state.numQ2;
handles.numQ3 = files{1,1}.state.numQ3;
handles.numQ4 = files{1,1}.state.numQ4;
handles.percbelowX = files{1,1}.state.percbelowX;
handles.percaboveX = files{1,1}.state.percaboveX;
handles.numbelowX = files{1,1}.state.numbelowX;
handles.numaboveX = files{1,1}.state.numaboveX;
handles.percbelowY = files{1,1}.state.percbelowY;
handles.percaboveY = files{1,1}.state.percaboveY;
handles.numbelowY = files{1,1}.state.numbelowY;
handles.numaboveY = files{1,1}.state.numaboveY;
handles.percofallQ1 = files{1,1}.state.percofallQ1;
handles.percofallQ2 = files{1,1}.state.percofallQ2;
handles.percofallQ3 = files{1,1}.state.percofallQ3;
handles.percofallQ4 = files{1,1}.state.percofallQ4;
handles.percofallaX = files{1,1}.state.percofallaX;
handles.percofallbX = files{1,1}.state.percofallbX;
handles.percofallaY = files{1,1}.state.percofallaY;
handles.percofallbY = files{1,1}.state.percofallbY;
handles.aritID = files{1,1}.state.aritID;
handles.aritstats = files{1,1}.state.aritstats;
handles.names = files{1,1}.state.names;
handles.stats = files{1,1}.state.stats;
handles.BiEx_StatsMatrix = files{1,1}.state.BiEx_StatsMatrix;
handles.statsCl = files{1,1}.state.statsCl;
handles.statsClear = files{1,1}.state.statsClear;
handles.namesCl = files{1,1}.state.namesCl;
handles.inda = files{1,1}.state.inda;
handles.indb = files{1,1}.state.indb;
handles.indexAa = files{1,1}.state.indexAa;
handles.indexAb = files{1,1}.state.indexAb;
handles.NamesforExp = files{1,1}.state.NamesforExp;
handles.histo = files{1,1}.state.histo;
handles.line = files{1,1}.state.line;
handles.fillarea = files{1,1}.state.fillarea;
axes1 = findobj('type','axes');
handles.axes1 = axes1;
handles.kmCol = 0;
handles.gatinghist = files{1,1}.state.gatinghist;
handles.gateboxtext = files{1,1}.state.gateboxtext;
handles.gateboxvalue = files{1,1}.state.gateboxvalue;
handles.nodes = files{1,1}.state.nodes;
guidata(hObject,handles)

f = get(handles.uipanel1,'SelectedObject');
Sel = get(f,'String');

xgate = str2double(get(handles.Gate_X,'String'));
ygate = str2double(get(handles.Gate_Y,'String'));
stats = handles.stats;
StatsMatrixCl = handles.statsCl;
num_forperc = size(StatsMatrixCl,1);
ind_a = handles.inda;
ind_b = handles.indb;
sizeSc = handles.sizeSc;
s = get(handles.popupCol,'Value');
kCol = handles.kmCol;
abin = str2double(get(handles.densitybin,'String'));
bins = str2double(get(handles.hist_bins,'String'));
xmin = str2double(get(handles.Xmin,'String'));
xmax = str2double(get(handles.Xmax,'String'));
ymin = str2double(get(handles.Ymin,'String'));
ymax = str2double(get(handles.Ymax,'String'));


XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,1,1,...
    str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)
a = getappdata(XIT,'handl');

if get(handles.popupCol,'value') > 2
    cmax = str2double(get(handles.colorMax,'String'));    
    cmin = str2double(get(handles.colorMin,'String'));  
    if isnan(cmin)
        cmin = 0;
    end
    if isnan(cmax)
        cmax = 255;
    end
    axes(handles.axes1)
    caxis([cmin cmax])  
end

GateID = a.ID;
if GateID == 0
elseif GateID == 1
    handles.StatsMatrix2 = a.StatsMatrix2;
    handles.StatsMatrix3 = a.StatsMatrix3;
    handles.percbelowX = a.percbelowX;
    handles.percaboveX = a.percaboveX;
    handles.numbelowX = a.numbelowX;
    handles.numaboveX = a.numaboveX;
    handles.percofallaX = a.percofallaX;
    handles.percofallbX = a.percofallbX;
elseif GateID == 3
    handles.StatsMatrix2 = a.StatsMatrix2;
    handles.StatsMatrix3 = a.StatsMatrix3;
    handles.percbelowY = a.percbelowY;
    handles.percaboveY = a.percaboveY;
    handles.numbelowY = a.numbelowY;
    handles.numaboveY = a.numaboveY;
    handles.percofallaY = a.percofallaY;
    handles.percofallbY = a.percofallbY;
elseif GateID == 2
    handles.StatsMatrixQ1 = a.StatsMatrixQ1;
    handles.StatsMatrixQ2 = a.StatsMatrixQ2;
    handles.StatsMatrixQ3 = a.StatsMatrixQ3;
    handles.StatsMatrixQ4 = a.StatsMatrixQ4;
    handles.percQ1 = a.percQ1;
    handles.percQ2 = a.percQ2;
    handles.percQ3 = a.percQ3;
    handles.percQ4 = a.percQ4;
    handles.percofallQ1 = a.percofallQ1;
    handles.percofallQ2 = a.percofallQ2;
    handles.percofallQ3 = a.percofallQ3;
    handles.percofallQ4 = a.percofallQ4;
    handles.numQ1 = a.numQ1;
    handles.numQ2 = a.numQ2;
    handles.numQ3 = a.numQ3;
    handles.numQ4 = a.numQ4;
end

set(handles.gatebox,'String',handles.gateboxtext)
set(handles.gatebox,'Value',handles.gateboxvalue)
set(handles.asinhX,'Value',files{1,1}.state.asinhX);
set(handles.asinhY,'Value',files{1,1}.state.asinhY);
set(handles.linX,'Value',files{1,1}.state.linX);
set(handles.linY,'Value',files{1,1}.state.linY);
set(handles.linX,'Enable',files{1,1}.state.enlinX);
set(handles.linY,'Enable',files{1,1}.state.enlinY);
set(handles.LinBtn,'Enable',files{1,1}.state.LinBtn);
set(handles.asinhX,'Enable',files{1,1}.state.enasinhX);
set(handles.asinhY,'Enable',files{1,1}.state.enasinhY);
set(handles.BiExBtn,'Enable',files{1,1}.state.BiExBtn);
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject,handles)

% --- Executes on selection change in popupCol.
function popupCol_Callback(hObject, eventdata, handles)
% hObject    handle to popupCol (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupCol contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupCol
% this popupmenu enables chosing black, density info or statistical
% informations as color coding for the scatter plot
set(handles.figure1, 'pointer', 'watch')
drawnow;
if get(handles.scatterplot,'Value') == 1
    set(handles.popupCol,'Enable','on')
    s = get(handles.popupCol,'Value');
   
    %gather stats to run XITplot
    ind_a = handles.inda;
    ind_b = handles.indb;
    f = get(handles.uipanel1,'SelectedObject');
    Sel = get(f,'String');
    xgate = str2double(get(handles.Gate_X,'String'));
    ygate = str2double(get(handles.Gate_Y,'String'));
    stats = handles.stats;
    StatsMatrixCl = handles.statsCl;
    num_forperc = size(StatsMatrixCl,1);
    sizeSc = handles.sizeSc;

    kCol = handles.kmCol;
    abin = str2double(get(handles.densitybin,'String'));
    bins = str2double(get(handles.hist_bins,'String'));

    xmin = str2double(get(handles.Xmin,'String'));
    xmax = str2double(get(handles.Xmax,'String'));
    ymin = str2double(get(handles.Ymin,'String'));
    ymax = str2double(get(handles.Ymax,'String'));


    XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,get(handles.asinhX,'value'),get(handles.asinhY,'value'),...
        str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)
    a = getappdata(XIT,'handl');
    
    if get(handles.popupCol,'value') > 2
        cmax = str2double(get(handles.colorMax,'String'));    
        cmin = str2double(get(handles.colorMin,'String'));  
        if isnan(cmin)
            cmin = 0;
        end
        if isnan(cmax)
            cmax = 255;
        end
        axes(handles.axes1)
        caxis([cmin cmax])  
    end
    % get gating info from XITplot
    GateID = a.ID;
    if GateID == 0
    elseif GateID == 1
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowX = a.percbelowX;
        handles.percaboveX = a.percaboveX;
        handles.numbelowX = a.numbelowX;
        handles.numaboveX = a.numaboveX;
        handles.percofallaX = a.percofallaX;
        handles.percofallbX = a.percofallbX;
    elseif GateID == 3
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowY = a.percbelowY;
        handles.percaboveY = a.percaboveY;
        handles.numbelowY = a.numbelowY;
        handles.numaboveY = a.numaboveY;
        handles.percofallaY = a.percofallaY;
        handles.percofallbY = a.percofallbY;
    elseif GateID == 2
        handles.StatsMatrixQ1 = a.StatsMatrixQ1;
        handles.StatsMatrixQ2 = a.StatsMatrixQ2;
        handles.StatsMatrixQ3 = a.StatsMatrixQ3;
        handles.StatsMatrixQ4 = a.StatsMatrixQ4;
        handles.percQ1 = a.percQ1;
        handles.percQ2 = a.percQ2;
        handles.percQ3 = a.percQ3;
        handles.percQ4 = a.percQ4;
        handles.percofallQ1 = a.percofallQ1;
        handles.percofallQ2 = a.percofallQ2;
        handles.percofallQ3 = a.percofallQ3;
        handles.percofallQ4 = a.percofallQ4;
        handles.numQ1 = a.numQ1;
        handles.numQ2 = a.numQ2;
        handles.numQ3 = a.numQ3;
        handles.numQ4 = a.numQ4;
    end
        
    handles.colorcode = s;
    handles.kmCol = 0;
    
    reziseaxes(stats,ind_a,xmin,xmax,ymin,ymax,handles.axes1)
end
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject,handles)


% --- Executes during object creation, after setting all properties.
function popupCol_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupCol (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupSize.
function popupSize_Callback(hObject, eventdata, handles)
% hObject    handle to popupSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupSize contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupSize
% This popup menu allows you to control the size of the scatter plot
set(handles.figure1, 'pointer', 'watch')
drawnow;
if get(handles.scatterplot,'Value') == 1
    set(handles.popupCol,'Enable','on')
    set(handles.popupSize,'Enable','on')
    sizeVal = get(handles.popupSize,'Value');
    sizeSc1 = get(handles.popupSize,'String');
    sizeSc = str2double(sizeSc1{sizeVal,1}); %size selected
    stats = handles.stats;
    ind_a = handles.inda;
    ind_b = handles.indb;
    kCol = handles.kmCol;
    s = get(handles.popupCol,'Value');
    
    if s == 1 & kCol == 0;
    	axes(handles.axes1)
    	scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,[0 0 0],'filled');
    elseif s == 2 & kCol == 0;
        abin = str2double(get(handles.densitybin,'String'));
        edgesX = linspace(min(stats(:,ind_a)), max(stats(:,ind_a)), abin);
        edgesY = linspace(min(stats(:,ind_b)), max(stats(:,ind_b)), abin);
        [One,~] = size(stats(:,ind_a));
        [~,CountsX] = histc(stats(:,ind_a),edgesX);
        [~,CountsY] = histc(stats(:,ind_b),edgesY);
        Counts = [CountsX,CountsY];
        Darray = accumarray(Counts,1)./One;
        DarrayNorm = Darray./max(Darray(:));
        DarrayNorm = imgaussfilt(DarrayNorm,2);
        ind = sub2ind(size(DarrayNorm),CountsX,CountsY);
        col2 = DarrayNorm(ind);
        U = sortrows([stats(:,ind_a), stats(:,ind_b), col2],3);
        col1 = U(:,3);
        colormap(jet(4096));
        axes(handles.axes1)
        scatter(U(:,1),U(:,2),sizeSc,col1,'filled')
    elseif s > 2 & kCol == 0;
    	es = s-2;
    	axes(handles.axes1)
    	scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,handles.stats(:,es),'filled');
    elseif length(kCol) > 1;
    	axes(handles.axes1)
    	scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,kCol,'filled');   
    end

    handles.sizeSc = sizeSc;
    xmin = str2double(get(handles.Xmin,'String'));
    xmax = str2double(get(handles.Xmax,'String'));
    ymin = str2double(get(handles.Ymin,'String'));
    ymax = str2double(get(handles.Ymax,'String')); 
    
    reziseaxes(stats,ind_a,xmin,xmax,ymin,ymax,handles.axes1)
end
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function popupSize_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in hmBtn.
function hmBtn_Callback(hObject, eventdata, handles)
% hObject    handle to hmBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% runs a heatmap algorithm on the current gate and produces plots and
% overlays
set(handles.figure1, 'pointer', 'watch')
drawnow;

data = handles.stats;
datapp = handles.statsCl;
BiExID = handles.BiExID;
ind_a = handles.inda;
ind_b = handles.indb;
PositionToScale = handles.ParentXYZs;

if BiExID == 1
    set(handles.asinhX,'Enable','on');
    set(handles.asinhY,'Enable','on');
    set(handles.BiExBtn,'Enable','on');
    set(handles.linX,'Enable','off');
    set(handles.linY,'Enable','off');
    set(handles.LinBtn,'Enable','off');
    if get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 0
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(data(:,ind_a)) - exp(-1.*(data(:,ind_a))));
        data(:,ind_a) = lin_StatsX;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',0);
    elseif get(handles.linX,'Value') == 0 & get(handles.linY,'Value') == 1
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(data(:,ind_b)) - exp(-1.*(data(:,ind_b))));
        data(:,ind_b) = lin_StatsY;
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',0);
        set(handles.asinhY,'Value',1);
    elseif get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 1
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(data(:,ind_a)) - exp(-1.*(data(:,ind_a))));
        data(:,ind_a) = lin_StatsX;
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(data(:,ind_b)) - exp(-1.*(data(:,ind_b))));
        data(:,ind_b) = lin_StatsY;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',1);
    end
end
        
handles.datapp = datapp(:,(end-3):(end));
handles.data_for_HMs = data(:,(end-3):(end-1));
parameters1 = inputdlg({'Enter volume for density analysis in um3'},'Input',1,{'125000'}); %volume of voxel to raster the dataset
if isempty(parameters1)
    
end
Vs = str2double(parameters1{:});
handles.edge = nthroot(Vs,3);
handles.IDsforExport_1 = data(:,end);
marker = [get(handles.textXax,'String'); get(handles.textYax,'String')];
handles.markercell = marker;
Positions = datapp(:,(end-3):(end-1));  

%allows checking the sample orientation; clicking x in the following window
%will all you to not do any action
parameters2 = questdlg('Do you want to check the orientation of your sample?','Sample orientation','Yes','No','No');
        switch parameters2
            case 'Yes'
                first = figure('position', [50, 100, 1800, 1000]);
                scatter(Positions(:,2),Positions(:,1),3,'Markerfacecolor',[0 0 0],...
                    'MarkerEdgeColor','none')
                daspect([1 1 1])
                title('XY projection')
                parameters3 = questdlg('Do you want to flip/mirror your sample?','Sample orientation','Yes','No','Yes');
                switch parameters3
                    case 'Yes'
                        parameters4 = questdlg('I want to...','Sample orientation','flip (horizontal)','mirror (vertical)','flip and mirror','Flip (horizontal)');
                       	switch parameters4
                            case 'flip (horizontal)'
                                flipid = 1;
                                mirrorid = 0;
                            case 'mirror (vertical)'
                                flipid = 0;
                                mirrorid = 1;
                            case 'flip and mirror'
                                flipid = 1;
                                mirrorid = 1;
                        end
                        if isempty(parameters4)
                            flipid = 0;
                            mirrorid = 0;
                        end
                    case 'No'
                        flipid = 0;
                        mirrorid = 0;
                end
                if isempty(parameters3)
                    flipid = 0;
                    mirrorid = 0;
                end
                close(first)
        case 'No'
                parameters3 = questdlg('Do you want to flip/mirror your sample?','Sample orientation','Yes','No','Yes');
                switch parameters3
                    case 'Yes'
                        parameters4 = questdlg('I want to...','Sample orientation','flip (horizontal)','mirror (vertical)','flip and mirror','Flip (horizontal)');
                       	switch parameters4
                            case 'flip (horizontal)'
                                flipid = 1;
                                mirrorid = 0;
                            case 'mirror (vertical)'
                                flipid = 0;
                                mirrorid = 1;
                            case 'flip and mirror'
                                flipid = 1;
                                mirrorid = 1;
                        end
                        if isempty(parameters4)
                            flipid = 0;
                            mirrorid = 0;
                        end
                    case 'No'
                        flipid = 0;
                        mirrorid = 0;
            	end
                if isempty(parameters3)
                    flipid = 0;
                    mirrorid = 0;
                end
        end
        
pathname = handles.savepath;
saveID = handles.saveID;

if saveID == 1
    [FileName,PathName] = uiputfile('*.tif','Save heatmaps',pathname);
else
    [FileName,PathName] = uiputfile('*.tif','Save heatmaps');
end

HMsSW

waitfor(msgbox('Done'));
drawnow;
set(handles.figure1, 'pointer', 'arrow')


function densitybin_Callback(hObject, eventdata, handles)
% hObject    handle to handles.densitybin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of handles.densitybin as text
%        str2double(get(hObject,'String')) returns contents of handles.densitybin as a double

% --- Executes during object creation, after setting all properties.
function densitybin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to handles.densitybin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Btn3D.
function Btn3D_Callback(hObject, eventdata, handles)
% hObject    handle to Btn3D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% allows 3D data vizualisation, choosing size and color of the scatter plot
% as well as the statistics
hand = handles;
setappdata(XIT,'hand',hand)

View4D
guidata(hObject, handles)

% --- Executes on selection change in popupFontSize.
function popupFontSize_Callback(hObject, eventdata, handles)
% hObject    handle to popupFontSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupFontSize contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupFontSize
% Allows changing font size of plots added to the popupfigure popup menu by
% AddBtn
set(handles.figure1, 'pointer', 'watch')
drawnow;
b = get(handles.popupFigure,'String');
a = get(handles.popupFigure,'Value');
a1 = b(a,1);

figs =  findobj('type','figure');

for i = 1:length(figs)
    if strcmp(a1,get(figs(i),'Name'))
        index = i;
    end
end
hand = findobj(figs(index),'type','axes');

b = get(handles.popupFontSize,'Value'); %fontsize gathered from the popup menu

set(hand,'Fontsize',b)
set(get(hand,'Xlabel'),'Fontsize',b)
set(get(hand,'Ylabel'),'Fontsize',b)
tx = get(hand,'Xtick');
ty = get(hand,'Ytick');
handles.tx = tx;
handles.ty = ty;
set(hand,'XTickMode','auto')
set(hand,'YTickMode','auto')
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject, handles)

% --- Executes during object creation, after setting all properties.
function popupFontSize_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupFontSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in popupFigure.
function popupFigure_Callback(hObject, eventdata, handles)
% hObject    handle to popupFigure (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupFigure contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupFigure
% Allows changing the current figure in the Figure popup menu, all properties 
% that can be changed will be "read" and displayed in the buttons and popup menus 
set(handles.figure1, 'pointer', 'watch')
drawnow;
b = get(handles.popupFigure,'String');
a = get(handles.popupFigure,'Value');
a1 = b(a,1);

figs =  findobj('type','figure');

for i = 1:length(figs)
    if strcmp(a1,get(figs(i),'Name'))
        index = i;
    end
end

hand = findobj(figs(index),'type','axes');
texthand = findobj(hand,'type','text');

hline = findobj(figs(index), 'type', 'line');

a0 = get(hand,'xtick');
if ~isempty(a0)
    set(handles.Axesti,'Value',1);
else
    set(handles.Axesti,'Value',0);
end

ass = get(get(hand,'xlabel'),'Visible');
ass2 = get(get(hand,'Xlabel'),'type');
if strcmp(ass2,'text') == 1  & strcmp(ass,'on')
    set(handles.ticklabels,'Value',1);
else
    set(handles.ticklabels,'Value',0);
end
drawnow

b = get(hand,'Box');
if strcmp(b,'on') == 1
    set(handles.tickbox,'Value',1)
else
    set(handles.tickbox,'Value',0)
end

c = get(texthand,'Visible');
if isempty(c)
    set(handles.ticktext,'Value',0);
elseif strcmp(c,'on') == 1
    set(handles.ticktext,'Value',1);
elseif strcmp(c,'off') == 1
    set(handles.ticktext,'Value',0);
end

d = get(hand,'Fontsize');
set(handles.popupFontSize,'Value',d)

e = get(hline,'LineWidth');
if isempty(e) == 0
    if length(e) > 1
        set(handles.popupLiT,'Value',e{1,1})
        if e{1,1} == 0.5
            set(handles.popupLiT,'Value',1)
        end
    elseif e == 0.5
        set(handles.popupLiT,'Value',1)
    else
        set(handles.popupLiT,'Value',e)
    end
else
    set(handles.popupLiT,'Value',1)
end

f = get(hand,'LineWidth');
if isempty(f) == 0
    if length(f) > 1
        set(handles.boxthipopup,'Value',f{1,1})
    elseif f == 0.5
        set(handles.boxthipopup,'Value',1)
    else
        set(handles.boxthipopup,'Value',f)
    end
else
    set(handles.boxthipopup,'Value',1)
end
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function popupFigure_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupFigure (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in ticklabels.
function ticklabels_Callback(hObject, eventdata, handles)
% hObject    handle to ticklabels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ticklabels
% allows having labels on the axes (checked) or not (not checked)
set(handles.figure1, 'pointer', 'watch')
drawnow;
b = get(handles.popupFigure,'String');
a = get(handles.popupFigure,'Value');
a1 = b(a,1);

figs =  findobj('type','figure');

for i = 1:length(figs)
    if strcmp(a1,get(figs(i),'Name'))
        index = i;
    end
end
hand = findobj(figs(index),'type','axes');

b = get(handles.ticklabels,'Value'); % checked or not checked?
c = get(handles.popupFontSize,'Value');

if b == 0
    set(get(hand,'Xlabel'),'visible','off')
    set(get(hand,'Ylabel'),'visible','off')
    LabelID = 0;
else
    set(get(hand,'Xlabel'),'visible','on')
    set(get(hand,'Ylabel'),'visible','on')
    set(get(hand,'Xlabel'),'Fontsize',c)
    set(get(hand,'Ylabel'),'Fontsize',c)
    LabelID = 1;
end
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject, handles)

% --- Executes on button press in tickbox.
function tickbox_Callback(hObject, eventdata, handles)
% hObject    handle to tickbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of tickbox
% Allows changing if a box is located around the plot or not
set(handles.figure1, 'pointer', 'watch')
drawnow;
b = get(handles.popupFigure,'String');
a = get(handles.popupFigure,'Value');
a1 = b(a,1);

figs =  findobj('type','figure');

for i = 1:length(figs)
    if strcmp(a1,get(figs(i),'Name'))
        index = i;
    end
end
hand = findobj(figs(index),'type','axes');

b = get(handles.tickbox,'Value'); %checked or not?

if b == 0
    set(hand,'Box','off')
else
    set(hand,'Box','on')
end
set(handles.figure1, 'pointer', 'arrow')


% --- Executes on button press in ticktext.
function ticktext_Callback(hObject, eventdata, handles)
% hObject    handle to ticktext (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ticktext
% allows deciding wheather text should be in the plot (from gating) or not
set(handles.figure1, 'pointer', 'watch')
drawnow;
b = get(handles.popupFigure,'String');
a = get(handles.popupFigure,'Value');
a1 = b(a,1);

figs =  findobj('type','figure');

for i = 1:length(figs)
    if strcmp(a1,get(figs(i),'Name'))
        index = i;
    end
end
hand = findobj(figs(index),'type','axes');

b = get(handles.ticktext,'Value');  %checked or not?
texthand = findobj(hand,'type','text');

if b == 0
    set(texthand,'Visible','off')
else
    set(texthand,'Visible','on')
end
set(handles.figure1, 'pointer', 'arrow')

% --- Executes on selection change in popupLiT.
function popupLiT_Callback(hObject, eventdata, handles)
% hObject    handle to popupLiT (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupLiT contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupLiT
% allows changing the line thickness for the current figure
set(handles.figure1, 'pointer', 'watch')
drawnow;
b = get(handles.popupFigure,'String');
a = get(handles.popupFigure,'Value');
a1 = b(a,1);

figs =  findobj('type','figure');

for i = 1:length(figs)
    if strcmp(a1,get(figs(i),'Name'))
        index = i;
    end
end
hand = findobj(figs(index),'type','axes');
hline = findobj(hand, 'type', 'line');
hpatch = findobj(hand,'type','patch');

if ~isempty(hline)
    c = get(handles.popupLiT,'Value'); %how big should the line be
    set(hline,'Linewidth',c)
elseif ~isempty(hpatch)
    c = get(handles.popupLiT,'Value'); %how big should the line be
    set(hpatch,'Linewidth',c)
end
set(handles.figure1, 'pointer', 'arrow')


% --- Executes during object creation, after setting all properties.
function popupLiT_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupLiT (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in popupColor.
function popupColor_Callback(hObject, eventdata, handles)
% hObject    handle to popupColor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupColor contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupColor
% enables to change the color for all type of plots for the current figure
set(handles.figure1, 'pointer', 'watch')
drawnow;
b = get(handles.popupFigure,'String');
a = get(handles.popupFigure,'Value');
a1 = b(a,1);

figs =  findobj('type','figure');

for i = 1:length(figs)
    if strcmp(a1,get(figs(i),'Name'))
        index = i;
    end
end

b = get(handles.popupColor,'String');
b1 = get(handles.popupColor,'Value');
Sele = cell2mat(b(b1,1));

hline = findobj(figs(index), 'type', 'line');
haxes = findobj(figs(index),'type','axes');
scatterg = findobj(figs(index),'type','patch');
ydata = get(scatterg,'YData');
scatterid = size(ydata,2);

type = get(get(get(figs(index),'child'),'children'),'type');
if length(type) == 2
    type = type{2,1};
    type1 = 'abc';
    typo = 'abc';
elseif iscell(type) & length(type) > 2
    type1 = type{end,1};
    typo = type{end-1,1};
else
    type1 = 'abc';
    typo = 'abc';
end

%scatter plot
if strcmp(type,'scatter')
    switch Sele
        case 'Red'
            set(get(get(figs(index),'child'),'children'),'MarkerFaceColor','r')
        case 'Black'
            set(get(get(figs(index),'child'),'children'),'MarkerFaceColor','k')
        case 'Green'
            set(get(get(figs(index),'child'),'children'),'MarkerFaceColor','g')
        case 'Blue'
            set(get(get(figs(index),'child'),'children'),'MarkerFaceColor','b')
        case 'Gray'
            set(get(get(figs(index),'child'),'children'),'MarkerFaceColor',[0.8 0.8 0.8])
        case 'Magenta'
            set(get(get(figs(index),'child'),'children'),'MarkerFaceColor','m')
        case 'Yellow'
            set(get(get(figs(index),'child'),'children'),'MarkerFaceColor','y')
        case 'Cyan'
            set(get(get(figs(index),'child'),'children'),'MarkerFaceColor','c')
    end
end

%scatter plot with gate
if strcmp(type1,'scatter') & strcmp(typo,'line')
    switch Sele
        case 'Red'
            h = findobj(get(figs(index),'child'),'Type','scatter');
            set(h,'MarkerFaceColor','r')
        case 'Black'
            h = findobj(get(figs(index),'child'),'Type','scatter');
            set(h,'MarkerFaceColor','k')
        case 'Green'
            h = findobj(get(figs(index),'child'),'Type','scatter');
            set(h,'MarkerFaceColor','g')
        case 'Blue'
            h = findobj(get(figs(index),'child'),'Type','scatter');
            set(h,'MarkerFaceColor','b')
        case 'Gray'
            h = findobj(get(figs(index),'child'),'Type','scatter');
            set(h,'MarkerFaceColor',[0.8 0.8 0.8])
        case 'Magenta'
            h = findobj(get(figs(index),'child'),'Type','scatter');
            set(h,'MarkerFaceColor','m')
        case 'Yellow'
            h = findobj(get(figs(index),'child'),'Type','scatter');
            set(h,'MarkerFaceColor','y')
        case 'Cyan'
            h = findobj(get(figs(index),'child'),'Type','scatter');
            set(h,'MarkerFaceColor','c')
    end
end

% area plot
if strcmp(type,'area')
    switch Sele
        case 'Red'
            h = findobj(get(figs(index),'child'),'Type','area');
            set(h,'FaceColor','r')
        case 'Black'
            h = findobj(get(figs(index),'child'),'Type','area');
            set(h,'FaceColor','k')
        case 'Green'
            h = findobj(get(figs(index),'child'),'Type','area');
            set(h,'FaceColor','g')
        case 'Blue'
            h = findobj(get(figs(index),'child'),'Type','area');
            set(h,'FaceColor','b')
        case 'Gray'
            h = findobj(get(figs(index),'child'),'Type','area');
            set(h,'FaceColor',[0.8 0.8 0.8])
        case 'Magenta'
            h = findobj(get(figs(index),'child'),'Type','area');
            set(h,'FaceColor','m')
        case 'Yellow'
            h = findobj(get(figs(index),'child'),'Type','area');
            set(h,'FaceColor','y')
        case 'Cyan'
            h = findobj(get(figs(index),'child'),'Type','area');
            set(h,'FaceColor','c')
    end
end

%line plot 
if strcmp(type,'line')
    switch Sele
        case 'Red'
            h = findobj(get(figs(index),'child'),'Type','line');
            set(h,'Color','r')
        case 'Black'
            h = findobj(get(figs(index),'child'),'Type','line');
            set(h,'Color','k')
        case 'Green'
            h = findobj(get(figs(index),'child'),'Type','line');
            set(h,'Color','g')
        case 'Blue'
            h = findobj(get(figs(index),'child'),'Type','line');
            set(h,'Color','b')
        case 'Gray'
            h = findobj(get(figs(index),'child'),'Type','line');
            set(h, 'Color',[0.8 0.8 0.8])
        case 'Magenta'
            h = findobj(get(figs(index),'child'),'Type','line');
            set(h,'Color','m')
        case 'Yellow'
            h = findobj(get(figs(index),'child'),'Type','line');
            set(h,'Color','y')
        case 'Cyan'
            h = findobj(get(figs(index),'child'),'Type','line');
            set(h,'Color','c')
    end
end

%histogram
if strcmp(type,'patch')
    switch Sele
        case 'Red'
            h = findobj(get(figs(index),'child'),'Type','patch');
            set(h,'FaceColor','r','EdgeColor','r')
        case 'Black'
            h = findobj(get(figs(index),'child'),'Type','patch');
            set(h,'FaceColor','k','EdgeColor','k')
        case 'Green'
            h = findobj(get(figs(index),'child'),'Type','patch');
            set(h,'FaceColor','g','EdgeColor','g')
        case 'Blue'
            h = findobj(get(figs(index),'child'),'Type','patch');
            set(h,'FaceColor','b','EdgeColor','b')
        case 'Gray'
            h = findobj(get(figs(index),'child'),'Type','patch');
            set(h,'FaceColor',[0.8 0.8 0.8],'EdgeColor',[0.8 0.8 0.8])
        case 'Magenta'
            h = findobj(get(figs(index),'child'),'Type','patch');
            set(h,'FaceColor','m','EdgeColor','m')
        case 'Yellow'
            h = findobj(get(figs(index),'child'),'Type','patch');
            set(h,'FaceColor','y','EdgeColor','y')
        case 'Cyan'
            h = findobj(get(figs(index),'child'),'Type','patch');
            set(h,'FaceColor','c','EdgeColor','c')
    end
end
set(handles.figure1, 'pointer', 'arrow')

% --- Executes during object creation, after setting all properties.
function popupColor_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupColor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in popupOpt.
function popupOpt_Callback(hObject, eventdata, handles)
% hObject    handle to popupOpt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupOpt contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupOpt
% This popup menu allows different actions for the current or more figures:
% Save one figure, save all figures, save one figure transparent, do an
% overlay of two figures
set(handles.figure1, 'pointer', 'watch')
drawnow;
Selection = get(handles.popupOpt,'Value');

b = get(handles.popupFigure,'String');
a = get(handles.popupFigure,'Value');
a1 = b(a,1);

figs =  findobj('type','figure');

for i = 1:length(figs)
    if strcmp(a1,get(figs(i),'Name'))
        index = i;
    end
end

pathname = handles.savepath;
saveID = handles.saveID;

if Selection == 1 % save one figure as .tif
    hand = findobj(figs(index),'type','axes');
            
    if get(handles.Axesti,'Value') == 1
        set(hand,'XTickMode','auto')
        set(hand,'YTickMode','auto')
    else
    end
    
    set(hand,'ActivePositionProperty','position')
    set(figs(index), 'Units','normalized', 'OuterPosition',[0 0 1 1])
    set(hand,'position',[0.15 0.15 0.7 0.7],'units','normalized')
    po = questdlg('Do you want a colorbar to be plotted with your figure?','Colorbar','Yes','No','Yes');
    switch po
        case 'Yes'
            axes(hand)
          	ch = colorbar('eastoutside');
           	set(figs(index),'Visible','off')
        case 'No'
    end
    
    if saveID == 1
        [FileName,pathname] = uiputfile('*.tif','Save graph',pathname);
        FileName2 = fullfile(pathname, FileName);
        PathName = pathname;
    else
        [FileName,PathName] = uiputfile('*.tif','Save graph');
        FileName2 = fullfile(PathName, FileName);
    end
    
    if ~ischar(PathName)
        
    else
        set(figs(index),'PaperPositionMode','auto')
        print(figs(index),FileName2,'-dtiff','-r300')
        waitfor(msgbox('Export successful!'))
        drawnow;
    end
    

    set(figs(index), 'Units','normalized', 'OuterPosition',[0.3 0.2 0.3 0.5])
    set(hand,'outerposition',[0 0 1 1],'units','normalized')
    set(hand, 'LooseInset', [0,0,0,0]);
    set(hand,'XTickMode','manual')
    
    switch po
        case 'Yes'
            delete(ch);
        case 'No'
    end
    
elseif Selection == 2; % save one figure transparent as .png
        
    hand = findobj(figs(index),'type','axes');
    if get(handles.Axesti,'Value') == 1
        set(hand,'XTickMode','auto')
        set(hand,'YTickMode','auto')
    else
    end
    
    set(hand,'ActivePositionProperty','position')
    set(figs(index), 'Units','normalized', 'OuterPosition',[0 0 1 1])
    set(hand,'position',[0.15 0.15 0.7 0.7],'units','normalized')

    if saveID == 1
        [FileName,pathname] = uiputfile('*.png','Save graph',pathname);
        FileName2 = fullfile(pathname, FileName);
        PathName = pathname;
    else
        [FileName,PathName] = uiputfile('*.png','Save graph');
        FileName2 = fullfile(PathName, FileName);
    end
    if ~ischar(PathName)
        
    else
        set(figs(index),'PaperPositionMode','auto')
        print(figs(index),FileName2,'-dtiff','-r300') 
        Img = imread(FileName2);
        imwrite(Img,[FileName2(1:end-4) '_transparent.png'],'png','Transparency',[1 1 1],'XResolution',300,'YResolution',300);
        set(figs(index), 'Units','normalized', 'OuterPosition',[0.3 0.2 0.3 0.5])
        set(hand,'outerposition',[0 0 1 1],'units','normalized')
        set(hand, 'LooseInset', [0,0,0,0]);
        set(hand,'XTickMode','manual')
        waitfor(msgbox('Export successful!'))
        drawnow;
    end
    
    
elseif Selection == 3; % save all figures as "XYZ" with the attachment "_Figure1/2/3/4/5..."
    figs =  findobj('type','figure');
    
    for i = 1:length(figs)
        if strcmp('XIT',get(figs(i),'Name'))
            index = i;
        end
    end

    figs(index) = [];
    hand = findobj(figs,'type','axes');

    if saveID == 1
        [FileName,pathname] = uiputfile('*.tif','Save graph',pathname);
        FileName2 = fullfile(pathname, FileName);
        PathName = pathname;
    else
        [FileName,PathName] = uiputfile('*.tif','Save graph');
        FileName2 = fullfile(PathName, FileName);
    end
       
    if ~ischar(PathName)
        
    else  
        for i = 1:length(figs)
            if get(handles.Axesti,'Value') == 1
                set(hand,'XTickMode','auto')
                set(hand,'YTickMode','auto')
            else
            end
            hand = findobj(figs(i),'type','axes');
            set(hand,'ActivePositionProperty','position')
            set(figs(i), 'Units','normalized', 'OuterPosition',[0 0 1 1])
            set(hand,'position',[0.15 0.15 0.7 0.7],'units','normalized')
            Name = get(figs(i),'Name');
            FileName3 = [FileName2(1:end-4) '_' Name '.tif'];
            set(figs(i),'PaperPositionMode','auto')
            print(figs(i),FileName3,'-dtiff','-r300')
        end
        
    end
   
end
set(handles.figure1, 'pointer', 'arrow')

% --- Executes during object creation, after setting all properties.
function popupOpt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupOpt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in AddBtn.
function AddBtn_Callback(hObject, eventdata, handles)
% hObject    handle to AddBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Adds the current view from the main axes/coordinate system to the figure
% popupmenu to be edited and saved
set(handles.figure1, 'pointer', 'watch')
drawnow;
fig = handles.axes1;
Names = get(handles.popupFigure,'string');
% checks if there is already an entry in the menu
if strcmp(Names,'Figures') | strcmp(Names,' ')
    figgi = figure('name',['Figure ' num2str(1)],'numbertitle','off'); set(figgi, 'Visible', 'off');
    name = {get(figgi,'Name')};
    set(handles.popupFigure,'String',name);
    Val = 0;
else
    Str = get(handles.popupFigure,'String');
    Val = str2num(Str{end,1}(end-1:end));
    figgi = figure('name',['Figure ' num2str(Val+1)],'numbertitle','off'); set(figgi, 'Visible', 'off');
    name = get(figgi,'Name');
    namethere = {get(handles.popupFigure,'String')};
    namethere{1,1}{end+1,1} = name;
    set(handles.popupFigure,'String',namethere{1,1});
end

copyobj(fig,figgi); %copies the object
d = daspect;
daspect(d);

hand = findobj(figgi,'type','axes');
set(handles.popupFigure,'Value',Val+1);

handles.tx = get(hand,'Xtick');
handles.ty = get(hand,'Ytick');
tx = get(hand,'Xtick');
ty = get(hand,'Ytick');

kCol = handles.kmCol;
s = get(handles.popupCol,'Value');

if strcmp(get(get(handles.axes1,'child'),'type'),'contour')
    cID = 1;
else
    cID = 0;
end

% from Matlab2015: set the default colormap to jet when needed
if s == 2 & kCol == 0 & cID == 0
    colormap(figgi,jet);
elseif s > 2 & kCol == 0
    colormap(figgi,jet);
elseif s == 2 & kCol == 0 & cID == 1
    colormap(figgi,gray(1));
end

histo = handles.histo;
line = handles.line;
fillarea =handles.fillarea;

if histo == 0 & line == 0 & fillarea == 0
    Xstring = cell2mat(get(handles.textXax,'String'));
    Ystring = cell2mat(get(handles.textYax,'String'));
else
    Xstring = cell2mat(get(handles.textXax,'String'));
    Ystring = 'Count';
end

idcsX = strfind(Xstring,'_');
idcsY = strfind(Ystring,'_');
Xstring(idcsX) = ' '; 
Ystring(idcsY) = ' '; 
xlabel(Xstring)
ylabel(Ystring)

set(figgi, 'Units','normalized', 'OuterPosition',[0.3 0.2 0.3 0.5])
set(hand,'outerposition',[0 0 1 1],'units','normalized')
set(hand, 'LooseInset', [0,0,0,0]);
axis square

% gets the tick labels to store for adding them later if needed
var_prep = ['tx_' get(figgi,'Name')];
var1 = matlab.lang.makeValidName(var_prep);
eval([var1, '= tx;'])

var_prep1 = ['ty_' get(figgi,'Name')];
var2 = matlab.lang.makeValidName(var_prep1);
eval([var2, '= ty;'])
eval(['handles.', var1, '= tx;'])
eval(['handles.', var2, '= ty;'])
    
set(handles.popupColor,'Value',1)
set(handles.popupLiT,'Value',1)
set(handles.popupFontSize,'Value',10)

hand = findobj(figgi,'type','axes');
texthand = findobj(hand,'type','text');
hline = findobj(figgi, 'type', 'line');

% reads all properties to be edited later and returns them in the
% appropriate buttons, check boxes etc.
a0 = get(hand,'xtick');
if ~isempty(a0)
    set(handles.Axesti,'Value',1);
else
    set(handles.Axesti,'Value',0);
end

set(handles.ticklabels,'Value',1);
set(get(hand,'Xlabel'),'visible','on')
set(get(hand,'Ylabel'),'visible','on')

b = get(hand,'Box');
if strcmp(b,'on') == 1
    set(handles.tickbox,'Value',1)
else
    set(handles.tickbox,'Value',0)
end

c = get(texthand,'Visible');
if isempty(c)
    set(handles.ticktext,'Value',0);
elseif strcmp(c,'on') == 1
    set(handles.ticktext,'Value',1);
elseif strcmp(c,'off') == 1
    set(handles.ticktext,'Value',0);
end

d = get(hand,'Fontsize');
set(handles.popupFontSize,'Value',d)

e = get(hline,'LineWidth');
if isempty(e) == 0
    if length(e) > 1
        set(handles.popupLiT,'Value',e{1,1})
        if e{1,1} == 0.5
            set(handles.popupLiT,'Value',1)
        end
    elseif e == 0.5
        set(handles.popupLiT,'Value',1)
    else
        set(handles.popupLiT,'Value',e+1)
    end
else
    set(handles.popupLiT,'Value',1)
end

f = get(hand,'LineWidth');
if isempty(f) == 0
    if length(f) > 1
        set(handles.boxthipopup,'Value',f(1,1))
    elseif f == 0.5
        set(handles.boxthipopup,'Value',1)
    else
        set(handles.boxthipopup,'Value',f+1)
    end
else
    set(handles.boxthipopup,'Value',1)
end

set(handles.figure1, 'pointer', 'arrow')
guidata(hObject, handles);

% --- Executes on button press in prevBtn.
function prevBtn_Callback(hObject, eventdata, handles)
% hObject    handle to prevBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%Names = handles.sortedFigs;
% allows for a preview of the figure you are handling from the popup Figure
% menu, upon clicking it the button will display Close (closign the preview upon clicking)
% and clicking it again displays Preview again etc.
b = get(handles.popupFigure,'String');
a = get(handles.popupFigure,'Value');
a1 = b(a,1);

figs =  findobj('type','figure');

for i = 1:length(figs)
    if strcmp(a1,get(figs(i),'Name'))

        if strcmp(get(handles.prevBtn,'String'),'Close/Preview') == 1
           set(figs(i), 'Visible', 'off');
           set(handles.prevBtn,'String','Preview/Close')
           guidata(hObject, handles);
        else
            set(figs(i), 'Visible', 'on');
            if get(handles.Axesti,'Value') == 1
                set(gca,'XTickMode','auto')
            end
            
            set(figs(i), 'Units','normalized', 'OuterPosition',[0.3 0.2 0.3 0.5])
            hand = findobj(figs(i),'type','axes');
            set(hand,'outerposition',[0 0 1 1],'units','normalized')
            set(hand, 'LooseInset', [0,0,0,0]);
            set(handles.prevBtn,'String','Close/Preview')
            guidata(hObject, handles);
        end
    end
end

% --- Executes on button press in clearBtn.
function clearBtn_Callback(hObject, eventdata, handles)
% hObject    handle to clearBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Clears the Figure popup menu
set(handles.figure1, 'pointer', 'watch')
drawnow;
figs =  findobj('type','figure');
for i = 1:length(figs)
    if strcmp('XIT',get(figs(i),'Name'))
        index = i;
    end
end

figs(index) = [];

close(figs)

set(handles.popupFigure,'String','Figures')
set(handles.popupFigure,'Value',1)
set(handles.figure1, 'pointer', 'arrow')

% --- Executes on button press in randdotsBtn.
function randdotsBtn_Callback(hObject, eventdata, handles)
% hObject    handle to randdotsBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% produces randomly distributed dots (Radius 6um) within the volume the
% segemnted objects span
set(handles.figure1, 'pointer', 'watch')
drawnow;
tic;
tStart = tic;

AnalysisMatrix = handles.stats;
r = handles.gatinghist;
BiExID = handles.BiExID;
ind_a = handles.inda;
ind_b = handles.indb;

if BiExID == 1
    set(handles.asinhX,'Enable','on');
    set(handles.asinhY,'Enable','on');
    set(handles.BiExBtn,'Enable','on');
    set(handles.linX,'Enable','off');
    set(handles.linY,'Enable','off');
    set(handles.LinBtn,'Enable','off');
    if get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 0
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_a)) - exp(-1.*(AnalysisMatrix(:,ind_a))));
        AnalysisMatrix(:,ind_a) = lin_StatsX;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',0);
    elseif get(handles.linX,'Value') == 0 & get(handles.linY,'Value') == 1
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_b)) - exp(-1.*(AnalysisMatrix(:,ind_b))));
        AnalysisMatrix(:,ind_b) = lin_StatsY;
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',0);
        set(handles.asinhY,'Value',1);
    elseif get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 1
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_a)) - exp(-1.*(AnalysisMatrix(:,ind_a))));
        AnalysisMatrix(:,ind_a) = lin_StatsX;
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_b)) - exp(-1.*(AnalysisMatrix(:,ind_b))));
        AnalysisMatrix(:,ind_b) = lin_StatsY;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',1);
    end
end

Position_Matrix = AnalysisMatrix(:,(end-3):end);

P = [Position_Matrix(:,1) Position_Matrix(:,2) Position_Matrix(:,3)];

a1 = str2num(get(handles.randnum,'String'));

rng('shuffle'); %random 3d coordinates
randis = [(max(Position_Matrix(:,1))-min(Position_Matrix(:,1))).*rand(size(P,1),1)+min(Position_Matrix(:,1))...
    (max(Position_Matrix(:,2))-min(Position_Matrix(:,2))).*rand(size(P,1),1)+min(Position_Matrix(:,2))...
    (max(Position_Matrix(:,3))-min(Position_Matrix(:,3))).*rand(size(P,1),1)+min(Position_Matrix(:,3))];

tElapsed = toc(tStart); 
uh = msgbox(['Elapsed time is: '  num2str(tElapsed) '. Current status: Preparing random dots...']);
child = get(uh,'Children');
delete(child(1))
set(uh, 'closerequestfcn',[]) 

%DT = delaunayTriangulation(P);  %creates a volume arond the cells
%t = tsearchn(randis,DT.ConnectivityList,P); %checks for cells within the volume
%t1 = ~isnan(t);
randiis2 = randis;%(t1,1:3);

x = P(:,1);
y = P(:,2);
z = P(:,3);
ka = boundary([x y],1);
ka2 = boundary([x z],1);
ka3 = boundary([y z],0.25);

h = waitbar(0,'Preparing random dots...');
for i = 1:size(randiis2,1) %checks if cells are out of bounds in the distinct projection planes and deletes them
    [inr,onr]   = inpolygon(randiis2(i,1),randiis2(i,2),x(ka),y(ka));
    [in2r,on2r] = inpolygon(randiis2(i,1),randiis2(i,3),x(ka2),z(ka2));
    [in3r,on3r] = inpolygon(randiis2(i,2),randiis2(i,3),y(ka3),z(ka3));
    
    if (inr == 0 | in2r == 0 | in3r == 0) & (onr == 0 | on2r == 0 | on3r == 0)      
        randiis2(i,1) = NaN;
        randiis2(i,2) = NaN;
        randiis2(i,3) = NaN;
    end
    waitbar(i/size(randiis2,1))
end
close(h)

set(uh, 'closerequestfcn','closereq') 
close(uh)
tElapsed = toc(tStart);
uh = msgbox(['Elapsed time is: '  num2str(tElapsed) '. Current status: Running...']);
child = get(uh,'Children');
delete(child(1))
set(uh, 'closerequestfcn',[]) 

Id3 = ~isnan(randiis2);
ids3 = Id3(:,1);
true_rands3 = randiis2(ids3,:); 

randiis3 = true_rands3;

while size(randiis3,1) < a1 %if the random dots are not enough to satisfy the users input run it again as long as we have it
    rng('shuffle'); 
    Arandis = [(max(Position_Matrix(:,1))-min(Position_Matrix(:,1))).*rand(size(P,1),1)+min(Position_Matrix(:,1))...
    (max(Position_Matrix(:,2))-min(Position_Matrix(:,2))).*rand(size(P,1),1)+min(Position_Matrix(:,2))...
    (max(Position_Matrix(:,3))-min(Position_Matrix(:,3))).*rand(size(P,1),1)+min(Position_Matrix(:,3))];

    ADT = delaunayTriangulation(P);
    St = tsearchn(Arandis,ADT.ConnectivityList,P);
    At1 = ~isnan(St);
    Arandiis2 = Arandis(At1,1:3);

    Aka = boundary([x y],1);
    Aka2 = boundary([x z],1);
    Aka3 = boundary([y z],0.25);

    h = waitbar(0,'Checking random dots...');
    for i = 1:size(Arandiis2,1)
        [inr,onr]   = inpolygon(Arandiis2(i,1),Arandiis2(i,2),x(Aka),y(Aka));
        [in2r,on2r] = inpolygon(Arandiis2(i,1),Arandiis2(i,3),x(Aka2),z(Aka2));
        [in3r,on3r] = inpolygon(Arandiis2(i,2),Arandiis2(i,3),y(Aka3),z(Aka3));
    
        if (inr == 0 | in2r == 0 | in3r == 0) & (onr == 0 | on2r == 0 | on3r == 0)      
            Arandiis2(i,1) = NaN;
            Arandiis2(i,2) = NaN;
            Arandiis2(i,3) = NaN;
        end
        waitbar(i/size(Arandiis2,1))
    end
    close(h)

    AId3 = ~isnan(Arandiis2);
    Aids3 = AId3(:,1);
    Atrue_rands3 = Arandiis2(Aids3,:); 
    Arandiis3 = Atrue_rands3;
    randiis3 = [randiis3; Arandiis3];
end
set(uh, 'closerequestfcn','closereq') 
close(uh)
tElapsed = toc(tStart);
uh = msgbox(['Elapsed time is: '  num2str(tElapsed) '. Current status: Finishing up...']);
child = get(uh,'Children');
delete(child(1))
set(uh, 'closerequestfcn','closereq')

randdots = randiis3(1:a1,:);

if size(unique(randdots,'rows'),1) == a1
    radius = 6;
    pathname = handles.savepath;
    saveID = handles.saveID;

    if saveID == 1
        [FileName,pathname] = uiputfile('*.txt','Save random dots',pathname);
        FileName2 = fullfile(pathname, FileName);
        PathName = pathname;
    else
        [FileName,PathName] = uiputfile('*.txt','Save random dots');
        FileName2 = fullfile(PathName, FileName);
    end
    
    if ~ischar(PathName)
        
    else
        fileID = fopen(FileName2,'w'); % text format used for CreateSpotsFromFile Xtension in Imaris
        formatspec  = 'SpotRadius, %2d\n';
        fprintf(fileID,formatspec,radius);
        dlmwrite(FileName2,randdots,'-append','newline', 'pc', 'roffset',1)
        fclose(fileID);
        clearvars FileName2 FileName PathName

        waitfor(msgbox('Export successful!'));
        drawnow;
    end
else
    waitfor(msgbox('An error in XiT has occured during calculation. Please try again, it should work the second time.'))
    drawnow;
end
close(uh)
set(handles.figure1, 'pointer', 'arrow')


function randnum_Callback(hObject, eventdata, handles)
% hObject    handle to randnum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of randnum as text
%        str2double(get(hObject,'String')) returns contents of randnum as a double

% --- Executes during object creation, after setting all properties.
function randnum_CreateFcn(hObject, eventdata, handles)
% hObject    handle to randnum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in boxthipopup.
function boxthipopup_Callback(hObject, eventdata, handles)
% hObject    handle to boxthipopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns boxthipopup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from boxthipopup
% allows you to change thickness of axes line in figures from the figure
% popup menu in the plot editor panel
set(handles.figure1, 'pointer', 'watch')
drawnow;
b = get(handles.popupFigure,'String');
a = get(handles.popupFigure,'Value');
a1 = b(a,1);

figs =  findobj('type','figure');

for i = 1:length(figs)
    if strcmp(a1,get(figs(i),'Name'))
        index = i;
    end
end
hand = findobj(figs(index),'type','axes');
c = get(handles.boxthipopup,'Value');
set(hand,'Linewidth',c)
set(handles.figure1, 'pointer', 'arrow')

% --- Executes during object creation, after setting all properties.
function boxthipopup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to boxthipopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in Axesti.
function Axesti_Callback(hObject, eventdata, handles)
% hObject    handle to Axesti (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Axesti
% allows you to decide whether or not one wants to have tick marks in figures from the figure
% popup menu in the plot editor panel
set(handles.figure1, 'pointer', 'watch')
drawnow;
b = get(handles.popupFigure,'String');
a = get(handles.popupFigure,'Value');
a1 = b(a,1);

figs =  findobj('type','figure');

for i = 1:length(figs)
    if strcmp(a1,get(figs(i),'Name'))
        index = i;
    end
end
hand = findobj(figs(index),'type','axes');

b = get(handles.Axesti,'Value');

var_prep11 = ['tx_' get(figs(index),'Name')];
var_prep22 = ['ty_' get(figs(index),'Name')];
var11 = matlab.lang.makeValidName(var_prep11);
var22 = matlab.lang.makeValidName(var_prep22);

if b == 0
    set(hand,'xtick',[])
    set(hand,'ytick',[])
else
    eval(['tx = ', 'handles.', var11 ';'])
    eval(['ty = ', 'handles.', var22 ';'])
    set(hand,'Xtick',tx)
    set(hand,'Ytick',ty)
end
set(handles.figure1, 'pointer', 'arrow')

% --- Executes on button press in appltoallbtn.
function appltoallbtn_Callback(hObject, eventdata, handles)
% hObject    handle to appltoallbtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% allows application of Axes thickness, axes visisbility, box on or off,
% axes labels on/off and fontsize to all figures within the figure popup
% menu
set(handles.figure1, 'pointer', 'watch')
drawnow;
figs =  findobj('type','figure');
tx = handles.tx;
ty = handles.ty;

for i = 1:length(figs)
    if strcmp('XIT',get(figs(i),'Name'))
        index = i;
    end
end

figs(index) = [];
hand = findobj(figs,'type','axes');

%Box thickness
a1 = get(handles.boxthipopup,'Value');
set(hand,'Linewidth',a1)

%axes visible or not
a2 = get(handles.Axesti,'Value');

for i = 1:length(figs)
    handi = findobj(figs(i),'type','axes');
    var_prep11 = ['tx_' get(figs(i),'Name')];
    var_prep22 = ['ty_' get(figs(i),'Name')];
    var11 = matlab.lang.makeValidName(var_prep11);
    var22 = matlab.lang.makeValidName(var_prep22);

    if a2 == 0
        set(handi,'Xtick',[])
        set(handi,'Ytick',[])
        set(handles.Axesti,'Value',0);
    else
        eval(['tx = ', 'handles.', var11 ';'])
        eval(['ty = ', 'handles.', var22 ';'])
        set(handi,'Xtick',tx)
        set(handi,'Ytick',ty)
        set(handles.Axesti,'Value',1);
    end
end

% box visible or not
a23 = get(handles.tickbox,'Value');
if a23 == 0
    set(handi,'Box','off')
else
    set(handi,'Box','on')
    set(handles.tickbox,'Value',1);
end

% axes lables visible or not
a3 = get(handles.ticklabels,'Value');

if a3 == 0
    for i = 1:length(figs)
        set(get(hand(i),'Xlabel'),'visible','off')
        set(get(hand(i),'Ylabel'),'visible','off')
        LabelID = 0;
    end
else
    for i = 1:length(figs)
        set(get(hand(i),'Xlabel'),'visible','on')
        set(get(hand(i),'Ylabel'),'visible','on')
        LabelID = 1;
    end
end

% Fontsize
a4 = get(handles.popupFontSize,'Value');

set(hand,'Fontsize',a4)
for i = 1:length(figs)
    set(get(hand(i),'Xlabel'),'Fontsize',a4)
    set(get(hand(i),'Ylabel'),'Fontsize',a4)
end

% axes visible or not
if a2 == 1
    set(hand,'XTickMode','auto')
    set(hand,'YTickMode','auto')
end

% text in figure
for i = 1:length(figs)
    hand2 = findobj(figs(i),'type','axes');
    texthand = findobj(hand2,'type','text');
    ca = get(texthand,'Visible');
    
    b = get(handles.ticktext,'Value');  %checked or not?
    
    if isempty(ca)
        if b == 0
            set(texthand,'Visible','off')
        else
            set(texthand,'Visible','on')
        end
    elseif strcmp(ca,'on') == 1
        if b == 0
            set(texthand,'Visible','off')
        else
            set(texthand,'Visible','on')
        end
    elseif strcmp(ca,'off') == 1
        if b == 0
            set(texthand,'Visible','off')
        else
            set(texthand,'Visible','on')
        end
    end
end

% line thickness
for i = 1:length(figs)
    hand = findobj(figs(i),'type','axes');
    hline = findobj(hand, 'type', 'line');

    if ~isempty(hline)
        cb = get(handles.popupLiT,'Value'); %how big should the line be
        set(hline,'Linewidth',cb)
    end
end
set(handles.figure1, 'pointer', 'arrow')

% --- Executes on button press in subpopBtn.
function subpopBtn_Callback(hObject, eventdata, handles)
% hObject    handle to subpopBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% From known thresholds for parameters an automated subpopulation analysis
% with optional heatmap plotting is carriedout upon pressign this button
% (see also documentation)
set(handles.figure1, 'pointer', 'watch')
drawnow;

datapp = handles.gatinghist{1,1}; %parent population data
pathname = handles.savepath;
saveID = handles.saveID;
    
if saveID == 1
    waitfor(msgbox('Specify directory to store results in!'));
    dname = uigetdir(pathname); 
else
    waitfor(msgbox('Specify directory to store results in!'));
    dname = uigetdir;
end

warning('off','all') %creates folder with date and time
currentFolder = dname;
c = clock;
cd = fix(c);
cde = num2str(cd);
theName = [cde ' Subpop_analysis'];
mkdir(currentFolder,theName)
clearvars c cd cde

sizeWindow = [800 600]; %selecting channels for subpop analysis
[Selection1,~] = listdlg('PromptString','Select channels for subpopulation analysis:',...
                'SelectionMode','multiple',...
                'ListString',handles.names,...
                'ListSize',sizeWindow);
            
suggestions = handles.names(Selection1);
            
parameters = inputdlg({'Enter channel names:','Enter thresholds:','falsepositive'},'Input',1,{'a,b,c', '5,10,5', '0'});
tmp = regexp(parameters{1,1},'([^ ,:]*)','tokens');
tmp2 = regexp(parameters{2,1},'([^ ,:]*)','tokens');

allnames = cat(2,tmp{:});
MarkerNames = allnames';
for i = 1:length(tmp2)
    tmp2{1,i} = str2double(tmp2{1,i});
end
allthresholds = cat(2,tmp2{:})';
falsepositive = str2double(parameters{3,1});

StatNames = handles.NamesforExp';
Names_for_an = StatNames(Selection1)';
subpopdata_ID = [datapp(:,Selection1) datapp(:,end)];
subpopnames_ID = [Names_for_an StatNames(end)];
         
PopAnalysis_Matrix = subpopdata_ID;         %contains data for subpop analysis+ ID
Position_Matrix = datapp(:,(end-3):(end));  %contains data of xyz coordinates + ID
Stats_Matrix = datapp;                     	%contains all stats except for coord. + xyz coordinates + ID


% Artifact Removal
% Prepare data for artifact removal & data cleanup

% Question dialog for the Artifact Removal option
REM = questdlg('Do you want to remove position artifacts from your dataset?','DataEditor','Yes','No & Start','Yes');
switch REM
    case 'Yes'
        AnalysisMatrix = [Position_Matrix PopAnalysis_Matrix Stats_Matrix];
        data1{1,1} = AnalysisMatrix;
        data2{1,1} = Position_Matrix;
        jj = 1;
            
        
        ArtRemovalV2
         
        
        Positions = data3{1,1}.data{1,1}(:,1:4); %XYZ coordinates plus ID
        FlowJo_matrix = data3{1,1}.data{1,1}(:,5:(4+size(PopAnalysis_Matrix,2))); %Channels for Subpop analysis plus ID
        Stats = data3{1,1}.data{1,1}(:,(5+(size(PopAnalysis_Matrix,2))):end); %All stats plus XYZ coordinates plus ID
    case 'No & Start'
        Positions = Position_Matrix;
        FlowJo_matrix = PopAnalysis_Matrix;
        Stats = Stats_Matrix;
end

Stat = num2cell(Stats);
Statis = [StatNames'; Stat];
Name = 'Stats_parentpop.xlsx';
FileName = fullfile(currentFolder, theName, Name);
xlswrite(FileName,Statis)
clearvars Name FileName

% Subpopulation Analysis
        
% execution of subpopulation analysis and creation of specific
% statistic files (needs MarkerNames, FlowJo_matrix, allthresholds, falsepositive)
kkt = 1;
woi = 'Subpopulation Analysis.csv';

h = waitbar(33/100,'Subpopulation analysis ongoing...');
XIT_SubPop_DataExtr
close(h)
% Heatmaps
HMsqst = questdlg('Do you want to plot heatmaps of your data?','Heatmaps','Yes','No','Yes');

switch HMsqst
    case 'Yes'
        parameters1 = inputdlg({'Enter volume for density analysis in um3'},'Input',1,{'125000'});
        if isempty(parameters1)
           
        end
        Vs = str2num(parameters1{:});

        edge = nthroot(Vs,3);
        data_for_HMs{1,1}{1,1} = Positions;
        IDsforExport_1{1,1} = IDsforExport;
        markercell{1,1} = marker;
        PositionToScale = handles.ParentXYZs;

        % Allows checking and changing the orientation of the sample
        parameters2 = questdlg('Do you want to check the orientation of your sample?','Sample orientation','Yes','No','No');
        switch parameters2
            case 'Yes'
                first = figure('position', [50, 100, 1800, 1000]);
                scatter(Positions(:,2),Positions(:,1),3,'Markerfacecolor',[0 0 0],...
                    'MarkerEdgeColor','none')
                daspect([1 1 1])
                title('XY projection')
                parameters3 = questdlg('Do you want to flip/mirror your sample?','Sample orientation','Yes','No','Yes');
                switch parameters3
                    case 'Yes'
                        parameters4 = questdlg('I want to...','Sample orientation','flip (horizontal)','mirror (vertical)','flip and mirror','Flip (horizontal)');
                       	switch parameters4
                            case 'flip (horizontal)'
                                flipid = 1;
                                mirrorid = 0;
                            case 'mirror (vertical)'
                                flipid = 0;
                                mirrorid = 1;
                            case 'flip and mirror'
                                flipid = 1;
                                mirrorid = 1;
                        end
                        if isempty(parameters4)
                            flipid = 0;
                            mirrorid = 0;
                        end
                    case 'No'
                        flipid = 0;
                        mirrorid = 0;
                end
                if isempty(parameters3)
                    flipid = 0;
                    mirrorid = 0;
                end
                close(first)
        case 'No'
                parameters3 = questdlg('Do you want to flip/mirror your sample?','Sample orientation','Yes','No','Yes');
                switch parameters3
                    case 'Yes'
                        parameters4 = questdlg('I want to...','Sample orientation','flip (horizontal)','mirror (vertical)','flip and mirror','Flip (horizontal)');
                       	switch parameters4
                            case 'flip (horizontal)'
                                flipid = 1;
                                mirrorid = 0;
                            case 'mirror (vertical)'
                                flipid = 0;
                                mirrorid = 1;
                            case 'flip and mirror'
                                flipid = 1;
                                mirrorid = 1;
                        end
                        if isempty(parameters4)
                            flipid = 0;
                            mirrorid = 0;
                        end
                    case 'No'
                        flipid = 0;
                        mirrorid = 0;
            	end
                if isempty(parameters3)
                    flipid = 0;
                    mirrorid = 0;
                end
        end
        
        
        XIT_HMs
        
    case 'No'
end

waitfor(msgbox('Done'))
drawnow;
set(handles.figure1, 'pointer', 'arrow')


% --- Executes on key press with focus on densitybin and none of its controls.
function densitybin_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to densitybin (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
% upon pressing return in the textbox where one enters the resolution for
% the density plot the plot will update, shift allows to see a contour plot
set(handles.figure1, 'pointer', 'watch')
drawnow;
current_key = eventdata.Key;
stats = handles.stats;
ind_a = handles.inda;
ind_b = handles.indb;
sizeSc = handles.sizeSc;
kCol = handles.kmCol;
s = get(handles.popupCol,'Value');
drawnow
xmin = str2double(get(handles.Xmin,'String'));
xmax = str2double(get(handles.Xmax,'String'));
ymin = str2double(get(handles.Ymin,'String'));
ymax = str2double(get(handles.Ymax,'String'));

if strcmp(current_key,'return')
    if s == 2 & kCol == 0;
        abin = str2double(get(handles.densitybin,'String'));
        edgesX = linspace(min(stats(:,ind_a)), max(stats(:,ind_a)), abin);
        edgesY = linspace(min(stats(:,ind_b)), max(stats(:,ind_b)), abin);
        [One,~] = size(stats(:,ind_a));
        [~,CountsX] = histc(stats(:,ind_a),edgesX);
        [~,CountsY] = histc(stats(:,ind_b),edgesY);       
        Counts = [CountsX,CountsY];
        Darray = accumarray(Counts,1)./One;
        DarrayNorm = Darray./max(Darray(:)); 
        DarrayNorm = imgaussfilt(DarrayNorm,2);
        DarrayNorm = imgaussfilt(DarrayNorm,2);
        ind = sub2ind(size(DarrayNorm),CountsX,CountsY);
        col2 = DarrayNorm(ind);
        U = sortrows([stats(:,ind_a), stats(:,ind_b), col2],3);
        col1 = U(:,3);
        normcol = col1./max(col1);
        colormap(jet(4096))
        axes(handles.axes1)
        s = scatter(U(:,1),U(:,2),sizeSc,normcol,'filled');
        reziseaxes(stats,ind_a,xmin,xmax,ymin,ymax,handles.axes1)
    end
elseif strcmp(current_key,'shift')
    if s == 2 & kCol == 0;
        axes(handles.axes1)
        dc = handles.axes1;
        axXl = get(gca,'XTickLabel');
        axYl = get(gca,'YTickLabel');
        abin = str2double(get(handles.densitybin,'String'));
        edgesX = linspace(min(stats(:,ind_a)), max(stats(:,ind_a)), abin);
        edgesY = linspace(min(stats(:,ind_b)), max(stats(:,ind_b)), abin);
        [One,~] = size(stats(:,ind_a));    
        [~,CountsX] = histc(stats(:,ind_a),edgesX);
        [~,CountsY] = histc(stats(:,ind_b),edgesY);
        Counts = [CountsX,CountsY];
        Darray = accumarray(Counts,1)./One;
        DarrayNorm = Darray./max(Darray(:));
        DarrayNorm = imgaussfilt(DarrayNorm,2);
        contour(DarrayNorm',10)
        colormap(gray(1))
    end
end
set(handles.figure1, 'pointer', 'arrow')

% --- Executes on button press in exphistbtn.
function exphistbtn_Callback(hObject, eventdata, handles)
% hObject    handle to exphistbtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% the data from the histogram is exported as an excel file
set(handles.figure1, 'pointer', 'watch')
drawnow;
bins = str2double(get(handles.hist_bins,'String'));
StatsMatrix = handles.stats;
ind_a = handles.inda;
range = get(gca,'Xlim');
diffrange = (range(1,2)-range(1,1));
edges = [range(1,1):(diffrange/bins):range(1,2)];

h = histogram(StatsMatrix(:,ind_a),edges);

a = get(h,'Values');                %values
b = get(h,'BinEdges');              %edges
c = a./size(StatsMatrix,1)*100; %
bums = [(b(1,2:end))' a' c']; % as a representation for each bin the uper value is printed (e.g. from 0-5,5-10,... one gets 5,10,15...)

pathname = handles.savepath;
saveID = handles.saveID;

if saveID == 1
    [FileName,pathname] = uiputfile('*.xlsx','Save histogram stats as .xlsx',pathname);
    FileName2 = fullfile(pathname, FileName);
    PathName = pathname;
else
    [FileName,PathName] = uiputfile('*.xlsx','Save histogram stats as .xlsx');
    FileName2 = fullfile(PathName, FileName);
end
if ~ischar(PathName)
	
else
    xlswrite(FileName2,bums)
    waitfor(msgbox('Export successful!'))
	drawnow;
end
set(handles.figure1, 'pointer', 'arrow')

% --- Executes on button press in normzbtn.
function normzbtn_Callback(hObject, eventdata, handles)
% hObject    handle to normzbtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Pressing this button the z-Position statistic is normalized to the lowest
% z value (closest to the objective). This is done in 50 um bins along the
% y axis.
set(handles.figure1, 'pointer', 'watch')
drawnow;
AnalysisMatrix = handles.stats;
BiExID = handles.BiExID;
ind_a = handles.inda;
ind_b = handles.indb;

if BiExID == 1 %if data is asinh transformed, transform it back for this purpose
    set(handles.asinhX,'Enable','on');
    set(handles.asinhY,'Enable','on');
    set(handles.BiExBtn,'Enable','on');
    set(handles.linX,'Enable','off');
    set(handles.linY,'Enable','off');
    set(handles.LinBtn,'Enable','off');
    if get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 0
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_a)) - exp(-1.*(AnalysisMatrix(:,ind_a))));
        AnalysisMatrix(:,ind_a) = lin_StatsX;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',0);
    elseif get(handles.linX,'Value') == 0 & get(handles.linY,'Value') == 1
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_b)) - exp(-1.*(AnalysisMatrix(:,ind_b))));
        AnalysisMatrix(:,ind_b) = lin_StatsY;
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',0);
        set(handles.asinhY,'Value',1);
    elseif get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 1
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_a)) - exp(-1.*(AnalysisMatrix(:,ind_a))));
        AnalysisMatrix(:,ind_a) = lin_StatsX;
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_b)) - exp(-1.*(AnalysisMatrix(:,ind_b))));
        AnalysisMatrix(:,ind_b) = lin_StatsY;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',1);
    end
end
handles.BiExID = 0;
pop_Pos = AnalysisMatrix(:,(end-3):end);

Max = max(pop_Pos(:,2));
Min = min(pop_Pos(:,2));

minz = min(pop_Pos(:,3));
diff = (Max-Min);
edge = 50; %%%%%%%%%%%%%%%%%%%%%%%%%%%% bin size for normalization %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% can be changed to smaller values if more datapoints are present and to
% higher values if less datapoints are present (50 seems a good number ofr
% around 30000 datapoints distributed in one mouse femur.
X1 = diff/edge;
X2 = round(X1);
        
difftogo = round(diff*0.01);
edgesY = linspace(min(pop_Pos(:,2)), max(pop_Pos(:,2)), difftogo);
edge = edgesY(1,3)-edgesY(1,2);

% sort and bucket the x values
X = pop_Pos;
Xmin = Min;

X3 = zeros(1,X2);
for i = 1:X2
	X3(1,i) = Xmin + (i*(edge));
end

X4 = cell(1,X2);
X5 = cell(1,X2);
for i = 1:X2
	if i == 1
        X4{1,i} = find(X(:,2) <= X3(1,i));
    else
        X5{1,i} = find(X(:,2) <= X3(1,i) & X(:,2) > X3(1,i-1));
  	end
end
X5{1,1} = X4{1,1};

Xend = cell(1,X2);
for xj = 1:X2
	Xend{1,xj} = X(X5{1,xj},1:3);
end

for i = 1:length(Xend)
    minZ = min(Xend{1,i}(:,3));
    diffz = abs(minz - minZ);
    Xend{1,i}(:,3) = Xend{1,i}(:,3)-diffz;
end

normedParentpop_Pos = cell2mat(Xend');
New_Name = 'normalized_Z_Positions';
New_Stats = normedParentpop_Pos(:,3);
Names_of_stats = handles.names;

NamesforExp = handles.NamesforExp; %new statistic is added before positions and after the other statistics
New_NamesfExp = [NamesforExp(:,1:(end-4)) New_Name NamesforExp(:,(end-3):end)];
New_StatsMatrix = [AnalysisMatrix(:,1:(end-4)) New_Stats AnalysisMatrix(:,(end-3):end)];
New_Names = [Names_of_stats(:,1:(end-3)) New_Name Names_of_stats(:,(end-2):end)];
                    
handles.NamesforExp = New_NamesfExp;
handles.stats = New_StatsMatrix;
handles.names = New_Names;

set(handles.popupX,'String',New_Names)
set(handles.popupY,'String',New_Names)
set(handles.popupA,'String',New_Names)
set(handles.popupB,'String',New_Names)
ColorNames = [{'Black'} {'Density'} New_Names];
set(handles.popupCol,'String',ColorNames);
handles.aritstats = New_StatsMatrix;
handles.aritID = 1;

f = get(handles.uipanel1,'SelectedObject');
Sel = get(f,'String');
xgate = str2double(get(handles.Gate_X,'String'));
ygate = str2double(get(handles.Gate_Y,'String'));
stats = New_StatsMatrix;
StatsMatrixCl = handles.statsCl;
num_forperc = size(StatsMatrixCl,1);
set(handles.popupX,'Value',ind_a)
set(handles.popupY,'Value',ind_b)
xx = get(handles.popupX,'String');
yy = get(handles.popupY,'String');
set(handles.textXax,'String',xx(ind_a))
set(handles.textYax,'String',yy(ind_b))
sizeSc = handles.sizeSc;
s = get(handles.popupCol,'Value');
kCol = handles.kmCol;
abin = str2double(get(handles.densitybin,'String'));
bins = str2double(get(handles.hist_bins,'String'));
xmin = str2double(get(handles.Xmin,'String'));
xmax = str2double(get(handles.Xmax,'String'));
ymin = str2double(get(handles.Ymin,'String'));
ymax = str2double(get(handles.Ymax,'String'));

XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,1,1,...
    str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)

if get(handles.popupCol,'value') > 2
    cmax = str2double(get(handles.colorMax,'String'));    
    cmin = str2double(get(handles.colorMin,'String'));  
    if isnan(cmin)
        cmin = 0;
    end
    if isnan(cmax)
        cmax = 255;
    end
    axes(handles.axes1)
    caxis([cmin cmax])  
end
    
a = getappdata(XIT,'handl');
waitfor(msgbox('Normalization done.'));
drawnow;

Val = get(handles.gatebox,'Value');
gatehist = handles.gatinghist;
gatehist{1,Val} = New_StatsMatrix;
gatehist{2,Val} = ind_a;
gatehist{3,Val} = ind_b;
gatehist{4,Val} = Sel;
asinhIDX = get(handles.asinhX,'Value');
asinhIDY = get(handles.asinhY,'Value');
asinhIDen = handles.BiExID;
if asinhIDen == 1 & (asinhIDX == 1 & asinhIDY == 0) 
    gatehist{5,Val} = 1;
elseif asinhIDen == 1 & (asinhIDX == 0 & asinhIDY == 1)
    gatehist{5,Val} = 2;
elseif asinhIDen == 1 & (asinhIDX == 1 & asinhIDY == 1) 
    gatehist{5,Val} = 3;
elseif asinhIDen == 0
    gatehist{5,Val} = 0;    
end
gatehist{6,Val} = asinhIDen;
gatehist{7,Val} = New_Names;
handles.gatinghist = gatehist;

set(handles.figure1, 'pointer', 'arrow')
guidata(hObject,handles);

function Gate_Xperc_Callback(hObject, eventdata, handles)
% hObject    handle to Gate_Xperc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Gate_Xperc as text
%        str2double(get(hObject,'String')) returns contents of Gate_Xperc as a double

% --- Executes during object creation, after setting all properties.
function Gate_Xperc_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Gate_Xperc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function Gate_Yperc_Callback(hObject, eventdata, handles)
% hObject    handle to Gate_Yperc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Gate_Yperc as text
%        str2double(get(hObject,'String')) returns contents of Gate_Yperc as a double

% --- Executes during object creation, after setting all properties.
function Gate_Yperc_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Gate_Yperc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in asinhX.
function asinhX_Callback(hObject, eventdata, handles)
% hObject    handle to asinhX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of asinhX

% --- Executes on button press in asinhY.
function asinhY_Callback(hObject, eventdata, handles)
% hObject    handle to asinhY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of asinhY

% --- Executes on button press in linX.
function linX_Callback(hObject, eventdata, handles)
% hObject    handle to linX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of linX


% --- Executes on button press in linY.
function linY_Callback(hObject, eventdata, handles)
% hObject    handle to linY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of linY


% --- Executes on button press in savepathbtn.
function savepathbtn_Callback(hObject, eventdata, handles)
% hObject    handle to savepathbtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% allows you to set a saving path from which every saving dialog starts
LT_dname = uigetdir;

handles.savepath = LT_dname;
handles.saveID = 1;
guidata(hObject,handles);


% --- Executes on selection change in gatebox.
function gatebox_Callback(hObject, eventdata, handles)
% hObject    handle to gatebox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns gatebox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from gatebox
% the gatebox is a listbox in which the parentpopulation and gates are
% stored so that the user can go back to the gate by clicking on the gate
% name in the listbox
set(handles.figure1, 'pointer', 'watch')
drawnow;
a = get(handles.gatebox,'String');
b = get(handles.gatebox,'Value');
c = cell2mat(a(b,1));

gatinghist = handles.gatinghist;
selGate = gatinghist{1,b};  % statistic dataset
ind_a = gatinghist{2,b};    % x axis statistic
ind_b = gatinghist{3,b};    % y axis statstic
Sel = gatinghist{4,b};      % which plot type was chosen
asinhID = gatinghist{5,b};  % how was the data transformed
Names = gatinghist{7,b};    % names i.e. statistics present in this gate

if strcmp(Sel,'Scatter')
    set(handles.scatterplot,'Value',1)
    set(handles.histplot,'Value',0)
    set(handles.lineplot,'Value',0)
    set(handles.fillplot,'Value',0)
elseif strcmp(Sel,'Histogram')
    set(handles.scatterplot,'Value',0)
    set(handles.histplot,'Value',1)
    set(handles.lineplot,'Value',0)
    set(handles.fillplot,'Value',0)
elseif strcmp(Sel,'Line')
    set(handles.scatterplot,'Value',0)
    set(handles.histplot,'Value',0)
    set(handles.lineplot,'Value',1)
    set(handles.fillplot,'Value',0)
elseif strcmp(Sel,'Fill')
    set(handles.scatterplot,'Value',0)
    set(handles.histplot,'Value',0)
    set(handles.lineplot,'Value',0)
    set(handles.fillplot,'Value',1)
end

handles.stats = selGate;
handles.inda = ind_a;
handles.indb = ind_b;
handles.names = Names;
guidata(hObject,handles);

if asinhID == 1
    set(handles.asinhX,'Value',1)
    set(handles.asinhY,'Value',0)
    set(handles.linX,'Value',1)
    set(handles.linY,'Value',0)
    set(handles.linX,'Enable','off');
    set(handles.linY,'Enable','off');
    set(handles.asinhX,'Enable','off');
    set(handles.asinhY,'Enable','off');
    set(handles.LinBtn,'Enable','on');
    set(handles.BiExBtn,'Enable','off');
    handles.BiExID = 1;
elseif asinhID == 2
    set(handles.asinhX,'Value',0)
    set(handles.asinhY,'Value',1)
    set(handles.linX,'Value',0)
    set(handles.linY,'Value',1)
    set(handles.asinhX,'Enable','off');
    set(handles.asinhY,'Enable','off');
    set(handles.linX,'Enable','off');
    set(handles.linY,'Enable','off');
    set(handles.LinBtn,'Enable','on');
    set(handles.BiExBtn,'Enable','off');
    handles.BiExID = 1;
elseif asinhID == 3
    set(handles.asinhX,'Value',1)
    set(handles.asinhY,'Value',1)
    set(handles.linX,'Value',1)
    set(handles.linY,'Value',1)
    set(handles.linX,'Enable','off');
    set(handles.linY,'Enable','off');
    set(handles.asinhX,'Enable','off');
    set(handles.asinhY,'Enable','off');
    set(handles.LinBtn,'Enable','on');
    set(handles.BiExBtn,'Enable','off');
    handles.BiExID = 1;
elseif asinhID == 0
    set(handles.asinhX,'Value',1)
    set(handles.asinhY,'Value',1)
    set(handles.linX,'Value',1)
    set(handles.linY,'Value',1)
    set(handles.asinhX,'Enable','on');
    set(handles.asinhY,'Enable','on');
    set(handles.linX,'Enable','off');
    set(handles.linY,'Enable','off');
    set(handles.LinBtn,'Enable','off');
    set(handles.BiExBtn,'Enable','on');
    handles.BiExID = 0;
end

StatsMatrixCl = handles.statsCl;
num_forperc = size(StatsMatrixCl,1);
stats = handles.stats;

if isempty(get(handles.Gate_Xperc,'String'))
    set(handles.Gate_Xperc,'String',' ')
end
if isempty(get(handles.Gate_Yperc,'String'))
    set(handles.Gate_Yperc,'String',' ')
end
if strcmp(' ',get(handles.Gate_Xperc,'String')) == 0 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 1
	xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
	xgate = prctile(stats(:,ind_a),xgate_perc);
  	ygate = str2double(get(handles.Gate_Y,'String'));
elseif strcmp(' ',get(handles.Gate_Xperc,'String')) == 1 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 0
   	ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
  	ygate = prctile(stats(:,ind_b),ygate_perc);
 	xgate = str2double(get(handles.Gate_X,'String'));
elseif strcmp(' ',get(handles.Gate_Xperc,'String')) == 0 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 0
  	xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
  	ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
  	set(handles.Gate_X,'String',' ');
  	set(handles.Gate_Y,'String',' ');
	xgate = prctile(stats(:,ind_a),xgate_perc);
	ygate = prctile(stats(:,ind_b),ygate_perc);
elseif strcmp(' ',get(handles.Gate_Xperc,'String')) == 1 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 1
 	xgate = str2double(get(handles.Gate_X,'String'));
   	ygate = str2double(get(handles.Gate_Y,'String'));
end

set(handles.textXax,'string',Names(1,ind_a));
set(handles.textYax,'string',Names(1,ind_b));
set(handles.popupX,'string',Names);
set(handles.popupY,'string',Names);
set(handles.popupX,'value',ind_a);
set(handles.popupY,'value',ind_b);
sizeSc = handles.sizeSc;
s = get(handles.popupCol,'Value');
kCol = handles.kmCol;
abin = str2double(get(handles.densitybin,'String'));
bins = str2double(get(handles.hist_bins,'String'));
xmin = str2double(get(handles.Xmin,'String'));
xmax = str2double(get(handles.Xmax,'String'));
ymin = str2double(get(handles.Ymin,'String'));
ymax = str2double(get(handles.Ymax,'String'));

XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,1,1,...
    str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)
a = getappdata(XIT,'handl');
if get(handles.popupCol,'value') > 2
    cmax = str2double(get(handles.colorMax,'String'));    
    cmin = str2double(get(handles.colorMin,'String'));  
    if isnan(cmin)
        cmin = 0;
    end
    if isnan(cmax)
        cmax = 255;
    end
    axes(handles.axes1)
    caxis([cmin cmax])  
end
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function gatebox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gatebox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in splitbtn.
function splitbtn_Callback(hObject, eventdata, handles)
% hObject    handle to splitbtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% if arithmetic or z norm was done, the stats and names are updated
% accordingly, so that those new stats will be saved as well
% allows the user to separate the dataset into separate workspaces on the
% basis of a spatial gating i.e on ROIs in the sample
set(handles.figure1, 'pointer', 'watch')
drawnow;
AnalysisMatrix = handles.stats;
BiExID = handles.BiExID;
ind_a = handles.inda;
ind_b = handles.indb;

if BiExID == 1 %is data transformed?, then transform it back!
    set(handles.asinhX,'Enable','on');
    set(handles.asinhY,'Enable','on');
    set(handles.BiExBtn,'Enable','on');
    set(handles.linX,'Enable','off');
    set(handles.linY,'Enable','off');
    set(handles.LinBtn,'Enable','off');
    if get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 0
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_a)) - exp(-1.*(AnalysisMatrix(:,ind_a))));
        AnalysisMatrix(:,ind_a) = lin_StatsX;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',0);
    elseif get(handles.linX,'Value') == 0 & get(handles.linY,'Value') == 1
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_b)) - exp(-1.*(AnalysisMatrix(:,ind_b))));
        AnalysisMatrix(:,ind_b) = lin_StatsY;
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',0);
        set(handles.asinhY,'Value',1);
    elseif get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 1
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_a)) - exp(-1.*(AnalysisMatrix(:,ind_a))));
        AnalysisMatrix(:,ind_a) = lin_StatsX;
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(AnalysisMatrix(:,ind_b)) - exp(-1.*(AnalysisMatrix(:,ind_b))));
        AnalysisMatrix(:,ind_b) = lin_StatsY;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',1);
    end
end

Names_of_stats = handles.names;
Position_Matrix = AnalysisMatrix(:,(end-3):end);
data1{1,1} = AnalysisMatrix;
data2{1,1} = Position_Matrix;
xgate = str2double(get(handles.Gate_X,'String'));
ygate = str2double(get(handles.Gate_Y,'String'));
jj = 1;

ArtRemovalV4
set(handles.figure1, 'pointer', 'arrow')
                    
% --- Executes on key press with focus on hist_bins and none of its controls.
function hist_bins_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to hist_bins (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
% upon pressing return in the textbox where histogram bin number can be
% changed the plot will update
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    f = get(handles.uipanel1,'SelectedObject');
    Sel = get(f,'String');
    stats = handles.stats;
    xgate = str2double(get(handles.Gate_X,'String'));
    ygate = str2double(get(handles.Gate_Y,'String'));
    xmin = str2double(get(handles.Xmin,'String'));
    xmax = str2double(get(handles.Xmax,'String'));
    ymin = str2double(get(handles.Ymin,'String'));
    ymax = str2double(get(handles.Ymax,'String'));
    ind_a = handles.inda;
    ind_b = handles.indb;
    sizeSc = handles.sizeSc;
    s = get(handles.popupCol,'Value');
    kCol = handles.kmCol;
    abin = str2double(get(handles.densitybin,'String'));
    bins = str2double(get(handles.hist_bins,'String'));
    StatsMatrixCl = handles.statsCl;
    num_forperc = size(StatsMatrixCl,1);
    
    if isempty(get(handles.Gate_Xperc,'String'))
        set(handles.Gate_Xperc,'String',' ')
    end
    if isempty(get(handles.Gate_Yperc,'String'))
        set(handles.Gate_Yperc,'String',' ')
    end
    if strcmp(' ',get(handles.Gate_Xperc,'String')) == 0 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 1
        xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
        xgate = prctile(stats(:,ind_a),xgate_perc);
        ygate = str2double(get(handles.Gate_Y,'String'));
    elseif strcmp(' ',get(handles.Gate_Xperc,'String')) == 1 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 0
        ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
        ygate = prctile(stats(:,ind_b),ygate_perc);
        xgate = str2double(get(handles.Gate_X,'String'));
    elseif strcmp(' ',get(handles.Gate_Xperc,'String')) == 0 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 0
        xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
        ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
        set(handles.Gate_X,'String',' ');
        set(handles.Gate_Y,'String',' ');
        xgate = prctile(stats(:,ind_a),xgate_perc);
        ygate = prctile(stats(:,ind_b),ygate_perc);
    elseif strcmp(' ',get(handles.Gate_Xperc,'String')) == 1 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 1
        xgate = str2double(get(handles.Gate_X,'String'));
        ygate = str2double(get(handles.Gate_Y,'String'));
    end
    
    XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,1,1,...
        str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)
    a = getappdata(XIT,'handl');
    if get(handles.popupCol,'value') > 2
        cmax = str2double(get(handles.colorMax,'String'));    
        cmin = str2double(get(handles.colorMin,'String'));  
        if isnan(cmin)
            cmin = 0;
        end
        if isnan(cmax)
            cmax = 255;
        end
        axes(handles.axes1)
        caxis([cmin cmax])  
    end

    GateID = a.ID;
    if GateID == 0
    elseif GateID == 1
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowX = a.percbelowX;
        handles.percaboveX = a.percaboveX;
        handles.numbelowX = a.numbelowX;
        handles.numaboveX = a.numaboveX;
        handles.percofallaX = a.percofallaX;
        handles.percofallbX = a.percofallbX; 
    end
    
    if strcmp(Sel,'Histogram')
        set(handles.histplot,'Value',1)
        set(handles.lineplot,'Value',0)
        set(handles.fillplot,'Value',0)
    elseif strcmp(Sel,'Line')
        set(handles.histplot,'Value',0)
        set(handles.lineplot,'Value',1)
        set(handles.fillplot,'Value',0)
    elseif strcmp(Sel,'Fill')
        set(handles.histplot,'Value',0)
        set(handles.lineplot,'Value',0)
        set(handles.fillplot,'Value',1)
    end
    set(handles.scatterplot,'Value',0)
    handles.inda = ind_a;
    handles.bins = bins; 
    guidata(hObject, handles);
    set(handles.figure1, 'pointer', 'arrow')
end

% --- Executes on button press in loadpathbtn.
function loadpathbtn_Callback(hObject, eventdata, handles)
% hObject    handle to loadpathbtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Allows the user to define a specific loading path (optional for imaris
% data; required for workspaces and XIT format data)
LT_dname = uigetdir;
handles.loadpath = LT_dname;
handles.loadID = 1;
guidata(hObject,handles);

% --- Executes on key press with focus on Xmax and none of its controls.
function Xmax_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to Xmax (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
% pressing return in the Xmax textbox updates the Xmax/Xmin handles
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    xmin = str2double(get(handles.Xmin,'String'));
    xmax = str2double(get(handles.Xmax,'String'));

    o = handles.stats;
    p = handles.inda;
    q = o(:,p);
    h = max(q);

    if isnan(xmin)
        xmin = [];
    end
    if isnan(xmax)
        xmax = [];
    end

    if isempty(xmin) == 1 & isempty(xmax) == 1
    	ax = handles.axes1;
    	ax.XTickMode  = 'auto';
    elseif isempty(xmin) == 1 & strcmp(xmax,' ') == 0
        axes(handles.axes1)
        xlim([0 xmax])
    elseif strcmp(xmin,' ') == 0 & isempty(xmax) == 1
        axes(handles.axes1)
        xlim([xmin h])
    elseif strcmp(xmin,' ') == 0 & strcmp(xmax,' ') == 0
        axes(handles.axes1)
        xlim([xmin xmax])
    end
    set(handles.figure1, 'pointer', 'arrow')
end

% --- Executes on key press with focus on Ymax and none of its controls.
function Ymax_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to Ymax (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
% pressing return in the Ymin textbox updates the Ymax/Ymin handles
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    ymin = str2double(get(handles.Ymin,'String'));
    ymax = str2double(get(handles.Ymax,'String'));

    o = handles.stats;
    p = handles.indb;
    q = o(:,p);
    h = max(q);

    if isnan(ymin)
        ymin = [];
    end
    if isnan(ymax)
        ymax = [];
    end

    if isempty(ymin) == 1 & isempty(ymax) == 1
        ax = handles.axes1;
    	ax.YTickMode  = 'auto';
    elseif isempty(ymin) == 1 & strcmp(ymax,' ') == 0
        axes(handles.axes1)
        ylim([0 ymax])
    elseif strcmp(ymin,' ') == 0 & isempty(ymax) == 1
        axes(handles.axes1)
        ylim([ymin h])
    elseif strcmp(ymin,' ') == 0 & strcmp(ymax,' ') == 0
        axes(handles.axes1)
        ylim([ymin ymax])
    end
    set(handles.figure1, 'pointer', 'arrow')
end

% --- Executes on key press with focus on Ymin and none of its controls.
function Ymin_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to Ymin (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
% pressing return in the Ymin textbox updates the Ymax/Ymin handles
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    ymin = str2double(get(handles.Ymin,'String'));
    ymax = str2double(get(handles.Ymax,'String'));

    o = handles.stats;
    p = handles.indb;
    q = o(:,p);
    h = max(q);

    if isnan(ymin)
        ymin = [];
    end
    if isnan(ymax)
        ymax = [];
    end

    if isempty(ymin) == 1 & isempty(ymax) == 1
        ax = handles.axes1;
    	ax.YTickMode  = 'auto';
    elseif isempty(ymin) == 1 & strcmp(ymax,' ') == 0
        axes(handles.axes1)
        ylim([0 ymax])
    elseif strcmp(ymin,' ') == 0 & isempty(ymax) == 1
        axes(handles.axes1)
        ylim([ymin h])
    elseif strcmp(ymin,' ') == 0 & strcmp(ymax,' ') == 0
        axes(handles.axes1)
        ylim([ymin ymax])
    end
    set(handles.figure1, 'pointer', 'arrow')
end

% --- Executes on key press with focus on Xmin and none of its controls.
function Xmin_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to Xmin (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
% pressing return in the Xmin textbox updates the Xmax/Xmin handles
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    xmin = str2double(get(handles.Xmin,'String'));
    xmax = str2double(get(handles.Xmax,'String'));

    o = handles.stats;
    p = handles.inda;
    q = o(:,p);
    h = max(q);

    if isnan(xmin)
        xmin = [];
    end
    if isnan(xmax)
        xmax = [];
    end

    if isempty(xmin) == 1 & isempty(xmax) == 1
    	ax = handles.axes1;
    	ax.XTickMode  = 'auto';
    elseif isempty(xmin) == 1 & strcmp(xmax,' ') == 0
        axes(handles.axes1)
        xlim([0 xmax])
    elseif strcmp(xmin,' ') == 0 & isempty(xmax) == 1
        axes(handles.axes1)
        xlim([xmin h])
    elseif strcmp(xmin,' ') == 0 & strcmp(xmax,' ') == 0
        axes(handles.axes1)
        xlim([xmin xmax])
    end
    set(handles.figure1, 'pointer', 'arrow')
end

% --- Executes on key press with focus on Gate_X and none of its controls.
function Gate_X_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to Gate_X (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
% pressing return in the GateX textbox draws a gate on the x axis. if a
% perc gate is defined in the Gateperc textbox this will be drawn instead. Also
% gates in y will be drawn if values are defined
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    f = get(handles.uipanel1,'SelectedObject');
    Sel = get(f,'String');
    StatsMatrixCl = handles.statsCl;
    num_forperc = size(StatsMatrixCl,1);
    stats = handles.stats;
    ind_a = handles.inda;
    ind_b = handles.indb;
    XPercEmpty = isnan(str2double(get(handles.Gate_Xperc,'String')));
    YPercEmpty = isnan(str2double(get(handles.Gate_Yperc,'String')));
    XValueEmpty = isnan(str2double(get(handles.Gate_X,'String')));
    YValueEmpty = isnan(str2double(get(handles.Gate_Y,'String')));

    if  XPercEmpty == 0 & YPercEmpty == 1
        xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
        xgate = prctile(stats(:,ind_a),xgate_perc);
        ygate = str2double(get(handles.Gate_Y,'String'));
    elseif XPercEmpty == 1 & YPercEmpty == 0
        ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
        ygate = prctile(stats(:,ind_b),ygate_perc);
        xgate = str2double(get(handles.Gate_X,'String'));
    elseif XPercEmpty == 0 & YPercEmpty == 0
        xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
        ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
        xgate = prctile(stats(:,ind_a),xgate_perc);
        ygate = prctile(stats(:,ind_b),ygate_perc);
    elseif XPercEmpty == 1 & YPercEmpty == 1
       if XValueEmpty == 1 & YValueEmpty == 0
           xgate = [];
           set(handles.Gate_X,'String',' ');
           ygate = str2double(get(handles.Gate_Y,'String'));
       elseif XValueEmpty == 0 & YValueEmpty == 1
            xgate = str2double(get(handles.Gate_X,'String'));
            ygate = [];
            set(handles.Gate_Y,'String',' ');
        elseif XValueEmpty == 0 & YValueEmpty == 0
            xgate = str2double(get(handles.Gate_X,'String'));
            ygate = str2double(get(handles.Gate_Y,'String'));
       end  
    end

    sizeSc = handles.sizeSc;
    s = get(handles.popupCol,'Value');
    kCol = handles.kmCol;
    abin = str2double(get(handles.densitybin,'String'));
    bins = str2double(get(handles.hist_bins,'String'));
    xmin = str2double(get(handles.Xmin,'String'));
    xmax = str2double(get(handles.Xmax,'String'));
    ymin = str2double(get(handles.Ymin,'String'));
    ymax = str2double(get(handles.Ymax,'String'));
    XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,1,1,...
        str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)
    a = getappdata(XIT,'handl');
    if get(handles.popupCol,'value') > 2
        cmax = str2double(get(handles.colorMax,'String'));    
        cmin = str2double(get(handles.colorMin,'String'));  
        if isnan(cmin)
            cmin = 0;
        end
        if isnan(cmax)
            cmax = 255;
        end
        axes(handles.axes1)
        caxis([cmin cmax])  
    end

    GateID = a.ID;

    if GateID == 0
    elseif GateID == 1
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowX = a.percbelowX;
        handles.percaboveX = a.percaboveX;
        handles.numbelowX = a.numbelowX;
        handles.numaboveX = a.numaboveX;
        handles.percofallaX = a.percofallaX;
        handles.percofallbX = a.percofallbX;
    elseif GateID == 3
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowY = a.percbelowY;
        handles.percaboveY = a.percaboveY;
        handles.numbelowY = a.numbelowY;
        handles.numaboveY = a.numaboveY;
        handles.percofallaY = a.percofallaY;
        handles.percofallbY = a.percofallbY;
    elseif GateID == 2
       handles.StatsMatrixQ1 = a.StatsMatrixQ1;
      	handles.StatsMatrixQ2 = a.StatsMatrixQ2;
    	handles.StatsMatrixQ3 = a.StatsMatrixQ3;
     	handles.StatsMatrixQ4 = a.StatsMatrixQ4;
      	handles.percQ1 = a.percQ1;
     	handles.percQ2 = a.percQ2;
      	handles.percQ3 = a.percQ3;
     	handles.percQ4 = a.percQ4;
     	handles.percofallQ1 = a.percofallQ1;
     	handles.percofallQ2 = a.percofallQ2;
      	handles.percofallQ3 = a.percofallQ3;
     	handles.percofallQ4 = a.percofallQ4;
     	handles.numQ1 = a.numQ1;
     	handles.numQ2 = a.numQ2;
    	handles.numQ3 = a.numQ3;
      	handles.numQ4 = a.numQ4;
    end
    set(handles.figure1, 'pointer', 'arrow')
    guidata(hObject, handles)
end

% --- Executes on key press with focus on Gate_Y and none of its controls.
function Gate_Y_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to Gate_Y (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
% pressing return in the GateY textbox draws a gate on the y axis. if a
% perc gate is defined in the Gateperc textbox this will be drawn instead. Also
% gates in x will be drawn if values are defined
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    f = get(handles.uipanel1,'SelectedObject');
    Sel = get(f,'String');

    StatsMatrixCl = handles.statsCl;
    num_forperc = size(StatsMatrixCl,1);
    stats = handles.stats;
    ind_a = handles.inda;
    ind_b = handles.indb;

    XPercEmpty = isnan(str2double(get(handles.Gate_Xperc,'String')));
    YPercEmpty = isnan(str2double(get(handles.Gate_Yperc,'String')));
    XValueEmpty = isnan(str2double(get(handles.Gate_X,'String')));
    YValueEmpty = isnan(str2double(get(handles.Gate_Y,'String')));

    if  XPercEmpty == 0 & YPercEmpty == 1
        xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
        xgate = prctile(stats(:,ind_a),xgate_perc);
        ygate = str2double(get(handles.Gate_Y,'String'));
    elseif XPercEmpty == 1 & YPercEmpty == 0
        ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
        ygate = prctile(stats(:,ind_b),ygate_perc);
        xgate = str2double(get(handles.Gate_X,'String'));
    elseif XPercEmpty == 0 & YPercEmpty == 0
        xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
        ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
        xgate = prctile(stats(:,ind_a),xgate_perc);
        ygate = prctile(stats(:,ind_b),ygate_perc);
    elseif XPercEmpty == 1 & YPercEmpty == 1
       if XValueEmpty == 1 & YValueEmpty == 0
           xgate = [];
           set(handles.Gate_X,'String',' ');
           ygate = str2double(get(handles.Gate_Y,'String'));
       elseif XValueEmpty == 0 & YValueEmpty == 1
            xgate = str2double(get(handles.Gate_X,'String'));
            ygate = [];
            set(handles.Gate_Y,'String',' ');
        elseif XValueEmpty == 0 & YValueEmpty == 0
            xgate = str2double(get(handles.Gate_X,'String'));
            ygate = str2double(get(handles.Gate_Y,'String'));
       end  
    end

    sizeSc = handles.sizeSc;
    s = get(handles.popupCol,'Value');
    kCol = handles.kmCol;
    abin = str2double(get(handles.densitybin,'String'));
    bins = str2double(get(handles.hist_bins,'String'));

    xmin = str2double(get(handles.Xmin,'String'));
    xmax = str2double(get(handles.Xmax,'String'));
    ymin = str2double(get(handles.Ymin,'String'));
    ymax = str2double(get(handles.Ymax,'String'));

    XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,1,1,...
        str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)
    a = getappdata(XIT,'handl');
    if get(handles.popupCol,'value') > 2
        cmax = str2double(get(handles.colorMax,'String'));    
        cmin = str2double(get(handles.colorMin,'String'));  
        if isnan(cmin)
            cmin = 0;
        end
        if isnan(cmax)
            cmax = 255;
        end
        axes(handles.axes1)
        caxis([cmin cmax])  
    end

    GateID = a.ID;

    if GateID == 0
    elseif GateID == 1
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowX = a.percbelowX;
        handles.percaboveX = a.percaboveX;
        handles.numbelowX = a.numbelowX;
        handles.numaboveX = a.numaboveX;
        handles.percofallaX = a.percofallaX;
        handles.percofallbX = a.percofallbX;
    elseif GateID == 3
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowY = a.percbelowY;
        handles.percaboveY = a.percaboveY;
        handles.numbelowY = a.numbelowY;
        handles.numaboveY = a.numaboveY;
        handles.percofallaY = a.percofallaY;
        handles.percofallbY = a.percofallbY;
    elseif GateID == 2
       handles.StatsMatrixQ1 = a.StatsMatrixQ1;
      	handles.StatsMatrixQ2 = a.StatsMatrixQ2;
    	handles.StatsMatrixQ3 = a.StatsMatrixQ3;
     	handles.StatsMatrixQ4 = a.StatsMatrixQ4;
      	handles.percQ1 = a.percQ1;
     	handles.percQ2 = a.percQ2;
      	handles.percQ3 = a.percQ3;
     	handles.percQ4 = a.percQ4;
     	handles.percofallQ1 = a.percofallQ1;
     	handles.percofallQ2 = a.percofallQ2;
      	handles.percofallQ3 = a.percofallQ3;
     	handles.percofallQ4 = a.percofallQ4;
     	handles.numQ1 = a.numQ1;
     	handles.numQ2 = a.numQ2;
    	handles.numQ3 = a.numQ3;
      	handles.numQ4 = a.numQ4;
    end
    set(handles.figure1, 'pointer', 'arrow')
    guidata(hObject, handles)
end

% --- Executes on key press with focus on Gate_Xperc and none of its controls.
function Gate_Xperc_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to Gate_Xperc (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
% pressing return in the GateXperc textbox draws a gate on the x axis. if a
% value gate is defined in the designated textbox this will not be drawn. Also
% gates in y will be drawn if values are defined
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    f = get(handles.uipanel1,'SelectedObject');
    Sel = get(f,'String');

    StatsMatrixCl = handles.statsCl;
    num_forperc = size(StatsMatrixCl,1);
    stats = handles.stats;
    ind_a = handles.inda;
    ind_b = handles.indb;

    XPercEmpty = isnan(str2double(get(handles.Gate_Xperc,'String')));
    YPercEmpty = isnan(str2double(get(handles.Gate_Yperc,'String')));
    XValueEmpty = isnan(str2double(get(handles.Gate_X,'String')));
    YValueEmpty = isnan(str2double(get(handles.Gate_Y,'String')));

    if  XPercEmpty == 0 & YPercEmpty == 1
        xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
        xgate = prctile(stats(:,ind_a),xgate_perc);
        ygate = str2double(get(handles.Gate_Y,'String'));
        set(handles.Gate_X,'String',num2str(xgate))
    elseif XPercEmpty == 1 & YPercEmpty == 0
        ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
        ygate = prctile(stats(:,ind_b),ygate_perc);
        xgate = str2double(get(handles.Gate_X,'String'));
        set(handles.Gate_Y,'String',num2str(ygate))
    elseif XPercEmpty == 0 & YPercEmpty == 0
        xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
        ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
        xgate = prctile(stats(:,ind_a),xgate_perc);
        ygate = prctile(stats(:,ind_b),ygate_perc);
        set(handles.Gate_X,'String',num2str(xgate))
        set(handles.Gate_Y,'String',num2str(ygate))
    elseif XPercEmpty == 1 & YPercEmpty == 1
       if XValueEmpty == 1 & YValueEmpty == 0
           xgate = [];
           set(handles.Gate_X,'String',' ');
           ygate = str2double(get(handles.Gate_Y,'String'));
       elseif XValueEmpty == 0 & YValueEmpty == 1
            xgate = str2double(get(handles.Gate_X,'String'));
            ygate = [];
            set(handles.Gate_Y,'String',' ');
        elseif XValueEmpty == 0 & YValueEmpty == 0
            xgate = str2double(get(handles.Gate_X,'String'));
            ygate = str2double(get(handles.Gate_Y,'String'));
       end  
    end

    sizeSc = handles.sizeSc;
    s = get(handles.popupCol,'Value');
    kCol = handles.kmCol;
    abin = str2double(get(handles.densitybin,'String'));
    bins = str2double(get(handles.hist_bins,'String'));

    xmin = str2double(get(handles.Xmin,'String'));
    xmax = str2double(get(handles.Xmax,'String'));
    ymin = str2double(get(handles.Ymin,'String'));
    ymax = str2double(get(handles.Ymax,'String'));

    XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,1,1,...
        str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)
    a = getappdata(XIT,'handl');
    if get(handles.popupCol,'value') > 2
        cmax = str2double(get(handles.colorMax,'String'));    
        cmin = str2double(get(handles.colorMin,'String'));  
        if isnan(cmin)
            cmin = 0;
        end
        if isnan(cmax)
            cmax = 255;
        end
        axes(handles.axes1)
        caxis([cmin cmax])  
    end

    GateID = a.ID;

    if GateID == 0
    elseif GateID == 1
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowX = a.percbelowX;
        handles.percaboveX = a.percaboveX;
        handles.numbelowX = a.numbelowX;
        handles.numaboveX = a.numaboveX;
        handles.percofallaX = a.percofallaX;
        handles.percofallbX = a.percofallbX;
    elseif GateID == 3
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowY = a.percbelowY;
        handles.percaboveY = a.percaboveY;
        handles.numbelowY = a.numbelowY;
        handles.numaboveY = a.numaboveY;
        handles.percofallaY = a.percofallaY;
        handles.percofallbY = a.percofallbY;
    elseif GateID == 2
       handles.StatsMatrixQ1 = a.StatsMatrixQ1;
      	handles.StatsMatrixQ2 = a.StatsMatrixQ2;
    	handles.StatsMatrixQ3 = a.StatsMatrixQ3;
     	handles.StatsMatrixQ4 = a.StatsMatrixQ4;
      	handles.percQ1 = a.percQ1;
     	handles.percQ2 = a.percQ2;
      	handles.percQ3 = a.percQ3;
     	handles.percQ4 = a.percQ4;
     	handles.percofallQ1 = a.percofallQ1;
     	handles.percofallQ2 = a.percofallQ2;
      	handles.percofallQ3 = a.percofallQ3;
     	handles.percofallQ4 = a.percofallQ4;
     	handles.numQ1 = a.numQ1;
     	handles.numQ2 = a.numQ2;
    	handles.numQ3 = a.numQ3;
      	handles.numQ4 = a.numQ4;
    end
    guidata(hObject, handles)
    set(handles.figure1, 'pointer', 'arrow')
end

% --- Executes on key press with focus on Gate_Yperc and none of its controls.
function Gate_Yperc_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to Gate_Yperc (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
% pressing return in the GateYperc textbox draws a gate on the y axis. if a
% value gate is defined in the designated textbox this will not be drawn. Also
% gates in x will be drawn if values are defined
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    f = get(handles.uipanel1,'SelectedObject');
    Sel = get(f,'String');

    StatsMatrixCl = handles.statsCl;
    num_forperc = size(StatsMatrixCl,1);
    stats = handles.stats;
    ind_a = handles.inda;
    ind_b = handles.indb;

    XPercEmpty = isnan(str2double(get(handles.Gate_Xperc,'String')));
    YPercEmpty = isnan(str2double(get(handles.Gate_Yperc,'String')));
    XValueEmpty = isnan(str2double(get(handles.Gate_X,'String')));
    YValueEmpty = isnan(str2double(get(handles.Gate_Y,'String')));

    if  XPercEmpty == 0 & YPercEmpty == 1
        xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
        xgate = prctile(stats(:,ind_a),xgate_perc);
        ygate = str2double(get(handles.Gate_Y,'String'));
        set(handles.Gate_X,'String',num2str(xgate))
    elseif XPercEmpty == 1 & YPercEmpty == 0
        ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
        ygate = prctile(stats(:,ind_b),ygate_perc);
        xgate = str2double(get(handles.Gate_X,'String'));
        set(handles.Gate_Y,'String',num2str(ygate))
    elseif XPercEmpty == 0 & YPercEmpty == 0
        xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
        ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
        xgate = prctile(stats(:,ind_a),xgate_perc);
        ygate = prctile(stats(:,ind_b),ygate_perc);
        set(handles.Gate_X,'String',num2str(xgate))
        set(handles.Gate_Y,'String',num2str(ygate))
    elseif XPercEmpty == 1 & YPercEmpty == 1
       if XValueEmpty == 1 & YValueEmpty == 0
           xgate = [];
           set(handles.Gate_X,'String',' ');
           ygate = str2double(get(handles.Gate_Y,'String'));
       elseif XValueEmpty == 0 & YValueEmpty == 1
            xgate = str2double(get(handles.Gate_X,'String'));
            ygate = [];
            set(handles.Gate_Y,'String',' ');
        elseif XValueEmpty == 0 & YValueEmpty == 0
            xgate = str2double(get(handles.Gate_X,'String'));
            ygate = str2double(get(handles.Gate_Y,'String'));
       end  
    end

    sizeSc = handles.sizeSc;
    s = get(handles.popupCol,'Value');
    kCol = handles.kmCol;
    abin = str2double(get(handles.densitybin,'String'));
    bins = str2double(get(handles.hist_bins,'String'));
    xmin = str2double(get(handles.Xmin,'String'));
    xmax = str2double(get(handles.Xmax,'String'));
    ymin = str2double(get(handles.Ymin,'String'));
    ymax = str2double(get(handles.Ymax,'String'));

    XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,1,1,...
        str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)
    a = getappdata(XIT,'handl');
    if get(handles.popupCol,'value') > 2
        cmax = str2double(get(handles.colorMax,'String'));    
        cmin = str2double(get(handles.colorMin,'String'));  
        if isnan(cmin)
            cmin = 0;
        end
        if isnan(cmax)
            cmax = 255;
        end
        axes(handles.axes1)
        caxis([cmin cmax])  
    end
    GateID = a.ID;

    if GateID == 0
    elseif GateID == 1
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowX = a.percbelowX;
        handles.percaboveX = a.percaboveX;
        handles.numbelowX = a.numbelowX;
        handles.numaboveX = a.numaboveX;
        handles.percofallaX = a.percofallaX;
        handles.percofallbX = a.percofallbX;
    elseif GateID == 3
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowY = a.percbelowY;
        handles.percaboveY = a.percaboveY;
        handles.numbelowY = a.numbelowY;
        handles.numaboveY = a.numaboveY;
        handles.percofallaY = a.percofallaY;
        handles.percofallbY = a.percofallbY;
    elseif GateID == 2
       handles.StatsMatrixQ1 = a.StatsMatrixQ1;
      	handles.StatsMatrixQ2 = a.StatsMatrixQ2;
    	handles.StatsMatrixQ3 = a.StatsMatrixQ3;
     	handles.StatsMatrixQ4 = a.StatsMatrixQ4;
      	handles.percQ1 = a.percQ1;
     	handles.percQ2 = a.percQ2;
      	handles.percQ3 = a.percQ3;
     	handles.percQ4 = a.percQ4;
     	handles.percofallQ1 = a.percofallQ1;
     	handles.percofallQ2 = a.percofallQ2;
      	handles.percofallQ3 = a.percofallQ3;
     	handles.percofallQ4 = a.percofallQ4;
     	handles.numQ1 = a.numQ1;
     	handles.numQ2 = a.numQ2;
    	handles.numQ3 = a.numQ3;
      	handles.numQ4 = a.numQ4;
    end
    guidata(hObject, handles)
    set(handles.figure1, 'pointer', 'arrow')
end


% --- Executes on button press in ClearGateWindows.
function ClearGateWindows_Callback(hObject, eventdata, handles)
% hObject    handle to ClearGateWindows (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.figure1, 'pointer', 'watch')
drawnow;
set(handles.Gate_X,'String',' ')
set(handles.Gate_Y,'String',' ')
set(handles.Gate_Xperc,'String',' ')
set(handles.Gate_Yperc,'String',' ')
handles.xgate = [];
handles.ygate = [];
guidata(hObject,handles)

f = get(handles.uipanel1,'SelectedObject');
Sel = get(f,'String');
xgate = [];
ygate = [];
stats = handles.stats;
StatsMatrixCl = handles.statsCl;
num_forperc = size(StatsMatrixCl,1);
ind_a = handles.inda;
ind_b = handles.indb;
sizeSc = handles.sizeSc;
s = get(handles.popupCol,'Value');
kCol = handles.kmCol;
abin = str2double(get(handles.densitybin,'String'));
bins = str2double(get(handles.hist_bins,'String'));
xmin = str2double(get(handles.Xmin,'String'));
xmax = str2double(get(handles.Xmax,'String'));
ymin = str2double(get(handles.Ymin,'String'));
ymax = str2double(get(handles.Ymax,'String'));

XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,1,1,...
    str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)
a = getappdata(XIT,'handl');
if get(handles.popupCol,'value') > 2
    cmax = str2double(get(handles.colorMax,'String'));    
    cmin = str2double(get(handles.colorMin,'String'));  
    if isnan(cmin)
        cmin = 0;
    end
    if isnan(cmax)
        cmax = 255;
    end
    axes(handles.axes1)
    caxis([cmin cmax])  
end
y = handles.loadpath;
yy = handles.loadID;
handles.loadpath = y;
handles.loadID = yy;
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject,handles)


% --- Executes on button press in RectGateBtn.
function RectGateBtn_Callback(hObject, eventdata, handles)
% hObject    handle to RectGateBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
stats = handles.stats;
fig = handles.axes1;
ind_a = handles.inda;
ind_b = handles.indb;
clearst = handles.statsCl;
set(handles.Gate_X,'String',' ');
set(handles.Gate_Y,'String',' ');
s = get(handles.popupCol,'Value');
sizeSc = handles.sizeSc;
kCol = handles.kmCol;

        
% the user can draw a rect on the main axes
h = imrect(fig);
setColor(h,'r');
nodes1 = getPosition(h);
leftdown = nodes1(1,1:2);
rightdown = [(nodes1(1,1) + nodes1(1,3)), nodes1(1,2)];
rightup = [(nodes1(1,1) + nodes1(1,3)), (nodes1(1,2) + nodes1(1,4))];
leftup = [nodes1(1,1), (nodes1(1,2) + nodes1(1,4))];
nodes = [leftdown; rightdown; rightup; leftup];
% everything outside the polygon (on the lines = within the polygon) will be deleted
selected_indices = find(inpolygon(stats(:,ind_a),stats(:,ind_b), nodes(:,1), nodes(:,2)));
StatsMatrix2 = stats(selected_indices(:,1),:);

set(handles.figure1, 'pointer', 'watch')
drawnow;
%save this gate?
savegate = questdlg('Do you want to save this gate in order to apply it later?','Save gate','Yes','No','Yes');
switch savegate  
	case 'Yes'
        handles.nodes = nodes;
        set(handles.applygateBtn,'Enable','on')
        guidata(hObject, handles);
    case 'No'
end

%dialog that allows adding gate view to figures
saveit = questdlg('Do you want to save this gate view in the plot editor?','Add figure','Yes','No','Yes');
switch saveit  
	case 'Yes'
        hold on
        hey = fill(nodes(:,1),nodes(:,2),'k','FaceAlpha',0,'EdgeColor','r','Linewidth',1);
        hold off
        delete(findobj(h));
     	Names = get(handles.popupFigure,'string');
        % checks if there is already an entry in the menu
        if strcmp(Names,'Figures') | strcmp(Names,' ')
            figgi = figure('name',['Figure ' num2str(1)],'numbertitle','off'); set(figgi, 'Visible', 'off');
            name = {get(figgi,'Name')};
            set(handles.popupFigure,'String',name);
            Val = 0;
        else
            Str = get(handles.popupFigure,'String');
            Val = str2num(Str{end,1}(end-1:end));
            figgi = figure('name',['Figure ' num2str(Val+1)],'numbertitle','off'); set(figgi, 'Visible', 'off');
            name = get(figgi,'Name');
            namethere = {get(handles.popupFigure,'String')};
            namethere{1,1}{end+1,1} = name;
            set(handles.popupFigure,'String',namethere{1,1});
        end

        copyobj(fig,figgi); %copies the object
        d = daspect;
        daspect(d);

        hand = findobj(figgi,'type','axes');
        set(handles.popupFigure,'Value',Val+1);

        handles.tx = get(hand,'Xtick');
        handles.ty = get(hand,'Ytick');
        tx = get(hand,'Xtick');
        ty = get(hand,'Ytick');

        kCol = handles.kmCol;
        s = get(handles.popupCol,'Value');

        if strcmp(get(get(handles.axes1,'child'),'type'),'contour')
            cID = 1;
        else
            cID = 0;
        end

        % Matlab2015 specific set the default colormap to jet when needed
        if s == 2 & kCol == 0 & cID == 0
            colormap(figgi,jet);
        elseif s > 2 & kCol == 0
            colormap(figgi,jet);
        elseif s == 2 & kCol == 0 & cID == 1
            colormap(figgi,gray(1));
        end

        histo = handles.histo;
        line = handles.line;
        fillarea =handles.fillarea;

        if histo == 0 & line == 0 & fillarea == 0
            Xstring = cell2mat(get(handles.textXax,'String'));
            Ystring = cell2mat(get(handles.textYax,'String'));
        else
            Xstring = cell2mat(get(handles.textXax,'String'));
            Ystring = get(handles.textYax,'String');
        end

        idcsX = strfind(Xstring,'_');
        idcsY = strfind(Ystring,'_');
        Xstring(idcsX) = ' '; 
        Ystring(idcsY) = ' '; 
        xlabel(Xstring)
        ylabel(Ystring)

        set(figgi, 'Units','normalized', 'OuterPosition',[0.3 0.2 0.3 0.5])
        set(hand,'outerposition',[0 0 1 1],'units','normalized')
        set(hand, 'LooseInset', [0,0,0,0]);
        axis square

        % gets the tick labels to store for adding them later if needed
        var_prep = ['tx_' get(figgi,'Name')];
        var1 = matlab.lang.makeValidName(var_prep);
        eval([var1, '= tx;'])

        var_prep1 = ['ty_' get(figgi,'Name')];
        var2 = matlab.lang.makeValidName(var_prep1);
        eval([var2, '= ty;'])
        eval(['handles.', var1, '= tx;'])
        eval(['handles.', var2, '= ty;'])

        set(handles.popupColor,'Value',1)
        set(handles.popupLiT,'Value',1)
        set(handles.popupFontSize,'Value',10)

        hand = findobj(figgi,'type','axes');
        texthand = findobj(hand,'type','text');
        hline = findobj(figgi, 'type', 'line');

        % reads all properties to be edited later and returns them in the
        % appropriate buttons, check boxes etc.
        a0 = get(hand,'xtick');
        if ~isempty(a0)
            set(handles.Axesti,'Value',1);
        else
            set(handles.Axesti,'Value',0);
        end

        set(handles.ticklabels,'Value',1);

        b = get(hand,'Box');
        if strcmp(b,'on') == 1
            set(handles.tickbox,'Value',1)
        else
            set(handles.tickbox,'Value',0)
        end

        c = get(texthand,'Visible');
        if isempty(c)
            set(handles.ticktext,'Value',0);
        elseif strcmp(c,'on') == 1
            set(handles.ticktext,'Value',1);
        elseif strcmp(c,'off') == 1
            set(handles.ticktext,'Value',0);
        end

        d = get(hand,'Fontsize');
        set(handles.popupFontSize,'Value',d)

        e = 1;
        set(handles.popupLiT,'Value',2)

        f = get(hand,'LineWidth');
        if isempty(f) == 0
            if length(f) > 1
                set(handles.boxthipopup,'Value',f(1,1))
            elseif f == 0.5
                set(handles.boxthipopup,'Value',1)
            else
                set(handles.boxthipopup,'Value',f+1)
            end
        else
            set(handles.boxthipopup,'Value',1)
        end
        delete(hey)
    case 'No'
        delete(findobj(h));
end


% new dataset is plotted
if s == 1 & kCol == 0;
	axes(handles.axes1)
	scatter(StatsMatrix2(:,ind_a),StatsMatrix2(:,ind_b),sizeSc,[0 0 0],'filled');
elseif s == 2 & kCol == 0;
	abin = str2double(get(handles.densitybin,'String'));
	edgesX = linspace(min(StatsMatrix2(:,ind_a)), max(StatsMatrix2(:,ind_a)), abin);
 	edgesY = linspace(min(StatsMatrix2(:,ind_b)), max(StatsMatrix2(:,ind_b)), abin);   
  	[One,~] = size(StatsMatrix2(:,ind_a));  
 	[~,CountsX] = histc(StatsMatrix2(:,ind_a),edgesX);
	[~,CountsY] = histc(StatsMatrix2(:,ind_b),edgesY);         
  	Counts = [CountsX,CountsY];
   	Darray = accumarray(Counts,1)./One;
	DarrayNorm = Darray./max(Darray(:));
    DarrayNorm = imgaussfilt(DarrayNorm,2);   
  	ind = sub2ind(size(DarrayNorm),CountsX,CountsY);    
	col2 = DarrayNorm(ind);
  	U = sortrows([StatsMatrix2(:,ind_a), StatsMatrix2(:,ind_b), col2],3);
  	col1 = U(:,3);   
 	colormap(jet(4096));
  	axes(handles.axes1)
  	scatter(U(:,1),U(:,2),sizeSc,col1,'filled')
elseif s > 2 & kCol == 0;
	es = s-2;
	axes(handles.axes1)
	scatter(StatsMatrix2(:,ind_a),StatsMatrix2(:,ind_b),sizeSc,StatsMatrix2(:,es),'filled');
elseif length(kCol) > 1;
    kCol2 = kCol(selected_indices(:,1),:);
	axes(handles.axes1)
	scatter(StatsMatrix2(:,ind_a),StatsMatrix2(:,ind_b),sizeSc,kCol2,'filled');   
end
axis 'auto xy'
set(handles.Ymin,'String',' ');
set(handles.Ymax,'String',' ');
set(handles.Xmin,'String',' ');
set(handles.Xmax,'String',' ');
        
% percentage of the gate within the parent population is calculated and
% inserted into the gating history table
percofall = size(StatsMatrix2,1)/size(clearst,1)*100;
perc = size(StatsMatrix2,1)/size(stats,1)*100;
numb = size(StatsMatrix2,1);
a = [cell2mat(get(handles.textXax,'String')) ' vs. ' cell2mat(get(handles.textYax,'String')) ' rectangle'];
a1 = get(handles.GatingTable,'Data');
a2 = (size(a1,1)+1);
                                
if isempty(a1) == 1 %if its the first entry in the table
    b = {a, numb, perc, percofall};
    set(handles.GatingTable,'Data',b)
else
end
if isempty(a1) == 0 %if there is already an entry in the table
    b1 = {' ', ' ', ' ',' '};
    a1 = [a1; b1];
    a1(a2,:) = {a, numb, perc, percofall};
    set(handles.GatingTable,'Data',a1)
else
end 
handles.stats = StatsMatrix2;
handles.aritstats = StatsMatrix2;
Names = get(handles.gatebox,'string');

for i = 1:length(Names)
	if strcmp(Names{i,1},'...')
        Val = i;
        break
	end
end
% Gating history is updated
gatehist = handles.gatinghist;
gatehist{1,Val} = StatsMatrix2;
gatehist{2,Val} = ind_a;
gatehist{3,Val} = ind_b;

if strcmp(Names{Val-1},'Parent population') == 1
    gatehist{2,Val-1} = ind_a;
    gatehist{3,Val-1} = ind_b;
end

f = get(handles.uipanel1,'SelectedObject');
Sel = get(f,'String');
gatehist{4,Val} = Sel;
asinhIDX = get(handles.asinhX,'Value');
asinhIDY = get(handles.asinhY,'Value');
asinhIDen = get(handles.BiExBtn,'Enable');
if strcmp(asinhIDen,'off')
    asinhIDen = 1;
else
    asinhIDen = 0;
end
if asinhIDen == 1 & (asinhIDX == 1 & asinhIDY == 0) 
    gatehist{5,Val} = 1;
elseif asinhIDen == 1 & (asinhIDX == 0 & asinhIDY == 1)
    gatehist{5,Val} = 2;
elseif asinhIDen == 1 & (asinhIDX == 1 & asinhIDY == 1) 
    gatehist{5,Val} = 3;
elseif asinhIDen == 0
    gatehist{5,Val} = 0;    
end
gatehist{6,Val} = handles.BiExID;
gatehist{7,Val} = handles.names;

handles.gatinghist = gatehist;
Names{Val,1} = a;
Names{Val+1,1} = '...';
set(handles.gatebox,'Value',(Val));
set(handles.gatebox,'String',Names);
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject, handles);


% --- Executes on button press in ExpID.
function ExpID_Callback(hObject, eventdata, handles)
% hObject    handle to ExpID (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.figure1, 'pointer', 'watch')
drawnow;
stats = handles.stats;
BiExID = handles.BiExID;
ind_a = handles.inda;
ind_b = handles.indb;

if BiExID == 1
    set(handles.asinhX,'Enable','on');
    set(handles.asinhY,'Enable','on');
    set(handles.BiExBtn,'Enable','on');
    set(handles.linX,'Enable','off');
    set(handles.linY,'Enable','off');
    set(handles.LinBtn,'Enable','off');
    if get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 0
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats(:,ind_a)) - exp(-1.*(stats(:,ind_a))));
        stats(:,ind_a) = lin_StatsX;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',0);
    elseif get(handles.linX,'Value') == 0 & get(handles.linY,'Value') == 1
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats(:,ind_b)) - exp(-1.*(stats(:,ind_b))));
        stats(:,ind_b) = lin_StatsY;
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',0);
        set(handles.asinhY,'Value',1);
    elseif get(handles.linX,'Value') == 1 & get(handles.linY,'Value') == 1
        lin_StatsX = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats(:,ind_a)) - exp(-1.*(stats(:,ind_a))));
        stats(:,ind_a) = lin_StatsX;
        lin_StatsY = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(stats(:,ind_b)) - exp(-1.*(stats(:,ind_b))));
        stats(:,ind_b) = lin_StatsY;
        handles.xgate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_X,'String'))) - exp(-1.*(str2double(get(handles.Gate_X,'String')))));
        handles.ygate = (str2double(get(handles.cofactor,'String')))...
        *(1/2)*(exp(str2double(get(handles.Gate_Y,'String'))) - exp(-1.*(str2double(get(handles.Gate_Y,'String')))));
        set(handles.asinhX,'Value',1);
        set(handles.asinhY,'Value',1);
    end
end

StatNames  =  handles.NamesforExp;
pathname = handles.savepath;
saveID = handles.saveID;

% if a savepath has been defined the browser starts there, otherwise it
% starts from c
if saveID == 1
    [FileName,pathname] = uiputfile('*.txt','Save IDs',pathname);
    FileName2 = fullfile(pathname, FileName);
    PathName = pathname;
else    
    [FileName,PathName] = uiputfile('*.txt','Save IDs');
    FileName2 = fullfile(PathName, FileName);
end

IDs = stats(:,end);

if ~ischar(PathName)
  	
else
    fileID = fopen(FileName2,'w'); % text format used for CreateSpotsFromFile Xtension in Imaris
    dlmwrite(FileName2,IDs','-append','newline', 'pc')
    fclose(fileID);
    clearvars FileName2 FileName PathName
    waitfor(msgbox('Export successful!'));
    drawnow;
end
set(handles.figure1, 'pointer', 'arrow')

% --- Executes on button press in applygateBtn.
function applygateBtn_Callback(hObject, eventdata, handles)
% hObject    handle to applygateBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.figure1, 'pointer', 'watch')
drawnow;
stats = handles.stats;
fig = handles.axes1;
ind_a = handles.inda;
ind_b = handles.indb;
clearst = handles.statsCl;
set(handles.Gate_X,'String',' ');
set(handles.Gate_Y,'String',' ');
s = get(handles.popupCol,'Value');
sizeSc = handles.sizeSc;
kCol = handles.kmCol;

if s == 1 & kCol == 0;
	axes(handles.axes1)
	scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,[0 0 0],'filled');
elseif s == 2 & kCol == 0;
	abin = str2double(get(handles.densitybin,'String'));
	edgesX = linspace(min(stats(:,ind_a)), max(stats(:,ind_a)), abin);
	edgesY = linspace(min(stats(:,ind_b)), max(stats(:,ind_b)), abin); 
	[One,~] = size(stats(:,ind_a));   
 	[~,CountsX] = histc(stats(:,ind_a),edgesX);
  	[~,CountsY] = histc(stats(:,ind_b),edgesY);   
    Counts = [CountsX,CountsY];
	Darray = accumarray(Counts,1)./One;
	DarrayNorm = Darray./max(Darray(:));
    DarrayNorm = imgaussfilt(DarrayNorm,2);   
    ind = sub2ind(size(DarrayNorm),CountsX,CountsY);  
 	col2 = DarrayNorm(ind);
   	U = sortrows([stats(:,ind_a), stats(:,ind_b), col2],3);
  	col1 = U(:,3);
    colormap(jet(4096));
  	axes(handles.axes1)
 	scatter(U(:,1),U(:,2),sizeSc,col1,'filled')
elseif s > 2 & kCol == 0;
	if get(handles.colasinh,'Value') == 1 & handles.BiExID == 0 %color should be transformed, not data
            BiEx_StatsX = log((stats/(str2double(get(handles.cofact_col,'String'))))...
                +sqrt((((stats/(str2double(get(handles.cofact_col,'String')))).^2)+1)));
            es = s-2;
            axes(handles.axes1)
            scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,BiEx_StatsX(:,es),'filled');
            ch = colorbar('northoutside');
            set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
        elseif get(handles.colasinh,'Value') == 0 & handles.BiExID == 1 %color should not be transformed, but data
            lin_Stats = (str2double(get(handles.cofact_col,'String')))...
            *(1/2)*(exp(stats) - exp(-1.*(stats)));
            es = s-2;
            axes(handles.axes1)
            scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,lin_Stats(:,es),'filled');
            ch = colorbar('northoutside');
            set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
        elseif get(handles.colasinh,'Value') == 0 & handles.BiExID == 0 %color should not be transformed, neither data
            es = s-2;
            axes(handles.axes1)
            scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,stats(:,es),'filled');
            ch = colorbar('northoutside');
            set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
        elseif get(handles.colasinh,'Value') == 1 & handles.BiExID == 1 %color and data should be transformed
            es = s-2;
            axes(handles.axes1)
            scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,stats(:,es),'filled');
            ch = colorbar('northoutside');
            set(ch,'location','manual','position',[0.285 0.815 0.25 0.015]);
        end
elseif length(kCol) > 1;
	axes(handles.axes1)
	scatter(stats(:,ind_a),stats(:,ind_b),sizeSc,kCol,'filled');   
end

xmin = str2double(get(handles.Xmin,'String'));
xmax = str2double(get(handles.Xmax,'String'));
ymin = str2double(get(handles.Ymin,'String'));
ymax = str2double(get(handles.Ymax,'String'));        
reziseaxes(stats,ind_a,xmin,xmax,ymin,ymax,handles.axes1) %calls the axes resize function

nodes = handles.nodes;
hold on 
hey1 = fill(nodes(:,1),nodes(:,2),'k','FaceAlpha',0,'EdgeColor','r','Linewidth',1);
hold off

% everything outside the polygon (on the lines = within the polygon) will be deleted
selected_indices = find(inpolygon(stats(:,ind_a),stats(:,ind_b), nodes(:,1), nodes(:,2)));
StatsMatrix2 = stats(selected_indices(:,1),:);

%dialog that allows adding gate view to figures
saveit = questdlg('Do you want to save this gate view in the plot editor?','Add figure','Yes','No','Yes');
switch saveit  
	case 'Yes'
        hold on
        hey = fill(nodes(:,1),nodes(:,2),'k','FaceAlpha',0,'EdgeColor','r','Linewidth',1);
        hold off
        delete(hey1);
     	Names = get(handles.popupFigure,'string');
        % checks if there is already an entry in the menu
        if strcmp(Names,'Figures') | strcmp(Names,' ')
            figgi = figure('name',['Figure ' num2str(1)],'numbertitle','off'); set(figgi, 'Visible', 'off');
            name = {get(figgi,'Name')};
            set(handles.popupFigure,'String',name);
            Val = 0;
        else
            Str = get(handles.popupFigure,'String');
            Val = str2num(Str{end,1}(end-1:end));
            figgi = figure('name',['Figure ' num2str(Val+1)],'numbertitle','off'); set(figgi, 'Visible', 'off');
            name = get(figgi,'Name');
            namethere = {get(handles.popupFigure,'String')};
            namethere{1,1}{end+1,1} = name;
            set(handles.popupFigure,'String',namethere{1,1});
        end

        copyobj(fig,figgi); %copies the object
        d = daspect;
        daspect(d);

        hand = findobj(figgi,'type','axes');
        set(handles.popupFigure,'Value',Val+1);

        handles.tx = get(hand,'Xtick');
        handles.ty = get(hand,'Ytick');
        tx = get(hand,'Xtick');
        ty = get(hand,'Ytick');

        kCol = handles.kmCol;
        s = get(handles.popupCol,'Value');

        if strcmp(get(get(handles.axes1,'child'),'type'),'contour')
            cID = 1;
        else
            cID = 0;
        end

        % Matlab2015 specific set the default colormap to jet when needed
        if s == 2 & kCol == 0 & cID == 0
            colormap(figgi,jet);
        elseif s > 2 & kCol == 0
            colormap(figgi,jet);
        elseif s == 2 & kCol == 0 & cID == 1
            colormap(figgi,gray(1));
        end

        histo = handles.histo;
        line = handles.line;
        fillarea = handles.fillarea;

        if histo == 0 & line == 0 & fillarea == 0
            Xstring = cell2mat(get(handles.textXax,'String'));
            Ystring = cell2mat(get(handles.textYax,'String'));
        else
            Xstring = cell2mat(get(handles.textXax,'String'));
            Ystring = get(handles.textYax,'String');
        end

        idcsX = strfind(Xstring,'_');
        idcsY = strfind(Ystring,'_');
        Xstring(idcsX) = ' '; 
        Ystring(idcsY) = ' '; 
        xlabel(Xstring)
        ylabel(Ystring)

        set(figgi, 'Units','normalized', 'OuterPosition',[0.3 0.2 0.3 0.5])
        set(hand,'outerposition',[0 0 1 1],'units','normalized')
        set(hand, 'LooseInset', [0,0,0,0]);
        axis square

        % gets the tick labels to store for adding them later if needed
        var_prep = ['tx_' get(figgi,'Name')];
        var1 = matlab.lang.makeValidName(var_prep);
        eval([var1, '= tx;'])

        var_prep1 = ['ty_' get(figgi,'Name')];
        var2 = matlab.lang.makeValidName(var_prep1);
        eval([var2, '= ty;'])
        eval(['handles.', var1, '= tx;'])
        eval(['handles.', var2, '= ty;'])

        set(handles.popupColor,'Value',1)
        set(handles.popupLiT,'Value',1)
        set(handles.popupFontSize,'Value',10)

        hand = findobj(figgi,'type','axes');
        texthand = findobj(hand,'type','text');
        hline = findobj(figgi, 'type', 'line');

        % reads all properties to be edited later and returns them in the
        % appropriate buttons, check boxes etc.
        a0 = get(hand,'xtick');
        if ~isempty(a0)
            set(handles.Axesti,'Value',1);
        else
            set(handles.Axesti,'Value',0);
        end

        set(handles.ticklabels,'Value',1);

        b = get(hand,'Box');
        if strcmp(b,'on') == 1
            set(handles.tickbox,'Value',1)
        else
            set(handles.tickbox,'Value',0)
        end

        c = get(texthand,'Visible');
        if isempty(c)
            set(handles.ticktext,'Value',0);
        elseif strcmp(c,'on') == 1
            set(handles.ticktext,'Value',1);
        elseif strcmp(c,'off') == 1
            set(handles.ticktext,'Value',0);
        end

        d = get(hand,'Fontsize');
        set(handles.popupFontSize,'Value',d)

        e = 1;
        set(handles.popupLiT,'Value',2)

        f = get(hand,'LineWidth');
        if isempty(f) == 0
            if length(f) > 1
                set(handles.boxthipopup,'Value',f(1,1))
            elseif f == 0.5
                set(handles.boxthipopup,'Value',1)
            else
                set(handles.boxthipopup,'Value',f+1)
            end
        else
            set(handles.boxthipopup,'Value',1)
        end
        delete(hey)
    case 'No'
        delete(hey1);
end


% new dataset is plotted
if s == 1 & kCol == 0;
	axes(handles.axes1)
	scatter(StatsMatrix2(:,ind_a),StatsMatrix2(:,ind_b),sizeSc,[0 0 0],'filled');
elseif s == 2 & kCol == 0;
	abin = str2double(get(handles.densitybin,'String'));
	edgesX = linspace(min(StatsMatrix2(:,ind_a)), max(StatsMatrix2(:,ind_a)), abin);
 	edgesY = linspace(min(StatsMatrix2(:,ind_b)), max(StatsMatrix2(:,ind_b)), abin);   
  	[One,~] = size(StatsMatrix2(:,ind_a));  
 	[~,CountsX] = histc(StatsMatrix2(:,ind_a),edgesX);
	[~,CountsY] = histc(StatsMatrix2(:,ind_b),edgesY);         
  	Counts = [CountsX,CountsY];
   	Darray = accumarray(Counts,1)./One;
	DarrayNorm = Darray./max(Darray(:));
    DarrayNorm = imgaussfilt(DarrayNorm,2);   
  	ind = sub2ind(size(DarrayNorm),CountsX,CountsY);    
	col2 = DarrayNorm(ind);
  	U = sortrows([StatsMatrix2(:,ind_a), StatsMatrix2(:,ind_b), col2],3);
  	col1 = U(:,3);   
 	colormap(jet(4096));
  	axes(handles.axes1)
  	scatter(U(:,1),U(:,2),sizeSc,col1,'filled')
elseif s > 2 & kCol == 0;
	es = s-2;
	axes(handles.axes1)
	scatter(StatsMatrix2(:,ind_a),StatsMatrix2(:,ind_b),sizeSc,StatsMatrix2(:,es),'filled');
elseif length(kCol) > 1;
    kCol2 = kCol(selected_indices(:,1),:);
	axes(handles.axes1)
	scatter(StatsMatrix2(:,ind_a),StatsMatrix2(:,ind_b),sizeSc,kCol2,'filled');   
end
axis 'auto xy'
set(handles.Ymin,'String',' ');
set(handles.Ymax,'String',' ');
set(handles.Xmin,'String',' ');
set(handles.Xmax,'String',' ');
        
% percentage of the gate within the parent population is calculated and
% inserted into the gating history table
percofall = size(StatsMatrix2,1)/size(clearst,1)*100;
perc = size(StatsMatrix2,1)/size(stats,1)*100;
numb = size(StatsMatrix2,1);
a = [cell2mat(get(handles.textXax,'String')) ' vs. ' cell2mat(get(handles.textYax,'String')) ' rectangle'];
a1 = get(handles.GatingTable,'Data');
a2 = (size(a1,1)+1);
                                
if isempty(a1) == 1 %if its the first entry in the table
    b = {a, numb, perc, percofall};
    set(handles.GatingTable,'Data',b)
else
end
if isempty(a1) == 0 %if there is already an entry in the table
    b1 = {' ', ' ', ' ',' '};
    a1 = [a1; b1];
    a1(a2,:) = {a, numb, perc, percofall};
    set(handles.GatingTable,'Data',a1)
else
end 
handles.stats = StatsMatrix2;
handles.aritstats = StatsMatrix2;
Names = get(handles.gatebox,'string');

for i = 1:length(Names)
	if strcmp(Names{i,1},'...')
        Val = i;
        break
	end
end
% Gating history is updated
gatehist = handles.gatinghist;
gatehist{1,Val} = StatsMatrix2;
gatehist{2,Val} = ind_a;
gatehist{3,Val} = ind_b;
f = get(handles.uipanel1,'SelectedObject');
Sel = get(f,'String');
gatehist{4,Val} = Sel;
asinhIDX = get(handles.asinhX,'Value');
asinhIDY = get(handles.asinhY,'Value');
asinhIDen = get(handles.BiExBtn,'Enable');
if strcmp(asinhIDen,'off')
    asinhIDen = 1;
else
    asinhIDen = 0;
end
if asinhIDen == 1 & (asinhIDX == 1 & asinhIDY == 0) 
    gatehist{5,Val} = 1;
elseif asinhIDen == 1 & (asinhIDX == 0 & asinhIDY == 1)
    gatehist{5,Val} = 2;
elseif asinhIDen == 1 & (asinhIDX == 1 & asinhIDY == 1) 
    gatehist{5,Val} = 3;
elseif asinhIDen == 0
    gatehist{5,Val} = 0;    
end
gatehist{6,Val} = handles.BiExID;
gatehist{7,Val} = handles.names;

handles.gatinghist = gatehist;
Names{Val,1} = a;
Names{Val+1,1} = '...';
set(handles.gatebox,'Value',(Val));
set(handles.gatebox,'String',Names);
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject, handles);


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over textYax.
function textYax_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to textYax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.figure1, 'pointer', 'watch')
drawnow;
prompt = {'Change the statistic name'};
dlg_title = 'Input';
num_lines = 1;
defaultans = {''};
answer = inputdlg(prompt,dlg_title,num_lines,defaultans);

indb = handles.indb;
e = handles.names;
e(1,indb) = answer;

set(handles.popupX,'string',e);
set(handles.popupY,'string',e);
set(handles.popupA,'string',e);
set(handles.popupB,'string',e);
set(handles.textXax,'string',e(1,handles.inda));
set(handles.textYax,'string',e(1,handles.indb));
handles.names = e;

b = get(handles.gatebox,'Value');
gatinghist = handles.gatinghist;
gatinghist{7,b} = e;
handles.gatinghist = gatinghist;
guidata(hObject, handles);
set(handles.figure1, 'pointer', 'arrow')


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over textXax.
function textXax_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to textXax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.figure1, 'pointer', 'watch')
drawnow;
prompt = {'Change the statistic name'};
dlg_title = 'Input';
num_lines = 1;
defaultans = {''};
answer = inputdlg(prompt,dlg_title,num_lines,defaultans);

inda = handles.inda;
e = handles.names;

e(1,inda) = answer;

set(handles.popupX,'string',e);
set(handles.popupY,'string',e);
set(handles.popupA,'string',e);
set(handles.popupB,'string',e);
set(handles.textXax,'string',e(1,handles.inda));
set(handles.textYax,'string',e(1,handles.indb));
handles.names = e;

b = get(handles.gatebox,'Value');
gatinghist = handles.gatinghist;
gatinghist{7,b} = e;
handles.gatinghist = gatinghist;
guidata(hObject, handles);
set(handles.figure1, 'pointer', 'arrow')



function cofactor_Callback(hObject, eventdata, handles)
% hObject    handle to cofactor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cofactor as text
%        str2double(get(hObject,'String')) returns contents of cofactor as a double


% --- Executes during object creation, after setting all properties.
function cofactor_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cofactor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on key press with focus on cofactor and none of its controls.
function cofactor_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to cofactor (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return')
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    asinhX = get(handles.asinhX,'Value');
    asinhY = get(handles.asinhY,'Value');
    stats1 = handles.stats;
    ind_a = handles.inda;
    ind_b = handles.indb;

    if isempty(get(handles.Gate_Xperc,'String'))
        set(handles.Gate_Xperc,'String',' ')
    end
    if isempty(get(handles.Gate_Yperc,'String'))
        set(handles.Gate_Yperc,'String',' ')
    end
    if strcmp(' ',get(handles.Gate_Xperc,'String')) == 0 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 1
        xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
        xgate = prctile(stats1(:,ind_a),xgate_perc);
        ygate = str2double(get(handles.Gate_Y,'String'));
    elseif strcmp(' ',get(handles.Gate_Xperc,'String')) == 1 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 0
        ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
        ygate = prctile(stats1(:,ind_b),ygate_perc);
        xgate = str2double(get(handles.Gate_X,'String'));
    elseif strcmp(' ',get(handles.Gate_Xperc,'String')) == 0 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 0
        xgate_perc = str2double(get(handles.Gate_Xperc,'String'));
        ygate_perc = str2double(get(handles.Gate_Yperc,'String'));
        set(handles.Gate_X,'String',' ');
        set(handles.Gate_Y,'String',' ');
        xgate = prctile(stats1(:,ind_a),xgate_perc);
        ygate = prctile(stats1(:,ind_b),ygate_perc);
    elseif strcmp(' ',get(handles.Gate_Xperc,'String')) == 1 & strcmp(' ',get(handles.Gate_Yperc,'String')) == 1
        xgate = str2double(get(handles.Gate_X,'String'));
        ygate = str2double(get(handles.Gate_Y,'String'));
    end
    handles.xgate = xgate;
    handles.ygate = ygate;
    guidata(hObject,handles)

    set(handles.cofactor,'enable','off')

    % gets values of the tick boxes below the asinh/Linear button and thus
    % determines if one or both axes should be transformed
    if asinhX == 1 & asinhY == 0
        BiEx_StatsX = log((stats1(:,ind_a)/(str2double(get(handles.cofactor,'String'))))...
            +sqrt((((stats1(:,ind_a)/(str2double(get(handles.cofactor,'String')))).^2)+1)));
        stats1(:,ind_a) = BiEx_StatsX;
        handles.xgate = log((xgate/(str2double(get(handles.cofactor,'String'))))...
            +sqrt((((xgate/(str2double(get(handles.cofactor,'String')))).^2)+1)));
        set(handles.linX,'Value',1);
        set(handles.linY,'Value',0);
    elseif asinhX == 0 & asinhY == 1
        BiEx_StatsY = log((stats1(:,ind_b)/(str2double(get(handles.cofactor,'String'))))...
            +sqrt((((stats1(:,ind_b)/(str2double(get(handles.cofactor,'String')))).^2)+1)));
        stats1(:,ind_b) = BiEx_StatsY;
        handles.ygate = log((ygate/(str2double(get(handles.cofactor,'String'))))...
            +sqrt((((ygate/(str2double(get(handles.cofactor,'String')))).^2)+1)));
        set(handles.linX,'Value',0);
        set(handles.linY,'Value',1);
    elseif asinhX == 1 & asinhY == 1
        BiEx_StatsX = log((stats1(:,ind_a)/(str2double(get(handles.cofactor,'String'))))...
            +sqrt((((stats1(:,ind_a)/(str2double(get(handles.cofactor,'String')))).^2)+1)));
        stats1(:,ind_a) = BiEx_StatsX;
        BiEx_StatsY = log((stats1(:,ind_b)/(str2double(get(handles.cofactor,'String'))))...
            +sqrt((((stats1(:,ind_b)/(str2double(get(handles.cofactor,'String')))).^2)+1)));
        stats1(:,ind_b) = BiEx_StatsY;
        handles.xgate = log((xgate/(str2double(get(handles.cofactor,'String'))))...
            +sqrt((((xgate/(str2double(get(handles.cofactor,'String')))).^2)+1)));
        handles.ygate = log((ygate/(str2double(get(handles.cofactor,'String'))))...
            +sqrt((((ygate/(str2double(get(handles.cofactor,'String')))).^2)+1)));
        set(handles.linX,'Value',1);
        set(handles.linY,'Value',1);
    end
    set(handles.linX,'Enable','off');
    set(handles.linY,'Enable','off');
    set(handles.LinBtn,'Enable','on');
    set(handles.asinhX,'Enable','off');
    set(handles.asinhY,'Enable','off');
    set(handles.BiExBtn,'Enable','off'); 
    handles.stats = stats1;
    handles.BiExID = 1;
    r = handles.gatinghist;
    r{6,get(handles.gatebox,'value')} = 1;
    handles.gatinghist = r;
    guidata(hObject, handles);

    set(handles.Gate_X,'String',num2str(handles.xgate))
    set(handles.Gate_Y,'String',num2str(handles.ygate))

    %gather stats to run XITplot
    f = get(handles.uipanel1,'SelectedObject');
    Sel = get(f,'String');
    xgate = str2double(get(handles.Gate_X,'String'));
    ygate = str2double(get(handles.Gate_Y,'String'));
    stats = handles.stats;
    StatsMatrixCl = handles.statsCl;
    num_forperc = size(StatsMatrixCl,1);
    sizeSc = handles.sizeSc;
    s = get(handles.popupCol,'Value');
    kCol = handles.kmCol;
    abin = str2double(get(handles.densitybin,'String'));
    bins = str2double(get(handles.hist_bins,'String'));

    xmin = str2double(get(handles.Xmin,'String'));
    xmax = str2double(get(handles.Xmax,'String'));
    ymin = str2double(get(handles.Ymin,'String'));
    ymax = str2double(get(handles.Ymax,'String'));


    XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,asinhX,asinhY,...
        str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)
    a = getappdata(XIT,'handl');
    if get(handles.popupCol,'value') > 2
        cmax = str2double(get(handles.colorMax,'String'));    
        cmin = str2double(get(handles.colorMin,'String'));  
        if isnan(cmin)
            cmin = 0;
        end
        if isnan(cmax)
            cmax = 255;
        end
        axes(handles.axes1)
        caxis([cmin cmax])  
    end
    % get gating info from XITplot
    GateID = a.ID;
    if GateID == 0
    elseif GateID == 1
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowX = a.percbelowX;
        handles.percaboveX = a.percaboveX;
        handles.numbelowX = a.numbelowX;
        handles.numaboveX = a.numaboveX;
        handles.percofallaX = a.percofallaX;
        handles.percofallbX = a.percofallbX;
    elseif GateID == 3
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowY = a.percbelowY;
        handles.percaboveY = a.percaboveY;
        handles.numbelowY = a.numbelowY;
        handles.numaboveY = a.numaboveY;
        handles.percofallaY = a.percofallaY;
        handles.percofallbY = a.percofallbY;
    elseif GateID == 2
        handles.StatsMatrixQ1 = a.StatsMatrixQ1;
        handles.StatsMatrixQ2 = a.StatsMatrixQ2;
        handles.StatsMatrixQ3 = a.StatsMatrixQ3;
        handles.StatsMatrixQ4 = a.StatsMatrixQ4;
        handles.percQ1 = a.percQ1;
        handles.percQ2 = a.percQ2;
        handles.percQ3 = a.percQ3;
        handles.percQ4 = a.percQ4;
        handles.percofallQ1 = a.percofallQ1;
        handles.percofallQ2 = a.percofallQ2;
        handles.percofallQ3 = a.percofallQ3;
        handles.percofallQ4 = a.percofallQ4;
        handles.numQ1 = a.numQ1;
        handles.numQ2 = a.numQ2;
        handles.numQ3 = a.numQ3;
        handles.numQ4 = a.numQ4;
    end
    guidata(hObject, handles);
    set(handles.figure1, 'pointer', 'arrow')

end


% --- Executes on button press in colasinh.
function colasinh_Callback(hObject, eventdata, handles)
% hObject    handle to colasinh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of colasinh
set(handles.figure1, 'pointer', 'watch')
drawnow;
if get(handles.scatterplot,'Value') == 1 & get(handles.popupCol,'Value') > 2
    %gather stats to run XITplot
    ind_a = handles.inda;
    ind_b = handles.indb;
    f = get(handles.uipanel1,'SelectedObject');
    Sel = get(f,'String');
    xgate = str2double(get(handles.Gate_X,'String'));
    ygate = str2double(get(handles.Gate_Y,'String'));
    stats = handles.stats;
    StatsMatrixCl = handles.statsCl;
    num_forperc = size(StatsMatrixCl,1);
    sizeSc = handles.sizeSc;
    s = get(handles.popupCol,'Value');
    kCol = handles.kmCol;
    abin = str2double(get(handles.densitybin,'String'));
    bins = str2double(get(handles.hist_bins,'String'));

    xmin = str2double(get(handles.Xmin,'String'));
    xmax = str2double(get(handles.Xmax,'String'));
    ymin = str2double(get(handles.Ymin,'String'));
    ymax = str2double(get(handles.Ymax,'String'));


    XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,get(handles.asinhX,'value'),get(handles.asinhY,'value'),...
        str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)
    a = getappdata(XIT,'handl');
    % get gating info from XITplot
    GateID = a.ID;
    if GateID == 0
    elseif GateID == 1
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowX = a.percbelowX;
        handles.percaboveX = a.percaboveX;
        handles.numbelowX = a.numbelowX;
        handles.numaboveX = a.numaboveX;
        handles.percofallaX = a.percofallaX;
        handles.percofallbX = a.percofallbX;
    elseif GateID == 3
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowY = a.percbelowY;
        handles.percaboveY = a.percaboveY;
        handles.numbelowY = a.numbelowY;
        handles.numaboveY = a.numaboveY;
        handles.percofallaY = a.percofallaY;
        handles.percofallbY = a.percofallbY;
    elseif GateID == 2
        handles.StatsMatrixQ1 = a.StatsMatrixQ1;
        handles.StatsMatrixQ2 = a.StatsMatrixQ2;
        handles.StatsMatrixQ3 = a.StatsMatrixQ3;
        handles.StatsMatrixQ4 = a.StatsMatrixQ4;
        handles.percQ1 = a.percQ1;
        handles.percQ2 = a.percQ2;
        handles.percQ3 = a.percQ3;
        handles.percQ4 = a.percQ4;
        handles.percofallQ1 = a.percofallQ1;
        handles.percofallQ2 = a.percofallQ2;
        handles.percofallQ3 = a.percofallQ3;
        handles.percofallQ4 = a.percofallQ4;
        handles.numQ1 = a.numQ1;
        handles.numQ2 = a.numQ2;
        handles.numQ3 = a.numQ3;
        handles.numQ4 = a.numQ4;
    end
    guidata(hObject, handles);
    set(handles.figure1, 'pointer', 'arrow')
end


function cofact_col_Callback(hObject, eventdata, handles)
% hObject    handle to cofact_col (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cofact_col as text
%        str2double(get(hObject,'String')) returns contents of cofact_col as a double


% --- Executes during object creation, after setting all properties.
function cofact_col_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cofact_col (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on key press with focus on cofact_col and none of its controls.
function cofact_col_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to cofact_col (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return') & get(handles.popupCol,'value') > 2 & get(handles.colasinh,'value') == 1
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    %gather stats to run XITplot
    ind_a = handles.inda;
    ind_b = handles.indb;
    f = get(handles.uipanel1,'SelectedObject');
    Sel = get(f,'String');
    xgate = str2double(get(handles.Gate_X,'String'));
    ygate = str2double(get(handles.Gate_Y,'String'));
    stats = handles.stats;
    StatsMatrixCl = handles.statsCl;
    num_forperc = size(StatsMatrixCl,1);
    sizeSc = handles.sizeSc;
    s = get(handles.popupCol,'Value');
    kCol = handles.kmCol;
    abin = str2double(get(handles.densitybin,'String'));
    bins = str2double(get(handles.hist_bins,'String'));

    xmin = str2double(get(handles.Xmin,'String'));
    xmax = str2double(get(handles.Xmax,'String'));
    ymin = str2double(get(handles.Ymin,'String'));
    ymax = str2double(get(handles.Ymax,'String'));


    XITplot(Sel,xgate,ygate,xmin,xmax,ymin,ymax,ind_a,ind_b,stats,s,kCol,sizeSc,bins,handles.axes1,abin,num_forperc,get(handles.asinhX,'value'),get(handles.asinhY,'value'),...
        str2double(get(handles.cofactor,'String')),str2double(get(handles.cofact_col,'String')),get(handles.colasinh,'Value'),handles.BiExID)
    a = getappdata(XIT,'handl');
  
    % get gating info from XITplot
    GateID = a.ID;
    if GateID == 0
    elseif GateID == 1
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowX = a.percbelowX;
        handles.percaboveX = a.percaboveX;
        handles.numbelowX = a.numbelowX;
        handles.numaboveX = a.numaboveX;
        handles.percofallaX = a.percofallaX;
        handles.percofallbX = a.percofallbX;
    elseif GateID == 3
        handles.StatsMatrix2 = a.StatsMatrix2;
        handles.StatsMatrix3 = a.StatsMatrix3;
        handles.percbelowY = a.percbelowY;
        handles.percaboveY = a.percaboveY;
        handles.numbelowY = a.numbelowY;
        handles.numaboveY = a.numaboveY;
        handles.percofallaY = a.percofallaY;
        handles.percofallbY = a.percofallbY;
    elseif GateID == 2
        handles.StatsMatrixQ1 = a.StatsMatrixQ1;
        handles.StatsMatrixQ2 = a.StatsMatrixQ2;
        handles.StatsMatrixQ3 = a.StatsMatrixQ3;
        handles.StatsMatrixQ4 = a.StatsMatrixQ4;
        handles.percQ1 = a.percQ1;
        handles.percQ2 = a.percQ2;
        handles.percQ3 = a.percQ3;
        handles.percQ4 = a.percQ4;
        handles.percofallQ1 = a.percofallQ1;
        handles.percofallQ2 = a.percofallQ2;
        handles.percofallQ3 = a.percofallQ3;
        handles.percofallQ4 = a.percofallQ4;
        handles.numQ1 = a.numQ1;
        handles.numQ2 = a.numQ2;
        handles.numQ3 = a.numQ3;
        handles.numQ4 = a.numQ4;
    end
    guidata(hObject, handles);
    set(handles.figure1, 'pointer', 'arrow')
end


function colorMin_Callback(hObject, eventdata, handles)
% hObject    handle to colorMin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of colorMin as text
%        str2double(get(hObject,'String')) returns contents of colorMin as a double


% --- Executes during object creation, after setting all properties.
function colorMin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to colorMin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function colorMax_Callback(hObject, eventdata, handles)
% hObject    handle to colorMax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of colorMax as text
%        str2double(get(hObject,'String')) returns contents of colorMax as a double


% --- Executes during object creation, after setting all properties.
function colorMax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to colorMax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on key press with focus on colorMin and none of its controls.
function colorMin_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to colorMin (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return') & get(handles.popupCol,'value') > 2
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    cmax = str2double(get(handles.colorMax,'String'));    
    cmin = str2double(get(handles.colorMin,'String'));  
    if isnan(cmax)
        cmax = 255;
    end
    if isnan(cmin)
        cmin = 0;
    end
    axes(handles.axes1)
    caxis([cmin cmax])
    set(handles.figure1, 'pointer', 'arrow')
end

% --- Executes on key press with focus on colorMax and none of its controls.
function colorMax_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to colorMax (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
current_key = eventdata.Key;
drawnow

if strcmp(current_key,'return') & get(handles.popupCol,'value') > 2   
    set(handles.figure1, 'pointer', 'watch')
    drawnow;
    cmax = str2double(get(handles.colorMax,'String'));    
    cmin = str2double(get(handles.colorMin,'String'));  
    if isnan(cmin)
        cmin = 0;
    end
    if isnan(cmax)
        cmax = 255;
    end
    axes(handles.axes1)
    caxis([cmin cmax])
    set(handles.figure1, 'pointer', 'arrow')
end